#ifndef __DATA_HELPER_H__
#define __DATA_HELPER_H__
#include "DataHelperConfig.h"

typedef struct
{
	int count;
	int tail;
	int head;
	int total;
	unsigned char * buffer;
} fifo_buffer_t;

void dh_fifo_init(fifo_buffer_t * fifo, unsigned char * buffer, int total);
void dh_fifo_push(fifo_buffer_t * fifo, unsigned char dat);
int dh_fifo_pop(fifo_buffer_t *fifo, unsigned char *dat);

#endif
