#ifndef __MODBUS_ENCODER_H__
#define __MODBUS_ENCODER_H__

#include "modbus_common.h"

#define MODBUS_ENCODER_RTU      1
#define MODBUS_ENCODER_ASCII    0

typedef struct
{
    int (* encode)(unsigned char * dst, unsigned char * src, int length);
    int (* decode)(unsigned char * dst, unsigned char * src, int length);
    int (* length_calc)(int dir,int length);
} modbus_encoder_t;

modbus_encoder_t * modbus_encoder_match(unsigned char * buffer, int length); 
modbus_encoder_t * modbus_encoder_get(int no); 
#endif
