#ifndef __HW_BOARD_H__
#define __HW_BOARD_H__

#include "st_sys.h"
#include "st_dma.h"
#include "st_flash.h"
#include "software_timer.h"
#include "hardware_delay.h"

#include "hw_io_pin.h"
#include "hw_dma_uart.h"
#include "hw_power_off.h"


#include "hw_flash_data.h"
#include "hw_pwm.h"
#include "hw_iic.h"
#include "Encode.h"


int hw_boot_key_read(void);
void hw_board_init(void);
void hw_run_status_show(void);
void hw_run_status_set(int status);
void hw_board_enter_powerless(void);
void hw_noinit_write(int no, int value);
int hw_noinit_read(int no);
void hw_board_reboot(void);

extern void hw_run_status_on(void);
extern void hw_run_status_off(void);

extern unsigned long run_led_speed;
#endif
