#include "global.h"

#if BRUCE_MACHINE== 1
unsigned long ReSetOrigin(unsigned short axis);//返回原点
void  RetSetSyStem(void);//系统上电复位
void StartReady(void);//启动准备
void MovePos(unsigned short axis);//移动距离
void BRUCE_CountData(unsigned short alr);
void BRUCE_DaZheJiAction(void);
void DaZheJi_InitAction(void);
void BRUCE_DaZheJiCheckStart(void);
void  BRUCE_DaZheJi_Motor(void);
void BRUCE_DaZheJi_ManualAction(void);
void BRUCE_DaZhe_AutoAction(void);
void BRUCE_DaZheJi_CheckAlarm(void);

unsigned long cZipperLength[2];
long dwRealPosX,dwRealPosY;

unsigned long runcount;

#define SycleRunMode M24

short *len_buf;
short *offset_len;
//故障报警
void DAZHE_SetAlarmCode(unsigned alarm_code)
{

}

//高速输入X31/X17外部色标信号中断
void DAZHE_ExtiActionX31(void)
{

}




void MXC_ExtiActionX20(void)
{

}

//故障报警
void DZ_SetAlarmCode(unsigned alarm_code)
{
    SetAlarmCode(DZ_ALARM_ADDR,alarm_code);
}

//复位原点动作
unsigned long ReSetOrigin(unsigned short axis)
{
     switch(axis)
    {
        case X_AXIS: //褶宽电机
            switch(XRunResetOStep)
            {
                case 1:
                    Y02 = 0;    //方向返回
                    if(!X02)
                    {
                        XRunResetOStep = 2;
                        ReSetXDelay = dwTickCount + 5000;
                        Y02 = 0;
                        if(!X_DRV)
                        {
                            //                  X轴       运行速度                    启动速度        加速度  减速度
                            AxisContinueMoveAcc(X_AXIS,XMOTOR_HANDRUN_SPEED,DIR_N,XMOTOR_HANDRUN_SPEED/3,15,15);
                        }
                    }
                    else
                    {
                       XRunResetOStep = 0;
                       return 1;
                    }
                    break;
                case 2:
                    if(X02)
                    {
                        AxisEgmStop(X_AXIS);
                        XRunResetOStep = 0;
                        return 1;
                    }
                    else if(dwTickCount >= ReSetXDelay)   //多长时间没回到位警告
                    {
                        DZ_SetAlarmCode(ALARM_ZheKuan_YuanWei);
                    }
                    break;

            }
            break;
    case Y_AXIS://褶距电机
            switch(YRunResetOStep)
            {
                case 1:
                    Y03 = 0;    //方向返回
                    if(!X03)
                    {
                        ReSetYDelay = dwTickCount + 5000;
                        YRunResetOStep = 2;
                        Y03 = 0;
                        if(!Y_DRV)
                        {
                            //                Y轴       运行速度                    启动速度        加速度  减速度
                            AxisContinueMoveAcc(Y_AXIS,YMOTOR_HANDRUN_SPEED,DIR_N,YMOTOR_HANDRUN_SPEED/2,15,15);
                        }
                    }
                    else
                    {
                       YRunResetOStep = 0;
                       return 1;
                    }
                    break;
                case 2:
                    if(X03)
                    {
                        AxisEgmStop(Y_AXIS);
                        YRunResetOStep = 0;
                        return 1;
                    }
                    else if(dwTickCount >= ReSetYDelay)   //多长时间没回到位警告
                    {
                        DZ_SetAlarmCode(ALARM_ZheJu_YuanWei);
                    }
                    break;
            }
            break;
    }
}
//移动距离
void MovePos(unsigned short axis)
{
    switch(axis)
    {
        case X_AXIS: //褶宽电机
              if(!X_DRV)
                XRunMovePosStep = 0;
              break;
        case Y_AXIS: //褶距电机
            if(!Y_DRV)
                YRunMovePosStep = 0;
            break;
  }
}
//褶宽电机动作
//基准褶宽位置D57  基准实际褶宽D59 大概褶宽D13
void ZheKuan_MotorActoin(long Pos)
{ unsigned long ch,k;
    switch(ZheKuan_MotorRunStep)
    {
        case 1:         //算出褶宽绝对位置
             ZheKuan_MotorRunStep = 2;
            if(user_datas[13] > user_datas[59])
            {
                ch =user_datas[57] + user_datas[13]- user_datas[59];
                k = ch;
            }
            else
                ch =user_datas[57] -(user_datas[59]- user_datas[13]);
            if(dwRealPosX < ch)
            {
                Y02 = 1;    //控制方向
                axis_cw(axis_x);
            }
            else
            {
                Y02 = 0;
                axis_ccw(axis_x);
            }
            AxisMovePoint(X_AXIS,XMOTOR_HANDRUN_SPEED,ch);
            break;
        case 2:
            if(!X_DRV)
                ZheKuan_MotorRunStep = 0;
            break;

    }
}

//基准参数动作
/*
D0 窗户宽度
D1 窗户宽度
D2 布料宽度
D3 布料宽度
D4 褶子个数
D5 补偿量
D6 打褶方式
D7 窗帘款式(0 单开,1 双开)
D8 预加宽度
D9 帘边宽度
D10 预计单片成品宽度
D11 预计单片成品宽度
D12 褶距
D13 大概褶宽
D14 褶子用料
D15 起头尺寸
D43 褶宽与褶深的距离差
D44 褶距计算基准数值
D55
D56 花样打褶选择
*/
void BRUCE_CountData(unsigned short alr)  //是否警告输出
{
  unsigned long ch,k;
  short kk;
  //花样打褶选择
    if(user_datas[56] == 0)   //常规打褶
    {
        ch = (user_datas[0] | (user_datas[1] << 16)); //窗户宽度
        //单开双开选择
        if(user_datas[7] == 1)//双开
        {
           ch /=2;
        }
        ch += user_datas[8];   //预加宽度
        user_datas[10] = ch&0xffff;
        user_datas[11] = (ch>>16)&0xffff;


        //计算褶数
        if(user_datas[55] == 1)  //自动算褶数
        {//预加宽度除以褶距计算基准数值
            user_datas[4] = ch/user_datas[44];
            user_datas[4] += 1;
        }
        //计算褶距

        k = ch*10/(user_datas[4] - 1);
        user_datas[12] = k;
        if(alr)
        {
            if(user_datas[12]<user_datas[48]*10)
            {
                 DZ_SetAlarmCode(ALARM_ZheJu_Size_Limit);
            }
            if(user_datas[12]>user_datas[47]*10)
            {
                DZ_SetAlarmCode(ALARM_ZheJu_Size_Biger);
            }
        }
        //计算褶子用料
        k = (user_datas[2] | (user_datas[3] << 16)); //布料宽度
        //(布料宽度-2*帘边宽度-成品宽度)除以褶数,一位小数点
        if(k > (2*user_datas[9] + ch)) //布料不能小于窗户
        {
            user_datas[14] = ((k - 2*user_datas[9] -ch) * 10)/user_datas[4];

 //         user_datas[14] = k;
        //计算褶子大概宽度
            if(user_datas[6]==0)
            {
                k = ((user_datas[14]+(user_datas[6] * 20 *user_datas[43]))/(user_datas[6]+1) - (user_datas[5]-1) * 15)/2 + 3;
            }
            else if(user_datas[6]==1)
            {
                k = ((user_datas[14]+(user_datas[6] * 20 *user_datas[43]))/(user_datas[6]+1) - (user_datas[5]-1) * 15)/2 + 13;
            }
            else if(user_datas[6]==2)
            {
                k = ((user_datas[14]+(user_datas[6] * 20 *user_datas[43]))/(user_datas[6]+1) - (user_datas[5]-1) * 15)/2 + 41;
            }
            user_datas[13] = k;
            //褶宽大小超出范围,最宽最小
            if(alr)
            {
                if(user_datas[13]<user_datas[46]*10)
                {
                    DZ_SetAlarmCode(ALARM_ZheKuan_Size_Limit);
                }
                if(user_datas[13]>user_datas[45]*10)
                {
                    DZ_SetAlarmCode(ALARM_ZheKuan_Size_Biger);
                }
            }
            //褶宽电机位置动作
            kk = user_datas[13]- user_datas[59];
            user_datas[72] = user_datas[57] + kk;
            //电机位置超出最长位置警告
            if(alr)
            {
                if(user_datas[72] > user_datas[67])
                    DZ_SetAlarmCode(ALARM_ZheKuan_LimitWei);
            }
            //算褶距电机位置
            if(user_datas[12] > user_datas[63])
            {
               ch = user_datas[12]- user_datas[63];     //实际比基准宽
               k = user_datas[61] - ch;
            }
            else
            {
               ch = user_datas[63]- user_datas[12];
               k = user_datas[61] + ch;
            }
            user_datas[73] = k- kk + 15;
            //电机位置超出最长位置警告
            if(alr)
            {
                if(user_datas[73] > user_datas[68])
                    DZ_SetAlarmCode(ALARM_ZheJu_LimitWei);
            }
            //计算起头尺寸,注意小数点差别 褶子用料-帘边宽度-褶刀厚度/2(6.0MM)
            k = ((user_datas[14]+(user_datas[6] * 20 *user_datas[43]))/(user_datas[6]+1) -(10 *user_datas[43])+ (10*user_datas[9])-60)/10;
            //k = (user_datas[14]/2 + (10*user_datas[9])-60)/10;

            user_datas[15] = k;
        }
        else if(alr)    //警告布料不足
        {
            //输出警告
            DZ_SetAlarmCode(ALARM_Size_Limit);
        }
    }
    else //花样打褶 褶距和褶宽不用算，直接输入的，
         //窗宽和布宽直接无效，要算出褶子用料
    {
        if(alr)
        {
            if(user_datas[12]<user_datas[48]*10)
            {
                 DZ_SetAlarmCode(ALARM_ZheJu_Size_Limit);
            }
            if(user_datas[12]>user_datas[47]*10)
            {
                DZ_SetAlarmCode(ALARM_ZheJu_Size_Biger);
            }
        }
        //褶宽大小超出范围,最宽最小
        if(alr)
        {
                if(user_datas[13]<user_datas[46]*10)
                {
                    DZ_SetAlarmCode(ALARM_ZheKuan_Size_Limit);
                }
                if(user_datas[13]>user_datas[45]*10)
                {
                    DZ_SetAlarmCode(ALARM_ZheKuan_Size_Biger);
                }
        }
        //计算褶子用料
        k = (user_datas[13] - 13)*2 + (user_datas[5]-1) * 15-10 *user_datas[43];
        user_datas[14] = k * 2;

        //褶宽电机位置动作
        kk = user_datas[13]- user_datas[59];
        user_datas[72] = user_datas[57] + kk;
        //电机位置超出最长位置警告
        if(alr)
        {
            if(user_datas[72] > user_datas[67])
            DZ_SetAlarmCode(ALARM_ZheKuan_LimitWei);
        }
        //算褶距电机位置
        if(user_datas[12] > user_datas[63])
        {
           ch = user_datas[12]- user_datas[63];     //实际比基准宽
            k = user_datas[61] - ch;
        }
        else
        {
           ch = user_datas[63]- user_datas[12];
           k = user_datas[61] + ch;
        }
        user_datas[73] = k- kk + 15;
        //电机位置超出最长位置警告
        if(alr)
        {
            if(user_datas[73] > user_datas[68])
                DZ_SetAlarmCode(ALARM_ZheJu_LimitWei);
        }
    }
}

void DaZheJi_InitAction(void)
{
    float length_buff,pulse_buff;

    length_buff = user_datas[19]*10;       //褶宽丝杆镙距
    if(user_datas[18])
        pulse_buff  = user_datas[18];
    else
        pulse_buff  = 10000;
    XGearRatio  = pulse_buff/length_buff;   //电子齿轮比
    length_buff = user_datas[64]*10;       //褶距丝杆镙距
    YGearRatio  = pulse_buff/length_buff;

    //运行次数
    runcount=(user_datas[74] |  (user_datas[75] << 16));
    //上电回位
    //XRunResetOStep = 1;//褶宽电机回原点
    //YRunResetOStep = 1;//褶距电机回原点启动
    //基准参数没设定的情况下要配默认值
 //   if(user_datas[57] <= 500) ||
//    ReSetSysTemStep = 1;
     bDZStart = 1;
}

void BRUCE_DaZheJiAction(void)
{
    user_datas[121] = bDZRunning;
    user_datas[122] = AutoRunStep;
    user_datas[123] = XRunResetOStep;
    user_datas[124] = YRunResetOStep;
    user_datas[125] = XRunMovePosStep;
    user_datas[126] = YRunMovePosStep;
    user_datas[127] = StartReadyStep;
//    user_datas[128] = bDZJiaoZhunState;
    BRUCE_CountData(0); //尺寸不用警告
    BRUCE_DaZheJiCheckStart();  //启动
    //ReSetOrigin(X_AXIS);        //褶宽电机回原点
    //ReSetOrigin(Y_AXIS);        //褶距电机回原点
    MovePos(X_AXIS);//褶宽电机移动距离
    MovePos(Y_AXIS);//褶距电机移动距离
    StartReady();
    if(!M39)//锁机标志
    {
        BRUCE_DaZheJi_ManualAction();
        BRUCE_DaZhe_AutoAction();
    }
    //BRUCE_DaZheJi_CheckAlarm();
    runcount=(user_datas[74] |  (user_datas[75] << 16));


}

void BRUCE_DaZheJi_ManualAction(void)
{
    unsigned long ch,k;
    long i;
    static unsigned char save_flg = 0,XMoto_Flag = 0, YMoto_Flag = 0,
    XMotoRun_Flag = 0, YMotoRun_Flag = 0;

    if(X02)SetPos(X_AXIS, 0);//回到原位
    if(X03)SetPos(Y_AXIS, 0);//回到原位

    dwRealPosX = GetPos(X_AXIS);
    user_datas[50] = dwRealPosX & 0xffff;
    user_datas[51] = (dwRealPosX >> 16) & 0xffff;
    dwRealPosY = GetPos(Y_AXIS);
    user_datas[52] = dwRealPosY & 0xffff;
    user_datas[53] = (dwRealPosY >> 16) & 0xffff;

    M40 = bDZRunning;

    if(X15_UP)
        bDZStart = 0;
    //压脚也可由缝纫机控制
    Y11 = Y13;
    if((!bDZRunning)) ////手动
    {
        if(!X15)
        {
          //压脚压住和其它信号都回原位才能回到加工位
            if((X00_UP||M20||M23) && !X17 && !Y07 && X06 && !Y04 && !Y05 && !X_DRV
               //   移动限位 定位针原位
               && !X13 && X12 && X14)
            {
                BRUCE_CountData(1); //尺寸警告
                if(GetAlarmCode(DZ_ALARM_ADDR)==0)
                {
                    StartReadyStep = 1;     //回到加工位
                    M20 = 0;
                    M21 = 1;
                    M23 = 0;
                }
            }
        }
        else if(!bDZStart)   //退出加工状态下
        {
           //压脚压住和其它信号都回原位才能回到加工位
            if(X00_UP || M20 || M23) //M20是准备按钮，M23循环工作的测试按钮
            {
//                if(M20)
//                    M21 = !M21;
                BRUCE_CountData(1); //尺寸警告
              //要另一条件褶距电机也要到位
                if((((dwRealPosX == user_datas[72]) && (dwRealPosY == user_datas[73])) || bDZJiaoZhunState)
                   && Y07 &&Y13 &&
                   X17 && X06 && X13 && !X12 && X14 && !X_DRV && !Y_DRV )
                {

                    if(GetAlarmCode(DZ_ALARM_ADDR)==0)       //如果有警告不能启动
                    {
                        M21 = 1;
                        if(!M20)
                        {
                              AutoRunStep = 1;
                              bDZRunning = 1;
                        }
                        if(M23)
                        {
                            SycleRunMode=1;
                            M23=0;
                        }
                    }
                }
                else if(StartReadyStep == 0)
                {
                    BRUCE_CountData(1); //尺寸警告
                    if(GetAlarmCode(DZ_ALARM_ADDR)==0)       //如果有警告不能启动
                    {
                        //StartReadyStep = 20;
    //                    if(!M20)
                        M21 = 1;
                    }
                }
//                M20 = 1;
            }

            if(!(X00_UP || M20 || M23) && (StartReadyStep == 0) && !X_DRV && !Y_DRV && M21)
            {
                if(dwTickCount>AutoResetDelay+(user_datas[36]*60000))
                {
                    StartReadyStep = 40;
                    //M21 = 0;
                }
            }
            else
            {
                AutoResetDelay= dwTickCount;
            }

            if(M27 && (StartReadyStep == 0) && !X_DRV && !Y_DRV && M21)
            {
                M27=0;
                StartReadyStep = 40;
            }
        }
        if(M20)
        {
            M20 = 0;
        }
        //停机复位
        if(M22)
        {
            M22=0;
            StartReadyStep=30;
        }

      //1#褶皱电磁阀
        if(M00)
        {
            M00 = 0;
            if(Y13 && X17)
            {
                Y04 = !Y04;
            }
            else
            {
                DZ_SetAlarmCode(ALARM_ZheZhou_Out_Limit);       //压脚要抬起
            }
        }
       //2#褶皱电磁阀
        if(M01)
        {
            M01 = 0;
            if(Y13 && X17)
            {
                Y05 = !Y05;
            }
            else
            {
                DZ_SetAlarmCode(ALARM_ZheZhou_Out_Limit);       //压脚要抬起
            }
        }
       //移动气缸
        if(M02)
        {
            M02 = 0;
            if(X15 && Y13 && X17)
            {
               Y06 = !Y06;
                Y07 = Y06;
                if(!Y06 && !Y05)
                {
                    if(user_datas[72] > (user_datas[13] + 80))
                    {
                        ch = user_datas[72]- user_datas[13] - 80;
                        if(dwRealPosX > ch)
                        {
                            Y02 = 0;
                            XRunResetOStep = 1;
                        }
                    }
                }
            }
            else
            {
                DZ_SetAlarmCode(ALARM_YuWei_Out_Limit);       //压脚要抬起
            }
        }
       //定位针
        if(M03)
        {
            M03 = 0;
            if(Y10)
                Y10 = 0;
            else if((Y07 && !Y04 && !Y05) || !Y07)
            {
                Y10 = 1;
            }
            else
            {
                DZ_SetAlarmCode(ALARM_DinWei_Out_Limit);        //定位针
            }
        }
       //压脚气缸
        if(M04)
        {
            M04 = 0;
            if(!Y04 && !Y05 && !Y07 &&
             (dwRealPosX <= (user_datas[72] - user_datas[13] -80)) )    //要加上褶宽电机位置限制
            {
                Y13 = !Y13;
            }
            else //压脚输出条件
            {
                DZ_SetAlarmCode(ALARM_YaJiao_Out_Limit);        //定位针
            }
        }

/*        if(M05)
        {
            M05=0;
            //AxisMovePoint(X_AXIS,2,2000);
            AxisMoveTwoPos(X_AXIS,2,2000,1,1000,DIR_N);
        }
        if(M06)
        {
            M06=0;
            //AxisMovePoint(X_AXIS,10,0);
            //AxisMoveTwoPos(X_AXIS,2,4000,20,4000,DIR_N);
        }*/

        //褶宽电机
        //if((XRunResetOStep == 0) && (XRunMovePosStep == 0) && (StartReadyStep == 0))
        {
            if(M05)
            {
                Y02 = 1;    //控制方向
                if(dwRealPosX >= user_datas[67])
                {
                    M05 = 0;
                    AxisEgmStop(X_AXIS);
                    XMoto_Flag = 0;
                }
                else if(XMoto_Flag == 0)
                {
                    XMoto_Flag = 1;
                    //                  X轴       运行速度                    启动速度        加速度  减速度
                    AxisContinueMoveAcc(X_AXIS,XMOTOR_HANDRUN_SPEED,DIR_P,XMOTOR_HANDRUN_SPEED/3,15,15);
                }
            }
            else if(M06)
            {
                Y02 = 0;    //控制方向
                if(X02)     //回到原点要停止
                {
                    M06 = 0;
                    AxisEgmStop(X_AXIS);
                    XMoto_Flag = 0;
                }
                else if(XMoto_Flag == 0)
                {
                    XMoto_Flag = 1;
                    //                  X轴       运行速度                    启动速度        加速度  减速度
                    AxisContinueMoveAcc(X_AXIS,XMOTOR_HANDRUN_SPEED,DIR_N,XMOTOR_HANDRUN_SPEED/3,15,15);
                }

            }
            else
            {
                AxisDecStop(X_AXIS);
                XMoto_Flag = 0;
            }
        }
        //褶距电机
       //if((YRunResetOStep == 0) && (YRunMovePosStep == 0) && (StartReadyStep == 0))
       {
           if(M07)
            {
                Y03 = 1;    //控制方向
                if(dwRealPosY >= user_datas[68])
                {
                    M07 = 0;
                    AxisEgmStop(Y_AXIS);
                    YMoto_Flag = 0;
                }
                else if(YMoto_Flag == 0)
                {
                    YMoto_Flag = 1;
                    //                Y轴       运行速度                    启动速度        加速度  减速度
                    AxisContinueMoveAcc(Y_AXIS,YMOTOR_HANDRUN_SPEED,DIR_P,YMOTOR_HANDRUN_SPEED/3,15,15);
                }
            }
            else if(M08)
            {

                Y03 = 0;    //控制方向
                if(X03)
                {
                    M08 = 0;
                    AxisEgmStop(Y_AXIS);
                }
                else if(YMoto_Flag == 0)
                {
                    YMoto_Flag = 1;
                    //                   Y轴       运行速度                    启动速度        加速度  减速度
                    AxisContinueMoveAcc(Y_AXIS,YMOTOR_HANDRUN_SPEED,DIR_N,YMOTOR_HANDRUN_SPEED/3,15,15);
                }
            }
            else
            {
                AxisDecStop(Y_AXIS);
                YMoto_Flag = 0;
            }
        }
        if(M14)
        {
            M14 = 0;
            XRunResetOStep = 1;         //两个轴回原点
        }
        if(M15)
        {
            M15 = 0;
            YRunResetOStep = 1;//两个轴回原点
        }
        //M16 M17为测试位置用
        if(M16)
        {
            M16 = 0;
            if(dwRealPosX < user_datas[70])
            {
                Y02 = 1;    //控制方向
                axis_cw(axis_x);
            }
            else
            {
                Y02 = 0;
                axis_ccw(axis_x);
            }
            XRunMovePosStep = 1;

            AxisMovePoint(X_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[70]);
//            AxisMovePosAccDec(X_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[70],XMOTOR_HANDRUN_SPEED/5,80,80 );
        }
        if(M17)
        {
            M17 = 0;
            if(dwRealPosY < user_datas[71])
            {
                Y03 = 1;    //控制方向
                axis_cw(axis_y);
            }
            else
            {
                Y03 = 0;
                axis_ccw(axis_y);
            }
            YRunMovePosStep = 1;
            AxisMovePoint(Y_AXIS,YMOTOR_HANDRUN_SPEED,user_datas[71]);
//            AxisMovePosAccDec(Y_AXIS,YMOTOR_HANDRUN_SPEED,user_datas[71],YMOTOR_HANDRUN_SPEED/5,80,80);
        }
        if(M09)
        {
            M09 = 0;
            //压脚回到原位并已抬起
            if(!Y04 && !Y05 && !Y10
               && X17 && Y13&& X14 && X15)
            {
                Y06 = 1;
                Y07 = 1;

                bDZJiaoZhunState = 1;
 //               bDZRunning = 1;
//                AutoRunStep = 2;
                //褶宽电机
                XRunMovePosStep = 1;
                if(dwRealPosX < user_datas[57])
                {
                    Y02 = 1;    //控制方向
                    axis_cw(axis_x);
                }
                else
                {
                    Y02 = 0;
                    axis_ccw(axis_x);
                }
                AxisMovePoint(X_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[57]);
                //褶距电机
                YRunMovePosStep = 1;
                if(dwRealPosY < user_datas[61])
                {
                    Y03 = 1;    //控制方向
                    axis_cw(axis_y);
                }
                else
                {
                    Y03 = 0;
                    axis_ccw(axis_y);
                }
                AxisMovePoint(Y_AXIS,YMOTOR_HANDRUN_SPEED,user_datas[61]);
            }
            else
            {
                DZ_SetAlarmCode(ALARM_Start_Limit);//起动条件
            }
        }
        if(M11)
        {
            M10 = 0;
            bDZJiaoZhunState = 0;
            bDZRunning = 0;
            StartReadyStep = 4; //变为正常加工位
        }
    }
    //停止循环运行模式
    if(SycleRunMode)
    {
        if(M23)
        {
            SycleRunMode=0;
            M23=0;
        }
    }
}

void BRUCE_DaZhe_AutoAction(void)
{
  unsigned short ch;
    if(bDZRunning)
    {
        switch(AutoRunStep)
        {
            case 1://褶宽电机,褶距电机定位
                AutoRunStep = 2;
                break;
            case 2:     //两个电机已经定位结束,等待脚踏
                if((!X_DRV) && (!Y_DRV))
                {
                    Y05 = 1;
                    AutoRunStep = 3;
                    AutoRunDelay = dwTickCount + 1500; //褶皱输出到位时间警告
                }
                break;
            case 3:
                if(!X06 && X07)
                {
                    AutoRunDelay = dwTickCount + user_datas[38]; //送料延时
                    AutoRunStep = 4;
                }
                else if(dwTickCount >= AutoRunDelay)
                {
                    DZ_SetAlarmCode(ALARM_ZheZhou_DaoWei);       //褶皱输出不到位
                    Y05 = 0;
                    bDZRunning = 0;
                    AutoRunStep = 0;
                }
                break;
            case 4:
                if(dwTickCount >= AutoRunDelay)
                {
  //                  if(M25)//为测试断点用
  //                  {
                        M25 = 0;
                        Y06 = 0;
                        Y07 = 0;
                        AutoRunStep = 5;
                        AutoRunDelay = dwTickCount + 1500; //移位回到位时间警告
    //                }
                }
                break;
            case 5:
                //移位回到原点
                if(!X13 && X12)
                {
 //                  if(M25)//为测试断点用
 //                 {
                        M25 = 0;
                        AutoRunStep = 6;
                        AutoRunDelay = dwTickCount + user_datas[39]; //定位针延时下降
 //                 }
                }
                else if(dwTickCount >= AutoRunDelay)
                {
                    DZ_SetAlarmCode(ALARM_ZheZhou_DaoWei);       //褶皱输出不到位
                    bDZRunning = 0;
                    AutoRunStep = 0;
                    XRunResetOStep = 1;         //褶宽回原点
                }
                break;
            case 6:
                if(dwTickCount >= AutoRunDelay)
                {
//  //                  if(M25)//为测试断点用
//  //                  {
                        M25 = 0;
                        Y10 = 1;
                        AutoRunStep = 7;
                        AutoRunDelay = dwTickCount + 1500; //定位针离开原点时间警告
//  //                  }
                }
                break;
            case 7:
                if(!X14)//定位针离开
                {
                    AutoRunDelay = dwTickCount + user_datas[66];
                    AutoRunStep = 8;
                }
                else if(dwTickCount >= AutoRunDelay)  //定位针没法离开
                {
                    DZ_SetAlarmCode(ALARM_FenZhen_YuanWei);       //定位针没法离开
                    Y10 = 0;
                    bDZRunning = 0;
                    AutoRunStep = 0;
                }
                break;
            case 8:
                if(dwTickCount >= AutoRunDelay)
                {

                        Y05 = 0;      //   褶皱气缸退
                        AutoRunStep = 9;
                        Y02 = 0;    //控制方向
                        axis_ccw(axis_x);
  //                      XRunMovePosStep = 1;
                        //电机离开
                        //两段速度移动距离,先快速回来只剩80MM时变为慢速
                        if(dwRealPosX > 120)
                            AxisMoveTwoPos(X_AXIS,XMOTOR_AUTORUN_SPEED,(dwRealPosX - 120),XMOTOR_HANDRUN_SPEED,150,DIR_N);

                        XRunResetOStep = 1;         //褶宽回原点
                    AutoRunDelay = dwTickCount + 1500;
                }
                break;
            case 9:
                if(X06 && !X07)         //褶皱气缸回到位
                {
                    if(1)
                    {
                        M25 = 0;
                        if(dwRealPosX <= (user_datas[72] - user_datas[13] -80))      //褶宽电机已经离开
                        {
                            Y13 = 0;    //关闭时压下
                            AutoRunStep = 10;
                            AutoRunDelay = dwTickCount + 700;
                        }
                    }
                }
                else if(dwTickCount >= AutoRunDelay)  //褶皱气缸回原位异常
                {
                    DZ_SetAlarmCode(ALARM_ZheZhou_YuanWei);
                    bDZRunning = 0;
                    AutoRunStep = 0;
                }
                break;
            case 10:
                if(!X17)   //压脚到位
                {
                    AutoRunStep = 11;
                    AutoRunDelay = dwTickCount + user_datas[40]; //定位针延时上升
                }
                else if(dwTickCount >= AutoRunDelay)  //压脚到位异常
                {
                    DZ_SetAlarmCode(ALARM_YaJiao_YuanWei);
                    bDZRunning = 0;
                    AutoRunStep = 0;
                }
                break;
            case 11:
                if(dwTickCount >= AutoRunDelay)  //延时退定位针
                {
                    AutoRunStep = 12;
                    Y10 = 0;
                    AutoRunDelay = dwTickCount + 700;
                }
                break;
            case 12:
                if(X14)         //定位针原位
                {
                    AutoRunStep = 13;
                    AutoRunDelay = dwTickCount + user_datas[41]; //延时启动加工
                }
                else if(dwTickCount >= AutoRunDelay)  //定位针回原位异常
                {
                    DZ_SetAlarmCode(ALARM_FenZhen_Left);       //定位针没法离开
                    Y10 = 0;
                    bDZRunning = 0;
                    AutoRunStep = 0;
                }
                break;
            case 13:
                if(dwTickCount >= AutoRunDelay)
                {
//                    if(M25)
//                    {
                        M25 = 0;
                        AutoRunStep = 14;
                        Y12 = 1;
                        AutoRunDelay = dwTickCount + 40; //延时启动加工
//                    }
                }
                break;
            case 14:
                if(dwTickCount >= AutoRunDelay)
                {
                    AutoRunStep = 15;
                    Y12 = 0;
                }
                break;
            case 15:
                if(X15_UP)      //加工结束后
                {
                    AutoRunStep = 16;
                    AutoRunDelay = dwTickCount + 60;
                }
                break;
            case 16:
                if(dwTickCount >= AutoRunDelay)
                {
                    AutoRunStep = 17;
                    Y13 = 1;            //
                    AutoRunDelay = dwTickCount + 700;
                }
                break;
            case 17:
                if(X17) //压脚上升到位
                {
                    if(XRunResetOStep== 0)
                    {
                        Y06 = 1;    //移位退出
                        Y07 = 1;
                        AutoRunStep = 18;
                        //电机回到褶宽处
                        StartReadyStep = 4;
                        AutoRunDelay = dwTickCount + 1500;
                    }
                }
                else if(dwTickCount >= AutoRunDelay)  //压脚原位异常
                {
                    DZ_SetAlarmCode(ALARM_YaJiao_YuanWei);       //压脚原位
                    bDZRunning = 0;
                    AutoRunStep = 0;
                }
                break;
            case 18:
                if(X13 && !X12)
                {
                    if(!X_DRV && (StartReadyStep == 0))
                    {
                        if(SycleRunMode)
                        {
                            AutoRunStep = 19;
                            AutoRunDelay = dwTickCount + 1500;
                        }
                        else
                        {
                            bDZRunning = 0;
                            AutoRunStep = 0;
                        }
                        runcount++;
                        user_datas[74] = runcount&0xffff;
                        user_datas[75] = (runcount>>16)&0xffff;
                    }
                }
                else if(dwTickCount >= AutoRunDelay)
                {
                    DZ_SetAlarmCode(ALARM_YuWei_DaoWei);       //移位输出不到位
                }
                break;
            case 19:
                if(dwTickCount >= AutoRunDelay)
                {
                    bDZRunning = 1;
                    AutoRunStep = 1;
                }
                break;
        }
    }
}

// 检测是否踏了脚踏开关
void BRUCE_DaZheJiCheckStart(void)
{
    unsigned short ch;

 //停止
    if(X11_UP || M26)
    {
        M26 = 0;
        AxisEgmStop(X_AXIS);
        AxisEgmStop(Y_AXIS);
        bDZRunning = 0;
        bDZJiaoZhunState = 0;
        AutoRunStep = 0;
        XRunResetOStep = 0;
        XRunMovePosStep = 0;
        YRunResetOStep = 0;
        YRunMovePosStep = 0;
        StartReadyStep = 0;
    }
}












unsigned char ComPareLength(void)
{

}
//基准
void  DaZheJi_JiZhun(void)
{
        static long save_buff,gou_zhen_buff,zipper_length_buff;
	static unsigned long zipper_length;
        short *revise_buff;


}


 //    SetAlarmCode(MXC_ALARM_ADDR,0);    //警告清零
    //基准参数没设定的情况下要配默认值
    //压脚回到原位并已抬起
//    if(!Y04 && !Y05 && !Y10 && !Y06 && !Y07 && X12
//       && X14 && X15)
//    {
//        Y13 = 1;
//    }
//系统上电复位
void  RetSetSyStem(void)
{
    switch(ReSetSysTemStep)
    {
        case 1:
            //上电回位
            XRunResetOStep = 1;//褶宽电机回原点
            YRunResetOStep = 1;//褶距电机回原点启动
            ReSetSysTemStep = 2;
            break;
        case 2:
            if(!X_DRV && !Y_DRV && (AutoRunStep == 0))
            {
                if(X15) //
                {
                    ReSetSysTemStep = 2;
                }
                else
                {
                    Y04 = 0;
                    Y05 = 0;
                    Y06 = 0;
                    Y07 = 0;
                    Y10 = 0;
                    ReSetSysTemStep = 2;
                }
            }
            break;
        case 3:
            break;
    }
}
//启动准备
void StartReady(void)
{
  unsigned short ch;
    switch(StartReadyStep)
    {
        case 1:
            Y12 = 1;
            cDelayTime4 = dwTickCount + 50;
            StartReadyStep = 2;
            break;
        case 2:
            if((dwTickCount >= cDelayTime4))
            {
                Y12 = 0;
                StartReadyStep = 3;
            }
            break;
        case 3:
          if(X15_UP)  //机台回到准备就绪点
            {
                Y13 = 1;        //压脚抬起
                StartReadyStep = 4;
            }
            break;
        case 4:
            if(X17)
            {
                StartReadyStep = 5;
               //褶宽电机位置动作
                if(dwRealPosX < user_datas[72])
                {
                    Y02 = 1;    //控制方向
                    AXIS_SET_DIR(axis_x,DIR_P);
                }
                else
                {
                    Y02 = 0;
                    AXIS_SET_DIR(axis_x,DIR_N);
                }
                if(dwRealPosY < user_datas[73])
                {
                    Y03 = 1;    //控制方向
                     AXIS_SET_DIR(axis_y,DIR_P);
                }
                else
                {
                    Y03 = 0;
                    AXIS_SET_DIR(axis_y,DIR_N);
                }
                if(bDZJiaoZhunState)
                {
                    AxisMovePoint(X_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[57]);
                    AxisMovePoint(Y_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[61]);
                }
                else
                {
                    if(dwRealPosX != user_datas[72])
                        AxisMovePoint(X_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[72]);  //褶宽电机回到加工位
                    if((dwRealPosY != user_datas[73]) || (dwRealPosY == 0))
                        AxisMovePoint(Y_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[73]);  //褶距电机回到加工位
                }
                Y06 = 1;
                Y07 = 1;
            }
            break;
        case 5:
            if(!X_DRV && !Y_DRV)
            {
                StartReadyStep = 0;
            }
            break;
        //系统复位
  //          if(!X17 && !Y07 && X06 && !Y04 && !Y05 && !X_DRV
               //   移动限位 定位针原位
  //             && !X13 && X12 && X14)
        case 20:
            if(X15)
            {
                Y13 = 1;
            }
            if(X17)
            {
                StartReadyStep = 21;
                Y04 = 0;
                Y05 = 0;
                Y06 = 1;
                Y07 = 1;
            }
            break;
        case 21:
            if(X17)
            {
                StartReadyStep = 22;
                //褶宽电机位置动作
                if(dwRealPosX < user_datas[72])
                {
                    Y02 = 1;    //控制方向
                    AXIS_SET_DIR(axis_x,DIR_P);
                }
                else
                {
                    Y02 = 0;
                    AXIS_SET_DIR(axis_x,DIR_N);
                }
                if(dwRealPosY < user_datas[73])
                {
                    Y03 = 1;    //控制方向
                     AXIS_SET_DIR(axis_y,DIR_P);
                }
                else
                {
                    Y03 = 0;
                    AXIS_SET_DIR(axis_y,DIR_N);
                }
                if(bDZJiaoZhunState)
                {
                    AxisMovePoint(X_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[57]);
                    AxisMovePoint(Y_AXIS,YMOTOR_HANDRUN_SPEED,user_datas[61]);
                }
                else
                {
                    if(dwRealPosX != user_datas[72])
                    {
                        AxisMovePoint(X_AXIS,XMOTOR_HANDRUN_SPEED,user_datas[72]);  //褶宽电机回到加工位
                    }
                        //                 if(!bDZRunning)
                    AxisMovePoint(Y_AXIS,YMOTOR_HANDRUN_SPEED,user_datas[73]);  //褶距电机回到加工位
                }

            }
            break;
        case 22:
            if(!X_DRV && !Y_DRV)
            {
                StartReadyStep = 0;
 //               AutoRunStep = 1;
//                bDZRunning = 1;
            }
            break;

        case 30://关机动作流程
            if(!X13 && X12)
            {
                StartReadyStep = 31;
                XRunResetOStep = 1;
            }
            else
            {
                if(X15 && Y13 && X17)//移动气缸归位条件满足
                {
                    Y06 = 0;
                    Y07 = 0;
                    if(!Y06 && !Y05)
                    {
                        if(user_datas[72] > (user_datas[13] + 80))
                        {
                            ch = user_datas[72]- user_datas[13] - 80;
                            if(dwRealPosX > ch)
                            {
                                Y02 = 0;
                                XRunResetOStep = 1;
                            }
                        }
                    }
                    StartReadyStep = 31;
                }
                else
                {
                    DZ_SetAlarmCode(ALARM_YuWei_Out_Limit);       //压脚要抬起
                }
            }
            break;
        case 31:
            if(!X13 && X12 && (XRunResetOStep == 0))//移动气缸原点
            {
                M21=0;//停机状态显示
                ShutDownDelay = dwTickCount + 2000;
                StartReadyStep = 32;
            }
            break;
        case 32:
            if(dwTickCount >= ShutDownDelay)
            {
                Y14=1;//断电
                Y15=1;//断电
                StartReadyStep=0;
            }
           break;

        case 40://离机复位
            if(!X13 && X12)
            {
                StartReadyStep = 41;
                XRunResetOStep = 1;
            }
            else
            {
                if(X15 && Y13 && X17)//移动气缸归位条件满足
                {
                    Y06 = 0;
                    Y07 = 0;
                    if(!Y06 && !Y05)
                    {
                        if(user_datas[72] > (user_datas[13] + 80))
                        {
                            ch = user_datas[72]- user_datas[13] - 80;
                            if(dwRealPosX > ch)
                            {
                                Y02 = 0;
                                XRunResetOStep = 1;
                            }
                        }
                    }
                    StartReadyStep = 41;
                }
                else
                {
                    DZ_SetAlarmCode(ALARM_YuWei_Out_Limit);       //压脚要抬起
                }
            }
            break;
        case 41:
            if(!X13 && X12 && (XRunResetOStep == 0))//移动气缸原点
            {
                Y13=0;//压脚压下
                StartReadyStep = 42;
            }
            break;
        case 42:
            if(!X17)//压脚压下到位
            {
                M21=0;//停机状态显示
                StartReadyStep = 0;
            }
            break;
    }
}

//故障报警
void BRUCE_DaZheJi_CheckAlarm(void)
{
    static unsigned long alarmdelay1,alarmdelay2,alarmdelay3,alarmdelay4,alarmdelay5,alarmdelay6;
    //褶皱传感器原点故障
    if((Y05 && X06)||(!Y05 && !X06))
    {
       if(dwTickCount > alarmdelay1 + 2000)
       {
           DZ_SetAlarmCode(ALARM_ZheZhou_CGQ_YuanDian);
       }
    }
    else
    {
        alarmdelay1=dwTickCount;
    }
    //褶皱传感器到位故障
    if((Y05 && !X07)||(!Y05 && X07))
    {
       if(dwTickCount > alarmdelay2 + 2000)
       {
           DZ_SetAlarmCode(ALARM_ZheZhou_CGQ_Daowei);
       }
    }
    else
    {
        alarmdelay2=dwTickCount;
    }
    //移位传感器原点故障
    if((Y07 && X12)||(!Y07 && !X12))
    {
        if(dwTickCount > alarmdelay3 + 2000)
       {
           DZ_SetAlarmCode(ALARM_YiWei_CGQ_YuanDian);
       }
    }
    else
    {
        alarmdelay3=dwTickCount;
    }
    //移位传感器到位故障
    if((Y07 && !X13)||(!Y07 && X13))
    {
        if(dwTickCount > alarmdelay4 + 2000)
       {
           DZ_SetAlarmCode(ALARM_YiWei_CGQ_Daowei);
       }
    }
    else
    {
        alarmdelay4=dwTickCount;
    }
    //定位针传感器故障
    if((Y10 && X14)||(!Y10 && !X14))
    {
        if(dwTickCount > alarmdelay5 + 2000)
       {
           DZ_SetAlarmCode(ALARM_DingWeiZhen_CGQ);
       }
    }
    else
    {
        alarmdelay5=dwTickCount;
    }
    //压脚传感器故障
    if((Y13 && !X17)||(!Y13 && X17))
    {
        if(dwTickCount > alarmdelay6 + 2000)
       {
           DZ_SetAlarmCode(ALARM_YaJiao_CGQ);
       }
    }
    else
    {
        alarmdelay6=dwTickCount;
    }

}

#endif
