
#if FU_XIAO_WEI_MACHINE==1

extern void XYChuanTou_HeLian_InitAction(void);
extern void XYChuanTou_HeLian_Action(void);
extern void XYChuanTou_HeLian_SetAlarmCode(unsigned alarm_code);
extern void ExtiAcitionX02(void);
extern void XY_CTHL_Action(void);
extern void XY_CTHL_InitAction(void);

#define DIR_P 1
#define DIR_N 0

#define MOTOR_EN 0
#define MOTOR_DISEN 1

#define MOTOR_ALARM 0
#define MOTOR_NOALARM 1

#define XY_CTHL_VAVLE_ERROR_TIME   3000 
#define XY_CTHL_MOTOR_ALARM_TIME   5000

//故障代码列表
#define XY_CTHL_NO_ALARM                0
#define XY_CTHL_WLZDTJ_ALARM            1   //无拉链自动停机
#define XY_CTHL_FKGYYC_Limit_ALARM      2   //感应不到方块或方块感应异常
#define XY_CTHL_TLiao_Limit_ALARM       3   //X04推料到位异常
#define XY_CTHL_COLOR_IN_ALARM          4   //X24色标感应停机
#define XY_CTHL_HSLiao_Limit_ALARM      5   //X06横送料到位异常
#define XY_CTHL_HSLiao_Origin_ALARM     6   //X07横送料原位异常
#define XY_CTHL_JLiao_Limit_ALARM       7   //X10接料到位异常
#define XY_CTHL_CTM_Limit_ALARM         8   //X11穿头模到位异常
#define XY_CTHL_CTM_Origin_ALARM        9   //X12穿头模原位异常
#define XY_CTHL_First_CT_Origin_ALARM   10  //X13一次穿头原位异常
#define XY_CTHL_LTou_Check_ALARM        11   //X14拉头缺料感应异常
#define XY_CTHL_CXSC_Limit_ALARM        12   //X15插稍上止感应异常
#define XY_CTHL_CX_Limit_ALARM          13   //X16插稍到位感应异常
#define XY_CTHL_XKTD_Origin_ALARM       14   //X17斜口原位感应异常
#define XY_CTHL_CXXY_Limit_ALARM        15   //X20插稍下移到位异常
#define XY_CTHL_SF_ALR_ALARM            16   //X22伺服报警异常
#define XY_CTHL_SF_Origin_ALARM         17   //X23伺服原位(穿链原位)异常
#define XY_CTHL_ZLT_ALARM               18   //装拉头异常
#define XY_CTHL_FK_Check_ALARM          19   //X02方块检测
#define XY_CTHL_FKCXDW_ALARM            20   //方块插销定位异常警告
#define XY_CTHL_YCCRYWYC_ALARM          21   //一次穿入原位异常
#define XY_CTHL_XCXXCYC_ALARM           22   //小插销行程异常
#define XY_CTHL_HENSONGLIAO_ALARM       23   //横送料不能输出
#define XY_CTHL_YCCT_ALARM              24   //一次穿头不能输出
#define XY_CTHL_YCXM_Origin_ALARM       25   //下模不能输出
#define XY_CTHL_DXKCTXM_Origin_ALARM    26   //顶斜口不能输出
#define XY_CTHL_XKTD_ALARM              27   //斜口推带不能有输出
#define XY_CTHL_CXQJD_ALARM             28   //插销前夹带不能有输出
#define XY_CTHL_WFZIDONGCX_ALARM         29   //无法自动插销
#define XY_CTHL_SafeDoor_ALARM           30    //安全门关上才能启动

#define XY_CTHL_AutoStep            cStepMByte
#define XY_CTHL_ZhuangLiaoStep      cStepMByte1
#define XY_CTHL_TLiaoStep           cStepMByte2
#define XY_CTHL_TD_MotorStep        cStepMByte3     //拖带电机
#define XY_CTHL_JiaLianStep         cStepMByte4
#define XY_CTHL_ZhenDongStep        cStepMByte6
#define XY_CTHL_SongLiaoStep        cStepMByte7
#define XY_CTHL_CL_MotorStep        cStepMByte8     //穿链
#define XY_CTHL_AutoStep1           cStepMByte9
#define XY_CTHL_bFKCXTDDW_Step      cStepMByte10    
#define XY_CTHL_bCXCR_Step          cStepMByte11
#define XY_CTHL_bCLFirst_Step       cStepMByte12
#define XY_CTHL_ColorStep           cStepMByte13
#define XY_CTHL_ShiJueStep           cStepMByte14
#define XY_CTHL_ShiJueStep1           cStepMByte15


#define XY_CTHL_ZhuangLiaoDelay      cDelayTime2
#define XY_CTHL_TLiao_Delay          cDelayTime3
#define XY_CTHL_TD_MotorDelay        cDelayTime4
#define XY_CTHL_AutoDelay            cDelayTime5
#define XY_CTHL_TestDelay            cDelayTime6
#define XY_CTHL_CL_MotorDelay        cDelayTime7
#define XY_CTHL_TouchDelay           cDelayTime8
#define XY_CTHL_AutoDelay1           cDelayTime9
#define XY_CTHL_ZDP_Delay            cDelayTime10
#define XY_CTHL_bCXCR_Delay          cDelayTime11
#define XY_CTHL_bFKCXTDDW_Delay      cDelayTime12
#define XY_CTHL_bCLFirst_Delay       cDelayTime13
#define XY_CTHL_bLTCHECK_Delay       cDelayTime14
#define XY_CTHL_bSFBBAOJIN_Delay      cDelayTime15
#define XY_CTHL_bTFKGD_Delay      cDelayTime16
#define XY_CTHL_bXiaMoSJ_Delay      cDelayTime17
#define XY_CTHL_btest_Delay      cDelayTime18
#define XY_CTHL_bColor_Delay      cDelayTime19
#define XY_CTHL_ZDP_auto_Delay      cDelayTime20
#define XY_CTHL_SQJD_Delay      cDelayTime21
#define XY_CTHL_ShiJue_Delay      cDelayTime22
#define XY_CTHL_ShiJue_Delay1      cDelayTime23
#define XY_CTHL_ShiJue_Delay2      cDelayTime24

//32位无符号变量
#define XY_CTHL_LianLengthCheck               cUDword32Buff1
#define XY_CTHL_LianLengthAutoCheck           cUDword32Buff2
#define XY_CTHL_LianLengthAutoCheckOLD         cUDword32Buff3
#define XY_CTHL_LianLengthAutoCheckERROR       cUDword32Buff4
#define XY_CTHL_LianLengSave                   cUDword32Buff5
#define XY_CTHL_testDCF                       cUDword32Buff6
#define XY_CTHL_LianLengthAutoCheckthree       cUDword32Buff7
#define XY_CTHL_LianLengthCheckOLD               cUDword32Buff8
#define XY_CTHL_LianLengthNEWCheck               cUDword32Buff9
//32位有符号变量
#define XY_CTHL_XSavePosBuff        cDword32Buff1
#define XY_CTHL_X_CXPosBuff         cDword32Buff2
#define XY_CTHL_YSavePosBuff        cDword32Buff3
#define XY_CTHL_CheckInX02PosBuff   cDword32Buff4
#define XY_CTHL_YsaveCXDWPosBuff   cDword32Buff5
#define XY_CTHL_LENTH              cDword32Buff6

#define XY_CTHL_Y_CL_Length         cDword32Buff8


//8位变量
#define XY_CTHL_TryCnt              cCharBuff1
#define XY_CTHL_cZipCnt                     cCharBuff2
#define cStopInCnt                  cCharBuff3
#define cStopMode                   cCharBuff4
#define cXcxcrCnt                   cCharBuff5
#define cWULATOUCnt                   cCharBuff6
#define cZDP_Auto                   cCharBuff7
#define cQDXK_DXK                   cCharBuff8
#define cBanAuTo                   cCharBuff9
#define cXiaoChaTest                   cCharBuff10
#define cXiaoChaCNT                   cCharBuff11
#define cBAOHUCNT                   cCharBuff12
#define cCHULIANBAOJIN                       cCharBuff13
#define cZhouWanone                       cCharBuff14
#define cZhouWantwo                       cCharBuff15
#define cXMdelay                       cCharBuff16
#define cXCXQXQD                       cCharBuff17
#define cJACEXIAOCA                       cCharBuff18
#define cTIMEONE                       cCharBuff19
#define cDLPONE                       cCharBuff20
#define cHeLian                       cCharBuff21
#define cHeLianone                       cCharBuff22
#define cStopGN                       cCharBuff23
#define cCXCONE                       cCharBuff24
#define cSTOPLENGTH                       cCharBuff25
#define cONERROR                       cCharBuff26
#define ctwoone                       cCharBuff27
#define cShiJue                       cCharBuff28
//位标志位
#define bTuiLaTouOkFlg              bBitFlag0
#define bZhuangLiaoOkFlg            bBitFlag1
#define bXiaMoENFlg                 bBitFlag2
#define bYFirstDingWeiFlg           bBitFlag3
#define bCL_EN_FLG                  bBitFlag4
#define bCL_OK_FLG                  bBitFlag5
#define bCheckEN_FLG                bBitFlag6
#define bSingOneFlg                 bBitFlag7  


#define XY_CTHL_TOTAL_ADDR  76

#define XY_CTHL_SPEED_ADDR     78
#define XY_CTHL_ALARM_ADDR     100
#define XY_CTHL_TRUST_ALARM_ADDR     102
#define XY_CTHL_TEST_ALARM_ADDR       106
//104、105地址 作产量锁

#define XY_CTHL_PARAM_CYCLE_PULSE       user_datas[0]//0 转一圈脉冲数  
#define XY_CTHL_PARAM_CYCLE_LENGTH      user_datas[1]//整数 转一圈拖带多长 
#define XY_CTHL_PARAM_SFCYCLE_LENGTH    user_datas[36] //伺服电机周长
#define XY_CTHL_PARAM_TD_RunSpeed       user_datas[2]//整数 拖带电机拖带速度
#define XY_CTHL_PARAM_FKDW_Speed        user_datas[3]//整数 方块定位速度(低速度)
#define XY_CTHL_PARAM_CL_Speed          user_datas[4]//整数 合链速度
#define XY_CTHL_PARAM_CL_Back_O_Speed   user_datas[5]//整数 合链电机回零速度
#define XY_CTHL_PARAM_FKDW_Length       user_datas[6]//0.01 方块定位长度
#define XY_CTHL_PARAM_CXDW_Length       user_datas[7]//0.01 插销定位长度
#define XY_CTHL_PARAM_CL_Length         user_datas[8]//0.01 合链长度
#define XY_CTHL_PARAM_CL_MAX_Length     user_datas[9]//0.01 穿链最长限制
#define XY_CTHL_PARAM_TLiao_BACKDELAY   (10*user_datas[10])//0.01推拉头到位延时返回
#define XY_CTHL_PARAM_MaGou_DELAY      (10*user_datas[11])//0.01接料到位延时码勾
#define XY_CTHL_PARAM_HSLiaoOff_DELAY   (10*user_datas[12])//0.01码勾输出后退横送料
#define XY_CTHL_PARAM_CheckLT_DELAY     (10*user_datas[13])//0.01码勾输出后延时检测拉头
#define XY_CTHL_PARAM_HL_BACK_Time      (10*user_datas[14])//0.01合链气缸返回时间
#define XY_CTHL_PARAM_First_CL_Timer    (10*user_datas[15])    //0.01一次穿入时间
#define XY_CTHL_PARAM_MGOff_XiaMo_DELAY (10*user_datas[16])     //0.01松码勾后延时退下模
#define XY_CTHL_PARAM_SCDWOff_CXDW_DELAY        (10*user_datas[17])    //0.01插销延时穿入
#define XY_CTHL_PARAM_XKDW_TD_DELAY        (10*user_datas[18])    //0.01斜口定位后延时拖带
#define XY_CTHL_PARAM_XK_CR_DELAY        (10*user_datas[19])    //0.01斜口延时穿拉头
#define XY_CTHL_PARAM_DXK_XKDW_Off_DELAY (10*user_datas[20])    //0.01顶斜口后延时退斜口定位
#define XY_CTHL_PARAM_XCQJD_XCDW_DELAY      (10*user_datas[21])    //0.01插销前夹带后延时插销定位
#define XY_CTHL_PARAM_First_CL_DELAY        (10*user_datas[22])    //0.01延时一次穿入
#define XY_CTHL_PARAM_HLJJ_CL_DELAY        (10*user_datas[23])    //0.01合链夹具延时穿入   
#define XY_CTHL_PARAM_ZDP_Start_TIME      (10*user_datas[24])      //0.01振动盘启动延时  
#define XY_CTHL_PARAM_ZDP_Stop_TIME       (10*user_datas[25])       //0.01振动盘延时停止 
#define XY_CTHL_PARAM_XCX_LENTH           user_datas[26]       //0.01 小插销感应后再走标准长度 
#define XY_CTHL_PARAM_XCXWC_LENTH          user_datas[27]       //0.01 小插销标准长度过长的误差值 
#define XY_CTHL_PARAM_TDFZ_LENTH          user_datas[28]       //0.01拖带电机反转长度
#define XY_CTHL_PARAM_WLCDSHEZHI_LENTH   (10* user_datas[29])       //0.1无拉链情况再走长度设置
#define XY_CTHL_PARAM_DXKFZ_LENTH         user_datas[30]       //顶斜口反转长度
#define XY_CTHL_PARAM_DXKYS_DELAY         (user_datas[31]*10)  //前顶斜口后延时顶斜口
#define XY_CTHL_PARAM_ZDP_AUTO                       user_datas[32]  //振动盘控制按钮
#define XY_CTHL_PARAM_CXXY_MODE                      user_datas[33]  //插销下移切换 0直插、1下移
#define XY_CTHL_PARAM_FKJD_DELAY                       (user_datas[34]*10) //延时方块夹带
#define XY_CTHL_PARAM_FKGD_DELAY                       (user_datas[35]*10) //延时方块固定
#define XY_CTHL_PARAM_AUTO_MODE                       user_datas[37] //合拉头测长模式
//#define XY_CTHL_PARAM_SDCFXM_MODE                       user_datas[38] //双电磁阀下模
#define XY_CTHL_PARAM_NLSL_MODE                       user_datas[39] //尼龙塑料切换 0塑料/1尼龙
#define XY_CTHL_PARAM_HLTSY_LENTH                       (user_datas[40]*10)  //合拉头剩余长度
#define XY_CTHL_PARAM_CR_MODE                       1  //1为电机穿入，0为气缸穿入
#define XY_CTHL_PARAM_BanZiDong                    user_datas[41]
#define XY_CTHL_PARAM_CLT_Time           (10*user_datas[42])//0.01 合链时间
#define XY_CTHL_PARAM_XCCR_DEALY                      (user_datas[43]*10)  //小插下移延时/定位延时
#define XY_CTHL_PARAM_DYTLL_LENTH                      user_datas[44] 
//#define XY_CTHL_PARAM_XCCR_DEALY                      user_datas[45]  //切换公司简介

#define XY_CTHL_PARAM_CXTHREE_MODE                      user_datas[46] //小插三次切换
#define XY_CTHL_PARAM_DB_MODE                        0//user_datas[47]  //DB切换 0为DB口、1为IO口
#define XY_CTHL_PARAM_FKJDSECONG_DEALY                      (user_datas[48]*10)  //拖带方块夹带延时
#define XY_CTHL_ANQUANMEN_MODE                      user_datas[49] //安全门切换
#define XY_CTHL_AUTO_run_LENGTH                      user_datas[50] //色标感应后再走长度
#define XY_CTHL_MotorChose_MODE                  0//    user_datas[51] //伺服 步进
#define XY_CTHL_DLPJG_TIME                      (user_datas[52]*10) //打拉片时间
#define XY_CTHL_PARAM_DALIAOPIAN                 user_datas[53] //打拉片模式
#define XY_CTHL_PARAM_COLOR_CODE               0// user_datas[54] //色标感应 /0无  1 有
#define XY_CTHL_PARAM_SD_LENGTH                user_datas[55] //提前退松带气缸长度
#define XY_CTHL_PARAM_SD_MODE                   user_datas[56] //提前退松带模式

#define XY_CTHL_PARAM_LXC_SPEED              user_datas[58] //拉小插速度
#define XY_CTHL_PARAM_BanAuto_MODE                   user_datas[59] //半自动 模式切换
//#define XY_CTHL_PARAM_first_SPEED                 7500//  user_datas[60] //半自动 模式切换
#define XY_CTHL_PARAM_TQJD_DELAY                   (user_datas[61]*10) //延时退前夹带
#define XY_CTHL_PARAM_STOP_length                   user_datas[62] //提前停机长度
#define XY_CTHL_PARAM_XCDWGY_MODE                  user_datas[63] //小插到位感应切换
#define XY_CTHL_PARAM_XCGY_MODE                 user_datas[64] //小插到位感应切换
//视觉模式参数
#define XY_CTHL_PARAM_SHIJUE_MODE                 0//user_datas[65] //视觉模式
#define XY_CTHL_PARAM_JIANCHE_DEALY                (user_datas[66]*10) //延时输出检测
#define XY_CTHL_PARAM_DingLT_time                 (user_datas[67]*10) //顶拉头时间
#define XY_CTHL_PARAM_GBXIANZZHI_DEALY              (user_datas[68]*10)//延时关闭限制
#define XY_CTHL_PARAM_DKXIANZZHI_DEALY              (user_datas[69]*10)//延时打开限制
#define XY_CTHL_PARAM_GBJIANCHE_DEALY           (user_datas[70]*10)//延时关闭限制
#define XY_CTHL_PARAM_DINGLTOU_DEALY            (user_datas[71]*10)//延时输出顶拉头
#define XY_CTHL_PARAM_ShiJue                    user_datas[72] //视觉控制
#define XY_CTHL_SHIJUE_ONE                      0  //1为视觉模式，0为正常模式
//速度调试参数
#define XY_CTHL_XCCR_SPEED                      user_datas[150] //小插穿入速度
#define XY_CTHL_XCCR_LENGTH                     user_datas[151] //小插穿入长度
#define XY_CTHL_PARAM_first_SPEED               user_datas[152] //]第一条速度
#define XY_CTHL_PARAM_first_LENGTH              user_datas[153] //第一条定位长度
#define XY_CTHL_StopSlow_LENGTH                 user_datas[154] //减速停机长度
#define XY_CTHL_GYHKSD_SPEED                    user_datas[155] //感应后速度

//输入


#define XY_CTHL_START_IN                M0384// X00启动       //M0386 //X02  //启动
#define XY_CTHL_START_IN_UP             (M0384 && !OLDM384)
#define XY_CTHL_STOP_IN                 M0385//X01停止       //M0395 // X13  //停止
#define XY_CTHL_STOP_IN_UP              (M0385 && !OLDM385)//(M0395 && !OLDM395)
#define XY_CTHL_STOP_IN_DW              (!M0385 && OLDM385)//(!M0395 && OLDM395)
#define XY_CTHL_FK_Check                M0386//X02过链方块感应//M0384   //X00方块检测
#define XY_CTHL_FK_Check_UP             (M0386 && !OLDM386)//
#define XY_CTHL_FK_Check_DW             (!M0386 && OLDM386)
#define XY_CTHL_XKSC_Limit_IN           M0387//X03斜口上止定位接近开关   //M0385   //X01斜口上止到位
#define XY_CTHL_XKTD_Origin_IN          M0388//X04斜码推带原位           //M0398   //X16斜口推带原位感应
#define XY_CTHL_HSLiao_Origin_IN        M0389//X05横送拉头原位           //M0387   //X03横送料原位
#define XY_CTHL_HSLiao_Limit_IN         M0390//X06横送拉头到位           //M0388   //X04横送料到位
#define XY_CTHL_TLiao_Origin_IN         M0391//X07推拉头原位             //M0392   //X10推料原位        原来是到位
#define XY_CTHL_First_CT_Origin_IN      M0392//X10一次穿入到位感应       //M0391   //X07一次穿头原位
#define XY_CTHL_CX_Limit_IN             M0393//X11小插分针到位感应       //M0396   //X14插稍到位感应
#define XY_CTHL_LTou_Check              M0394//X12马钩检测缺料感应       //M0394   //X12拉头缺料感应
#define XY_CTHL_JLiao_Limit_IN          M0395//X13接拉头到位感应         //M0400   //X20接料到位
#define XY_CTHL_CTM_Limit_IN            M0396//X14下模到位感应（下降）   //M0390   //X06穿头模到位
#define XY_CTHL_CTM_Origin_IN           M0397//X15下模原位（下降）       //M0401   //X21穿头模原位
#define XY_CTHL_CXSC_Limit_IN           M0398//X16小插过链感应           //M0397   //X15插稍上止感应
#define XY_CTHL_CXSC_Limit_IN_UP        (M0398 && !OLDM398)
#define XY_CTHL_CXSC_Limit_IN_DW        (!M0398 && OLDM398)

#define XY_CTHL_CXXY_Origin_IN          M0399//X17小插推到位感应         //M0399   //X17插稍下移到位
#define XY_CTHL_SafeDoor_IN             M0400//X20安全门                 //M0403   //X23安全门
#define XY_CTHL_SafeDoor_IN_DW          (!M0400 && OLDM400)
#define XY_CTHL_ZDP_IN                  M0401//X21振动盘启动感应         //M0389   //X05振动盘
#define XY_CTHL_SF_Origin_IN            M0402// M0400// M0400//X22合链电机原位           //M0393   //X11伺服原位(合链原位)
#define XY_CTHL_SF_ALR_IN               M0403// M0400//X23伺服报警               //M0402   //X22伺服报警
#define XY_CTHL_Colorcode_IN            M0404//X24色标感应关            //M0404   //X24色标感应
#define XY_CTHL_Colorcode_IN            M0404   //X24色标感应
#define XY_CTHL_Colorcode_IN_UP         (M0404 && !OLDM404)


//输出                                         后面屏蔽部分为原来输出点
#define XY_CTHL_CTXM_VAVLE              M0304//Y00 下模电磁阀            //M0304  //Y00 穿头下模电磁阀
#define XY_CTHL_JLTou_VAVLE             M0305//Y01 接拉头电磁阀         //M0319  //Y17 接拉头电磁阀
#define XY_CTHL_CXDWZ_VAVLE             M0306//Y02小插分针电磁阀        //M0312  //Y10 插销定位针(到位)电磁阀
#define XY_CTHL_First_CT_VAVLE          M0307//Y03一次穿头电磁阀        //M0318  //Y16 一次穿头电磁阀
#define XY_CTHL_MGuo_VAVLE              M0308//Y04码勾电磁阀            //M0317  //Y15 码勾电磁阀
#define XY_CTHL_CXSCDW_VAVLE            M0309//Y05小插上止定位电磁阀    //M0324  //Y24 插销上止定位电磁阀 
#define XY_CTHL_CXXY_VAVLE              M0310//Y06推小插电磁阀          //M0313  //Y11 插销下移电磁阀
#define XY_CTHL_CXQJD_VAVLE             M0311//Y07小插前夹带电磁阀      //M0323  //Y23 插销前夹带电磁阀
#define XY_CTHL_HLJJ_VAVLE              M0312//Y10合链夹具电磁阀        //M0325  //Y25 合链夹具电磁阀
 //                                     M0313//Y11下模活动电磁阀
#define XY_CTHL_CXHJD_VAVLE             M0314//Y12小插后夹带电磁阀      //M0307  //Y03 插销后夹带电磁阀
#define XY_CTHL_CXHDW_VAVLE             M0315//Y13后拉小插穿入电磁阀    //M0306  //Y02 插销后定位电磁阀
#define XY_CTHL_FKJD_VAVLE              M0316//Y14方块后夹带电磁阀      //M0305  //Y01 方块夹带电磁阀
#define XY_CTHL_FKGD_VAVLE              M0317//Y15固定方块电磁阀        //M0310  //Y06 方块固定电磁阀
#define XY_CTHL_QDXK_VAVLE              M0318//Ｙ１６前顶斜口电磁阀 外        //M0327  //Y27 前顶斜口电磁阀
#define XY_CTHL_XKDW_VAVLE              M0319//Y１７斜码钩定位电磁阀      //M0311  //Y07 斜口定位电磁阀
#define XY_CTHL_XKTD_VAVLE              M0320//Y20推带电磁阀            //M0309  //Y05 斜口推带电磁阀
#define XY_CTHL_DXK_VAVLE               M0321//Y21推斜码电磁阀          //M0320  //Y20 顶斜口电磁阀
#define XY_CTHL_TLiao_VAVLE             M0322//Y２２推拉头电磁阀        ／／M0316  //Y14 推料电磁阀 
#define XY_CTHL_HSLiao_VAVLE            M0323//Y２３横送拉头电磁阀      ／／M0308  //Y04 横送料电磁阀
#define XY_CTHL_DLP_VAVLE               M0324//Y２４顶片电磁阀           ／／M0314 // Y12打拉片电磁阀
#define XY_CTHL_SD_VAVLE                M0325//Y25松带电磁阀             //M0315  //Y13松带电磁阀
#define XY_CTHL_ZhenDongPian_OUT        M0326//Y26振动盘                 //M0321   //Y21 振动盘启动吹气电磁阀

#define XY_CTHL_SF_ALR_CLR              M0328//Y３０伺服报警清楚         ／／M0326 //Y26 伺服警告清除



//正常










//视觉不用，
#if XY_CTHL_SHIJUE_ONE
//视觉兼用
#define XY_CTHL_JIANCHE_VAVLE           M0314   // Y12检测电磁阀
#define XY_CTHL_DINGCHU_VAVLE            M0315    //Y13顶出电磁阀
#define XY_CTHL_XIANZHI_VAVLE           M0321    //Y21 限制电磁阀
#define XY_CTHL_SHIJUEMODE_VAVLE       M0328     //Y30 顶完信号
#define XY_CTHL_ZDP_IN                  M0402   //X22振动盘
//#define XY_CTHL_ZDP_IN_UP            (M0402  && !OLDM402 ) 
#define XY_CTHL_LMBJ                    M0389   //X05视觉信号振动盘
#define XY_CTHL_LMBJ_UP          (M0389  && !OLDM389 ) 
#define XY_CTHL_ZhenDongPian_OUT   M0326   //Y21 振动盘启动吹气电磁阀
#define XY_CTHL_SF_ALR_CLR         M0330 //Y26 伺服警告清除

//视觉屏蔽
#define XY_CTHL_DLP_VAVLE          M0330   // Y12打拉片电磁阀
#define XY_CTHL_SD_VAVLE            M0330    //Y13松带电磁阀
#define XY_CTHL_SF_ALR_IN           M0410   //X22伺服报警
#define XY_CTHL_XiaJiangXM_VAVLE          M0330     //Y30 下模  (下降）

#define XY_CTHL_SF_ALR_IN           M0410   //X22伺服报警

#else //无视觉

//屏蔽

#define XY_CTHL_JIANCHE_VAVLE           M0330   // Y12检测电磁阀
#define XY_CTHL_DINGCHU_VAVLE            M0330    //Y13顶出电磁阀
#define XY_CTHL_XIANZHI_VAVLE           M0330   //Y21 限制电磁阀
#define XY_CTHL_SHIJUEMODE_VAVLE        M0329     //Y30 顶完信号
#define XY_CTHL_LMBJ_UP          (M0410  && !OLDM410 ) 










#endif



//M0~M4全局固定使用
/*
#define bRunning                    M0000
#define bStart                      M0001
#define bStop                       M0002
#define bAlarmStop                  M0003
#define bClearTotal                 M0004
*/
#define XY_CTHL_bTLiao          M0005      //手动推料
#define XY_CTHL_bHSL            M0006      //手动横送料     
#define XY_CTHL_bJLT            M0007       //接拉头
#define XY_CTHL_bMG             M0008       //码勾
#define XY_CTHL_bFKJD           M0009       //方块夹带
#define XY_CTHL_bXKTD           M0010       //斜口推带
#define XY_CTHL_bXKDW           M0011       //斜口定位
#define XY_CTHL_bCTXM           M0012       //穿头下模
#define XY_CTHL_bDXK            M0013       //顶斜口
#define XY_CTHL_bFKGD           M0014       //方块固定
#define XY_CTHL_bCXQJD          M0015       //插销前夹带
#define XY_CTHL_bCXSY           M0016       //插销上移电磁阀
#define XY_CTHL_bCXDWZ          M0017       //Y14 插销定位针电磁阀
#define XY_CTHL_bCXHJD          M0018       //Y15 插销后夹带电磁阀
#define XY_CTHL_bCXHDW          M0019       //Y16 插销后定位电磁阀
//#define XY_CTHL_bCXDWCheck      M0020       //Y17 插销到位电磁阀
#define XY_CTHL_bFirst_CT       M0021       //Y20 一次穿头电磁阀
#define XY_CTHL_bHLJJ           M0022       //Y21 合链夹具电磁阀
#define XY_CTHL_bCXSCDW         M0023       //Y23 插销上止定位电磁阀

#define XY_CTHL_bCLMotor_P      M0026       //穿链电机正转
#define XY_CTHL_bCLMotor_N      M0025       //穿链电机反转
//下面为动作组合按键
#define XY_CTHL_bAutoZhuangLiao M0024       //自动装料
#define XY_CTHL_bCLMotor_O      M0027       //穿链电机定位原点
#define XY_CTHL_bCL_First       M0028       //一次穿链动作
#define XY_CTHL_bFKTDDW         M0029       //拖带方块定位
#define XY_CTHL_bFKCXTDDW       M0030       //拖带方块插销定位
#define XY_CTHL_bCXMotorDW      M0031       //插销电机前定位
#define XY_CTHL_bCXCR           M0032       //插销穿入(包含电机前定位,插销下移,后夹,后定位)
#define XY_CTHL_bMotorHL        M0033       //电机合链操作
#define XY_CTHL_bQianDXK        M0034       //Y27 前顶斜口电磁阀
#define XY_CTHL_bQianDXK_DXK    M0035       //顶斜口动作
#define XY_CTHL_bTESTCXTD       M0036       //测试插销拖带长度
#define XY_CTHL_bBanZiDong      M0037       //半自动
#define XY_CTHL_bSingleone      M0038       //单循环
#define XY_CTHL_bXiaoChaTest    M0039       //小插销测试
#define XY_CTHL_bCXHT           M0040       //Y12  插销后退
#define XY_CTHL_bHL             M0041       //Y13 插销后退
#define XY_CTHL_MotorTEST       M0042       //拖带电机测试
#define XY_CTHL_MotorTEST_N     M0043       //拖带电机测试N
#define XY_CTHL_DLP             M0044       //打拉片
#define XY_CTHL_STOPone         M0045       //拖带电机测试N
#define XY_CTHL_SD              M0046       //松带
#define XY_CTHL_CXC             M0047       //穿小插
#define XY_CTHL_DANBU_MODE      M0048       //单步动作

#define XY_CTHL_bXianZhi        M0049      //限制电磁阀
#define XY_CTHL_bJianChe        M0050      //检测电磁阀
#define XY_CTHL_bDingChu        M0051      //顶出电磁阀
#endif

 
