
#if JUN_YUE_MACHINE  ==  1

#define DIR_P 1
#define DIR_N 0

#define MOTOR_EN 0
#define MOTOR_DISEN 1


#define MOTOR_ALARM 0
#define MOTOR_NOALARM 1

#define CTHL_VAVLE_ERROR_TIME   3000 
#define CTHL_MOTOR_ALARM_TIME   5000

#define HSLIAO_CHECK_TIME                      1//横送是检测穿头模和第一次合链是否在原位
//合链运行状态
#define CTHL_STATE_IDE               0//空闲台
#define CTHL_STATE_QMDW              1//前码定位

//故障代码列表
#define CTHL_NO_ALARM                0
#define CTHL_WLZDTJ_ALARM            1   //无拉链自动停机
#define CTHL_GDLT_ALARM              2   //固定拉头异常
#define CTHL_TLiao_Limit_ALARM       3   //推料到位异常
#define CTHL_HSLiao_Limit_ALARM      5   //横送料到位异常
#define CTHL_HSLiao_Origin_ALARM     6   //横送料原位异常
#define CTHL_JLiao_Origin_ALARM      7   //接料到位异常
#define CTHL_CTM_Limit_ALARM         8     //穿头模到位异常
#define CTHL_CTM_Origin_ALARM        9   //穿头模原位异常
#define CTHL_JXM_Limit_ALARM         10  //夹斜码要输出才能推斜码
#define CTHL_XCDW_Limit_ALARM        11   //拉头缺料感应异常
#define CTHL_QMDW_Limit_ALARM        12   //前码定位感应异常
#define CTHL_TXM_Limit_ALARM        13   //推斜码到位异常
#define CTHL_XCBI_Limit_ALARM        14   //小插摆臂到位异常
#define CTHL_SafeDoor_ALARM             15   //
#define CTHL_SF_ALR_ALARM            16   //伺服报警异常
#define CTHL_FXDW_ALARM             17   //方块定位(X04)异常
#define CTHL_ZLT_ALARM               18   //装拉头异常
#define CTHL_CRFK_ALARM             19   //穿入方块超出预设长度

#define CTHL_SERVO_CONFIG_ALARM     20  //伺服配置转矩限制失败
#define CTHL_FZTD_KZ_ALARM          21  //反转拖带卡滞
#define CTHL_FK_Check_ALARM         22  //方块检测异常
#define CTHL_LTQL_CHECK_ALARM       23   //拉头缺料感应异常
#define CTHL_YLT_CHECK_ALARM        24   //拉头缺料感应异常

#define CTHL_AutoStep            cStepMByte
#define CTHL_ZhuangLiaoStep      cStepMByte1
#define CTHL_TLiaoStep           cStepMByte2
#define CTHL_TD_MotorStep        cStepMByte3     //拖带电机
#define CTHL_JiaLianStep         cStepMByte4
#define CTHL_ZhenDongStep        cStepMByte6
#define CTHL_SongLiaoStep        cStepMByte7
#define CTHL_FZ_MotorStep        cStepMByte8     //穿链
#define CTHL_CTXMSSStep          cStepMByte9


#define CTHL_ZhuangLiaoDelay      cDelayTime2
#define CTHL_TLiao_Delay          cDelayTime3
#define CTHL_TD_MotorDelay        cDelayTime4
#define CTHL_AutoDelay            cDelayTime5
#define CTHL_TestDelay            cDelayTime6
#define CTHL_FZ_MotorDelay        cDelayTime7
#define CTHL_TouchDelay           cDelayTime8
#define CTHL_AutoDelay1           cDelayTime9
#define CTHL_ZDP_Delay            cDelayTime10
#define CTHL_MOTORZ_Delay            cDelayTime11
#define CTHL_bSFBBAOJIN_Delay   cDelayTime12


//32位无符号变量
#define CTHL_LianLengthCheck     cUDword32Buff1
#define CTHL_LianLengthAutoCheck cUDword32Buff2
#define CTHL_LianLengthCheckOld  cUDword32Buff3
#define CTHL_LianLengthCheckFK_UP  cUDword32Buff4
#define CTHL_LianLengthAutoCheckERROR cUDword32Buff5
#define CTHL_LianLengthAutoCRCDcheck  cUDword32Buff6
#define CTHL_LianLengthAutoFZcheck  cUDword32Buff7
#define CTHL_LianLengthAutoFZCRcheck  cUDword32Buff8
#define CTHL_LianLengthAutoFZcheck_DW cUDword32Buff9
#define CTHL_LianLengthAutolengthcheck cUDword32Buff10
#define CTHL_DataBuff                  cUDword32Buff11
#define CTHL_LianLengthBuff            cUDword32Buff12         


//32位有符号变量
#define CTHL_XSavePosBuff        cDword32Buff1
#define CTHL_X_CXPosBuff         cDword32Buff2
#define CTHL_YSavePosBuff        cDword32Buff3
#define CTHL_CheckInX02PosBuff   cDword32Buff4
#define CTHL_YsaveCXDWPosBuff   cDword32Buff5
#define CTHL_LENTH              cDword32Buff6
#define CTHL_XSavePosBuff1      cDword32Buff7
#define CTHL_XSavePosBuff2      cDword32Buff8
#define CTHL_XSavePosBuff3      cDword32Buff9

//16位变量
#define CTHL_RunStepSave            cUShort16Buff1
#define CTHL_Test                   cUShort16Buff2
#define CTHL_RunState               cUShort16Buff3  //合链运行状态  
//8位变量
#define CTHL_TryCnt                 cCharBuff1
#define CTHL_cZipCnt                cCharBuff2
#define CTHL_stop                   cCharBuff3
#define CTHL_AUTO_start             cCharBuff4
#define CTHL_MOTOR_MODE             cCharBuff5
#define CTHL_wltzi                  cCharBuff6
#define CTHL_cStopMode              cCharBuff7
#define cTDAUTO                     cCharBuff8
#define cDELAYONE                   cCharBuff9
#define cGFJAUTO                    cCharBuff10
#define cHELIANMG                   cCharBuff11
#define cBAOjin                     cCharBuff12
#define CTHL_CTXMSS_FLAG            cCharBuff13
       
//位标志位
#define bTuiLaTouOkFlg              bBitFlag0
#define bZhuangLiaoOkFlg            bBitFlag1
#define bXiaMoENFlg                 bBitFlag2
#define bHeLaTouOK                  bBitFlag3
#define bCL_EN_FLG                  bBitFlag4
#define bCL_OK_FLG                  bBitFlag5
#define bCheckEN_FLG                bBitFlag6
#define bSingOneFlg                 bBitFlag7  
#define bCxcAuto                    bBitFlag8
#define bDanBuAuto                  bBitFlag9
#define bFZ_LengthOK                bBitFlag10  
#define bFKCheck_Flag               bBitFlag11
#define CTHL_ZhouWanone             bBitFlag12
#define CTHL_ZhouWantwo             bBitFlag13
#define CTHL_GF_Change              bBitFlag14
#define CTHL_SD                    bBitFlag15         //松一次带


#define CTHL_TOTAL_ADDR  76

#define CTHL_SPEED_ADDR     78
#define CTHL_ALARM_ADDR     100
#define CTHL_TRUST_ALARM_ADDR     102
//104、105地址 作产量锁

#define CTHL_PARAM_TDCYCLE_PULSE       user_datas[0]//0 转一圈脉冲数  
#define CTHL_PARAM_TDCYCLE_LENGTH      user_datas[1]//整数 转一圈拖带多长 
#define CTHL_PARAM_FZCYCLE_LENGTH      user_datas[2]//0 转一圈脉冲数  
#define CTHL_PARAM_FZLDCYCLE_LENGTH      user_datas[3]//整数 转一圈拖带多长   
//#define CTHL_PARAM_TD_RunSpeed         user_datas[4]//整数 拖带电机拖带速度---wu
#define CTHL_PARAM_FKDW_Speed          user_datas[5]//整数 方块定位速度(低速度)
//#define CTHL_PARAM_FZ_Speed            user_datas[6]//整数 反转速度

#define CTHL_PARAM_first_CL_MAX_Length       user_datas[7]//第一条拉链最长度
//#define CTHL_PARAM_FKDW_Length         user_datas[8]//0.01 方块定位长度
//#define CTHL_PARAM_FZFK_IN_LENGTH      user_datas[9]  //反转感应方块后再走长度
#define CTHL_PARAM_FKDWMAN_Speed        user_datas[10]  //感应到方块后慢速
#define CTHL_PARAM_HLT_SPEED_Speed      user_datas[11]//合拉头速度
#define CTHL_PARAM_TLiao_BACKDELAY   (10*user_datas[12])//0.01推拉头到位延时返回
#define CTHL_PARAM_JLTOU_DELAY       (10*user_datas[13])//0.01接料到位延时码勾
#define CTHL_PARAM_HSLiaoOff_DELAY   (10*user_datas[14])//0.01码勾输出后退横送料
#define CTHL_PARAM_CheckLT_DELAY     (10*user_datas[15])//0.01码勾输出后延时检测拉头
#define  CTHL_PARAM_WLCDSHEZHI_LENTH    user_datas[16]  //拉带报警长度

#define CTHL_PARAM_CXDW_Length         user_datas[17]  //小插定位长度

#define CTHL_PARAM_XCDWFZ_DELAY      (10*user_datas[18]) //前码定位后延时反转

#define CTHL_PARAM_CRTD_DELAY        (10*user_datas[19]) //延时穿入拖带

#define CTHL_PARAM_FMOTOR_BILI       0.95// (user_datas[20]/100)  //0.01 副电机指数

#define CTHL_PARAM_XCLD_DELAY        (10*user_datas[21]) //延时合链

#define CTHL_PARAM_HL_LENGTH         user_datas[22] //慢速合链长度

#define CTHL_PARAM_H_JLiao_DELAY       (10*user_datas[23])//横送到位延时接料

//#define CTHL_PARAM_CRHDW_LENGTH        user_datas[23] //穿入后定位长度

#define CTHL_PARAM_SMG_LENGTH        user_datas[24] //松码钩后输出合链长度

#define CTHL_PARAM_ZDP_Start_TIME      (10*user_datas[25])      //0.01振动盘启动延时  
#define CTHL_PARAM_ZDP_Stop_TIME       (10*user_datas[26])       //0.01振动盘延时停止 
#define CTHL_PARAM_HELIAN_LENGTH      user_datas[27] //剩余合链长度
//#define CTHL_PARAM_FDGN_LENGTH        user_datas[28] //第一个方块屏蔽长度
//#define CTHL_PARAM_FKJC_DELAY      (user_datas[29]*10) //延时输出方块检测
#define CTHL_PARAM_TXCDW_DELAY      (user_datas[30]*10) //延时退推方块
#define CTHL_PARAM_XCCR_SPEED        user_datas[31] //小插插入速度
#define  CTHL_PARAM_ZDP_AUTO         user_datas[32]  //振动盘控制
#define CTHL_PARAM_XCCR_LENGTH          user_datas[33] //小插插入长度
#define CTHL_PARAM_FKIN_LENGTH          user_datas[34] //提前下方块
#define CTHL_PARAM_XCIN_DELAY           (user_datas[35]*10) //小插定位后延时拖带
#define CTHL_PARAM_YDC_DELAY             (user_datas[36]*10) //延时压方块
//#define CTHL_PARAM_GFJSZ_LENGTH              user_datas[37] //倒带长度
#define CTHL_PARAM_XMDD_LENGTH              user_datas[38] //斜码松带反转
#define CTHL_PARAM_DBSF_MODE                 user_datas[39] // DB伺服报警切换   1外部接口
#define CTHL_PARAM_SLOW_LENGTH                 user_datas[40] // 减速长度
#define CTHL_PARAM_JXM_SPEED                  user_datas[41] //进斜码速度
#define CTHL_PARAM_TXM_DELAY                  (user_datas[42]*10) //推斜码进去长度
#define CTHL_PARAM_TTXM_LENGTH                 user_datas[43] //退推斜码长度          
#define CTHL_PARAM_TJXM_LENGTH                 user_datas[44]//退夹斜码长度
//#define CTHL_PARAM_FZSTOP_SPEED                 user_datas[45]//反转停机速度
#define CTHL_PARAM_FZSTOP_LENGTH                 user_datas[46]//反转停机距离
#define CTHL_PARAM_FZCXC_LENGTH                 user_datas[47]//穿小插反转距离
#define CTHL_PARAM_XMZM_MODE                   user_datas[48]//斜码直码切换
//#define CTHL_PARAM_YSXC_DELAY                   (user_datas[49]*10)//延时顶链
#define CTHL_PARAM_TD_RunSpeed                  (user_datas[50])//整数 拖带电机拖带速度
#define CTHL_PARAM_FZ_Speed                     (user_datas[51]) //整数 反转速度
#define CTHL_PARAM_FKDW_OUT_DELAY               (user_datas[52]) //方块定位阀延时动作
#define CTHL_PARAM_TuiXiaMo_DELAY                (10*user_datas[53]) //退下模时间
#define CTHL_PARAM_FKDW_FZSTOP_DELAY             (10*user_datas[54]) //方块反转定位延时停

#define CTHL_PARAM_Test                       1//(user_datas[55]) //
#define CTHL_PARAM_XMCR_SLOW_LENGTH          (user_datas[56]) //斜码穿入慢速长度
#define CTHL_PARAM_XMCR_YJDW_LENGTH          (user_datas[57]) //一键定位补偿距离
#define CTHL_PARAM_CRFZ_LENGTH          (user_datas[58]) //穿入小插后反转长度

#define CTHL_PARAM_GFJ_LENGTH             (user_datas[8]) //感应到方块后定位距离
#define CTHL_PARAM_HeLianSY_LENGTH          (user_datas[60]) //最后一条合链剩余长度
#define CTHL_PARAM_CR_BAOHU_LENGTH          (user_datas[61]) //穿入保护长度
#define CTHL_PARAM_CLsudu_SPEED            (user_datas[62]) //穿入保护长度
#define CTHL_PARAM_XCFZ_LENGTH            (user_datas[63]) //辅助拉小插长度
#define CTHL_PARAM_TQMDW_DELAY            (10 * user_datas[64]) //辅助拉小插长度
#define CTHL_PARAM_SDXZ                   (user_datas[65])               //反转时速度修正，倒退轮的速度和长度修正
#define CTHL_PARAM_TMG_TXM_DELAY            (user_datas[66]) //退码勾后延时退下模

#define CTHL_PARAM_FZJS_LENGTH             (user_datas[67]) //反转减速长度
#define CTHL_PARAM_FZDS_Speed             (user_datas[68]) //反转入方块速度
#define CTHL_PARAM_FZJSDS_LENGTH          user_datas[69] //穿入方块低速长度
#define CTHL_PARAM_TDDW_LENGTH             (user_datas[70]) //感应到方块后定位距离
#define CTHL_PARAM_XCCRBH_LENGTH             (user_datas[71]) //小插插入保护长度
#define CTHL_PARAM_JMDW_LENGTH             (user_datas[72]) //前码定位距离
#define CTHL_PARAM_GDLT_DELAY               (10*user_datas[73])//0.01接料到位延时码勾
#define CTHL_PARAM_HLWZ_LENGTH             (user_datas[74]) //合链位置长度
//速度页面调试参数
#define CTHL_PARAM_First_SPEED                  user_datas[150] //前两条速度
#define CTHL_PARAM_Stop_length                  user_datas[151] //前两条定位长度
#define CTHL_PARAM_FZFirst_SPEED                  user_datas[152] //前两条反转速度
#define CTHL_PARAM_FZStop_length                  user_datas[153] //前两条反转定位长度

//伺服参数 180~190
#define SERVO_PARAM_TRARR_LIMITMAX       user_datas[180]//伺服扭矩最大限制
#define SERVO_PARAM_TRARR_LIMITMIN       user_datas[181]//伺服扭矩最小限制
#define SERVO_PARAM_SPEED_DIFFER         user_datas[182]//速度差值
#define SERVO_PARAM_ENCODE             user_datas[190]//转换后的值
#define SERVO_PARAM_ALARM              user_datas[192]//转换后的值



//俊跃输入
#define CTHL_FKDW_IN              M0384    //X00方块定位感应
#define CTHL_FKDW_IN_UP           (M0384 && !OLDM384)
#define CTHL_FKDW_IN_DW           (!M0384 && OLDM384)
#define CTHL_FK_Check              M0385    //X01方块过链感应
#define CTHL_FK_Check_UP           (M0385 && !OLDM385)
#define CTHL_FK_Check_DW           (!M0385 && OLDM385)

#define CTHL_TXC_Limit_IN          M0386    //X02插销摆动到位

#define CTHL_LTou_Check              M0387    //X03码钩,拉头检测

#define CTHL_XCDW_Limit_IN               M0388       //X04插销到位感应开关

#define CTHL_CTM_Limit_IN          M0389       //X05下模到位
#define CTHL_CTM_Origin_IN         M0390       //X06下模原位
#define CTHL_HSLiao_Limit_IN        M0391       //X07横送料到位
#define CTHL_HSLiao_Origin_IN       M0392       //X08横送料原位

#define CTHL_START_IN              M0393         //X11 //启动
#define CTHL_START_IN_UP           (M0393 && !OLDM393)
#define CTHL_STOP_IN               M0394        // X12  //停止
#define CTHL_STOP_IN_UP            (M0394 && !OLDM394)

#define CTHL_TLiao_Limit_IN       M0396       //X14推料到位，给拉头到位
#define CTHL_TXM_Limit_IN          M0397       //X15推斜码到位，侧推布带到位

#define CTHL_FKGY_IN               M0398       //X16方块感应，反转时感应
#define CTHL_FKGY_IN_UP            (M0398 && !OLDM398)   
#define CTHL_FKGY_IN_DW            (!M0398 && OLDM398)  

#define CTHL_DingDai_Limit_IN      M0399   //顶带到位
#define CTHL_LinkStart_IN          M0400   //联机启动
#define CTHL_QMDW_IN               M0401   //护前码到位,前码定位
#define CTHL_SafeDoor_IN           M0402          //X21 安全门
#define CTHL_NoLaLian_IN           M0404          //X24 最后拉链信号
#define CTHL_NoLaLian_IN_UP        (M0404 && !OLDM404)
#define CTHL_SF_ALR_IN             M0405            //X20 伺服报警

//俊跃输出
#define CTHL_QMDW_VAVLE          M0304        //Y00护前码
#define CTHL_JXM_VAVLE          M0305      //Y01夹前码
#define CTHL_TXM_VAVLE          M0306      //Y02侧推布带电磁阀 ，推方块侧的斜码、直码
#define CTHL_XCDW_VAVLE         M0307     //Y03分针,小插到位检测
#define CTHL_TFK_VAVLE         M0308     //Y04方块固定

#define CTHL_TLiao_VAVLE        M0309      //Y05给拉头
#define CTHL_HSLiao_VAVLE       M0310      //Y06横送拉头
#define CTHL_CTXM_VAVLE         M0311      //Y07下模

#define CTHL_JLTou_VAVLE          M0312      //Y10夹拉头
#define CTHL_MGuo_VAVLE         M0313      //Y11码勾电磁阀，拉头开锁电磁阀
#define CTHL_JCBI_VAVLE         M0314      //Y12插销摆臂电磁阀，侧推小插侧的布带
#define CTHL_YFK_VAVLE        M0315       //Y13压方块拖带
#define CTHL_YXC_VAVLE        M0316       //Y14压小插拖带

#define CTHL_GDLT_VAVLE         M0317      //Y17接拉头
#define CTHL_HL_VAVLE           M0318      //Y20合练
#define CTHL_LINK_ALARM         M0319     //Y21联机告警
#define CTHL_DingDai_VAVLE      M0320    //Y22顶带

#define CTHL_TestLED              M0328   //Y30 测试状态灯
#define CTHL_SF_ALR_CLR           M0329   //Y31伺服报警清除

//M0~M4全局固定使用
/*
#define bRunning                    M0000
#define bStart                      M0001
#define bStop                       M0002
#define bAlarmStop                  M0003
#define bClearTotal                 M0004
*/

#define CTHL_bHSL            M0005      //手动横送料 0
#define CTHL_bTLiao          M0006      //手动推料 0
#define CTHL_bJLT            M0007      //接拉头 0
#define CTHL_bMG             M0008      //码勾 0
#define CTHL_bCTXM           M0009      //下模 0

#define CTHL_bJXM            M0010     //夹前码
#define CTHL_bTXM            M0011      //侧推斜码
#define CTHL_bQMDW           M0012      //护前码
#define CTHL_bTFK            M0013      //推方块
#define CTHL_bFKDW           M0014      //方块钩针定位

#define CTHL_bHL             M0015       //合链
#define CTHL_bYFK           M0016      //方块压轮
#define CTHL_bYCX           M0017      //插销压轮
#define CTHL_bXCDW           M0018     //分针
#define CTHL_bXCBI           M0019     //推插销



#define CTHL_bSingOne         M0020     //单循环
#define CTHL_bDANBU_MODE      M0021      //单步调试
#define CTHL_bHandWork_MODE   M0022      //手动穿链模式

#define CTHL_bAutoZhuangLiao  M0024       //自动装料

#define CTHL_bCLMotor_N       M0025       //X轴电机测试
#define CTHL_bCLMotor_P       M0026       //X轴电机测试
#define CTHL_bCLMotor_Z       M0027       //Z轴电机测试
#define CTHL_bBaoJin          M0028       //松轴
#define CTHL_bYJDW            M0029      //一键定位

#define CTHL_bGDLT             M0030      //固定拉头
#define CTHL_bCXDD            M0031      //插销顶带

#define CTHL_SERVO_COM        M0036       //伺服通讯

#define CTHL_bTiaoShiMode           M0040     //调试模式
#define CTHL_bTiaoShiStep           M0041     //调试单步


extern void CTHL_InitAction(void);
extern void CTHL_Action(void);

#endif


