#include "global.h"

#if LONG_YI_MACHINE  ==  1

void LY_CTHL_SetAlarmCode(unsigned short alarm_code,unsigned short cStopFlag);
void LY_CTHL_ManualAction(void);
void LY_CTHL_AutoStepAction(void);
void LY_CTHL_TableAction(void);
void LY_CTHL_TD_Motor(void);
void LY_CTHL_CL_Motor(void);
void LY_CTHL_CheckStart(void);
void LY_CTHL_TLiao_Step(void);  //(ͷ)
void LY_CTHL_AlarmProtect(void);
void LY_CTHL_ZLT_Step(void);
void LY_CTHL_ZhenDongAction(void);
void LY_CTHL_bFKCXTDDWStep(void);
void LY_CTHL_bCXCRStep(void);
void LY_CTHL_bCLFirstStep(void);


void ExtiAcitionX02(void)
{
    if(bCheckEN_FLG)
    {  
        bCheckEN_FLG = 0;
        LY_CTHL_CheckInX02PosBuff = GetPos(X_AXIS);
    }    
}

//ϱ
void LY_CTHL_SetAlarmCode(unsigned short alarm_code,unsigned short cStopFlag)
{
    SetAlarmCode(LY_CTHL_ALARM_ADDR,alarm_code);
  //  bAlarmStop = 0;
   // if(cStopFlag)
    if(!cWULATOUCnt && !cXiaoChaCNT && !cCHULIANBAOJIN)
    {
      bAlarmStop = 1;
    }
    else
    {
      cWULATOUCnt=0;
    }
    
    
        
}

//ʼ
void LY_CTHL_InitAction(void)
{
    float buff_pulse,buff_dist;
    
    buff_pulse  = LY_CTHL_PARAM_CYCLE_PULSE;
    buff_dist   = LY_CTHL_PARAM_CYCLE_LENGTH; 
    
    XGearRatio  =  buff_pulse/buff_dist; 
    
    buff_pulse  = 2000;//LY_CTHL_PARAM_CYCLE_PULSE;
    buff_dist   = 750;//LY_CTHL_PARAM_CYCLE_LENGTH;
    YGearRatio  =  buff_pulse/buff_dist;
    
   
    
    bYFirstDingWeiFlg = 1;
    user_datas[121] = 0;
    user_datas[122] = 0;
    user_datas[123] = 0;
    
    SetEnReverse(X_AXIS, 1);
    SetEnReverse(Y_AXIS, 1);
    SetEnReverse(Z_AXIS, 1);
    
    SetDirReverse(X_AXIS, 0);
    SetDirReverse(Y_AXIS, 0);
    SetDirReverse(Z_AXIS, 0);
    
    SetEn(X_AXIS, MOTOR_DISEN);
    SetEn(Y_AXIS, MOTOR_DISEN);
    SetEn(Z_AXIS, MOTOR_DISEN);
        
    SetAlarmCode(LY_CTHL_ALARM_ADDR,0); 
//    QDCT_SZ_OUT   = QDCT_MOTOR_DISEN;
}

void LY_CTHL_Action(void)
{ 
    user_datas[121] = LY_CTHL_LianLengSave;
 //   user_datas[122] =axis_x->cur_speed;
  //  user_datas[123] = LY_CTHL_bCXCR_Step;
    dwXRealPos = GetPos(X_AXIS);
    dwYRealPos = GetPos(Y_AXIS);
    dwZRealPos = GetPos(Z_AXIS);  
    user_datas[124] = dwXRealPos;
    user_datas[125] = dwYRealPos;
    
    user_datas[126] = LY_CTHL_CL_MotorStep;
    user_datas[127] = LY_CTHL_TD_MotorStep;
    user_datas[128] = LY_CTHL_AutoStep;  
    
    LY_CTHL_ZhenDongAction();
    LY_CTHL_AlarmProtect();
    LY_CTHL_CheckStart();    
    LY_CTHL_ZLT_Step();
    LY_CTHL_TLiao_Step();

    LY_CTHL_TD_Motor();
    LY_CTHL_CL_Motor();
    LY_CTHL_bFKCXTDDWStep();
    LY_CTHL_bCXCRStep();
    LY_CTHL_bCLFirstStep();
    LY_CTHL_ManualAction();

    LY_CTHL_AutoStepAction();  
}

void LY_CTHL_AlarmProtect(void)
{ 
    

 
}


//Զ
void LY_CTHL_AutoStepAction(void)
{  

   

    if(bRunning)
    {
        switch(LY_CTHL_AutoStep)
        {
            case 1:
              if(LY_CTHL_SF_Origin_IN || cBanAuTo)
              {
        /*       LY_CTHL_AutoStep = 10;       //ϴλ
               LY_CTHL_AutoDelay = dwTickCount + 1000;
               break; */
             if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
             {
                LY_CTHL_FKJD_VAVLE = 1;   //д
                LY_CTHL_XKTD_VAVLE = 1;   //бƴ    
                LY_CTHL_FKGD_VAVLE = 0;     //̶
            //    LY_CTHL_XKDW_VAVLE = 1;
                LY_CTHL_AutoStep = 2;
           //     LY_CTHL_AutoDelay = dwTickCount + 10;
                if(LY_CTHL_ZhuangLiaoStep == 0)
                { 
                    LY_CTHL_ZhuangLiaoStep = 1;
                    LY_CTHL_TryCnt = 0;
                }   
             }
              }
                break;
            case 2: 
                if(!LY_CTHL_XKTD_Origin_IN)// && (dwTickCount >= LY_CTHL_AutoDelay))  //бƴԭλ뿪
                {
                    if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
             {
                    LY_CTHL_AutoStep = 3;
                    LY_CTHL_XKDW_VAVLE = 1;
                    LY_CTHL_AutoDelay = dwTickCount + 20;
             }
                }  
                break;
            case 3://бڶλ
                if(dwTickCount >= LY_CTHL_AutoDelay)
                {                   
                    LY_CTHL_AutoStep = 4;
           //         LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_XKDW_TD_DELAY;
                }  
                break;
            case 4:
              if(!cBanAuTo)
              {
                  if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                {
                    AxisMovePosAccDecNotStop(X_AXIS,1600,150,600,1000,5,3,00); 
                    LY_CTHL_AutoStep = 5;
                   LY_CTHL_XSavePosBuff = dwXRealPos;
             //       SetPos(X_AXIS, 0);  //λΪ0
                      if(cZipCnt < 1)
                         LY_CTHL_AutoDelay = dwTickCount +350;
                      else
                       LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_FKJD_DELAY;
                }
              }
              else
              {
               LY_CTHL_AutoStep = 5;
                 LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_FKJD_DELAY;
                   LY_CTHL_XSavePosBuff = dwXRealPos;
              }
                  
                break;
            case 5:
              if(dwTickCount >= LY_CTHL_AutoDelay)
                {
                  LY_CTHL_FKJD_VAVLE = 1;   //д
                  
                }
                if(bCL_EN_FLG && (dwXRealPos >= 230) && LY_CTHL_XKSC_Limit_IN)
                {                    
                    LY_CTHL_HLJJ_VAVLE = 1; //Y20 оߵŷ,
                }

                if(LY_CTHL_XKSC_Limit_IN)   //ֹλ
                {
                    AxisEgmStop(X_AXIS);
                   // AxisMovePosAccDec(X_AXIS,1200,10,1200,1200,6,6,0); 
              if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_QDXK_VAVLE = 1;
                    LY_CTHL_FKJD_VAVLE=0;
                   
                    LY_CTHL_AutoStep = 6;
 //                   
                    
                    LY_CTHL_bLTCHECK_Delay = dwTickCount + 20;
                    //
                    bCL_OK_FLG = 1;   //ôĻΪѾ
                    if(bCL_EN_FLG)
                    {
                        bCL_OK_FLG = 0;
                        LY_CTHL_HLJJ_VAVLE = 1; //Y20 оߵŷ,
                        LY_CTHL_CL_MotorStep = 1;
                        LY_CTHL_CL_MotorDelay = dwTickCount + LY_CTHL_PARAM_HLJJ_CL_DELAY;
                        
                        LY_CTHL_AutoDelay = dwTickCount + 50 + LY_CTHL_PARAM_HLJJ_CL_DELAY;  
                    }
                    else
                    {
                        LY_CTHL_XKTD_VAVLE = 0;   //бƴ׹ر      
                        LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;       
                    }   
             }
                }
                else if(dwXRealPos >= (LY_CTHL_XSavePosBuff + 3000))
                {
                    LY_CTHL_SetAlarmCode(LY_CTHL_FKCXDW_ALARM,bRunning);  //λ쳣
                    
                }  
                break;
            case 6:
                if(((dwYRealPos > 1000) || (!Y_DRV && dwYRealPos)) && LY_CTHL_XKTD_VAVLE)
                {
                    LY_CTHL_XKTD_VAVLE = 0;   //бƴ׹ر      
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;    
                }  
              
                if(LY_CTHL_XKTD_Origin_IN)      //бƴصԭλ
                {
                    if(bZhuangLiaoOkFlg && (LY_CTHL_ZhuangLiaoStep == 0))
                    {
                       if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                         if(dwTickCount >= LY_CTHL_bLTCHECK_Delay)
                         {
                            if(bSingOneFlg)
                            {
                                LY_CTHL_AutoStep = 0;
                                bRunning = 0;
                            }     
                            else
                            {   
                              if(!LY_CTHL_LTou_Check)
                              {
                                if(LY_CTHL_PARAM_TDFZ_LENTH && !X_DRV)  //ϴת
                                  {
                                   AxisMovePosAccDec(X_AXIS,8000,-LY_CTHL_PARAM_DXKFZ_LENTH,800,600,6,6,0); 
                                  if(!LY_CTHL_PARAM_NLSL_MODE)
                                       LY_CTHL_FKJD_VAVLE= 0;   //д׹
                                     
                                  }
                                if(LY_CTHL_PARAM_CXLY_MODE)
                                    LY_CTHL_CXLY_VAVLE = 1;
                                LY_CTHL_CTXM_VAVLE = 1; //ͷģ
                                LY_CTHL_AutoStep = 7;
                                LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                              }
                              else
                              {
                                 cWULATOUCnt=1;
                                LY_CTHL_SetAlarmCode(LY_CTHL_ZLT_ALARM,bRunning);  // ûͷ                               
                              }
                            }
                         }
                    } 
                    }
                }
                else if((dwTickCount >= LY_CTHL_AutoDelay) && !LY_CTHL_XKTD_VAVLE  && !cBanAuTo) 
                {
                    LY_CTHL_SetAlarmCode(LY_CTHL_XKTD_Origin_ALARM,bRunning); //бƴص쳣
                }
                break;
            case 7: 
                if(!LY_CTHL_CTM_Origin_IN)
                {
                    LY_CTHL_JLTou_VAVLE = 0;    //ͷ
                }
                if(LY_CTHL_CTM_Limit_IN) 
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                  if(LY_CTHL_PARAM_NLSL_MODE)
                  {
                  
                    LY_CTHL_XKTD_VAVLE=1;
                  }
                    LY_CTHL_JLTou_VAVLE = 0;
                    LY_CTHL_AutoStep = 8;    
                   LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_DXKYS_DELAY;
                 }
                  
                }  
                else if(dwTickCount >= LY_CTHL_AutoDelay)
                {
                  LY_CTHL_SetAlarmCode(LY_CTHL_CTM_Limit_ALARM,bRunning);  //ͷģ쳣
                }
                break;

        case 8:
               if(!X_DRV)  //ʱб
               {
                  if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                 if((dwTickCount >= LY_CTHL_AutoDelay) || (LY_CTHL_PARAM_NLSL_MODE))
                 {  
                 if(!LY_CTHL_PARAM_NLSL_MODE)
                    LY_CTHL_DXK_VAVLE=1;
                  LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_DXK_XKDW_Off_DELAY;
                  LY_CTHL_AutoStep = 9;
                 }
                 }

               }
               break;
            case 9: 
                if((dwTickCount >= LY_CTHL_AutoDelay) && (bCL_OK_FLG))  //бʱбֹλ
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
 //                   AxisMovePosAccDec(X_AXIS,2000,-150,1200,1200,3,6,0);  //ת1.5CM
                    LY_CTHL_XKDW_VAVLE = 0;    //бֹλ
                    LY_CTHL_FKJD_VAVLE = 0;   //д׹
                    LY_CTHL_AutoStep = 10;    
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_XK_CR_DELAY;
                 }
                }              
                break;
            case 10:  
               if(!cBanAuTo)
               {
                if((dwTickCount >= LY_CTHL_AutoDelay) && !X_DRV)
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_TD_MotorStep = 10;   //ϴ            
                    LY_CTHL_AutoStep = 11;  
                 }

                }
               }
               else
               {
                LY_CTHL_AutoStep = 801; 
                  LY_CTHL_AutoDelay = dwTickCount + 1000;
               }
                break;
           case 801:
              if(dwTickCount >= LY_CTHL_AutoDelay)
              {
                 
                  bRunning=0;
                  cBanAuTo=0;
                  LY_CTHL_QDXK_VAVLE=0;
                  LY_CTHL_XKTD_VAVLE = 0;
                  LY_CTHL_DXK_VAVLE=0;
                  LY_CTHL_AutoStep = 0; 
              
              }
              break;
            case 11:
              
                if(LY_CTHL_TD_MotorStep == 0)  //붨λ
                {      
             /*   //ϴλ  
                    LY_CTHL_AutoStep = 1;       
                    LY_CTHL_AutoDelay = dwTickCount + 1000;
                     if(cZipCnt<3)
                        cZipCnt++;
                    break;  */
               if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                  
                        LY_CTHL_XKDW_VAVLE = 0;    //бֹλ
                        LY_CTHL_XKTD_VAVLE = 1;     //бƴ 
                        LY_CTHL_CXSCDW_VAVLE = 1;   //Y21 ֹλŷ
                        cXcxcrCnt = 0;
                        if(LY_CTHL_CL_MotorStep == 0)
                        {                          
                           LY_CTHL_CXQJD_VAVLE = 1;
                        }                 
                        LY_CTHL_AutoStep = 12; 
                        LY_CTHL_AutoDelay = dwTickCount;
                 }
                 
                }  
                break;        
            case 12: 
                if(LY_CTHL_CL_MotorStep == 0)  //ǰдصԭλ
                {
                  if(LY_CTHL_SF_Origin_IN)
                  {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 14; 
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_XCQJD_XCDW_DELAY;
                    if(cXcxcrCnt != 1)
                    {                        
                      LY_CTHL_CXQJD_VAVLE = 1;                    
                    }
                 }
                  }
                  else if(dwTickCount >= (LY_CTHL_AutoDelay+100))
                  {
                  LY_CTHL_SetAlarmCode(LY_CTHL_SF_Origin_ALARM,bRunning); //ŷԭλ
                  }
                }
                break;
            case 14:
                if(dwTickCount >= LY_CTHL_AutoDelay)
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_XKDW_VAVLE = 1; //бڶλ 
                    LY_CTHL_AutoStep = 15; 
                    LY_CTHL_FKGD_VAVLE = 1;     //̶
                    //Y
                    if(cXcxcrCnt != 1)
                    {   
                      LY_CTHL_CL_MotorStep = 20;  //λ     
                    }
                 }
                }
                break;
            case 15:   
                if(LY_CTHL_CL_MotorStep == 0)   //λ
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 16; 
                    LY_CTHL_CXDWZ_VAVLE = 1;    //λ(λ)ŷ
                    LY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
                    LY_CTHL_AutoDelay = dwTickCount + 10;  //ʱ
                 }
                }  
                break;
            case 16: 
                if(dwTickCount >= LY_CTHL_AutoDelay)
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 17; 
                     if(LY_CTHL_PARAM_CXLY_MODE)
                       LY_CTHL_CXLY_VAVLE = 0;
                    else
                       LY_CTHL_CXLY_VAVLE = 1;     //Y06 Ƶŷ
                    LY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;  //쳣ʱ
                 }
                }
                break;
            case 17:   
                 if(LY_CTHL_PARAM_CXLY_MODE)
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                  if(LY_CTHL_CXLY_Limit_IN)
                  {
                      LY_CTHL_AutoStep = 18; 
                      if( cXcxcrCnt==0 && !X_DRV && !cCXCONE)  //ϴת
                      {
                          AxisMovePosAccDec(X_AXIS,8000,-LY_CTHL_PARAM_TDFZ_LENTH,800,600,6,6,0);               
                      }
                      LY_CTHL_CXQJD_VAVLE = 0;    //ǰдŷ     
                      LY_CTHL_CXSCDW_VAVLE = 0;   //Y21 ֹλ                    
                      LY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
                      LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_SCDWOff_CXDW_DELAY;
                  }
                     
                  }  
                  else if(dwTickCount >= LY_CTHL_AutoDelay)  
                  {
                      LY_CTHL_SetAlarmCode(LY_CTHL_CXLY_Limit_ALARM,bRunning); //쳣
                      
                  }
                }
              else
              {        
                 if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 18; 
                    if( cXcxcrCnt==0 && !X_DRV && !cCXCONE)  //ϴת
                    {
                        AxisMovePosAccDec(X_AXIS,8000,-LY_CTHL_PARAM_TDFZ_LENTH,800,600,6,6,0);               
                    }
                    LY_CTHL_CXQJD_VAVLE = 0;    //ǰдŷ
                    LY_CTHL_CXSCDW_VAVLE = 0;   //Y21 ֹλ   
                    
                    LY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_SCDWOff_CXDW_DELAY;    
                 }
              }
                break;
            case 18:   
  //              if(START_IN_UP)
                {
                if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 19; 
                    cBAOHUCNT=0;
                    LY_CTHL_CXHDW_VAVLE = 1;     //λ()
                    LY_CTHL_AutoDelay = dwTickCount + 500;  //뵽λ쳣ʱ
                    LY_CTHL_CL_MotorStep = 50;  //ԭ
                 }
                }
                }
                break;
            case 19:   
                
                if(LY_CTHL_CX_Limit_IN && (cXcxcrCnt<4))
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                   cXcxcrCnt=0;
                   cXiaoChaCNT=0;
                   user_datas[100]=0;
                    bZhuangLiaoOkFlg = 0;
                  LY_CTHL_CXLY_VAVLE=0;
                    LY_CTHL_AutoStep = 901;
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_FKGD_DELAY; //˷̶ʱ
                    LY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
                 }
                   
                }  
                else if ((dwTickCount >= LY_CTHL_AutoDelay) && (cXcxcrCnt<3) )
                {
                   cXcxcrCnt++;
                   LY_CTHL_CXHJD_VAVLE=0;
                   LY_CTHL_CXHDW_VAVLE=0;
                   if(!LY_CTHL_PARAM_CXLY_MODE)
                      LY_CTHL_CXLY_VAVLE=0;
                    else
                      LY_CTHL_CXLY_VAVLE=1;
                   if(cXcxcrCnt<3)
                   {
                     LY_CTHL_CXSCDW_VAVLE=1;
                     LY_CTHL_AutoStep = 12;
                     LY_CTHL_AutoDelay = dwTickCount + 120;
                   }
                }
                else if((dwTickCount >= (LY_CTHL_AutoDelay +3000))  && !LY_CTHL_CX_Limit_IN )
                {
                   cXiaoChaCNT=1;
                   if(!LY_CTHL_PARAM_CXLY_MODE)
                     LY_CTHL_CXLY_VAVLE=0;
                   else
                     LY_CTHL_CXLY_VAVLE=1; 
                   LY_CTHL_CXHJD_VAVLE =0;
               
                   cBAOHUCNT=1;
                  LY_CTHL_SetAlarmCode(LY_CTHL_CX_Limit_ALARM ,bRunning);//뵽λ쳣  
                }
      
               if( cXcxcrCnt > 2) 
                {
                   cXiaoChaCNT=1;
              
                     LY_CTHL_CXLY_VAVLE=0;
                   LY_CTHL_CXHJD_VAVLE =0;
                   cBAOHUCNT=1;
                  LY_CTHL_SetAlarmCode(LY_CTHL_CX_Limit_ALARM ,bRunning);//뵽λ쳣  
                }
      
              break;
              
            case 901:
                if(dwTickCount >= LY_CTHL_AutoDelay)
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                 LY_CTHL_FKGD_VAVLE = 0;     //̶
                    LY_CTHL_AutoStep = 20;
                    if(!cBAOHUCNT)
                       LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_First_CL_DELAY;//ʱһδ
                    else
                    {
                      LY_CTHL_AutoDelay = dwTickCount + 1000;//ֶʱ
                      cBAOHUCNT=0;
                    }
                 }
             
                }
            break;
            case 20:  
                if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 21;
                    LY_CTHL_First_CT_VAVLE = 1;   //һδŷ
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                 }
                }
                break;
            case 21:   
                if(!LY_CTHL_First_CT_Origin_IN)  //ԭ뿪ſʼʱ
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 22;
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_First_CL_Timer;  //һδʱ
                 }
                }
                else if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                    LY_CTHL_SetAlarmCode(LY_CTHL_YCCRYWYC_ALARM,bRunning); //һδԭλ쳣
                }
                break;
            case 22:
                if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 23;
                    LY_CTHL_MGuo_VAVLE = 0;     //빴
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_PARAM_MGOff_XiaMo_DELAY;
                    LY_CTHL_FKGD_VAVLE = 0;     //̶
                    LY_CTHL_FKJD_VAVLE=0;
                    LY_CTHL_CXHJD_VAVLE = 0;    //Y14 д 
                    LY_CTHL_CXLY_VAVLE = 0;     //Y06 Ƶŷ
                 }
                } 
                break;
            case 23:  
                if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 24;
                    LY_CTHL_CTXM_VAVLE = 0; //ͷģ½
                    LY_CTHL_AutoDelay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                 }
                } 
                break;
            case 24: 
                if(!LY_CTHL_CTM_Limit_IN)
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 25;
                    LY_CTHL_AutoDelay = dwTickCount + 20;  //һδʱ
                 }
                }
                else if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                    LY_CTHL_SetAlarmCode(LY_CTHL_CTM_Origin_ALARM,bRunning);//ͷģ½쳣
                }
                break;
            case 25:
                if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    LY_CTHL_AutoStep = 26;
                    LY_CTHL_First_CT_VAVLE = 0;   //һδŷ
                    LY_CTHL_AutoDelay = dwTickCount + 5;
                    LY_CTHL_CXHDW_VAVLE = 0;     //λ()ر
                    //³
                    LY_CTHL_AutoDelay1 = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                    LY_CTHL_AutoStep1 = 1;
                 }
                }
                break;
        
          
            case 26: 
                if(dwTickCount >= LY_CTHL_AutoDelay) 
                {
                   if(!LY_CTHL_bDanBu || LY_CTHL_START_IN_UP)
                 {
                    if(!cCXCONE)
                    {
                    LY_CTHL_FKJD_VAVLE = 1;   //д   
                    LY_CTHL_FKGD_VAVLE = 0;     //̶            
                    LY_CTHL_AutoStep = 2;
                    bCL_EN_FLG = 1;
                    cXcxcrCnt=0;
                    AddToTal(LY_CTHL_TOTAL_ADDR);
                    
                    CalProSP(LY_CTHL_SPEED_ADDR);
                    if(cZipCnt<3)
                        cZipCnt++;
                    }
                    else
                    {
                      bRunning=0;
                      cCXCONE=0;
                    LY_CTHL_AutoStep = 0;
                    
                    }
                 }
                    
                }
                break;
                
        }   
    }       
        //ģͷ
        switch(LY_CTHL_AutoStep1)
        {   
            case 1:
              if(cStopMode==1)
              {
                bCL_EN_FLG=1;
                cStopMode=2;
                 bStop=1;
              }
                if(LY_CTHL_CTM_Origin_IN && LY_CTHL_First_CT_Origin_IN)
                {
                    LY_CTHL_ZhuangLiaoStep = 1;
                    LY_CTHL_TryCnt = 0;
                    LY_CTHL_AutoStep1 = 0;
                    LY_CTHL_MGuo_VAVLE = 0;
                    LY_CTHL_JLTou_VAVLE = 0;
                }
                else if(dwTickCount >= LY_CTHL_AutoDelay1) 
                {
                  //ͷģһδλ쳣
                    if(!LY_CTHL_CTM_Origin_IN)
                      LY_CTHL_SetAlarmCode(LY_CTHL_CTM_Origin_ALARM,bRunning);
                    else if(!LY_CTHL_First_CT_Origin_IN)
                      LY_CTHL_SetAlarmCode(LY_CTHL_First_CT_Origin_ALARM,bRunning);                    
                } 
                break;
                
        }  
         
}





void LY_CTHL_CheckStart(void)
{
  //
  if(cBanAuTo)
  {
  LY_CTHL_PARAM_XCRU=1;
  }
  else
  {
  LY_CTHL_PARAM_XCRU=0;
  }
  //
  if(cCXCONE)
  {
  LY_CTHL_PARAM_CXCR=1;
  }
  else
  {
  LY_CTHL_PARAM_CXCR=0;
  }
  
  if(cXCXQXQD)
  {
            if(LY_CTHL_START_IN_UP || bStart)
              {
                  bStart=0;
                if(!bRunning)
                {
                  if(LY_CTHL_SafeDoor_IN )
                  {
                   bRunning=1;             
                   cXCXQXQD =0;  
                 LY_CTHL_TD_MotorStep = 0;   
                   LY_CTHL_AutoStep=11;
                   }
                    else
                    {
                        LY_CTHL_SetAlarmCode(LY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
                    }
                }
              }
  
  
  }
      if(cWULATOUCnt) // ͷ
      {
            if(LY_CTHL_START_IN_UP || bStart)
            {
              bStart=0;
              if(!bRunning)
              {
                    if(LY_CTHL_SafeDoor_IN)
                    {  
                        bRunning=1;
                       LY_CTHL_TryCnt=0;
                       cWULATOUCnt=0;
                      LY_CTHL_ZhuangLiaoStep = 1; 
                      LY_CTHL_AutoStep=6;
                       bTuiLaTouOkFlg = 1;
                        bZhuangLiaoOkFlg= 0;
                       LY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
                       LY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
                    }
                    else
                    {
                        LY_CTHL_SetAlarmCode(LY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
                    }
              }
            }
      }
    if(!LY_CTHL_SafeDoor_IN && bRunning && !cBanAuTo && !cCXCONE)
    {
      bStop=1;
      LY_CTHL_SetAlarmCode(LY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
     }
      
       //    Զ һԶ	 			
    if((LY_CTHL_START_IN_UP || bStart ) && !cWULATOUCnt  && !cXCXQXQD)
    {
     if(cCHULIANBAOJIN) //ͣ
      {
      cCHULIANBAOJIN=0;
      SetEn(X_AXIS, MOTOR_EN);
  //      dwXRealPos=0;
       LY_CTHL_TD_MotorStep=10;
        if(LY_CTHL_SF_ALR_IN )
        {
          LY_CTHL_SF_ALR_CLR=1;
          LY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 300;
        }
        cZipCnt=0;
        LY_CTHL_TD_MotorDelay = dwTickCount + 500;
         LY_CTHL_AutoDelay = dwTickCount + 150;
        if(GetAlarmCode(LY_CTHL_ALARM_ADDR) != 0)
           SetAlarmCode(LY_CTHL_ALARM_ADDR,0);   

      }
      
        if(!bRunning)
        {
            if(LY_CTHL_SafeDoor_IN)
            {  
               cStopMode=0;
                bRunning = 1;
                cWULATOUCnt=0;
                cHeLian=0;
                SetEn(X_AXIS, MOTOR_EN);
                SetEn(Y_AXIS, MOTOR_EN);        
                LY_CTHL_CL_MotorStep = 40;
                LY_CTHL_AutoStep = 1;
                bTuiLaTouOkFlg = 1;
                LY_CTHL_PARAM_ZDP_AUTO= 0;
                bZhuangLiaoOkFlg= 0;
                LY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
             //   bCL_EN_FLG = 0;
                cZipCnt = 0;
                cQDXK_DXK=0;
                LY_CTHL_LianLengthCheck = 0;
                cStopInCnt = 0;
             }
             else
             {
                LY_CTHL_SetAlarmCode(LY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
             }            
        }  
        bStart = 0;
    }   
    
    //ֹͣ
    if(LY_CTHL_STOP_IN_UP || bStop)
    {	

      if(cStopMode < 2)
        cStopMode++;
      if(bRunning && cStopMode==2)
      {   
       cBanAuTo=0;
        cCXCONE=0;
        bRunning=0;
        cStopMode=0;
        cXcxcrCnt=0;
        cXCXQXQD=0;
        cCHULIANBAOJIN=0;
        cWULATOUCnt=0;
        AxisEgmStop(X_AXIS);
        AxisEgmStop(Y_AXIS);
        LY_CTHL_AutoStep = 0; 
        LY_CTHL_CL_MotorStep =0;      
        LY_CTHL_bCLFirst_Step=0;  
        LY_CTHL_ZhuangLiaoStep=0;
      //  LY_CTHL_XKTD_VAVLE = 0; 
        cQDXK_DXK=0;
     //   LY_CTHL_XKDW_VAVLE =0;
        if(LY_CTHL_SF_ALR_IN )
        {
          LY_CTHL_SF_ALR_CLR=1;
          LY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
        }
        if(GetAlarm(Y_AXIS)==0 || GetAlarm(X_AXIS)==0)
        {
           SetClr(Y_AXIS, MOTOR_NOALARM);
            SetClr(X_AXIS, MOTOR_NOALARM);
         LY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
        }
        if(GetAlarmCode(LY_CTHL_ALARM_ADDR) != 0)
           SetAlarmCode(LY_CTHL_ALARM_ADDR,0);    
        
      }
      else if(!bRunning)
      {
           cBanAuTo=0;
            cCXCONE=0;
         bRunning=0;
          cXcxcrCnt=0;
          cStopMode=0;
              cCHULIANBAOJIN=0;
            cXCXQXQD=0;
          cWULATOUCnt=0;
          bCL_EN_FLG=0;
         AxisEgmStop(X_AXIS);
          AxisEgmStop(Y_AXIS);
         SetEn(X_AXIS, MOTOR_DISEN);
         SetEn(Y_AXIS, MOTOR_DISEN);
          cStopMode=0;
          cQDXK_DXK=0;
        if(LY_CTHL_SF_ALR_IN )
        {
          LY_CTHL_SF_ALR_CLR=1;
          LY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
        }
       if(GetAlarm(Y_AXIS)==0 || GetAlarm(X_AXIS)==0)
        {
           SetClr(Y_AXIS, MOTOR_NOALARM);
            SetClr(X_AXIS, MOTOR_NOALARM);
         LY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
        }
          LY_CTHL_TLiao_VAVLE=0;             
         LY_CTHL_HSLiao_VAVLE  =0;    
         LY_CTHL_JLTou_VAVLE  =0;     
         LY_CTHL_XKTD_VAVLE  =0;        
         LY_CTHL_XKDW_VAVLE  =0;       
         LY_CTHL_DXK_VAVLE  =0;         
         LY_CTHL_CXLY_VAVLE  =0;         
         LY_CTHL_CTXM_VAVLE =0;         
         LY_CTHL_First_CT_VAVLE =0;     
         LY_CTHL_FKGD_VAVLE =0;         
         LY_CTHL_CXQJD_VAVLE =0;        
         LY_CTHL_CXDWZ_VAVLE  =0;       
         LY_CTHL_CXHJD_VAVLE =0;        
         LY_CTHL_CXHDW_VAVLE =0;        
         LY_CTHL_FKJD_VAVLE  =0;        
         LY_CTHL_HLJJ_VAVLE  =0;                       
         LY_CTHL_CXSCDW_VAVLE =0;
         LY_CTHL_MGuo_VAVLE =0;
         LY_CTHL_QDXK_VAVLE=0;
               
         LY_CTHL_AutoStep = 0;
         LY_CTHL_ZhuangLiaoStep=0;
         LY_CTHL_TLiaoStep=0;
         LY_CTHL_TD_MotorStep=0;
         LY_CTHL_JiaLianStep  =0;        
         LY_CTHL_SongLiaoStep   =0;     
         LY_CTHL_CL_MotorStep =0;      
         LY_CTHL_AutoStep1  =0;
         LY_CTHL_bFKCXTDDW_Step=0;
         LY_CTHL_bCXCR_Step=0;
         LY_CTHL_bCLFirst_Step=0;
         if(GetAlarmCode(LY_CTHL_ALARM_ADDR) != 0)
            SetAlarmCode(LY_CTHL_ALARM_ADDR,0);  
          SetPos(X_AXIS, 0); 

        LY_CTHL_TLiaoStep = 0; 
        LY_CTHL_AutoStep = 0;
        
        //㷽ʱֹͣ
        if(GetDir(Y_AXIS) == DIR_N)
            AxisEgmStop(Y_AXIS);

      }
      bStop=0;
    }
     
   if(bAlarmStop)
    {   
      bRunning   = 0;
      bAlarmStop=0;
      cStopMode=0;
      cXcxcrCnt=0;
      AxisEgmStop(X_AXIS);
      AxisEgmStop(Y_AXIS);
      LY_CTHL_AutoStep = 0; 
      cQDXK_DXK=0;
      LY_CTHL_CL_MotorStep =0;      
      LY_CTHL_bCLFirst_Step=0;  
      LY_CTHL_SongLiaoStep =0;
      LY_CTHL_ZhuangLiaoStep=0;
     // LY_CTHL_XKTD_VAVLE = 0; 
     // LY_CTHL_XKDW_VAVLE =0;
       
    }
}   

//ϴƶ  X
void LY_CTHL_TD_Motor(void)	 //
{   
#if 1
     switch(LY_CTHL_TD_MotorStep)
	{
        //1ʼλ, ûд
        case 1:
            if(dwTickCount >= LY_CTHL_TD_MotorDelay)  //ʱ
            {
                bCheckEN_FLG = 1;
                LY_CTHL_CheckInX02PosBuff= 0;
                 LY_CTHL_TD_MotorStep = 2;   
                 SetPos(X_AXIS, 0);  //λΪ0
                 AxisContinueMoveAcc(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed*2/3,DIR_P,800,600,15,15);
                 LY_CTHL_X_CXPosBuff=0;
            }  
            break;
        case 2://⵽
            if(dwXRealPos > 400)    //2CM
            {
                if(LY_CTHL_PARAM_NLSL_MODE)
                  {
                    LY_CTHL_XKTD_VAVLE=0;
                  }
                LY_CTHL_DXK_VAVLE = 0;   //б׹  
                LY_CTHL_QDXK_VAVLE = 0;
            }    
            if(dwXRealPos >= LY_CTHL_PARAM_WLCDSHEZHI_LENTH)
            {
              LY_CTHL_SetAlarmCode(LY_CTHL_WLZDTJ_ALARM,bRunning);   //Զͣ              
            }
            if(LY_CTHL_FK_Check)
            {
                LY_CTHL_DXK_VAVLE = 0;   //б׹
                LY_CTHL_QDXK_VAVLE = 0;
                LY_CTHL_XSavePosBuff = dwXRealPos;
                LY_CTHL_TD_MotorStep = 3;  
                user_datas[123] = dwXRealPos - LY_CTHL_CheckInX02PosBuff;
                if((dwXRealPos >= LY_CTHL_CheckInX02PosBuff) && LY_CTHL_CheckInX02PosBuff)
                    AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed*2/3,LY_CTHL_PARAM_FKDW_Length - (dwXRealPos- LY_CTHL_CheckInX02PosBuff)-160,
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,30,40); 
                else
                    AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed*2/3,LY_CTHL_PARAM_FKDW_Length-120,
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,30,40); 
            }
            break;
        case 3:    
            if(LY_CTHL_CXSC_Limit_IN_UP)
            {
                LY_CTHL_X_CXPosBuff = dwXRealPos;
                
            }  
           
             if(!X_DRV || (dwXRealPos >= (LY_CTHL_XSavePosBuff + LY_CTHL_PARAM_FKDW_Length)))
            {
                AxisEgmStop(X_AXIS);
               LY_CTHL_TD_MotorStep =4 ; 
               LY_CTHL_LianLengthAutoCheck = dwXRealPos;
            }
             break;
        case 4:
          if(LY_CTHL_PARAM_XCX_LENTH)   //0Ļжλ
            {
                   
                  if ((dwXRealPos - LY_CTHL_X_CXPosBuff) > (LY_CTHL_PARAM_XCX_LENTH + LY_CTHL_PARAM_XCXWC_LENTH)) 
                  {
//                    user_datas[121] = 1;
                      LY_CTHL_TD_MotorStep = 0;
                      LY_CTHL_SetAlarmCode(LY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
            
                  }         

                   else if(LY_CTHL_X_CXPosBuff == 0)
                   {
  //                    user_datas[121] = 3;
                       LY_CTHL_TD_MotorStep = 0;
                         LY_CTHL_SetAlarmCode(LY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
                   }   
                   else
                   {
                     LY_CTHL_TD_MotorStep = 0;
                     LY_CTHL_X_CXPosBuff=dwXRealPos;
                     
                    }

            }
            else
            {
                LY_CTHL_TD_MotorStep = 0;
           //     LY_CTHL_X_CXPosBuff=dwXRealPos;
            }
          break;
          
            //ͷλ
        case 10:   
            if(dwTickCount >= LY_CTHL_TD_MotorDelay)
            {
                LY_CTHL_TD_MotorStep = 11;
                SetPos(X_AXIS, 0);  //λΪ0
                dwXRealPos = 0;
                AxisContinueMoveAcc(X_AXIS,LY_CTHL_PARAM_TDCR_LowSpeed,DIR_P,200,200,5,5);   
                LY_CTHL_CheckInX02PosBuff= 0;
                LY_CTHL_X_CXPosBuff=0;
                bCheckEN_FLG = 1;
            }
            break;
        case 11:   
            if(LY_CTHL_PARAM_NLSL_MODE)
              LY_CTHL_Data_Buff = 600;
            else
               LY_CTHL_Data_Buff = 400;
            if(dwXRealPos > LY_CTHL_Data_Buff)    //2CM
            {
                LY_CTHL_CheckInX02PosBuff= 0;
                LY_CTHL_DXK_VAVLE = 0;   //б׹
                 LY_CTHL_QDXK_VAVLE = 0;
                  if(LY_CTHL_PARAM_NLSL_MODE)
                  {
                    LY_CTHL_XKTD_VAVLE=0;
                  }
                LY_CTHL_TD_MotorStep = 12;
                if((cZipCnt < 2) || ((LY_CTHL_LianLengthCheck < LY_CTHL_PARAM_TDCR_LowSpeedLength+300) && (LY_CTHL_PARAM_NLSL_MODE == 0)) || 
                   ((LY_CTHL_LianLengthCheck < LY_CTHL_PARAM_TDCR_LowSpeedLength+600) && (LY_CTHL_PARAM_NLSL_MODE == 1))) 
                    AxisContinueMoveAcc(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed*2/3,DIR_P,3000,600,10,10); 
                else ////ٶƶ                
                {  
                  if(LY_CTHL_PARAM_NLSL_MODE == 0)
                      AxisMovePosAccDecNotStop(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed * 1.5,LY_CTHL_LianLengthCheck-(LY_CTHL_PARAM_TDCR_LowSpeedLength),3000,LY_CTHL_PARAM_TD_RunSpeed*2/3,15,70,600); 
                  else  //
                  {  
                      AxisMovePosAccDecNotStop(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed * 1.3,LY_CTHL_LianLengthCheck-(LY_CTHL_PARAM_TDCR_LowSpeedLength),3000,LY_CTHL_PARAM_TD_RunSpeed*2/3,12,120,850); 
                  }
                }
            }
             if(LY_CTHL_FK_Check)    //⵽˵ٶȻû
            {
               LY_CTHL_DXK_VAVLE = 0;   //б׹
                 LY_CTHL_QDXK_VAVLE = 0;
                  if(LY_CTHL_PARAM_NLSL_MODE)
                  {
                    LY_CTHL_XKTD_VAVLE=0;
                  }
                LY_CTHL_TD_MotorDelay= dwTickCount + LY_CTHL_PARAM_FKJDSECONG_DEALY;
                LY_CTHL_LianLengthReal = dwXRealPos;
 
                LY_CTHL_XSavePosBuff = dwXRealPos;
                LY_CTHL_TD_MotorStep = 13;  
           //     user_datas[122] = LY_CTHL_PARAM_FKDW_Length - (dwXRealPos- LY_CTHL_CheckInX02PosBuff);
                
               if((dwXRealPos >= LY_CTHL_CheckInX02PosBuff) && LY_CTHL_CheckInX02PosBuff)
                   AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed,LY_CTHL_PARAM_FKDW_Length - (dwXRealPos- LY_CTHL_CheckInX02PosBuff),
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,150,10); 
                else
                    AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed,LY_CTHL_PARAM_FKDW_Length,
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,150,10); 
                 //LY_CTHL_TD_MotorStep = 0;  
            }
               else if(LY_CTHL_CXSC_Limit_IN_DW)
               {
                 LY_CTHL_SetAlarmCode(LY_CTHL_DK_ERROR_ALARM,bRunning);
               }
            else if(LY_CTHL_CXSC_Limit_IN_UP)
               {
                  AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed * 2/3,LY_CTHL_PARAM_FKDW_Length,
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,150,10); 
               }
            break;
        case 12://⵽       
          if(cZipCnt<2)
          { 
            if(dwXRealPos >= LY_CTHL_PARAM_WLCDSHEZHI_LENTH)
            {
                if(bRunning)
                {
                    cCHULIANBAOJIN=1;
                    SetEn(X_AXIS, MOTOR_DISEN);
                    AxisEgmStop(X_AXIS);
                    SetPos(X_AXIS, 0);  //λΪ0
            //     dwXRealPos=0;
                }
                LY_CTHL_SetAlarmCode(LY_CTHL_WLZDTJ_ALARM,bRunning);   //Զͣ             
            }
          }
          else
          {
            if(dwXRealPos >= LY_CTHL_LianLengthAutoCheckERROR + LY_CTHL_PARAM_WUCD_LENTH)
            {
                if(bRunning)
                {
                  cCHULIANBAOJIN=1;
                  SetEn(X_AXIS, MOTOR_DISEN);
                  AxisEgmStop(X_AXIS);
                  SetPos(X_AXIS, 0);  //λΪ0
          //     dwXRealPos=0;
                }
                LY_CTHL_SetAlarmCode(LY_CTHL_WLZDTJ_ALARM,bRunning);   //Զͣ             
            }
          
          }
            if(LY_CTHL_FK_Check)
            {
                LY_CTHL_TD_MotorDelay= dwTickCount + LY_CTHL_PARAM_FKJDSECONG_DEALY;
                LY_CTHL_LianLengthReal = dwXRealPos;
                if(cZipCnt == 1)
                    user_datas[122] = dwXRealPos;
 //               user_datas[121] = dwXRealPos;
                if((cZipCnt == 1)  || dwXRealPos < (LY_CTHL_LianLengthCheck*0.85) || dwXRealPos>(LY_CTHL_LianLengthCheck*1.2))
                    LY_CTHL_LianLengthCheck = dwXRealPos;
                
                LY_CTHL_LianLengthCheckOLD=LY_CTHL_LianLengthNEWCheck;
                LY_CTHL_LianLengthNEWCheck  = dwXRealPos; 
                //break;
                LY_CTHL_XSavePosBuff = dwXRealPos;
                LY_CTHL_TD_MotorStep = 13;  
           //     user_datas[122] = LY_CTHL_PARAM_FKDW_Length - (dwXRealPos- LY_CTHL_CheckInX02PosBuff);
                
               if((dwXRealPos >= LY_CTHL_CheckInX02PosBuff) && LY_CTHL_CheckInX02PosBuff)
                   AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed,LY_CTHL_PARAM_FKDW_Length - (dwXRealPos- LY_CTHL_CheckInX02PosBuff)-50,
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,150,40); 
                else
                    AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed,LY_CTHL_PARAM_FKDW_Length-50,
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,150,40); 
                 //LY_CTHL_TD_MotorStep = 0;  
            }
               else if(LY_CTHL_CXSC_Limit_IN_DW)
               {
                 LY_CTHL_SetAlarmCode(LY_CTHL_DK_ERROR_ALARM,bRunning);
               }
            else if(LY_CTHL_CXSC_Limit_IN_UP)
               {
                  AxisMovePosAccDec(X_AXIS,LY_CTHL_PARAM_TD_RunSpeed * 2/3,LY_CTHL_PARAM_FKDW_Length,
                                  LY_CTHL_PARAM_FKDW_Speed,LY_CTHL_PARAM_FKDW_Speed,10,150,40); 
               }
            break;   
        case 13:
           if(dwTickCount >= LY_CTHL_TD_MotorDelay)
            {
                LY_CTHL_FKJD_VAVLE = 1;   //д
            
            }
            if(LY_CTHL_CXSC_Limit_IN_UP)
            {
                LY_CTHL_X_CXPosBuff = dwXRealPos;
             
            }  
            if((!X_DRV ))// || (dwXRealPos >= (LY_CTHL_XSavePosBuff + LY_CTHL_PARAM_FKDW_Length)))
            {
               // user_datas[123] = dwXRealPos-LY_CTHL_CheckInX02PosBuff;
                AxisEgmStop(X_AXIS);
                LY_CTHL_TD_MotorStep = 14; 
       /*       if(cZipCnt>2)
                {
                 if(((LY_CTHL_LianLengthNEWCheck+LY_CTHL_LianLengthCheckOLD)*0.5) < (LY_CTHL_LianLengthCheck*0.95))
                 {
                   cZipCnt=0;  
                   cHeLian=1;
                 }
                }*/
                if(cZipCnt==1)
                    LY_CTHL_LianLengthAutoCheckERROR = dwXRealPos;
                
                if(cZipCnt==1)
                 LY_CTHL_LianLengSave=dwXRealPos;

                LY_CTHL_LianLengthAutoCheck = dwXRealPos;
 //                user_datas[122] = dwXRealPos-LY_CTHL_X_CXPosBuff;
            }
            break;
        case 14:
          
       if(LY_CTHL_PARAM_XCX_LENTH)   //0Ļжλ
            {
               
                  if ((dwXRealPos - LY_CTHL_X_CXPosBuff) > (LY_CTHL_PARAM_XCX_LENTH + LY_CTHL_PARAM_XCXWC_LENTH)) 
                  {
                  //  user_datas[121] = 1;
                      LY_CTHL_TD_MotorStep = 0;
                      cXCXQXQD=1;
                      LY_CTHL_SetAlarmCode(LY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
            
                  }         
                  else if((dwXRealPos - LY_CTHL_X_CXPosBuff) < (LY_CTHL_PARAM_XCX_LENTH - LY_CTHL_PARAM_XCXWC_LENTH))
                 {
                   //   user_datas[121] = 2;
                     LY_CTHL_TD_MotorStep = 0;
                      cXCXQXQD=1;
                      LY_CTHL_SetAlarmCode(LY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
                   }    
                   else if(LY_CTHL_X_CXPosBuff == 0)
                   {
                  //    user_datas[121] = 3;
                       LY_CTHL_TD_MotorStep = 0;
                        cXCXQXQD=1;
                         LY_CTHL_SetAlarmCode(LY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
                   }   
                   else
                   {
                  
                     LY_CTHL_TD_MotorStep = 15;
                    }

            }
            else
            {
       
                LY_CTHL_TD_MotorStep = 15;
            }
          break;
        case 15:
  //          if(LY_CTHL_START_IN_UP)
                LY_CTHL_TD_MotorStep = 0;
          
          
	}   
#endif    
}
//Y
void LY_CTHL_CL_Motor(void)	 //
{   
#if 0
    //1ʼ,  ȿʼ
  //20ʼ  λʼ
  //40,ԭΪ
    switch(LY_CTHL_CL_MotorStep)
	{
         //볤λ
         case 1:
            
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
              // SetDir(Y_AXIS, DIR_P);
                if(LY_CTHL_PARAM_CL_Length >= LY_CTHL_PARAM_CL_MAX_Length)
                    LY_CTHL_PARAM_CL_Length = LY_CTHL_PARAM_CL_MAX_Length;
                //볤Ҫݼⳤȼһδ1CM,ת2CM
                if((LY_CTHL_LianLengthAutoCheck < (LY_CTHL_PARAM_CL_Length + 500 )) && bRunning) 
                    AxisMovePosAccDec(Y_AXIS,LY_CTHL_PARAM_CL_Speed,(LY_CTHL_LianLengthAutoCheck-500),800,600,6,6,50);       
                else
                    AxisMovePosAccDec(Y_AXIS,LY_CTHL_PARAM_CL_Speed,(LY_CTHL_PARAM_CL_Length-100),800,600,6,6,50); 
                LY_CTHL_CL_MotorStep = 2; 
            }
            break;
        case 2:
            if((dwYRealPos + 120) > LY_CTHL_PARAM_CL_Length)
                LY_CTHL_HLJJ_VAVLE = 0;
            if(!Y_DRV || dwYRealPos >= LY_CTHL_PARAM_CL_Length)  
            {
                LY_CTHL_HLJJ_VAVLE = 0;
               LY_CTHL_CL_MotorStep = 3;  
                bCL_OK_FLG = 1;
               LY_CTHL_CL_MotorDelay = dwTickCount + 40;  //ʱػ
            }
            break; 
        case 3: 
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
                LY_CTHL_CL_MotorStep = 50;  
            }
            break;
          //дλ  
        case 20: //˴öλ
            if(cXcxcrCnt > 0)
            {
             LY_CTHL_LENTH = LY_CTHL_PARAM_CXDW_Length + 30; 
             LY_CTHL_CL_MotorStep = 21;
            }
            else
            {
            LY_CTHL_LENTH = LY_CTHL_PARAM_CXDW_Length ;
            LY_CTHL_CL_MotorStep = 21;
            }         
            break;
        case 21:
              SetDir(Y_AXIS, DIR_P);
              AxisMovePosAccDec(Y_AXIS,8000,LY_CTHL_LENTH,800,500,6,6,50);            
              LY_CTHL_CL_MotorStep = 22; 
            break;
        case 22: 
            if(!Y_DRV || (dwYRealPos >= LY_CTHL_LENTH)) //λѾ
            {
                AxisEgmStop(Y_AXIS);
                LY_CTHL_YsaveCXDWPosBuff = 0;
                LY_CTHL_CL_MotorStep = 0;                       
            } 
            break;
          //ԭ㿪ʼ
        case 40: 
          //Ҫ뿪    
            if(LY_CTHL_SF_Origin_IN && (GetEn(Y_AXIS) == MOTOR_DISEN))  
            {
                LY_CTHL_CL_MotorStep = 41; 
                SetDir(Y_AXIS, DIR_P);
            }    
            else  
            {
                SetDir(Y_AXIS, DIR_N);
                LY_CTHL_CL_MotorStep = 46;
                
            }    
            if(GetEn(Y_AXIS) == MOTOR_DISEN) 
            {
                SetEn(Y_AXIS, MOTOR_EN);
                LY_CTHL_CL_MotorDelay = dwTickCount + 260;   //ʱ
                
            }
            else  //Ѿ
                LY_CTHL_CL_MotorDelay = dwTickCount + 5;            
            break;
        case 41:
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
                LY_CTHL_CL_MotorStep = 42; 
                AxisContinueMoveAcc(Y_AXIS,5000,DIR_P,1000,800,15,15);
            }
            break;
        case 42:
            if(!LY_CTHL_SF_Origin_IN)
            {
                LY_CTHL_CL_MotorStep = 43; 
                LY_CTHL_YSavePosBuff = dwYRealPos;
            }
            break;
        case 43:    
            //뿪ԭ5CMֹͣ
            if((dwYRealPos - LY_CTHL_YSavePosBuff) >= 800)
            {
                AxisEgmStop(Y_AXIS);
                LY_CTHL_CL_MotorStep = 46; //ռ
                LY_CTHL_CL_MotorDelay = dwTickCount + 50;  
            }
            break;
        case 46:  
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
                LY_CTHL_CL_MotorStep = 47; //صԭλ
                if(!LY_CTHL_SF_Origin_IN)
                    AxisContinueMoveAcc(Y_AXIS,1500,DIR_N,1000,800,15,10);
            }
            break;
        case 47: 
           if(LY_CTHL_SF_Origin_IN)
            {
                LY_CTHL_CL_MotorStep = 0;       
                AxisEgmStop(Y_AXIS); 
                SetPos(Y_AXIS, 0);
            }    
          break;
         //ػԭλ (ΪԶSONһֱûɿ)  
        case 50: 
            if(dwYRealPos > 150)
            {  //ٶ
               SetDir(Y_AXIS, DIR_N);
                AxisMovePosAccDecNotStop(Y_AXIS,LY_CTHL_PARAM_CL_Back_O_Speed,-dwYRealPos + 150,5000,2000,10,50,50);
             
                    
            } 
            else
                AxisContinueMoveAcc(Y_AXIS,1000,DIR_N,1000,1000,15,15);
            LY_CTHL_CL_MotorStep = 51; 
            break;
        case 51: 
            if(LY_CTHL_SF_Origin_IN)
            {
                LY_CTHL_CL_MotorStep = 0;       
                AxisEgmStop(Y_AXIS); 
                SetPos(Y_AXIS, 0);
            } 
            break;
                 
	}
#endif

#if 1
    //1ʼ,  ȿʼ
  //20ʼ  λʼ
  //40,ԭΪ
    switch(LY_CTHL_CL_MotorStep)
	{
         //볤λ
         case 1:     
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
               if(!LY_CTHL_PARAM_AUTO_MODE) 
               {
                //볤Ҫݼⳤȼһδ1CM,ת2CM
                if(LY_CTHL_LianLengthAutoCheck <= 700)
                    {
                        LY_CTHL_Y_CL_Length=LY_CTHL_LianLengthAutoCheck-200;
                       if(LY_CTHL_Y_CL_Length<10)
                         LY_CTHL_Y_CL_Length=200;
                        if(LY_CTHL_Y_CL_Length >= LY_CTHL_PARAM_CL_MAX_Length)
                          LY_CTHL_Y_CL_Length = LY_CTHL_PARAM_CL_MAX_Length-40;  
                    AxisMovePosAccDec(Y_AXIS,LY_CTHL_PARAM_CL_Speed,LY_CTHL_Y_CL_Length,800,600,6,6,50);     
                }
                else if(LY_CTHL_LianLengthAutoCheck>700)
                {
                  
                   user_datas[123] =LY_CTHL_LianLengthAutoCheck;
                        if(cZipCnt>1)
                           LY_CTHL_Y_CL_Length=LY_CTHL_LianLengSave-LY_CTHL_PARAM_HLTSY_LENTH-300;
                        else
                        {
                          if(cZipCnt<1)
                             LY_CTHL_Y_CL_Length=LY_CTHL_LianLengthAutoCheck-LY_CTHL_PARAM_HLTSY_LENTH-100;
                          else
                             LY_CTHL_Y_CL_Length=LY_CTHL_LianLengthAutoCheck-LY_CTHL_PARAM_HLTSY_LENTH-300; 
                        }
                   if(cZipCnt>1)
                   {
                      if(LY_CTHL_LianLengthAutoCheck<(LY_CTHL_LianLengSave*0.7))
                      {
                           LY_CTHL_Y_CL_Length=LY_CTHL_LianLengthAutoCheck-LY_CTHL_PARAM_HLTSY_LENTH-300;
                           cZipCnt=0;
                      }
                   }
                       if(LY_CTHL_Y_CL_Length<200)
                         LY_CTHL_Y_CL_Length=200;   
                        if(LY_CTHL_Y_CL_Length >= LY_CTHL_PARAM_CL_MAX_Length)
                          LY_CTHL_Y_CL_Length = LY_CTHL_PARAM_CL_MAX_Length-40;  
                    AxisMovePosAccDec(Y_AXIS,LY_CTHL_PARAM_CL_Speed,LY_CTHL_Y_CL_Length,800,600,6,6,50); 
                
                }
               
               }
               
              else
              {
                  if(LY_CTHL_PARAM_CL_Length >= LY_CTHL_PARAM_CL_MAX_Length)
                        LY_CTHL_PARAM_CL_Length = LY_CTHL_PARAM_CL_MAX_Length;
                    //볤Ҫݼⳤȼһδ1CM,ת2CM
                    if((LY_CTHL_LianLengthAutoCheck < (LY_CTHL_PARAM_CL_Length + 500 )) && bRunning) 
                        AxisMovePosAccDec(Y_AXIS,LY_CTHL_PARAM_CL_Speed,(LY_CTHL_LianLengthAutoCheck-500),800,600,6,6,50);       
                    else
                        AxisMovePosAccDec(Y_AXIS,LY_CTHL_PARAM_CL_Speed,(LY_CTHL_PARAM_CL_Length-100),800,600,6,6,50); 
                        
              }
                LY_CTHL_CL_MotorStep = 2; 
            }
            break;
        case 2:
          if(LY_CTHL_PARAM_AUTO_MODE)
          {
            if((dwYRealPos + 120) > LY_CTHL_PARAM_CL_Length)
                LY_CTHL_HLJJ_VAVLE = 0;
            if(!Y_DRV || dwYRealPos >= LY_CTHL_PARAM_CL_Length)  
            {
                LY_CTHL_HLJJ_VAVLE = 0;
               LY_CTHL_CL_MotorStep = 3;  
                bCL_OK_FLG = 1;
               LY_CTHL_CL_MotorDelay = dwTickCount + 30;  //ʱػ
            }
          }
          else
          {
          if((dwYRealPos + 120) > LY_CTHL_Y_CL_Length)
                LY_CTHL_HLJJ_VAVLE = 0;
            if(!Y_DRV || dwYRealPos >= LY_CTHL_Y_CL_Length)  
            {
                LY_CTHL_HLJJ_VAVLE = 0;
               LY_CTHL_CL_MotorStep = 3;  
                bCL_OK_FLG = 1;
               LY_CTHL_CL_MotorDelay = dwTickCount + 30;  //ʱػ
            }
          
          }
            break; 
        case 3: 
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
                LY_CTHL_CL_MotorStep = 50;  
            }
            break;
          //дλ  
        case 20: //˴öλ
            if(cXcxcrCnt > 0)
            {
              if(cXcxcrCnt==1)
               LY_CTHL_LENTH = LY_CTHL_PARAM_CXDW_Length+LY_CTHL_PARAM_TDFZ_LENTH + 50; 
              if(cXcxcrCnt>1)
                LY_CTHL_LENTH = LY_CTHL_PARAM_CXDW_Length +LY_CTHL_PARAM_TDFZ_LENTH + 120;
             LY_CTHL_CL_MotorStep = 21;
            }
            else
            {
            LY_CTHL_LENTH = LY_CTHL_PARAM_CXDW_Length ;
            LY_CTHL_CL_MotorStep = 21;
            }    
            break;
        case 21:
              SetDir(Y_AXIS, DIR_P);
              LY_CTHL_Y_CL_PosBuff = dwYRealPos;
              AxisMovePosAccDec(Y_AXIS,20000,LY_CTHL_LENTH,800,500,6,6,50);            
              LY_CTHL_CL_MotorStep = 22; 
            break;
        case 22: 
            if(dwYRealPos >= LY_CTHL_Y_CL_PosBuff+LY_CTHL_LENTH-LY_CTHL_PARAM_CXDW_Length) //λѾ
            {
              LY_CTHL_CXSCDW_VAVLE = 1;                     
            }
          
          if(!Y_DRV || (dwYRealPos >= LY_CTHL_Y_CL_PosBuff+LY_CTHL_LENTH)) //λѾ
            {
                AxisEgmStop(Y_AXIS);
                LY_CTHL_YsaveCXDWPosBuff = 0;
                LY_CTHL_CL_MotorStep = 0;                       
            } 
            
            break;
        case 30:
                    LY_CTHL_YsaveCXDWPosBuff = 0;
                    LY_CTHL_CL_MotorStep = 0;  
            break;
          //ԭ㿪ʼ
        case 40: 
          //Ҫ뿪    
            if(LY_CTHL_SF_Origin_IN && (GetEn(Y_AXIS) == MOTOR_DISEN))  
            {
                LY_CTHL_CL_MotorStep = 41; 
                SetDir(Y_AXIS, DIR_P);
            }    
            else  
            {
                SetDir(Y_AXIS, DIR_N);
                LY_CTHL_CL_MotorStep = 46;
                
            }    
            if(GetEn(Y_AXIS) == MOTOR_DISEN) 
            {
                SetEn(Y_AXIS, MOTOR_EN);
                LY_CTHL_CL_MotorDelay = dwTickCount + 260;   //ʱ
                
            }
            else  //Ѿ
                LY_CTHL_CL_MotorDelay = dwTickCount + 5;            
            break;
        case 41:
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
                LY_CTHL_CL_MotorStep = 42; 
                AxisContinueMoveAcc(Y_AXIS,5000,DIR_P,1000,800,15,15);
            }
            break;
        case 42:
            if(!LY_CTHL_SF_Origin_IN)
            {
                LY_CTHL_CL_MotorStep = 43; 
                LY_CTHL_YSavePosBuff = dwYRealPos;
            }
            break;
        case 43:    
            //뿪ԭ5CMֹͣ
            if((dwYRealPos - LY_CTHL_YSavePosBuff) >= 800)
            {
                AxisEgmStop(Y_AXIS);
                LY_CTHL_CL_MotorStep = 46; //ռ
                LY_CTHL_CL_MotorDelay = dwTickCount + 50;  
            }
            break;
        case 46:  
            if(dwTickCount >= LY_CTHL_CL_MotorDelay)
            {
                LY_CTHL_CL_MotorStep = 47; //صԭλ
                if(!LY_CTHL_SF_Origin_IN)
                    AxisContinueMoveAcc(Y_AXIS,1500,DIR_N,1000,800,15,10);
            }
            break;
        case 47: 
           if(LY_CTHL_SF_Origin_IN)
            {
                LY_CTHL_CL_MotorStep = 0;       
                AxisEgmStop(Y_AXIS); 
                SetPos(Y_AXIS, 0);
            }    
          break;
         //ػԭλ (ΪԶSONһֱûɿ)  
        case 50: 
            if(dwYRealPos > 151)
            {  //ٶ
              
              SetDir(Y_AXIS, DIR_N);
               AxisMovePosAccDecNotStop(Y_AXIS,LY_CTHL_PARAM_CL_Back_O_Speed,-dwYRealPos + 150,5000,2000,10,50,100);
                  } 
             else
                AxisContinueMoveAcc(Y_AXIS,1000,DIR_N,1000,1000,15,15);
            LY_CTHL_CL_MotorStep = 51; 
            break;
        case 51: 
            if(LY_CTHL_SF_Origin_IN)
            {
                LY_CTHL_CL_MotorStep = 0;       
                AxisEgmStop(Y_AXIS); 
                SetPos(Y_AXIS, 0);
            } 
            break;
                 
	}
#endif      
}



//װͷ
void LY_CTHL_ZLT_Step(void)
{

    switch(LY_CTHL_ZhuangLiaoStep)
    {
        case 1:
          
             if(bZhuangLiaoOkFlg)
             {
                  LY_CTHL_ZhuangLiaoStep = 0;
             }
             else if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)
             {
                
                   if(((LY_CTHL_MGuo_VAVLE && LY_CTHL_LTou_Check) || (!LY_CTHL_MGuo_VAVLE)) && !LY_CTHL_JLiao_Limit_IN  )//˵ûͷ
                   {       
                          //ͷģһδԭλ,ϲ
                          if(LY_CTHL_CTM_Origin_IN && !LY_CTHL_CTXM_VAVLE)
                          {  
                              LY_CTHL_First_CT_VAVLE = 0;
                               LY_CTHL_JLTou_VAVLE = 0;
                              LY_CTHL_MGuo_VAVLE = 0;                     
                              if(LY_CTHL_TLiaoStep == 0)
                              {
                                 LY_CTHL_TLiaoStep = 1;        
                               LY_CTHL_ZhuangLiaoStep = 2; 
                              }
                           }
                      
                        else if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay + 500)  //뱣֤ͷģһδԭλ,ϲ
                        {
                          LY_CTHL_SetAlarmCode(LY_CTHL_CTM_Origin_ALARM,bRunning);
                            
                        }  
                   }
                   else  //Ѿͷֱ
                   {
                         LY_CTHL_ZhuangLiaoDelay = dwTickCount + 40;
                         LY_CTHL_ZhuangLiaoStep = 9;
                   }  
             }
             break;            
        case 2:        
            if(LY_CTHL_TLiaoStep == 0)  //Ѿ
            {
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
                LY_CTHL_JLTou_VAVLE = 0;
                LY_CTHL_MGuo_VAVLE = 0;   
                if(!LY_CTHL_JLiao_Limit_IN && LY_CTHL_First_CT_Origin_IN)
                {
                    LY_CTHL_ZhuangLiaoStep = 3;
                    LY_CTHL_HSLiao_VAVLE = 1;   
                }
            }
            break;
        case 3:
            //͵λ
            if(LY_CTHL_HSLiao_Limit_IN && !LY_CTHL_HSLiao_Origin_IN)
            {
                LY_CTHL_ZhuangLiaoStep = 4;
//                LY_CTHL_JLTou_VAVLE = 1;    //ͷ,Ҫʱ
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + 5;
            }
            else if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)
            {
                LY_CTHL_SetAlarmCode(LY_CTHL_HSLiao_Limit_ALARM,bRunning);
            }
            break;
        case 4:
            if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)
            {
                LY_CTHL_ZhuangLiaoStep = 5;
                LY_CTHL_JLTou_VAVLE = 1;    //ͷ,Ҫʱ
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
            }  
            break;
        case 5:    
            if(LY_CTHL_JLiao_Limit_IN)
            {
                LY_CTHL_ZhuangLiaoStep = 6;
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + LY_CTHL_PARAM_MaGou_DELAY;
            }
            else if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)  //ͷ()ź쳣
            {
                 LY_CTHL_SetAlarmCode(LY_CTHL_JLiao_Limit_ALARM,bRunning);
            }
            break;
        case 6:       
            if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)  //ʱ빴
            {
                LY_CTHL_MGuo_VAVLE = 1; //빴
                LY_CTHL_ZhuangLiaoStep = 7;
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + LY_CTHL_PARAM_HSLiaoOff_DELAY;
                bTuiLaTouOkFlg = 0;   //Ϊͷû
            }
            break;
        case 7:  
            if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)
            {
                LY_CTHL_HSLiao_VAVLE = 0; 
                LY_CTHL_ZhuangLiaoStep = 8;
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
            }
            break;
        case 8:  
            if(!LY_CTHL_HSLiao_Limit_IN)  //
            {
                LY_CTHL_ZhuangLiaoStep = 9;
                LY_CTHL_TLiaoStep = 1; //ͷ
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + LY_CTHL_PARAM_CheckLT_DELAY;   //ҲǸģʱ
            }          
            else if (LY_CTHL_LTou_Check)  //ʱź˵ûͷ
            {
                //3
               LY_CTHL_TryCnt++;
               LY_CTHL_JLTou_VAVLE = 0;    //ͷ
                LY_CTHL_MGuo_VAVLE = 0;     //빴
                if(LY_CTHL_TryCnt >= 3)
                {
                    LY_CTHL_TryCnt = 0;
                    bZhuangLiaoOkFlg = 0;
                    LY_CTHL_ZhuangLiaoStep = 0;
                    LY_CTHL_SetAlarmCode(LY_CTHL_ZLT_ALARM,bRunning);
                    cWULATOUCnt=1;
                }
                else
                {
                    LY_CTHL_ZhuangLiaoStep = 20;    //3   
                    LY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
                }  
            }
            else if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)
            {
                LY_CTHL_SetAlarmCode(LY_CTHL_HSLiao_Limit_ALARM,bRunning);
                if(bRunning)
                {
                    LY_CTHL_ZhuangLiaoStep = 0 ;
                }  
            }  
            break;
        case 9:   
            if(LY_CTHL_LTou_Check)  //ʱź˵ûͷ
            {
                LY_CTHL_TryCnt++;
                LY_CTHL_JLTou_VAVLE = 0;    //ͷ
                LY_CTHL_MGuo_VAVLE = 0;     //빴
                if(LY_CTHL_TryCnt >= 3)
                {
                  LY_CTHL_TryCnt=0;
                    bZhuangLiaoOkFlg = 0;
                    LY_CTHL_ZhuangLiaoStep = 0;
                    LY_CTHL_SetAlarmCode(LY_CTHL_ZLT_ALARM,bRunning);
                    cWULATOUCnt=1;
                }
                else
                {
                    LY_CTHL_ZhuangLiaoStep = 20;    //3   
                    LY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
                }  
            }
            else if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)
            {
                bZhuangLiaoOkFlg = 1;
                LY_CTHL_ZhuangLiaoStep = 0;
            }
            break;
          //װͷɹͷ
        case 20: 
            if(LY_CTHL_HSLiao_Origin_IN)
            {
                LY_CTHL_JLTou_VAVLE = 0;    //ͷ
                LY_CTHL_MGuo_VAVLE = 0;     //빴
                LY_CTHL_ZhuangLiaoStep = 1;
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + 10;
            }
            else if(dwTickCount >= LY_CTHL_ZhuangLiaoDelay)
            {
                LY_CTHL_SetAlarmCode(LY_CTHL_HSLiao_Origin_ALARM,bRunning);
            }  
            break;
    }  
}

void LY_CTHL_TLiao_Step(void)
{
    switch(LY_CTHL_TLiaoStep)
    {
        case 1:
            if(bTuiLaTouOkFlg)
            {
                LY_CTHL_TLiaoStep = 0; 
            }
            else
            {
                LY_CTHL_TLiao_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                LY_CTHL_TLiaoStep = 2;
            }
            break;
        case 2:    //ԭλ
            if(LY_CTHL_HSLiao_Origin_IN && !LY_CTHL_HSLiao_Limit_IN && !LY_CTHL_HSLiao_VAVLE)
            {
                LY_CTHL_TLiao_VAVLE = 1;    //(ͷ)
                LY_CTHL_TLiao_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                LY_CTHL_TLiaoStep = 3;
            }
            else if(dwTickCount >= LY_CTHL_TLiao_Delay) 
                LY_CTHL_SetAlarmCode(LY_CTHL_HSLiao_Origin_ALARM,1);          
            break;
        case 3:  //ͷλ
            if(LY_CTHL_TLiao_Limit_IN)
            { 
                LY_CTHL_TLiao_Delay = dwTickCount + LY_CTHL_PARAM_TLiao_BACKDELAY;
                LY_CTHL_TLiaoStep = 4;
            }
            else if(dwTickCount >= LY_CTHL_TLiao_Delay) 
                LY_CTHL_SetAlarmCode(LY_CTHL_TLiao_Limit_ALARM,1);        
            break;
        case 4:
            if(dwTickCount >= LY_CTHL_TLiao_Delay)
            {
                LY_CTHL_TLiao_VAVLE       = 0;
                LY_CTHL_TLiao_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME; 
                LY_CTHL_TLiaoStep = 5;
            }
            break;
        case  5:
            if(!LY_CTHL_TLiao_Limit_IN)
            {
                LY_CTHL_TLiaoStep = 0;
                LY_CTHL_TLiao_Delay = dwTickCount;
                bTuiLaTouOkFlg    = 1;
            }
            else if(dwTickCount >= LY_CTHL_TLiao_Delay) 
                LY_CTHL_SetAlarmCode(LY_CTHL_TLiao_Limit_ALARM,0);    
            break;
    } 
   
}
//̿
void LY_CTHL_ZhenDongAction(void)
{
 
#if 0  
    if((LY_CTHL_bDLP || bRunning) && LY_CTHL_ZhenDongPian_OUT && LY_CTHL_PARAM_DALIAOPIAN)
    {        
        if(CT_DLP_Time >= dwTickCount)
        {
            CT_ZDP_Delay = dwTickCount + CT_PARAM_DLP_TIME + 40;  
            CT_DaLaPian_VAVLE = ~CT_DaLaPian_VAVLE;
        }
    }
    else
        CT_DaLaPian_VAVLE = 0;   
#endif
    
#if 1  

//    if(bRunning)
//    {
      switch(LY_CTHL_PARAM_ZDP_AUTO)
      {
          case 0:
                if(LY_CTHL_ZhenDongPian_OUT == 0)
                {
                    if(!LY_CTHL_ZDP_IN)
                    {
                        if(dwTickCount >= LY_CTHL_ZDP_Delay)
                        {
                            LY_CTHL_ZhenDongPian_OUT = 1;
                            LY_CTHL_ZDP_Delay = dwTickCount + LY_CTHL_PARAM_ZDP_Stop_TIME;//LY_CTHL_PARAM_ZDP_Stop_TIME + 50;
                        }
                    }
                    else
                    {
                        LY_CTHL_ZDP_Delay = dwTickCount + LY_CTHL_PARAM_ZDP_Start_TIME;//LY_CTHL_PARAM_ZDP_Start_TIME;
                    }   
                }
                else
                {  
                    if(LY_CTHL_ZDP_IN)
                    {  
                        if(dwTickCount >= LY_CTHL_ZDP_Delay)
                        {
                             LY_CTHL_ZhenDongPian_OUT = 0;  
                             LY_CTHL_ZDP_Delay = dwTickCount + LY_CTHL_PARAM_ZDP_Start_TIME;//LY_CTHL_PARAM_ZDP_Start_TIME
                        }
                    }
                    else
                        LY_CTHL_ZDP_Delay = dwTickCount + LY_CTHL_PARAM_ZDP_Stop_TIME;//LY_CTHL_PARAM_ZDP_Stop_TIME+ 50;
                }
           break;
        case 1:
           LY_CTHL_ZhenDongPian_OUT=0;
           LY_CTHL_ZDP_Delay = dwTickCount;
          break;
        case 2:     
          LY_CTHL_ZhenDongPian_OUT=1;
          LY_CTHL_ZDP_Delay = dwTickCount;
          break;
      }    
       if(LY_CTHL_ZhenDongPian_OUT)
       {
          if(LY_CTHL_PARAM_LaPian_EN)
          {
              if(dwTickCount >= LY_CTHL_DLP_Delay)
              {
                  
                  LY_CTHL_DaLaPian_OUT = !LY_CTHL_DaLaPian_OUT;
                  
                  if(LY_CTHL_DaLaPian_OUT)
                    LY_CTHL_DLP_Delay = dwTickCount + LY_CTHL_PARAM_DaLaPian;
                  else
                    LY_CTHL_DLP_Delay = dwTickCount + LY_CTHL_PARAM_DaLaPian+50;
              }  
          }
          else
            LY_CTHL_DaLaPian_OUT = 0;      
       }
      else
        LY_CTHL_DaLaPian_OUT = 0;
#endif    
}
void LY_CTHL_bFKCXTDDWStep(void)
{
    switch(LY_CTHL_bFKCXTDDW_Step)
    {
        case 1:
                LY_CTHL_FKJD_VAVLE = 1;   //д
                LY_CTHL_XKTD_VAVLE = 1;   //бƴ    
                LY_CTHL_FKGD_VAVLE = 0;     //̶
                LY_CTHL_bFKCXTDDW_Step = 2;
                
                break;
            case 2: 
                if(!LY_CTHL_XKTD_Origin_IN)  //бƴԭλ뿪
                {
                    LY_CTHL_bFKCXTDDW_Step = 3;
                    LY_CTHL_bFKCXTDDW_Delay = dwTickCount + 20;
                }  
                break;
            case 3://бڶλ
                if(dwTickCount >= LY_CTHL_bFKCXTDDW_Delay)
                {
                    LY_CTHL_XKDW_VAVLE = 1;
                    LY_CTHL_bFKCXTDDW_Step = 4;
           //         LY_CTHL_bFKCXTDDW_Delay = dwTickCount + LY_CTHL_PARAM_XKDW_TD_DELAY;
                }  
                break;
            case 4:
                if(dwTickCount >= LY_CTHL_bFKCXTDDW_Delay)
                {
                    AxisContinueMoveAcc(X_AXIS,1200,DIR_P,800,600,10,10);//ϴ                       
                    LY_CTHL_bFKCXTDDW_Step = 5;
                    LY_CTHL_XSavePosBuff = dwXRealPos;
                    SetPos(X_AXIS, 0);  //λΪ0
                    dwXRealPos = 0;
                }
                break;
            case 5:
                if(LY_CTHL_XKSC_Limit_IN)   //鵽λ
                {
                    AxisEgmStop(X_AXIS);
                    LY_CTHL_QDXK_VAVLE=1;
                    LY_CTHL_bFKCXTDDW_Step = 6;
                    LY_CTHL_XKTD_VAVLE = 0;   //бƴ׹ر 
                    LY_CTHL_bFKCXTDDW_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                   
                }
                else if(dwXRealPos >= (LY_CTHL_XSavePosBuff + 800))
                {
                     LY_CTHL_SetAlarmCode(LY_CTHL_FKCXDW_ALARM,bRunning);//λ쳣
                    
                }  
                break;
          case 6:  
              if(LY_CTHL_PARAM_TDFZ_LENTH && !X_DRV)  //ϴת
                  AxisMovePosAccDec(X_AXIS,8000,-LY_CTHL_PARAM_DXKFZ_LENTH,800,600,6,6,0); 
              if(LY_CTHL_PARAM_CXLY_MODE)
                   LY_CTHL_CXLY_VAVLE = 1;
               LY_CTHL_bFKCXTDDW_Step = 0;
          break;
    
    }  
}

//붯
void LY_CTHL_bCXCRStep(void)
{
    switch(LY_CTHL_bCXCR_Step)
    {
            case 11:
                LY_CTHL_XKTD_VAVLE = 1;   //бƴ    
                LY_CTHL_FKGD_VAVLE = 0;     //̶
                LY_CTHL_CXSCDW_VAVLE=1;
                LY_CTHL_bCXCR_Step = 12;      
             
                break;
            case 12: 
                if(!LY_CTHL_XKTD_Origin_IN)  //бƴԭλ뿪
                {
                    LY_CTHL_bCXCR_Step = 13;
               //     LY_CTHL_CXQJD_VAVLE = 1;    //ǰд  
                    LY_CTHL_bCXCR_Delay = dwTickCount + 20;
                }  
                break;
            case 13: 
                if((LY_CTHL_CL_MotorStep == 0) && (LY_CTHL_SF_Origin_IN) && (dwTickCount >= LY_CTHL_bCXCR_Delay))  //ǰдصԭλ
                {
                    LY_CTHL_bCXCR_Step = 14; 
                 //  LY_CTHL_FKGD_VAVLE = 1;     //̶
                    LY_CTHL_CXQJD_VAVLE = 1;    //ǰд                    
                    LY_CTHL_bCXCR_Delay = dwTickCount + LY_CTHL_PARAM_XCQJD_XCDW_DELAY+100;
                }
                break;
            case 14:
                if(dwTickCount >= LY_CTHL_bCXCR_Delay)
                {
                    LY_CTHL_bCXCR_Step = 15; 
                    LY_CTHL_FKGD_VAVLE = 1;     //̶
                    //Y
                    LY_CTHL_CL_MotorStep = 20;  //λ                   
                }
                break;
            case 15:   
                if(LY_CTHL_CL_MotorStep == 0)   //λ
                {
                    LY_CTHL_bCXCR_Step = 16; 
                    LY_CTHL_CXDWZ_VAVLE = 1;    //λ(λ)ŷ
                    LY_CTHL_bCXCR_Delay = dwTickCount + 10;  //ʱ
                }  
                break;
            case 16: 
                if(dwTickCount >= LY_CTHL_bCXCR_Delay)
                {
                    LY_CTHL_bCXCR_Step = 17;
                   if(LY_CTHL_PARAM_CXLY_MODE)
                          LY_CTHL_CXLY_VAVLE = 0;
                       else
                          LY_CTHL_CXLY_VAVLE = 1;     //Y06 Ƶŷ
                    if(LY_CTHL_PARAM_NLSL_MODE == 0)
                      LY_CTHL_bCXCR_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;  //쳣ʱ
                    else
                      LY_CTHL_bCXCR_Delay = dwTickCount + 80;  //쳣ʱ
                }
                break;
            case 17:   
                if((LY_CTHL_CXLY_Limit_IN) || LY_CTHL_PARAM_NLSL_MODE)
                {
           
                  if(LY_CTHL_CXLY_Limit_IN || (dwTickCount >= LY_CTHL_bCXCR_Delay))
                  {
                    LY_CTHL_bCXCR_Step = 18; 
                     if( cXcxcrCnt==0 && !X_DRV)  //ϴת
                    {
                     AxisMovePosAccDec(X_AXIS,10000,-LY_CTHL_PARAM_TDFZ_LENTH,800,600,6,6,0);
                    }
                    LY_CTHL_CXQJD_VAVLE = 0;    //ǰдŷ
                    LY_CTHL_CXSCDW_VAVLE = 0;   //Y21 ֹλ                    
                    LY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
                    LY_CTHL_bCXCR_Delay = dwTickCount + LY_CTHL_PARAM_SCDWOff_CXDW_DELAY;

                  }
                }  
                else if(dwTickCount >= LY_CTHL_bCXCR_Delay)  
                {
                    LY_CTHL_SetAlarmCode(LY_CTHL_CXLY_Limit_ALARM,bRunning);//쳣
                    
                }
                break;
            case 18:   
  //              if(START_IN_UP)
                {
                if(dwTickCount >= LY_CTHL_bCXCR_Delay) 
                {
                    LY_CTHL_bCXCR_Step = 19; 
                    
                    LY_CTHL_CXHDW_VAVLE = 1;     //λ()
                    LY_CTHL_bCXCR_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME +1000;  //뵽λ쳣ʱ
                    LY_CTHL_CL_MotorStep = 50;  //ԭ
                }
                }
                break;
            case 19:  
                 if( cXcxcrCnt > 1)  
                {
                    LY_CTHL_SetAlarmCode(LY_CTHL_CX_Limit_ALARM,bRunning); //뵽λ쳣  
                }
                
                if( LY_CTHL_CX_Limit_IN  &&  cXcxcrCnt<2 )
                {
                    cXcxcrCnt=0;
                    bZhuangLiaoOkFlg = 0;
                    LY_CTHL_bCXCR_Step = 0;
                    LY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
              
                } 
                else if (dwTickCount >= LY_CTHL_bCXCR_Delay)
                {
                  cXcxcrCnt++;
              
                   LY_CTHL_CXHJD_VAVLE=0;
                   LY_CTHL_CXHDW_VAVLE=0;
                   LY_CTHL_CXDWZ_VAVLE = 0;
                       if(LY_CTHL_PARAM_CXLY_MODE)
                          LY_CTHL_CXLY_VAVLE = 0;
                       else
                          LY_CTHL_CXLY_VAVLE = 1;     //Y06 Ƶŷ
                  LY_CTHL_bCXCR_Step = 11;
                }
               
              break;
  }
}

void LY_CTHL_bCLFirstStep(void)
{
    switch(LY_CTHL_bCLFirst_Step)
    {
           case 19:   
                LY_CTHL_JLTou_VAVLE = 0;        //ͷ
                bZhuangLiaoOkFlg = 0;
                LY_CTHL_bCLFirst_Step = 20;
                LY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
                LY_CTHL_CXLY_VAVLE = 0;     //Y06 Ƶŷ
                LY_CTHL_bCLFirst_Delay = dwTickCount + LY_CTHL_PARAM_First_CL_DELAY;//ʱһδ
                break;
            case 20:  
                if(dwTickCount >= LY_CTHL_bCLFirst_Delay) 
                {
                    LY_CTHL_bCLFirst_Step = 21;
                    LY_CTHL_First_CT_VAVLE = 1;   //һδŷ
                    LY_CTHL_bCLFirst_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                }
                break;
            case 21:   
                if(!LY_CTHL_First_CT_Origin_IN)  //ԭ뿪ſʼʱ
                {
                    LY_CTHL_bCLFirst_Step = 22;
                    LY_CTHL_bCLFirst_Delay = dwTickCount + LY_CTHL_PARAM_First_CL_Timer;  //һδʱ
                }
                else if(dwTickCount >= LY_CTHL_bCLFirst_Delay) 
                {
                   LY_CTHL_SetAlarmCode(LY_CTHL_YCCRYWYC_ALARM,bRunning); //һδԭλ쳣
                }
                break;
            case 22:
                if(dwTickCount >= LY_CTHL_bCLFirst_Delay) 
                {
                    LY_CTHL_bCLFirst_Step = 23;                                     
                    LY_CTHL_MGuo_VAVLE = 0;     //빴
                    LY_CTHL_bCLFirst_Delay = dwTickCount + LY_CTHL_PARAM_MGOff_XiaMo_DELAY;
                    LY_CTHL_FKGD_VAVLE = 0;     //̶
                    LY_CTHL_CXHJD_VAVLE = 0;    //Y14 д 
                    LY_CTHL_CXLY_VAVLE = 0;     //Y06 Ƶŷ
                } 
                break;
            case 23:  
                if(dwTickCount >= LY_CTHL_bCLFirst_Delay) 
                {
                    LY_CTHL_bCLFirst_Step = 24;
                    LY_CTHL_CTXM_VAVLE = 0; //ͷģ½
                    LY_CTHL_CXHDW_VAVLE = 0;     //λ()ر
                    LY_CTHL_bCLFirst_Delay = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                } 
                break;
            case 24: 
                if(!LY_CTHL_CTM_Limit_IN)
                {
                     LY_CTHL_bCLFirst_Step= 25;
                    LY_CTHL_bCLFirst_Delay = dwTickCount + 25;  //һδʱ
                }
                else if(dwTickCount >= LY_CTHL_bCLFirst_Delay) 
                {
                    LY_CTHL_SetAlarmCode(LY_CTHL_CTM_Origin_ALARM,bRunning); //ͷģ½쳣
                }
                break;
            case 25:
                if(dwTickCount >= LY_CTHL_bCLFirst_Delay) 
                {
                  
                     LY_CTHL_bCLFirst_Step= 0;
                    LY_CTHL_First_CT_VAVLE = 0;   //һδŷ
                    LY_CTHL_CXHDW_VAVLE = 0;     //λ()ر
                    
                    
                    //³
                    LY_CTHL_AutoDelay1 = dwTickCount + LY_CTHL_VAVLE_ERROR_TIME;
                    LY_CTHL_AutoStep1 = 1;
                    bTuiLaTouOkFlg = 1;
                }
                break;
    }
}
//ֶ
void LY_CTHL_ManualAction(void)
{ 
      if(bRunning) // е
      {
      LY_CTHL_Run_State=1;
      LY_CTHL_Stop_State=0;
      }
      else 
      {
        LY_CTHL_Stop_State=1;
      LY_CTHL_Run_State=0;
      }
  
    if((LY_CTHL_SF_ALR_IN && (LY_CTHL_PARAM_DB_MODE == 1))|| (((GetAlarm(Y_AXIS)==0) || (GetAlarm(X_AXIS)==0)) && (LY_CTHL_PARAM_DB_MODE == 0))) // ŷ
    {
      cCHULIANBAOJIN=1;
      LY_CTHL_SetAlarmCode(LY_CTHL_SF_ALR_ALARM,0);
    }
     if(dwTickCount >= LY_CTHL_bSFBBAOJIN_Delay)  
     {
       LY_CTHL_SF_ALR_CLR=0;
         SetClr(Y_AXIS,MOTOR_ALARM);
           SetClr(X_AXIS,MOTOR_ALARM);
     }
 
    if(bRunning == 0)  
    {   
        if(bClearTotal) //жϼ
        {
            bClearTotal       = 0;
            ClrcToTal(QDCT_TOTAL_ADDR);
        }
        if(LY_CTHL_bTLiao )                 //ֶ(ͷ)
        {
            LY_CTHL_bTLiao = 0;           
            if(LY_CTHL_TLiao_VAVLE)
               LY_CTHL_TLiao_VAVLE = 0;//LY_CTHL_TLiao_VAVLE; 
            else if(!LY_CTHL_HSLiao_VAVLE && LY_CTHL_HSLiao_Origin_IN)
            {
                LY_CTHL_TLiao_VAVLE = 1;
            } 
            else//
            {
              LY_CTHL_SetAlarmCode(LY_CTHL_HENSONGLIAO_ALARM,0); // ϲ
            }

        } 

        if(LY_CTHL_bHSL)     //ֶ   
        {
            LY_CTHL_bHSL= 0;
            if(!LY_CTHL_First_CT_VAVLE)
            {
            if(LY_CTHL_HSLiao_VAVLE)
            {
                LY_CTHL_HSLiao_VAVLE = 0;//~LY_CTHL_HSLiao_VAVLE;
            }
            else if(!LY_CTHL_TLiao_VAVLE && !LY_CTHL_TLiao_Limit_IN && LY_CTHL_CTM_Origin_IN && !LY_CTHL_JLiao_Limit_IN &&
                    !LY_CTHL_JLTou_VAVLE && !LY_CTHL_CTXM_VAVLE && !LY_CTHL_CXDWZ_VAVLE && (!LY_CTHL_bMG || (LY_CTHL_bMG && LY_CTHL_LTou_Check)))
            {
                LY_CTHL_HSLiao_VAVLE = 1;
            }  
            else   //  һΪѾͷ
            {
               LY_CTHL_SetAlarmCode(LY_CTHL_YCCT_ALARM,0); 
            }  
            }
        }           
        if(LY_CTHL_bJLT)                  //ͷ
        {
            LY_CTHL_bJLT = 0;
            if(LY_CTHL_JLTou_VAVLE)
                LY_CTHL_JLTou_VAVLE = 0;
            else if(!LY_CTHL_First_CT_VAVLE && !LY_CTHL_CTXM_VAVLE && LY_CTHL_CTM_Origin_IN && LY_CTHL_First_CT_Origin_IN)
            {
                LY_CTHL_MGuo_VAVLE = 0;
                LY_CTHL_JLTou_VAVLE = 1;
            } 
            else//
            {
                 LY_CTHL_SetAlarmCode(LY_CTHL_YCXM_Origin_ALARM,0); 
            }
        } 
        if(LY_CTHL_bMG)                   //빴
        {
            LY_CTHL_bMG = 0;
            LY_CTHL_MGuo_VAVLE = !LY_CTHL_MGuo_VAVLE;
        } 
        if(LY_CTHL_bFKJD)                 //д
        {
            LY_CTHL_bFKJD = 0;
            LY_CTHL_FKJD_VAVLE = !LY_CTHL_FKJD_VAVLE;
        } 
        if(LY_CTHL_bXKTD)                  //бƴ
        {
            LY_CTHL_bXKTD = 0;
            if(LY_CTHL_XKTD_VAVLE)
                LY_CTHL_XKTD_VAVLE = 0;
            else if(!LY_CTHL_DXK_VAVLE && (!LY_CTHL_XKSC_Limit_IN  || !LY_CTHL_CTXM_VAVLE|| LY_CTHL_PARAM_NLSL_MODE))
                LY_CTHL_XKTD_VAVLE = 1;
            else//
            {
                LY_CTHL_SetAlarmCode(LY_CTHL_DXKCTXM_Origin_ALARM,0);          
            }
        } 
        if(LY_CTHL_bXKDW)                  //бڶλ
        {
            LY_CTHL_bXKDW = 0;
            LY_CTHL_XKDW_VAVLE = ~LY_CTHL_XKDW_VAVLE;
        } 
        if(LY_CTHL_bCTXM)                  //ͷģ
        {
            LY_CTHL_bCTXM = 0;
            if(LY_CTHL_CTXM_VAVLE )
            {
              if(!LY_CTHL_CXLY_VAVLE)
              {
                LY_CTHL_CTXM_VAVLE = 0;
                LY_CTHL_JLTou_VAVLE = 0;
              }
              else 
              {
                LY_CTHL_SetAlarmCode(LY_CTHL_TXC_Limit_ALARM,0);   
              }
            }    
            else if(!LY_CTHL_HSLiao_VAVLE && LY_CTHL_HSLiao_Origin_IN && (!LY_CTHL_XKSC_Limit_IN || !LY_CTHL_XKTD_VAVLE))                
            {  
               if(LY_CTHL_PARAM_CXLY_MODE)
                    LY_CTHL_CXLY_VAVLE = 1;
                LY_CTHL_MGuo_VAVLE = 1;
                LY_CTHL_CTXM_VAVLE = 1;
            }  
        } 
         if(LY_CTHL_bQianDXK)                  //ǰб
        {
            LY_CTHL_bQianDXK = 0;
            if(LY_CTHL_QDXK_VAVLE)
                LY_CTHL_QDXK_VAVLE = 0;
             else if(!LY_CTHL_XKTD_VAVLE)
                LY_CTHL_QDXK_VAVLE = 1;
             else  //
             {
                  LY_CTHL_SetAlarmCode(LY_CTHL_XKTD_ALARM,0);   
             } 
        } 
        
        if(LY_CTHL_bDXK)                  //б
        {
           LY_CTHL_bDXK = 0;
          if(!LY_CTHL_PARAM_NLSL_MODE)
          {
            if(LY_CTHL_DXK_VAVLE)
                LY_CTHL_DXK_VAVLE = 0;
             else if(!LY_CTHL_XKTD_VAVLE)
             {
               if(!LY_CTHL_PARAM_NLSL_MODE)
                LY_CTHL_DXK_VAVLE = 1;
             }
             else  //
             {
                  LY_CTHL_SetAlarmCode(LY_CTHL_XKTD_ALARM,0);   
             } 
          }
          else
          {
                if(LY_CTHL_XKTD_VAVLE)
                LY_CTHL_XKTD_VAVLE = 0;
            else if(!LY_CTHL_DXK_VAVLE )
            {
              if(!LY_CTHL_XKSC_Limit_IN  || !LY_CTHL_CTXM_VAVLE || LY_CTHL_PARAM_NLSL_MODE)
                LY_CTHL_XKTD_VAVLE = 1;
              else
              {
                LY_CTHL_SetAlarmCode(LY_CTHL_YCXM_Origin_ALARM,0);   
              }
            }
            else//
            {
                LY_CTHL_SetAlarmCode(LY_CTHL_DXKCTXM_Origin_ALARM,0);          
            }

          }
        } 
   
        if(LY_CTHL_bQianDXK_DXK)
        {
           LY_CTHL_bQianDXK_DXK = 0;
          if(!LY_CTHL_XKTD_VAVLE && LY_CTHL_AutoStep==0)
          {
            cQDXK_DXK=1;
             LY_CTHL_AutoStep = 8;
             SetEn(X_AXIS, MOTOR_EN);
             LY_CTHL_AutoDelay = dwTickCount + 50;
             bRunning=1;
          }
          
        }
        //б
        if(LY_CTHL_bBanZiDong)
        {
           LY_CTHL_bBanZiDong=0;
           cBanAuTo=1;
 //          LY_CTHL_PARAM_BanAuto_MODE=1;
          LY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
          LY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
          LY_CTHL_ZhuangLiaoStep = 1; 
           bTuiLaTouOkFlg = 1;
           bZhuangLiaoOkFlg= 0;
           bCL_EN_FLG=0;
           LY_CTHL_AutoStep = 1;  
           bRunning=1;
        }
         //С
         if(LY_CTHL_CXC)//С
        {
           LY_CTHL_CXC=0;
           cCXCONE=1;
           cBanAuTo=0;
     //    LY_CTHL_PARAM_BanAuto_MODE=0;
           LY_CTHL_AutoStep = 11;  
           bRunning=1;
           if(GetEn(Y_AXIS) == MOTOR_DISEN) 
            {
                SetEn(Y_AXIS, MOTOR_EN);
                LY_CTHL_CL_MotorDelay = dwTickCount + 260;   //ʱ
                
            } 
        }
        
        if(LY_CTHL_bFKGD)                 //̶
        {
            LY_CTHL_bFKGD = 0;
            LY_CTHL_FKGD_VAVLE = ~LY_CTHL_FKGD_VAVLE;
        } 
        if(LY_CTHL_bCXQJD)                 //ǰд
        {
            LY_CTHL_bCXQJD = 0;
            LY_CTHL_CXQJD_VAVLE = ~LY_CTHL_CXQJD_VAVLE;
        } 
        if(LY_CTHL_bCXSY)                 //Ƶŷ
        {
            LY_CTHL_bCXSY = 0;
            LY_CTHL_CXLY_VAVLE = !LY_CTHL_CXLY_VAVLE;
        } 
        if(LY_CTHL_bCXDWZ)                 //Y14 λŷ
        {
            LY_CTHL_bCXDWZ = 0;
            if(LY_CTHL_CXDWZ_VAVLE)
                LY_CTHL_CXDWZ_VAVLE = 0;
            else if(LY_CTHL_HSLiao_Origin_IN)
            {
                LY_CTHL_CXDWZ_VAVLE = 1;
            }
            else //
            {
            LY_CTHL_SetAlarmCode(LY_CTHL_HENSONGLIAO_ALARM,0);   
            }
                
        } 
        if(LY_CTHL_bCXHJD)                 //Y15 дŷ
        {
            LY_CTHL_bCXHJD = 0;
            LY_CTHL_CXHJD_VAVLE =~LY_CTHL_CXHJD_VAVLE;
        } 
        if(LY_CTHL_bCXHDW)                 //Y16 λŷ
        {
            LY_CTHL_bCXHDW = 0;
            if(LY_CTHL_CXHDW_VAVLE)
                LY_CTHL_CXHDW_VAVLE = 0;
            else if(!LY_CTHL_CXQJD_VAVLE)
                LY_CTHL_CXHDW_VAVLE = 1;
            else//
            {
            LY_CTHL_SetAlarmCode(LY_CTHL_CXQJD_ALARM,0);  
            }
        } 
        if(LY_CTHL_bFirst_CT)              //Y20 һδͷŷ
        {
            LY_CTHL_bFirst_CT = 0;
            if( !LY_CTHL_First_CT_VAVLE )
            {
              if(!LY_CTHL_CXLY_VAVLE)
                LY_CTHL_First_CT_VAVLE=1;
               else 
                LY_CTHL_SetAlarmCode(LY_CTHL_TXC_Limit_ALARM,0);   

            }
            else if(LY_CTHL_First_CT_VAVLE)
            {
            LY_CTHL_First_CT_VAVLE=0;
            }
             

        } 
        if(LY_CTHL_bHLJJ)                  //Y21 оߵŷ
        {
            LY_CTHL_bHLJJ = 0;
            LY_CTHL_HLJJ_VAVLE = ~LY_CTHL_HLJJ_VAVLE;
        } 
        if(LY_CTHL_bCXSCDW)               //Y23 ֹλŷ 
        {
            LY_CTHL_bCXSCDW = 0;
            LY_CTHL_CXSCDW_VAVLE = ~LY_CTHL_CXSCDW_VAVLE;
        } 
        //Զװ
        if(LY_CTHL_bAutoZhuangLiao)
        {
            LY_CTHL_bAutoZhuangLiao = 0;
            if(LY_CTHL_ZhuangLiaoStep == 0)
            {
                bTuiLaTouOkFlg = 1;
                bZhuangLiaoOkFlg = 0;
                LY_CTHL_ZhuangLiaoStep = 1;
                LY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
                LY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
            }  
        }
        //Ե
        if(LY_CTHL_bCLMotor_N)
        {           
            SetEn(Y_AXIS, MOTOR_EN);
            if(!LY_CTHL_SF_Origin_IN)
            {  
                if(!Y_DRV)
                  //                Y       ٶ                    ٶ        ٶ  ٶ
                        AxisContinueMoveAcc(Y_AXIS,2000,DIR_N,1000,1000,15,15);
            } 
            else
            {
                LY_CTHL_bCLMotor_N = 0;
            }
              
        }
        
        if(LY_CTHL_bCLMotor_P)  //λѾȡ
        {
            SetEn(Y_AXIS, MOTOR_EN);
           if(!Y_DRV)
              //                Y       ٶ                    ٶ        ٶ  ٶ
                    AxisContinueMoveAcc(Y_AXIS,2000,DIR_P,1000,1000,15,15);
        }
        
        if(!LY_CTHL_bCLMotor_P && !LY_CTHL_bCLMotor_N && (LY_CTHL_CL_MotorStep == 0))
        {
              AxisEgmStop(Y_AXIS);//AxisDecStop(Y_AXIS); 
        }
        //ԭ
        if(LY_CTHL_bCLMotor_O)
        {
            LY_CTHL_bCLMotor_O = 0;
            if(LY_CTHL_CL_MotorStep == 0)
                LY_CTHL_CL_MotorStep = 40;
        } 
        //ϴ鶨λ ,ⲽΪǰϴλ, ܶŷҪص       
        if(LY_CTHL_bFKTDDW)
        {
            LY_CTHL_bFKTDDW = 0;
            if(LY_CTHL_TD_MotorStep == 0)
            {
                LY_CTHL_XKDW_VAVLE = 0;     //бڶλ
                LY_CTHL_CXQJD_VAVLE = 0;    //ǰд 
           if(!LY_CTHL_PARAM_CXLY_MODE)     
                   LY_CTHL_CXLY_VAVLE = 0;     //
           
                LY_CTHL_CXHJD_VAVLE = 0;    //д 
                LY_CTHL_CXHDW_VAVLE = 0;    //λ
                LY_CTHL_CXDWZ_VAVLE = 0;    //λ
                LY_CTHL_bHLJJ = 0;          //о
                LY_CTHL_FKJD_VAVLE = 0;     //д
                if((GetEn(X_AXIS) == MOTOR_DISEN))
                {
                    SetEn(X_AXIS, MOTOR_EN);
                    LY_CTHL_TD_MotorDelay = dwTickCount + 200;                    
                } 
                else
                    LY_CTHL_TD_MotorDelay = dwTickCount + 50;
                LY_CTHL_TD_MotorStep = 1;
            } 
        } 
        //ϴλ(бƴбڶλб)
        if(LY_CTHL_bFKCXTDDW)
        {
            LY_CTHL_bFKCXTDDW = 0;
            if((LY_CTHL_bFKCXTDDW_Step == 0) && (LY_CTHL_CL_MotorStep == 0) && 
               !LY_CTHL_CTXM_VAVLE)
            {
                LY_CTHL_bFKCXTDDW_Step = 1;
                SetEn(X_AXIS, MOTOR_EN);
                LY_CTHL_CXQJD_VAVLE = 0;    //ǰд 
                LY_CTHL_CXLY_VAVLE = 0;     //
                LY_CTHL_CXHJD_VAVLE = 0;    //д 
                LY_CTHL_CXHDW_VAVLE = 0;    //λ
                LY_CTHL_CXDWZ_VAVLE = 0;    //λ
                LY_CTHL_HLJJ_VAVLE = 0;          //о
            }  
        } 
        //(ǰλ,,,λ)
        if(LY_CTHL_bCXCR) 
        {
            LY_CTHL_bCXCR = 0;
            //ͷģ浽ǲ빴,жͷ
            if(LY_CTHL_CTXM_VAVLE && LY_CTHL_MGuo_VAVLE && !LY_CTHL_CXQJD_VAVLE &&
               LY_CTHL_CTM_Limit_IN && !LY_CTHL_LTou_Check)
            {                
                if(LY_CTHL_CL_MotorStep == 0)
                {
                     LY_CTHL_bCXCR_Step = 11; 
                     SetEn(Y_AXIS, MOTOR_EN);
                     if(!LY_CTHL_SF_Origin_IN)
                        LY_CTHL_CL_MotorStep = 40;
                }
            }
            else   //治Զ
            {
            LY_CTHL_SetAlarmCode(LY_CTHL_WFZIDONGCX_ALARM,0);  
            }
        }
        //
        if(LY_CTHL_bMotorHL)
        {
            LY_CTHL_bMotorHL = 0;
            if(LY_CTHL_SF_Origin_IN)
            {
            if((LY_CTHL_CL_MotorStep == 0) && !LY_CTHL_CTXM_VAVLE && (!LY_CTHL_CTM_Limit_IN))
            {
                bCL_OK_FLG = 0;   
                LY_CTHL_HLJJ_VAVLE = 1; //Y20 оߵŷ,
                LY_CTHL_CL_MotorStep = 1;
                LY_CTHL_CL_MotorDelay = dwTickCount + LY_CTHL_PARAM_HLJJ_CL_DELAY + 130;
                if((GetEn(Y_AXIS) == MOTOR_DISEN))
                {
                    SetEn(Y_AXIS, MOTOR_EN);
                    LY_CTHL_CL_MotorDelay = dwTickCount + 250;                    
                } 
            }
            }
            else
            {
             LY_CTHL_bCLMotor_O =1;
             
            }
        } 
        //һδ
        if(LY_CTHL_bCL_First)
        {
            LY_CTHL_bCL_First = 0;
            //ͷģ浽ǲ빴,жͷ
            if(LY_CTHL_CTXM_VAVLE && LY_CTHL_MGuo_VAVLE && !LY_CTHL_CXQJD_VAVLE &&
               LY_CTHL_CTM_Limit_IN && !LY_CTHL_LTou_Check && (LY_CTHL_CL_MotorStep == 0))
            {  
                LY_CTHL_bCLFirst_Step = 19;
                LY_CTHL_CXHJD_VAVLE = 1;    //д 
                LY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
                LY_CTHL_CXQJD_VAVLE = 0;    //ǰд 
            }
        }        
    }        
}

#endif
