#ifndef __TY_HM_DING_ZHI_JI_H__
#define __TY_HM_DING_ZHI_JI_H__

#if TONG_YONG_MACHINE | BRUCE_MACHINE


extern void HMDZ_Action(void);
extern void HMDZ_InitAction(void);


#define HMDZ_DIR_P           1
#define HMDZ_DIR_N           0

#define HMDZ_YDIR_P          1
#define HMDZ_YDIR_N          0

#define HMDZ_TOTAL_ADDR      76
#define HMDZ_ALARM_ADDR      100
#define HMDZ_PROSPEED_ADDR   78



/*
 *                           
 */
#define HMDZ_NO_ALARM             	0                                
#define HMDZ_MOTOR_ORIGIN_ALARM		1                              	 
#define HMDZ_WL_CHECK_ALARM	        2                                
#define HMDZ_RS_LIMIT_ALARM             3                                
#define HMDZ_DL_LIMIT_ALARM             4    
#define HMDZ_DL_ORIGIN_ALARM            5 
#define HMDZ_QS_LIMIT_ALARM             6    
#define HMDZ_QS_ORIGIN_ALARM            7 
#define HMDZ_TS_LIMIT_ALARM             8    
#define HMDZ_TS_ORIGIN_ALARM            9 
#define HMDZ_SS_LIMIT_ALARM             10    
#define HMDZ_SS_ORIGIN_ALARM            11 
#define HMDZ_SG_LIMIT_ALARM             12  
   

#define VAVLE_ALARM_TIME                3000
#define MOTOR_ALARM_TIME                5000

#define HMDZ_PARAM_YL_DELAY     (user_datas[0]*10)  
#define HMDZ_PARAM_DL_DELAY     (user_datas[1]*10)  
#define HMDZ_PARAM_SS_DELAY     (user_datas[2]*10) 
#define HMDZ_PARAM_SS_BACK_DELAY (user_datas[3]*10) 
#define HMDZ_PARAM_RS_MOTOR_DELAY (user_datas[4]*10) 
#define HMDZ_PARAM_RS_MOTOR_STOP_DELAY (user_datas[5]*10) 
#define HMDZ_PARAM_TS_DELAY     (user_datas[6]*10)
#define HMDZ_PARAM_QS_DELAY     (user_datas[7]*10)
#define HMDZ_PARAM_QS_BACK_DELAY (user_datas[8]*10)
#define HMDZ_PARAM_CL_BACK_DELAY (user_datas[9]*10)
   
#define HMDZ_PARAM_RS_MOTOR_SPEED user_datas[20]
#define HMDZ_PARAM_RS_MOTOR_ACC   user_datas[21]
#define HMDZ_PARAM_RS_MOTOR_DEC   user_datas[22]
#define HMDZ_PARAM_RS_MOTOR_START_SPEED user_datas[23]
   
#define HMDZ_PARAM_TL_MODE  0
#define HMDZ_PARAM_ON_BACK_LENGTH 2000

#define HMDZ_AutoDelay     cDelayTime1
#define HMDZ_MotorDelay    cDelayTime2
#define HMDZ_XiaQieDelay   cDelayTime3   
#define HMDZ_KaDaiDelay    cDelayTime4 
#define HMDZ_CSDelay       cDelayTime5
#define HMDZ_TBDelay       cDelayTime6
#define HMDZ_TFKDelay      cDelayTime7
#define HMDZ_TLDelay      cDelayTime8
#define HMDZ_CheckDelay    cDelayTime9
#define HMDZ_AlarmDelay    cDelayTime10
#define HMDZ_SJDelay       cDelayTime11
 
#define HMDZ_AutoStep        cStepMByte
#define HMDZ_MotorStep       cStepMByte1
#define HMDZ_XiaQieStep      cStepMByte2
#define HMDZ_YuanDianStep    cStepMByte3
#define HMDZ_TuiLianStep     cStepMByte4
#define HMDZ_CheckLengthStep cStepMByte5
#define HMDZ_BinLianStep     cStepMByte6

//
#define HMDZ_START_IN     X00
#define HMDZ_START_IN_UP (X00 && !OLDX00)
#define HMDZ_STOP_IN      X01
#define HMDZ_STOP_IN_UP  (X01 && !OLDX01)

#define HMDZ_MOTOR_ORIGIN_IN    X02    // ԭ
#define HMDZ_WL_CHECK_IN     X03       // ϼ
#define HMDZ_RS_LIMIT_IN     X04       // ˿λ 
#define HMDZ_DL_LIMIT_IN     X05       // ϵλ
#define HMDZ_DL_ORIGIN_IN    X06       // ˵λ
#define HMDZ_QS_LIMIT_IN     X07       // ˿λ
#define HMDZ_QS_ORIGIN_IN    X10       // ˿˵λ
#define HMDZ_TS_LIMIT_IN     X11       // ˿λ
#define HMDZ_TS_ORIGIN_IN    X12       // ˿˵λ
#define HMDZ_SS_LIMIT_IN     X13       // ˿λ
#define HMDZ_SS_ORIGIN_IN    X14       // ˿˵λ
#define HMDZ_SG_LIMIT_IN     X15       // ˿˵λ
   
#define HMDZ_SS_VAVLE           Y01    // ˿
#define HMDZ_DL_VAVLE           Y02    // 
#define HMDZ_QS_VAVEL           Y03    // ˿
#define HMDZ_TS_VAVLE           Y04    // ˿
#define HMDZ_JL_VAVLE           Y05    // 
#define HMDZ_YL_VAVLE           Y06    // ѹ
#define HMDZ_CL_VAVLE           Y07    // 
#define HMDZ_SZ_OUT             Y10    // 

#define HMDZ_bRunning            M0000
#define HMDZ_bStart              M0001
#define HMDZ_bStop               M0002
#define HMDZ_bAlarmStop          M0003
#define HMDZ_bClearTotal         M0004
#define HMDZ_bSS                M0006
#define HMDZ_bDL                M0007
#define HMDZ_bQS                M0008
#define HMDZ_bTS                M0009
#define HMDZ_bJL                M0010
#define HMDZ_bYL                M0011
#define HMDZ_bCL                M0012
#define HMDZ_bGoMotor           M0013
#define HMDZ_bBackMotor         M0014

     
#endif

#endif