#include "global.h"

#if XIN_YE_MACHINE

void DK_InitAction(void);
void DK_ChuiQi(void);
void DK_Action(void);
void DK_XiaChong(void);
void DK_SetAlarmCode(unsigned alarm_code);
void DK_StartStopAction(void);
void DK_AutoRunStep(void);
void DK_Motor(void);

unsigned char DK_SingOneFlg = 0,caosheng_flg,DK_bRunning,DK_bStop;


void DK_SetAlarmCode(unsigned alarm_code)
{
    SetAlarmCode(DK_ALARM_ADDR,alarm_code);
    DK_bAlarmStop = 1;
}

void DK_InitAction(void)
{   
    float buff_pulse,buff_dist;
    XGearRatio  =  1;
    SetAlarmCode(DK_ALARM_ADDR,0);
}

void DK_ChuiQi(void)
{ 
      //废料吹气
      if(Y005 && (dwTickCount >= cDelayTime6))
      {
              Y05 = 0;	//下模吹气
      }
}


//手动动作
void DK_ManualAction(void)
{                  
    if((DK_bRunning == 0) && (X001 == 0)) ////手动 
    {   
    	if(!X_DRV)Y07 = 1;   
        SETDR();
         //手动钩针
        if(M3)
    	{
    		M3 = 0;

    		if(Y000)
    		{
    		    Y00 = 0;
           	}
           	else //if(((Y003 == 0) && (Y004 == 0)) || ((user_datas[12] == 1) && (Y005 == 0)))  //上下模不能输出
           	{
           		Y00 = 1;
           	}	
        }      
        //手动压带
        if(M4)
    	{
    		M4=0;
    		if(Y001)
    		{
    			Y001 = 0;
           	}
                else
                  Y001 = 1;
        }

        //上模下
        if(M5)
    	{
    		M5 = 0;
    		if(Y004)
    		{
    		   Y004 = 0;
           	}
           	else 
           	{
           	   Y004 = 1;
           	}

        }
        
        if(M13)
        {   
            Y015 = 1;
            cDelayTime1 = dwTickCount + user_datas[6]*10;
        }
         //超声动作
        if(M7)
    	{						//勾针要下
    		if((Y015 == 0)) 
    		{ 
    			{
	    			Y015 = 1;
	           		cDelayTime1 = dwTickCount + user_datas[6]*10;
           		}
           	}
        }
        if((Y015) && (dwTickCount >= cDelayTime1) && (cStepMByte2 == 0))   
        {
        	Y015 = 0;	
        	M7 = 0;
        }	

        if(M14== 0)
        {
	         //废料吹气动作
	        if(M9)
	    	{	
                   //勾针要下
                        M9  = 0;
	    		Y05 = 1;
                        cDelayTime6 = dwTickCount + user_datas[10]*10;
	        } 
        }        
         //自动切断
   	if(M12)
      	{
      		M12 = 0;

      		if((M14 == 0) && (X04|| (user_datas[18] == 0)) && X06 && Y00)
      		{
                    	M14 = 1;
      			cStepMByte2 = 1;
      		}
      		else //TODO 自动切断条件不满足
      		{
      		    if(!X04 && (user_datas[18] == 1))DK_SetAlarmCode(__W_LIAN_JIA_LIMIT);
                    else if(!X06)DK_SetAlarmCode(__W_GZ_LIMIT);
                    else if(!Y00)DK_SetAlarmCode(__W_GZ_OUT);  
      		}
      	} 
    }
    
        if((dwTickCount >= cDelayTime6) && Y05)
        {
            Y05 = 0;
        }
}


//打孔动作
void DK_Action(void)
{	
    unsigned char i;	
    DK_XiaChong();
     DK_ChuiQi();
    DK_ManualAction();
    DK_AutoRunStep();
    DK_StartStopAction();
    if((DK_bRunning)&&(X001 == 0))
    { 
    	switch(cStepMByte)
    	{
    		case 1://电机启动
    			if(dwTickCount >= cDelayTime2)
    			{
	    			cStepMByte1 = 1;   //拖带启动
	    			cStepMByte = 2;
    			}
    			break;
    		case 2: //等电机拖带完成
    			if(cStepMByte1 == 0)
    			{
    				Y001 = 1;
    				cStepMByte = 3;
    				cDelayTime2 = dwTickCount + user_datas[9]*10;//压带输出时间 
    			}
    			break;	
    		case 3:
	    		if(dwTickCount >= cDelayTime2)cStepMByte = 4;
    			break;	
    		case 4://延时和反转完成
                          cStepMByte2 = 1;    //启动合模打孔
                          cStepMByte = 5;	
    			break;
    		case 5:
    			if(cStepMByte2 == 0)	//打孔完成
    			{
    				Y004 = 0;	//上模
    				cStepMByte = 6;	  
                                cDelayTime2 = dwTickCount + DK_VAVLE_ERROR_TIME;
    			}
    			break;
		    case 6:	
    			if(X012 && (X006 == 0))	//上下都回到位
    			{				
                                cStepMByte = 9;
    				cDelayTime2 = dwTickCount + 10 * user_datas[15];
    			}
                        else if(dwTickCount >= cDelayTime2)
                        {
                            if(!X012)
                              DK_SetAlarmCode(__W_CUTTER_LIMIT);
                            else
                              DK_SetAlarmCode(__W_GZ_LIMIT);
                        }    
    			break;
    		case 9:
    			if(dwTickCount >= cDelayTime2)	
    			{
    				Y015 = 0;;
    				
    				AddToTal(20);
    				CalProSP(78);
                                
                                if(GetTotal(20) >= GetTotal(22))
                                {
                                   DK_SetAlarmCode(__W_PRODUCT);
                                } 
                                else
                                {
                                    cStepMByte = 1;
                                    cDelayTime2 = dwTickCount+user_datas[15];
                                }
                                
    			}
    			break;	
    	}	
    }    
}

//下冲动作
void DK_XiaChong(void)
{
    static unsigned long lianjia_delay;
    static unsigned char lianjia_flg = 0;
    if(caosheng_flg)
    {
       if(dwTickCount >= cDelayTime3)	
       {
           Y015 = 0;
           caosheng_flg = 0;
       } 
    }
	switch(cStepMByte2)
	{ 
		case 0:
			return;
			break;
                case 1:
                  {
                      if(DK_bRunning)
                      {
                          Y001 = 1;         
                      }
                       cStepMByte2 = 2;
                       cDelayTime3 = dwTickCount + DK_VAVLE_ERROR_TIME;
                  }break;
		case 2:
                       if(X04 || (user_datas[18] == 0))
                       {
				cStepMByte2 = 3;
				Y004 = 1;	//SETY004;    	//上模下降  
				cDelayTime3 = dwTickCount + 2000;   //上模下降的时间
                       }
                       else if(dwTickCount >= cDelayTime3)   //上模没下到警告
                            DK_SetAlarmCode(__W_LIAN_JIA_LIMIT);
			break;
		case 3:
			if(!X012)
			{
				cStepMByte2 = 4;
				cDelayTime3 = dwTickCount + 2000;   //上模下降的时间
			}
			else if(dwTickCount >= cDelayTime3)   //上模没下到警告
			{                       
                              DK_SetAlarmCode(__W_CUTTER_LIMIT);
                              Y004 = 0;	
        	        }
        	break;
		case 4:  //下模上到位
			{
				cDelayTime3 = dwTickCount + user_datas[5]*5;//延时发超声 
				cStepMByte2 = 5;
                        }
			break;                       
                case 5:
                  if(dwTickCount >= cDelayTime3)
                  {
                      cStepMByte1 = 10;
                      cDelayTime3 = dwTickCount + user_datas[5]*5;//延时发超声 
                      cStepMByte2 = 6;
                  }break;
		case 6:	
			if(dwTickCount >= cDelayTime3)	 //延时到发超声
			{
				cStepMByte2 = 7;
				Y015 = 1;//SETY002;      //发超声   
				caosheng_flg = 1;             
				cDelayTime3 = dwTickCount + user_datas[6]*10;//超声时间 				
			}
			break;
		case 7:	
			if((dwTickCount >= cDelayTime3))
			{
				cStepMByte2 = 8;
				Y015 = 0;	//CLRY006;
                                Y005 = 1;	//废料吹气启动
		    		cDelayTime6 = dwTickCount + user_datas[10]*10;//废料吹气输出时间
				cDelayTime3 = dwTickCount + user_datas[7]*10;//固化时间 
				cDelayTime8 = dwTickCount + user_datas[8]*10;//固化时间 
			}
			break;
		case 8:
			if((dwTickCount >= cDelayTime3))
			{
                                Y004 = 0;
				cStepMByte2 = 9;
                                cDelayTime3 = dwTickCount + DK_VAVLE_ERROR_TIME;
                                M14 = 0;
                                lianjia_flg = 1;
                                lianjia_delay = dwTickCount + user_datas[19]*100;                               
			}	
			break;
		case 9:
			if((X03 || (user_datas[18] == 0)) && (cStepMByte1 == 0))
			{         
                                Y000 = 0;
				cStepMByte2 = 0;
                                cDelayTime3 = dwTickCount;
			}
                        else if((dwTickCount >= cDelayTime3))
                            DK_SetAlarmCode(__W_LIAN_JIA_ORIGIN);
			break;
			
	}
    
        if(lianjia_flg)
        {
            if(dwTickCount >= lianjia_delay)
            {
                lianjia_flg = 0;
                Y001 = 0; 
            }
        }
}

//启动停止故障停止动作
void DK_StartStopAction(void)
{
      dwRealPos = GetPos(X_AXIS);
    user_datas[121] = cStepMByte;
    
    if(!X02)DK_SetAlarmCode(__W_KA_DAI);
    else 
    {
        if(user_datas[100] == __W_KA_DAI)user_datas[100] = 0;
    } 
    
    if(X20 && (DK_bRunning==1))DK_SetAlarmCode(__W_SAVE_DOOR);

    
    if(X00_UP || M0)   
    { //                       停止
    	if((DK_bRunning == 0) && (X001 == 0))
    	{//     勾针到位      勾针上气缸    勾针下    下模到位                   上模到位
    		if(!X20 && (X006 == 0) && (X012) && !X007 && (X03 || (user_datas[18] == 0)))
    		{  
    			M15=1;
		        DK_bRunning = 1;       // 取反运行标志位
		        CLRDR();
                        user_datas[100]=0;
		     //   cKey_Time = 10;
		        cStepMByte = 1;
		        cStepMByte1 = 0;
		        cStepMByte2 = 0;
		        cStepMByte3 = 0;
		        cStepMByte4 = 0;
                        cDelayTime2 = dwTickCount + 200;	
                        Y007 = 0;	
		}
                else  
                {
                        if(X006)
                            DK_SetAlarmCode(__W_GZ_LIMIT);
                        else if(X007)
                            DK_SetAlarmCode(__W_GZ_UP_LIMIT);
                        else if(!X03 && (user_datas[18] == 1))
                             DK_SetAlarmCode(__W_LIAN_JIA_ORIGIN);
                        else if(X20)
                             DK_SetAlarmCode(__W_SAVE_DOOR);
                        else
                        {
                           DK_SetAlarmCode(__W_CUTTER_LIMIT);
                        }
                }
			
	 }
	 M0 = 0;
    }
    if(DK_bAlarmStop)
    {
        DK_bAlarmStop = 0;
        M14 = 0;
        M2 = 0;
        M15=0;
        CLRDR();
        DK_bRunning = 0; 
        AxisEgmStop(X_AXIS);
        cStepMByte = 0;
        cStepMByte1 = 0;
        cStepMByte2 = 0;
        cStepMByte3 = 0;
        cStepMByte4 = 0;	
    }
    //停止
    if(X001 ||  M2)
    {
        M15=0;
        if(DK_bRunning)
        {   
	    	M2 = 0;
	    	Y000 = 0;
                Y001 = 0;
                Y002 = 0;
                Y004 = 0;
                Y015 = 0;
                M14 = 0;
                Y007 = 0;
	        DK_bRunning = 0; 
	        AxisEgmStop(X_AXIS);
                cStepMByte = 0;
                cStepMByte1 = 0;
                cStepMByte2 = 0;
                cStepMByte3 = 0;
                cStepMByte4 = 0;
        }
        else
        {
                M14 = 0;
                M2 = 0;
                CLRDR();
                Y000 = 0;
                Y001 = 0;
                Y002 = 0;
                Y004 = 0;
                Y015 = 0;
                Y007 = 0;
	        DK_bRunning = 0; 
	        AxisEgmStop(X_AXIS);
                cStepMByte = 0;
                cStepMByte1 = 0;
                cStepMByte2 = 0;
                cStepMByte3 = 0;
                cStepMByte4 = 0;
                CLRY000();
                CLRY001();
                CLRY002();
                CLRY004();
                CLRY006();
                
                if((user_datas[100] != 0) && !X20)user_datas[100] = 0;		
	}
		
    }

	
        //清总产量
	if(M1)         //清总产量
	{
		if(dwTickCount >= cDelayTime7)
		{
		    M1 = 0;
		    ClrcToTal(20);
		}		    		
	}
	else
	{
		cDelayTime7 = dwTickCount + 3000;
	}
}

//电机动作
void DK_Motor(void)	 //
{


}

//自动运行动作
void DK_AutoRunStep(void)
{    
	unsigned long  ch;
	switch(cStepMByte1)
	{
		case 0:
				return;
				break;
	   //         	缺料           勾针到位     勾针上气缸
		case 1: if((X006 == 0) && (X012)) 
                {
                        Y10 = 1;   
                        MoveAction_Const_AccDec(X_AXIS,0,user_datas[2],user_datas[0],user_datas[1],1);  
                        cStepMByte1 = 2;
                         cDelayTime1 = dwTickCount + user_datas[16]*1000;
                }
                break;
		case 2:				
			if(!X05)   //在空位
			{	
				cStepMByte1 = 3;
				AxisChangeSpeed(X_AXIS,user_datas[3]);
                                cDelayTime1 = dwTickCount + user_datas[16]*1000;
			}
                        else if(dwTickCount >= cDelayTime1)
                        {
                               DK_SetAlarmCode(__W_NO_ZIP);        
                        }
			break;	
                case 3:				
			if(X05)   //在空位
			{	
                                cStepMByte1 = 4;
                                cDelayTime1 = dwTickCount + user_datas[11];   //延时勾针
			}
                        else if(dwTickCount >= cDelayTime1)
                        {
                               DK_SetAlarmCode(__W_NO_ZIP);                     
                        }
			break;	
                case 4:	if(dwTickCount >= cDelayTime1)
			{
				Y000 = 1; //SETY000;	
                               cStepMByte1 = 5;
                               cDelayTime1 = dwTickCount + 1000;   //没链警告
                        }
                case 5:
                        if(X06 && X07)
                        {
                             cStepMByte1 = 6;                            
                             cDelayTime1 = dwTickCount + user_datas[4];   //延时停拖带
                        }    
                       else if(dwTickCount >= cDelayTime1)
                        {
                             if(!X06)
                                 DK_SetAlarmCode(__W_GZ_LIMIT);  
                             else
                                 DK_SetAlarmCode(__W_GZ_UP_LIMIT); 
                        }
		case 6:
			if(dwTickCount >= cDelayTime1)
			{
				cStepMByte1 = 7;
                                AxisEgmStop(X_AXIS);
				
			}			
			break;
		case 7:	
                        if(!X_DRV)
			{
				cStepMByte1 = 0;
                                cDelayTime1 = dwTickCount+ 50;
			}
			
			break;	
		case 10:	//反转一点
                        if(dwTickCount >= cDelayTime1)
                        {
                            Y10 = 0;
                            AxisMovePos(X_AXIS,10,user_datas[17]);
                            cStepMByte1 = 11;
                        }
			break;
		case 11:
			if(!X_DRV)
			{
			    cStepMByte1 = 0;
			}		
			break;		
	}
}


#endif
