
#include "st_sys.h"

//1뻻1usı
#define US_PER_SECOND   1000000

//ǰʱ
static volatile int cur_second = 0;
static volatile int cur_ms = 0;
static int reload_valve = 0;
unsigned long dwTickCount = 0;
static volatile int system_core_clock = 400; //ϵͳʱ
void SysTick_Handler(void)
{
    dwTickCount++;
    
    if (++cur_ms >= 1000) {
		cur_ms = 0;
		cur_second++;
     }
}


/**
 * ʼʱ
 * 
 * @author lxz 
 * 
 * @param void 
 */
void sw_timer_init(int clk)
{
    //clk = clk * 1000000;
    /*
    SysTick->CTRL &= ~(1 << 2);                    //SYSTICK ʱӸϵͳͬ
    SysTick->CTRL |= 1 << 1;                    //жʹ
    SysTick->LOAD = (clk / 8000) - 1; //1msж
    SysTick->CTRL |= 1 << 0;                    //ʹsystick
    Sys_NVIC_Init(1,1,SysTick_IRQn,1);
  */
    reload_valve = clk * 1000 - 1;
    SysTick_Config(clk * 1000);
    
    //__NVIC_EnableIRQ(SysTick_IRQn);
}


/**
 * ȡǰĶʱʱ
 * 
 * @author lxz 
 * 
 * @param timer 
 */
void sw_timer_now(sw_timer_t *timer)
{
    int second;
    int us;
    int ms;

    do
    {
        ms = cur_ms;
        second = cur_second;
        us = SysTick->VAL;
    }while (ms != cur_ms);

    timer->second = second;
    timer->usec = (ms * 1000) + (reload_valve - us) * 1000 / reload_valve;
}




/**
 * ʼһʱʵʱȽ
 * 
 * @author lxz 
 * 
 * @param timer object ʱʵ
 * @param second   Ҫʱ뵥λ
 * @param usec    Ҫʱĺ뵥λ 
 */
void sw_timer_start(sw_timer_t *timer, int sec, int usec)
{
    sw_timer_now(timer);
    sw_timer_delay(timer, sec, usec);
}
/**
 * ضʱǷѾʱ
 * 
 * @author lxz 
 * 
 * @param timer ʱʵ
 * 
 * @return int 
 */
int sw_timer_expire(sw_timer_t *timer)
{
    sw_timer_t now;
    sw_timer_now(&now);
    if (timer->second < now.second || 
        (timer->second == now.second && timer->usec <= now.usec)) return 1;
    return 0;
}
/**
 * ԵضʱʱӺ
 * 
 * @author lxz 
 * 
 * @param timer ʱʵ
 * @param sec  ҪӺ
 * @param usec  ҪӺ΢
 * 
 * @return int 
 */
void sw_timer_delay(sw_timer_t *timer, int sec, int usec)
{

    timer->usec += usec;
    timer->second += sec + timer->usec / US_PER_SECOND;
    timer->usec %= US_PER_SECOND;
}



