#ifndef __NODELINK_COMMON_H__
#define __NODELINK_COMMON_H__

#define NATIVE_DATA_BUFFER_SIZE  	64
#define NATIVE_DATA_OUT_BUFFER_SIZE 64
#define SLAVE_DATA_IN_BUFFER_SIZE	1024

#define NODELINK_RECV_FIN_TIME		500	//us为单位



/**
 * 数据编码
 * 
 * @author lxz (041820 14:21:27)
 * 
 * @param slave 
 * @param dst 
 * @param src 
 * @param len 
 * 
 * @return int 
 */
int nodelink_decode(unsigned char * dst, unsigned char * src, int len);
/**
 * 数据解码
 * 
 * @author lxz (041820 14:22:05)
 * 
 * @param id 
 * @param dst 
 * @param src 
 * @param len 
 * 
 * @return int 
 */
int nodelink_encode(unsigned char * dst,unsigned char * src ,int len);

#endif
