#ifndef __TINY_LOG_H__
#define __TINY_LOG_H__

typedef struct
{
    unsigned short size;    //总缓冲大小
    unsigned short first;   //第一个包的位置
    unsigned short last;

    short total;   //总记录条数
    unsigned short idle_size;//剩余大小
    unsigned short cur_site;//当前查抄的位置，当当前查找的编号为小于0时，表示无效
    short last_index;//上次定位的条木序号
    unsigned char * buf;    //数据存放地址
    unsigned char * log;    //记录存放地址
} tiny_log_t;

void tiny_log_init(tiny_log_t * log, void * buf, int size);
int tiny_log_read_type(tiny_log_t *log,char * log_flg);

int tiny_log_foreach_entry(tiny_log_t *log);
void tiny_log_beign_read(tiny_log_t * log);
int tiny_log_foreace_read(tiny_log_t * log,char * log_flg,void *buf);
int tiny_log_index_resad(tiny_log_t * log,char * log_flg,void *buf);

int tiny_log_read_type(tiny_log_t *log,char * log_flg);
int tiny_log_read_log(tiny_log_t *log,void * buf);
void tiny_log_clear(tiny_log_t * log);
void tiny_log_insert(tiny_log_t * log, char type, void *dat, unsigned char  size);
void tiny_log_save(tiny_log_t * log);

#endif
