#ifndef GLQUEDUAN_CHUANTOU_H
#define GLQUEDUAN_CHUANTOU_H

#if CHANG_SHENG_GEI_LI_MACHINE == 1

#define USE_X02_EXTI 1
#define X02EXTI_DIR 1 //1->أ0->½ (Ӧⲿ)

extern void GL_QDCT_InitAction(void);
extern void GL_QDCT_Action(void);
extern void GL_QDCT_ExtiActionX31(void);
extern void GL_QDCT_SetAlarmCode(unsigned alarm_code);



#define QDCT_LATOU   1// 0Ϊ˫ͷ   1Ϊͷ        
#define QDCT_LONG_LENGTH_USE 0 //0Ϊͨ 1Ϊ޳

#define QDCT_DIR_P 0
#define QDCT_DIR_N 1

#define QDCT_JJ_DIR_P 1
#define QDCT_JJ_DIR_N 0
#define QDCT_YL_DIR_P 0
#define QDCT_YL_DIR_N 1


#define QDCT_MOTOR_EN 0
#define QDCT_MOTOR_DISEN 1

#define QDCT_VAVLE_ERROR_TIME   6000 
#define QDCT_MOTOR_ALARM_TIME   5000

//ϴб
#define QDCT_NO_ALARM         0
#define QDCT_NO_ZIPPER_ALARM  1
#define QDCT_LT_ALARM         2
#define QDCT_XQ_ORIGIN_ALARM  3
#define QDCT_XQ_LIMIT_ALARM   4
#define QDCT_JD_ALARM         5
#define QDCT_DEC_ALARM        6
#define QDCT_GO_LIMIT_ALARM   7
#define QDCT_BACK_LIMIT_ALARM 8
#define QDCT_LTCZ_ALARM       9
#define QDCT_COUNT_ALARM      10    //û
#define QDCT_XM_LIMIT_ALARM   13
#define QDCT_XQ_ALARM         14
#define QDCT_TOTAL_ALARM      16
#define QDCT_XM_ORIGIN_ALARM  17
#define QDCT_SL_ORIGIN_ALARM  18
#define QDCT_SQ_ORIGIN_ALARM        19
#define QDCT_SL_ALARM               20
#define QDCT_HSL_LIMIT_ALARM         22
#define QDCT_HSL_ORIGIN_ALARM        23
#define QDCT_JD_LEFT_ALARM          24
#define QDCT_JD_RIGHT_ALARM         25
#define QDCT_JLT_ALARM              26
#define QDCT_ZLT_ALARM              27
#define QDCT_START_NO_ZIPPER_ALARM  30
#define QDCT_START_JLT_ALARM        31
#define QDCT_START_LTCZ_ALARM       32
#define QDCT_START_GL_ORIGIN_ALARM  33
#define QDCT_START_SL_LIMIT_ALARM   34
#define QDCT_START_SQ_ORIGIN_ALARM  35
#define QDCT_START_XQ_ORIGIN_ALARM  36
#define QDCT_START_SM_ORIGIN_ALARM  37
#define QDCT_YL_LIMIT_ALARM         38
#define QDCT_EX_ALARM               40
#define QDCT_SQ_LIMIT_ALARM         41
#define QDCT_KD_ALARM               42
#define QDCT_SE_BIAO_ALARM          43
#define QDCT_ZIPPER_LENGTH_ALARM    44
#define QDCT_HHSL_LIMIT_ALARM         45
#define QDCT_HHSL_ORIGIN_ALARM        46
#define QDCT_HJLT_ALARM              47
#define QDCT_HZLT_ALARM              48
#define QDCT_CLOK_ALARM              49 //⾯

#define QDCT_AutoStep           cStepMByte
#define QDCT_QZhuangLiaoStep    cStepMByte1
#define QDCT_HZhuangLiaoStep    cStepMByte2
#define QDCT_MotorStep          cStepMByte3
#define QDCT_JiaLianStep        cStepMByte4
#define QDCT_XiaQieStep         cStepMByte5
#define QDCT_ZhenDongStep       cStepMByte6
#define QDCT_QTLTStep           cStepMByte7
#define QDCT_HTLTStep           cStepMByte8
#define QDCT_QZDPStep           cStepMByte9
#define QDCT_HZDPStep           cStepMByte10
#define QDCT_TLPStep            cStepMByte11
#define QDCT_TuiLianStep        cStepMByte12
#define QDCT_HeMoStep           cStepMByte13          //ģ
#define QDCT_TestMotorStep      cStepMByte14

#define QDCT_XiaQieDelay        cDelayTime1
#define QDCT_QZhuangLiaoDelay   cDelayTime2
#define QDCT_HTLT_Delay         cDelayTime3
#define QDCT_MotorDelay         cDelayTime4
#define QDCT_AutoDelay          cDelayTime5
#define QDCT_TableDelay         cDelayTime6
#define QDCT_QZhenDongDelay     cDelayTime7
#define QDCT_HZhuangLiaoDelay   cDelayTime8
#define QDCT_JD_Delay           cDelayTime9
#define QDCT_QTLT_Delay         cDelayTime10
#define QDCT_HZhenDongDelay     cDelayTime11
#define QDCT_CQDelay            cDelayTime12
#define QDCT_KaDaiTime          cDelayTime13
#define QDCT_TLDelay            cDelayTime14
#define QDCT_HeMoDelay          cDelayTime15
#define QDCT_CS_Delay           cDelayTime16
#define QDCT_HDLPDelay          cDelayTime17
#define QDCT_QDLPDelay          cDelayTime18
#define QDCT_HHSLBackTime       cDelayTime19
#define QDCT_QHSLBackTime       cDelayTime20



#define QDCT_TestMotorDelay          cDelayTime21
#define QDCT_MotorBackLimitDelay          cDelayTime27
#define cTesttime                   cDelayTime28
//32λ޷ű
#define QDCT_LianLengthCheck        cUDword32Buff1

//32λзű
#define QDCT_XSavePosBuff           cDword32Buff1
#define QDCTL_X_CXPosBuff           cDword32Buff2
#define QDCT_YSavePosBuff           cDword32Buff3
#define QDCT_CheckInX02PosBuff      cDword32Buff4
#define QDCT_YsaveCXDWPosBuff       cDword32Buff5
#define QDCT_LENTH_Check            cDword32Buff6
//16λ޷ű
#define QDCT_cWorkCnt               cUShort16Buff1
#define QDCT_cZhaCnt                cUShort16Buff2
#define QDCT_QHSL_CheckBackTime     cUShort16Buff3
#define QDCT_HHSL_CheckBackTime     cUShort16Buff4
#define QDCT_ka_dai_cnt             cUShort16Buff5
//
#define QDCT_length_buff            *Short16Buff1

//8λ
#define QDCT_TryCnt                 cCharBuff1
#define QDCT_cZipCnt                cCharBuff2
#define QDCT_cStopInCnt             cCharBuff3
#define QDCT_cStopMode              cCharBuff4
#define DCCT_cSL_En                 cCharBuff5
#define QDCT_cQTryCnt               cCharBuff6
#define QDCT_cChuan_Lian_ErrorNum   cCharBuff7
//#define                    cCharBuff6
//λ־λ
#define QDCT_bFirstHStartFlg               bBitFlag0
#define QDCT_bFirstQStartFlg                bBitFlag1
#define QDCT_bStartOnceTime                 bBitFlag2  
#define QDCT_bCheck_Go_In_Flag              bBitFlag3
#define QDCT_bManFlg                        bBitFlag4
#define QDCT_bStopFlg                       bBitFlag5
#define QDCT_bXiaMo_En                      bBitFlag6
#define QDCT_bBackLimitCheck_EN             bBitFlag7
#define QDCT_bCheckDinWeiFlag               bBitFlag8
#define QDCT_bHZhuangLiaoOkFlg              bBitFlag9
#define QDCT_bQTuiLaTouOkFlg                bBitFlag10
#define QDCT_bHTuiLaTouOkFlg                bBitFlag11
#define QDCT_bQZhuangLiaoOkFlg              bBitFlag12
#define QDCT_bSeBiaoEn                      bBitFlag13
#define QDCT_bSeBiaoOk                      bBitFlag14
#define QDCT_bAlarmStop                     bBitFlag15
#define QDCT_bTuiLianOKFlag                 bBitFlag16
#define QDCT_bQHSL_BackTimeOK               bBitFlag17
#define QDCT_bHHSL_BackTimeOK               bBitFlag18
#define QDCT_bHemo_OK                       bBitFlag19
#define QDCT_bJZ_over                       bBitFlag20
#define QDCT_bChuan_LianCheckOK             bBitFlag21
#define QDCT_bSingOneFlg                    bBitFlag22 

#define QDCT_TOTAL_ADDR  8
#define QDCT_NOWTOTAL_ADDR  10
#define QDCT_SETTOTAL_ADDR  12
#define QDCT_SPEED_ADDR     14
#define QDCT_ALARM_ADDR    100

#define QDCT_PARAM_CYCLE_PULSE      user_datas[0]//0 תһȦ  
#define QDCT_PARAM_CYCLE_LENGTH     user_datas[1]//1 תһȦϴ೤ 
#define QDCT_PARAM_TABLE_TIME       (user_datas[2]*10)//̨ʱ
#define QDCT_PARAM_GO_LOWSPEED      user_datas[3]     //дǰ
#define QDCT_PARAM_TABLE_NUM         user_datas[4]
#define QDCT_PARAM_HSL_DELAY_BACK   (user_datas[5]*10)
#define QDCT_PARAM_XQ_UP_LENGTH      user_datas[6]      //ǰе
#define QDCT_PARAM_HSL_DELAY        (user_datas[7]*10)

#define QDCT_PARAM_SET_ZIPPER_LENGTH (user_datas[16] | user_datas[17] << 16)//
#define QDCT_PARAM_PUTIN_LENGTH     user_datas[18]  //볤

#define QDCT_PARAM_JJGO_SPEED       user_datas[20]  //ǰ
#define QDCT_PARAM_JJFZ_LENGTH      user_datas[21]  //˷תٶ
#define QDCT_PARAM_JJBACK_SPEED     user_datas[22]  //ٶ

#define QDCT_PARAM_JJDINGWEI_LENGTH    user_datas[23]  //ǰλ

#define QDCT_PARAM_CUT_BACK_LENGTH  user_datas[24]  //ʣ೤ɼ
#define QDCT_PARAM_SJZ_LENGTH       user_datas[25]  //жϺ˳
#define QDCT_PARAM_CUT_DELAY        (user_datas[26]*10) //ӳ
#define QDCT_PARAM_CUTBACK_DELAY    (user_datas[27]*10) //жϺʱ
#define QDCT_PARAM_CUTBACK_SPEED    user_datas[28]      //жϺٶ
//#define QDCT_PARAM_KL_TIME          (user_datas[30]*10) //ʱ
#define QDCT_PARAM_QLT_ON           (user_datas[31]) //ǰͷ
#define QDCT_PARAM_HLT_ON           (user_datas[32]) //ͷ
#define QDCT_PARAM_DLP_TIME          (user_datas[33]*10) //Ƭʱ
#define QDCT_PARAM_FZ_DELAY         (user_datas[34]*10) //ʱת
#define QDCT_PARAM_ZD_WORKNUM        user_datas[36] 
#define QDCT_PARAM_ZD_WORK_TIME     (user_datas[37]*10) //̹ʱ
#define QDCT_PARAM_ZD_DELAY_WORK    (user_datas[38]*10) //ʱ
#define QDCT_PARAM_KL_DELAY         (user_datas[40]*10)
#define QDCT_PARAM_JD_DELAY         (user_datas[41]*10) //ʱд
#define QDCT_PARAM_ZD_MODE           user_datas[42]     //̹ģʽ 0Ϊ1ΪЪ
#define QDCT_PARAM_CYCLE_DELAY      (user_datas[43]*10) //ʱһ
#define QDCT_PARAM_FIRST_SPEED      user_datas[44]      //һٶ
#define QDCT_PARAM_GO_LOWSPEED_LENGTH user_datas[45]    //ǰٳ
#define QDCT_PARAM_CZ_CHECK_DELAY   (user_datas[46]*10) //ʱͷ
#define QDCT_PARAM_LOCK_TIME         0// (user_datas[47]*10) //ͷʱ
#define QDCT_PARAM_Mold_Distance    user_datas[50]     //봩ģ
#define QDCT_BACK_LOWSPEED_LENGTH    user_datas[53]     //ٳȺ˹ģʽ
#define QDCT_ZFC_MODE                user_datas[51]     //ģʽ
#define QDCT_TL_LENGTH               user_datas[54]     //
#define QDCT_ZHA_NO                  user_datas[55]     //
#define QDCT_ZHA_STOP_TIME          (user_datas[56]*10) //ֹͣʱ
#define QDCT_BACK_LOWSPEED           user_datas[58] 
#define QDCT_SEBIAO_MODE             user_datas[59] 
#define QDCT_SEBIAO_LENGTH           user_datas[60]  
#define QDCT_REMAIN_CHECK_LENGTH     user_datas[61]  
#define QDCT_PARAM_MAX_BACK_LENGTH   user_datas[62]  
#define QDCT_PARAM_OFFSET_LENGTH     user_datas[63]     //
#define QDCT_PARAM_PUTIN_SPEED_LENGTH user_datas[64] 
#define QDCT_PARAN_SJ_TIME           user_datas[65] 
#define QDCT_PARAM_PUTIN_START_LENGTH user_datas[66] 
#define QDCT_PARAM_SL_BACKDELAY     (user_datas[67]*10)     //ͷλʱ
#define QDCT_PARAM_FZ_LENGTH         user_datas[68] 
#define QDCT_PARAM_DELAY_BACK       (user_datas[69]*10) 
#define QDCT_PARAM_XM_START_TIME     user_datas[70]             //ͷʱģ
#define QDCT_PARAM_FIRSTSPEED        user_datas[71]
#define QDCT_PARAM_CHANGE_LT         user_datas[72]
#define QDCT_PARAM_PUTIN_LOW_SPEED   user_datas[73]
#define QDCT_PARAM_PUTIN_LOW_SPEED_LENGTH user_datas[74]        //ٳ
#define QDCT_PARAM_DELAY_JLT       (user_datas[75]*10) 
#define QDCT_PARAM_START_SPEED       user_datas[76]
#define QDCT_PARAM_ACC_PULSE         user_datas[77]
#define QDCT_PARAM_DEC_PULSE         user_datas[78]
#define QDCT_PARAM_LOWSPEED_LENGTH   user_datas[79]
#define QDCT_PARAM_CNT_ENABLE_LENGTH user_datas[80]             //ɫλ
#define QDCT_PARAM_CQ_TIME          (user_datas[81]*10) 
#define QDCT_PARAM_TLP_ENABLE        user_datas[82] 
#define QDCT_PARAM_TLP_TIME          (user_datas[83]*10) 
#define QDCT_PARAM_TABLE_TIME2       (user_datas[84]*10)//̨ʱ
#define QDCT_PARAM_TABLE_NUM2        user_datas[85]
#define QDCT_PARAM_DELAY_SL          (user_datas[94]*10)//ʱ
#define QDCT_PARAM_XM_MODE            user_datas[95]   // 0Ϊģ 1Ϊģ
#define QDCT_PARAM_CS_CONTROL         user_datas[96]
#define QDCT_PARAM_CS_ENABLE          user_datas[97]    //
#define QDCT_PARAM_CS_DELAY          (user_datas[98]*10)
#define QDCT_PARAM_CS_TIME           (user_datas[99]*10)
#define QDCT_PARAM_CS_COLD_TIME      (user_datas[101]*10)
#define QDCT_PARAM_DELAY_KL          (user_datas[102]*10)
#define QDCT_PARAM_KL_TIME           (user_datas[103]*10)//ʱ
#define QDCT_SEBIAO_TQ_CHECK_LENGTH  user_datas[104] 
#define QDCT_SEBIAO_HIGH_SPEED        user_datas[105] 
#define QDCT_SEBIAO_LOW_SPEED         user_datas[106] 
#define QDCT_SEBIAO_ERROR_LENGHT      user_datas[107] 
#define QDCT_SEBIAO_BACK_LSPEED_LENGTH user_datas[108] 
#define QDCT_SEBIAO_BACK_DW_SPEED    user_datas[109] 
#define QDCT_PARAM_YLCYCLE_PULSE      user_datas[110]//0 תһȦ  
#define QDCT_PARAM_YLCYCLE_LENGTH     user_datas[111]//1 תһȦϴ೤ 
#define QDCT_PARAM_TRANS_LENGTH       user_datas[112]   
#define QDCT_PARAM_YL_SPEED           user_datas[113]   
#define QDCT_PARAM_YL_SL_LENGTH       user_datas[114]  
#define QDCT_PARAM_YL_SL_SPEED        user_datas[115]  
#define QDCT_PARAM_WAIT_LENGTH        user_datas[116]  
#define QDCT_PARAM_YL_DELAY          (user_datas[117]*10) 
#define QDCT_PARAM_YL_SL_DELAY       (user_datas[118]*10) 
#define QDCT_PARAM_YL_BACK_DELAY     (user_datas[119]*10) 
#define QDCT_PARAM_YL_FZ_DELAY       (user_datas[120]*10) 
#define QDCT_PARAM_BACK_DELAY        (user_datas[87]*10) 
#define QDCT_PARAM_TRY_TIMES          2//user_datas[88]
#define QDCT_PARAM_KL_QC_SELECT          (user_datas[130])  //ѡ    
#define QDCT_CHUAN_LIAN_CHECK_SELECT    (user_datas[131])

#define QDCT_PARAM_TB_CNT1            user_datas[200] 
#define QDCT_PARAM_TB_CNT2            user_datas[201] 
#define QDCT_PARAM_BACK_ALARM_MODE   1 //ΪӦ
#define QDCT_PARAM_TL_ENABLE         0

//
    #define QDCT_START_IN              M0384                //X00  
    #define QDCT_START_IN_UP           (M0384 && !OLDM384) //(X00 && !OLDX00)

    #define QDCT_STOP_IN                M0385 //X01    //ֹͣ
    #define QDCT_STOP_IN_UP             (M0385 && !OLDM385)//(X01 && !OLDX01)
    #define QDCT_STOP_IN_DW             (!M0385 && OLDM385)//(!X01 && OLDX01)
    #define QDCT_SEBIAO_IN              M0386   //   X02    ɫ   
    #define QDCT_SEBIAO_IN_UP           (M0386 && !OLDM386)//(X02 && !OLDX02)
    #define QDCT_SEBIAO_IN_DW           (!M0386 && OLDM386)//(!X02 && OLDX02)
    #define QDCT_NO_ZIPPER_CHECK_IN     M0387   //X03   
    #define QDCT_KA_DAI_IN              M0388   //(!X04)    
    #define QDCT_GO_LIMIT_IN            M0389   //X05          //ǰӦ
    #define QDCT_GO_LIMIT_IN_UP         (M0389 && !OLDM389)//(X05 && !OLDX05)
    #define QDCT_BACK_LIMIT_IN          M0390   //X06          //λ
    #define QDCT_BACK_LIMIT_IN_UP       (M0390 && !OLDM390)//(X06 && !OLDX06)
    #define QDCT_XM_LIMIT_IN            M0391   //X07       //ģλ(λ)
    #define QDCT_XM_ORIGIN_IN           M0392   //X10       //ģԭλ(λ)
    #define QDCT_XM_ORIGIN_IN_UP        (M0392 && !OLDM392)//(X10 && !OLDX10)
    #define QDCT_SQ_LIMIT_IN            M0393   //X11
    #define QDCT_XQ_LIMIT_IN            M0394   //X12
    #define QDCT_QTLT_LIMIT_IN          M0395   //X13
    #define QDCT_QHSL_ORIGIN_IN         M0396   //X14
    #define QDCT_QHSL_LIMIT_IN          M0397   //X15
    #define QDCT_QHSL_LIMIT_IN_DW       (M0397 && !OLDM397)//(!X15 && OLDX15)
    #define QDCT_QJLT_IN                M0398   //X16
    #define QDCT_QLTCZ_IN               M0399   //X17
    #define QDCT_QZDP_IN                M0400   //X20
    #define QDCT_CHUAN_LIAN_OK          M0401   //X21       //Ƿɹ  
    #define QDCT_CHUAN_LIAN_OK_UP       (M0401 && !OLDM401)//(X21 && !OLDX21)
    #define QDCT_SL_ORIGIN_IN           M0402   //X22
    #define QDCT_YL_LIMIT_IN            M0403   //X23
    #define QDCT_HTLT_LIMIT_IN          M0404   //X24
    #define QDCT_HHSL_ORIGIN_IN         M0405   //X25
    #define QDCT_HHSL_LIMIT_IN          M0406   //X26
    #define QDCT_HHSL_LIMIT_IN_DW       (M0406 && !OLDM406)//(!X26 && OLDX26)
    #define QDCT_HJLT_IN                M0407   //X27
    #define QDCT_HLTCZ_IN               M0408   //X30
    #define QDCT_HZDP_IN                M0409   //X31
    #define QDCT_CHUDAI_STOP            M0410   //X32
    #define QDCT_CHUNDAI_START          M0411   //X33
//
    #define QDCT_JD_OUT                 M0304  //Y00 //Y00 д
    #define QDCT_XM_OUT                 M0305  //Y01 //Y01ģ
    #define QDCT_SQ_OUT                 M0306  //Y02 //Y02е
    #define QDCT_XQ_OUT                 M0307  //Y03 //Y03е
    #define QDCT_QTLT_OUT               M0308  // Y04 //Y04ǰͷ
    #define QDCT_QHSL_OUT               M0309  // Y05 //Y05ǰͷ
    #define QDCT_QJLT_OUT               M0310  // Y06 //Y06ǰͷ
    #define QDCT_QZDP_OUT               M0311  // Y07 //Y07ǰ
    #define QDCT_QDLP_OUT               M0312  // Y10 //Y10ǰƬ  
    #define QDCT_TB_OUT                 M0313  // Y11 //Y11̨
    #define QDCT_SL_OUT                 M0314  // Y12 //Y12
    #define QDCT_CQ_OUT                 M0315  // Y13 //Y13
    #define QDCT_KL_OUT                 M0316  // Y14 //Y14
    #define QDCT_CS_OUT                 M0317  // Y15 //Y15
    #define QDCT_YL_OUT                 M0318  // Y16 //Y16ѹ   
    #define QDCT_YD_OUT                 M0319  // Y17 //Y17ѹ
    #define QDCT_STATE_RUN              M0320  // Y20 //е     
    #define QDCT_STATE_ERROR            M0321  // Y21 // 

    #define QDCT_HTLT_OUT               M0323  // Y23 //ǰͷ
    #define QDCT_HHSL_OUT               M0324  // Y24 //ǰͷ
    #define QDCT_HJLT_OUT               M0325  // Y25 //ǰͷ
    #define QDCT_HZDP_OUT               M0326  // Y26 //ǰ
    #define QDCT_HDLP_OUT               M0327  // Y27 //ǰƬ  
#define QDCT_Test_OUT               M0328  // Y27 //ǰƬ


#if 0
#if(QDCT_LATOU) //ͷ
    #define QDCT_START_IN     X00
    #define QDCT_START_IN_UP (X00 && !OLDX00)

    #define QDCT_STOP_IN      X01
    #define QDCT_STOP_IN_UP  (X01 && !OLDX01)
    #define QDCT_STOP_IN_DW  (!X01 && OLDX01)
    #define QDCT_NO_ZIPPER_CHECK_IN         X02
    #define QDCT_XQ_LIMIT_IN                X03
    #define QDCT_SL_ORIGIN_IN               X03

    #define QDCT_HJLT_IN                    1

    #define QDCT_PARAM_QLT_ON           (user_datas[31]) //ǰͷ
    #define QDCT_PARAM_HLT_ON           (0) //ͷ
    #define QDCT_PARAM_MODE             (user_datas[86])  // 0Ϊ 1Ϊ

    #define QDCT_JZ_LEFT_IN                1
    #define QDCT_JZ_RIGHT_IN               1
    #define QDCT_KA_DAI_IN                (!X04)

    #define QDCT_GO_LIMIT_IN               X05          //ǰӦ
    #define QDCT_GO_LIMIT_IN_UP            (X05 && !OLDX05)

    #define QDCT_SEBIAO_IN              1//(X06)
    #define QDCT_SEBIAO_IN_UP              1//(X06 && !OLDX06)
    #define QDCT_SEBIAO_IN_DW              1//(!X06 && OLDX06)
 
    #define QDCT_BACK_LIMIT_IN             X07
    #define QDCT_BACK_LIMIT_IN_UP         (X07 && !OLDX07)

    #define QDCT_HTLT_LIMIT_IN             0

    #define QDCT_QLTCZ_IN                  X10
    #define QDCT_HLTCZ_IN                  0
    #define QDCT_QTLT_LIMIT_IN             X11
    #define QDCT_XM_ORIGIN_IN              X12
    #define QDCT_XM_ORIGIN_IN_UP       (X12 && !OLDX12)

    #define QDCT_HHSL_ORIGIN_IN             1
    #define QDCT_HHSL_LIMIT_IN              0
    #define QDCT_HHSL_LIMIT_IN_DW           0//

    #define QDCT_QHSL_ORIGIN_IN            X13
    #define QDCT_QHSL_LIMIT_IN              X14
    #define QDCT_QHSL_LIMIT_IN_DW          (!X14 && OLDX14)
    #define QDCT_SQ_LIMIT_IN               X15
    #define QDCT_QZDP_IN                   X16

    #define QDCT_QJLT_IN                   X17
    #define QDCT_XM_LIMIT_IN               X20
    #define QDCT_SB_IN                     0

#define QDCT_CHUAN_LIAN_OK             X06       //Ƿɹ  
    #define QDCT_CHUAN_LIAN_OK_UP          (X06 && !OLDX06)

    #define QDCT_XQ_ORIGIN_IN               1

    #define QDCT_COUNT_IN                   1
    #define QDCT_HZDP_IN                    0


    #define QDCT_TLP_OUT                   Y00
    #define QDCT_SZ_OUT                    Y01
    #define QDCT_QHSL_OUT                  Y02  //ǰ
    #define QDCT_QJLT_OUT                  Y03
    #define QDCT_JD_OUT                    Y04
    #define QDCT_XM_OUT                    Y05
    #define QDCT_YD_OUT                    Y06
    #define QDCT_XQ_OUT                    Y07
    #define QDCT_SL_OUT                    Y07
    #define QDCT_SQ_OUT                    Y10
    #define QDCT_QTLT_OUT                  Y11

    #define QDCT_QZDP_OUT                  Y13

    #define QDCT_QDLP_OUT                   Y25
    #define QDCT_HDLP_OUT                   Y26


    #define QDCT_HTLT_OUT                  Y30
    #define QDCT_HZDP_OUT                  Y31
    #define QDCT_HHSL_OUT                  Y32
    #define QDCT_HJLT_OUT                  Y33
//Ϊ޳
    #if QDCT_LONG_LENGTH_USE
        #define QDCT_YL_LIMIT_IN           X30
        #define QDCT_JJ_DIR                Y12
        #define QDCT_YL_DIR                Y14  
        #define QDCT_YL_OUT                Y20
        #define QDCT_CQ_OUT                Y21
        #define QDCT_TB_OUT                Y22
        #define QDCT_KL_OUT                Y23
        #define QDCT_CS_OUT                 Y15
    #else  //ͨ
        #define QDCT_YL_LIMIT_IN             QDCT_YL_OUT
        #define QDCT_TB_OUT                    Y12
        #define QDCT_KL_OUT                    Y14
        #define QDCT_CS_OUT                    Y15
        #define QDCT_CQ_OUT                    Y16
        #define QDCT_JJ_DIR                   Y30
        #define QDCT_YL_DIR                   Y31  
        #define QDCT_YL_OUT                  Y32
    #endif

    #define QDCT_SEBIAO_MODE             0//user_datas[59] 

#else   //˫ͷ

    #define QDCT_PARAM_QLT_ON           (user_datas[31]) //ǰͷ
    #define QDCT_PARAM_HLT_ON           (user_datas[32]) //ͷ
    #define QDCT_PARAM_MODE             (user_datas[86])  // 0Ϊ 1Ϊ
    #define QDCT_SEBIAO_MODE             0
    #define QDCT_START_IN     X00
    #define QDCT_START_IN_UP (X00 && !OLDX00)

    #define QDCT_STOP_IN      X01
    #define QDCT_STOP_IN_UP  (X01 && !OLDX01)
    #define QDCT_STOP_IN_DW  (!X01 && OLDX01)

    #define QDCT_QJLT_IN                    X02
    #define QDCT_HJLT_IN                    X03
    #define QDCT_XQ_LIMIT_IN                X04
    #define QDCT_SL_ORIGIN_IN               X04
    #define QDCT_JZ_LEFT_IN                1
    #define QDCT_JZ_RIGHT_IN               1
    #define QDCT_GO_LIMIT_IN               X05
    #define QDCT_GO_LIMIT_IN_UP            (X05 && !OLDX05)

    #define QDCT_HTLT_LIMIT_IN             X06

    #define QDCT_BACK_LIMIT_IN             X07
    #define QDCT_BACK_LIMIT_IN_UP         (X07 && !OLDX07)


    #define QDCT_HHSL_ORIGIN_IN             X10
    #define QDCT_HHSL_LIMIT_IN              X11
    #define QDCT_HHSL_LIMIT_IN_DW           (!X11 && OLDX11)
    #define QDCT_QLTCZ_IN                  X12
    #define QDCT_HLTCZ_IN                  X13
    #define QDCT_XM_LIMIT_IN               X14
    #define QDCT_XM_ORIGIN_IN              X15
    #define QDCT_XM_ORIGIN_IN_UP            (X15 && !OLDX15)
    #define QDCT_SQ_LIMIT_IN               X16
    #define QDCT_SB_IN                     0
    #define QDCT_KA_DAI_IN                 !X17

    #define QDCT_CHUAN_LIAN_OK             X20       //Ƿɹ  
    #define QDCT_CHUAN_LIAN_OK_UP          (X20 && !OLDX20)

    #define QDCT_SEBIAO_IN                 X21     //ź
    #define QDCT_SEBIAO_IN_UP             (X21 && !OLDX21)
    #define QDCT_SEBIAO_IN_DW             (!X21 && OLDX21)

    #define QDCT_NO_ZIPPER_CHECK_IN        X30
    #define QDCT_QZDP_IN                    X31
    #define QDCT_QTLT_LIMIT_IN              X32
    #define QDCT_XQ_ORIGIN_IN               1
    #define QDCT_QHSL_ORIGIN_IN             X33
    #define QDCT_QHSL_LIMIT_IN              X34
    #define QDCT_QHSL_LIMIT_IN_DW           (!X34 && OLDX34)
    #define QDCT_HZDP_IN                    X35

    #define QDCT_QHSL_OUT                  Y00      //Y00 ǰͷ
    #define QDCT_QJLT_OUT                  Y01      //Y01 ǰͷ
    #define QDCT_HHSL_OUT                  Y02      //Y02 ͷ
    #define QDCT_HJLT_OUT                  Y03      //Y03 ͷ
    #define QDCT_JD_OUT                    Y04      //Y04 д
    #define QDCT_XM_OUT                    Y05      //Y05 ģ
    #define QDCT_SZ_OUT                    Y06      //Y06 д
    #define QDCT_XQ_OUT                    Y07      //Y07  е/
    #define QDCT_SL_OUT                    Y07      //Y07  е/
    #define QDCT_SQ_OUT                    Y10      //Y10 е
    #define QDCT_KL_OUT                    Y11      //
    #define QDCT_TB_OUT                    Y12      //Y12 ̨
    #define QDCT_YD_OUT                    Y13      //Y13 ѹ
    #define QDCT_CQ_OUT                    Y14      //Y14 /
    #define QDCT_CS_OUT                    Y15      //Y15A/B /ѹ
    #define QDCT_QTLT_OUT                  Y20      //EY00 ǰͷ
    #define QDCT_HTLT_OUT                  Y21      //EY01 ͷ
    #define QDCT_QZDP_OUT                  Y22      //EY02 ǰ
    #define QDCT_HZDP_OUT                  Y23      //EY03 
    #define QDCT_TLP_OUT                   Y24      //EY04 Ƭ
//ȡ
    #define QDCT_QDLP_OUT                   Y25//Y35 //    //EY05 ǰͷ
    #define QDCT_HDLP_OUT                   Y26 //Y36//    //EY06 ͷ
  //  
    #define QDCT_STATE_RUN                 Y35// Y25 //    //е     
    #define QDCT_STATE_ERROR                Y36// Y26 //    // 

    #define QDCT_YL_LIMIT_IN             QDCT_YL_OUT
    #define QDCT_JJ_DIR                   Y30
    #define QDCT_YL_DIR                   Y31  
    #define QDCT_YL_OUT                  Y32        //
    #endif
#endif
//M0~M4ȫ̶ֹʹ
/*
#define bRunning            M0000
#define bStart              M0001
#define bStop               M0002
#define bAlarmStop          M0003
#define bClearTotal         M0004
*/

#define QDCT_bClerNowTotal M0005
#define QDCT_bQianDianDW  M0006
#define QDCT_bGeiLT       M0007
#define QDCT_bTestMode    M0008
#define QDCT_bQieDuan     M0009
#define QDCT_bOnceStart   M0010

#define QDCT_bQZuangLT     M0013
#define QDCT_bHZuangLT     M0014
#define QDCT_bHeMo        M0015
#define QDCT_bChuanLT     M0016
#define QDCT_bSaveWorkState M0017
#define QDCT_bWorkMode    M0018

#define QDCT_bTable       M0020

#define QDCT_bCheckDinWei      M0021


#define QDCT_bManXQ      M0051    //е
#define QDCT_bManXM      M0052
#define QDCT_bMotorGo    M0053 
#define QDCT_bMotorBack  M0054
#define QDCT_bManSQ      M0055    //е
#define QDCT_bManJD      M0056
#define QDCT_bManQHSL    M0057
#define QDCT_bManHHSL    M0058
#define QDCT_bManQZD     M0059
#define QDCT_bManHZD     M0060
#define QDCT_bManQJLT    M0061
#define QDCT_bManHJLT    M0062
#define QDCT_bManSZ      M0063
#define QDCT_bManQTLT    M0064
#define QDCT_bManHTLT    M0065
#define QDCT_bManYD      M0066
#define QDCT_bManCQ      M0067
#define QDCT_bManDLP     M0068
#define QDCT_bYLGO       M0069
#define QDCT_bYLBACK     M0070
#define QDCT_bYL         M0071
#define QDCT_bManKL      M0072
#define QDCT_bManCS      M0073

#define QDCT_bReset_Origin      M0074
#define QDCT_bTest      M0075

#endif

#endif
