#ifndef __FJDAKONG_H__
#define __FJDAKONG_H__

#if FU_JIAN_MACHINE

extern void DK_InitAction(void);
extern void DK_ManualAction(void);
extern void DK_Action(void);

#define DK_ALARM_ADDR      100
#define DK_TOTAL_ADDR      0
#define DK_PROSPEED_ADDR   78


#define VAVLE_ALARM_TIME   3000
#define GUO_LIAN_OVER_TIME 10000

#define DK_DIR_N            1
#define DK_DIR_P            0
//故障代码列表
#define DK_NO_ALARM         0
#define DK_TOTAL_ALARM      1
#define DK_KADAI_ALARM      2
#define DK_XIACHONG_ARRIVE_ALARM     3
#define DK_XM_LIMIT_ALARM            4
#define DK_SM_LIMIT_ALARM            5
#define DK_GUOLIAN_ALARM             6


#define DK_XiaChongStep cStepMByte3
#define DK_ManualStep   cStepMByte2
#define DK_MotorStep    cStepMByte1
#define DK_AutoStep     cStepMByte

#define DK_XiaChongDelay cDelayTime1
#define DK_AutoDelay     cDelayTime2
#define DK_CQ_Delay      cDelayTime3
#define DK_MotorDelay    cDelayTime6    

#define DK_PARAM_SET_TOTAL          (user_datas[2] |  user_datas[3] << 16) 
#define DK_PARAM_ZIPRER_LENGTH      (user_datas[4] |  user_datas[5] << 16)
#define DK_PARAM_XC_DELAY           (user_datas[6] * 10)
#define DK_PARAM_CQ_TIME            (user_datas[7] * 10)
#define DK_PARAM_XC_ALARM_TIME      (user_datas[8] * 10)
#define DK_PARAM_XC_DELAY_STOP_TIME (user_datas[9] * 10)
#define DK_PARAM_HIGH_SPEED          user_datas[10] 
#define DK_PARAM_CYCLE_DELAY        (user_datas[11] * 10)
#define DK_PARAM_CYCLE_PULSE         user_datas[12]
#define DK_PARAM_CYCLE_LENGTH        user_datas[13]
#define DK_PARAM_BM_LINE             user_datas[14]
#define DK_PARAM_BM_LENGTH           user_datas[15]
#define DK_PARAM_LOWSPEED_LENGTH     user_datas[16]
#define DK_PARAM_BACK_LENGTH         user_datas[17]
#define DK_PARAM_LOW_SPEED           user_datas[18]
#define DK_PARAM_BIAN_MA_MODE        user_datas[19]

#define DISPLAY_DATA0           user_datas[121]
#define DISPLAY_DATA1           user_datas[122]
#define DISPLAY_DATA2           user_datas[123]
#define DISPLAY_DATA3           user_datas[124]
#define DISPLAY_DATA4           user_datas[125]
#define DISPLAY_DATA5           user_datas[126]
#define DISPLAY_DATA6           user_datas[127]
#define DISPLAY_DATA7           user_datas[128]




#define START_IN     X00
#define START_IN_UP (X00 && !OLDX00)
#define STOP_IN      X01
#define STOP_IN_UP  (X01 && !OLDX01)
#define DK_KaDai_IN  X02

#define DK_XC_ORIGIN_IN       X11
#define DK_XC_ORIGIN_IN_UP   (X11 && !OLDX11)
#define DK_MANAL_XC_IN     X03
#define DK_MANAL_XC_IN_UP (X03 && !OLDX03)

#define DK_SC_VAVLE       Y00
#define DK_XC_MOTOR       Y01
#define DK_CQ_VAVLE       Y03



//M0~M4 Actioon.h全局使用


#define DK_bMotor         M0005
#define DK_bBackMotor     M0006
#define DK_bManXiaChong   M0008
#define DK_bStart         M0009
#define DK_bCQ            M0013


#define DK_bRunning       M0017
#define DK_bStop          M0018
#define DK_bAlarmStop     M0036



#endif

#endif

