#ifndef __HYMXC_NILONG_STEP_JI_H__
#define __HYMXC_NILONG_STEP_JI_H__

#if HONG_YE_MACHINE

#define MXC_NO_ALARM        0
#define MXC_START_ALARM     1
#define MXC_XIA_CHONG_ALARM 2
#define MXC_KA_DAI_ALARM    3
#define MXC_FEN_ZHEN_ALARM  6
#define MXC_NO_ZIPPER_ALARM 7
#define MXC_NO_SEBIAO_ALARM 8

#define PARAM_XIAZHI_TIME user_datas[0]
#define PARAM_CHUIQI_TIME user_datas[1]
#define PARAM_CHAOSHENG_TIME user_datas[2]
#define PARAM_START_SPEED    user_datas[6]
#define PARAM_SET_SPEED      user_datas[8]
#define PARAM_LOW_SPEED      user_datas[9]
#define PARAM_LOWSPEED_LENGTH user_datas[10]
#define XiaMode              (user_datas[11] & 0x0001) 			//0　普通下止　1　超声下止
#define ShaCheMode           (user_datas[11] & 0x0002)         //0  刹车不放开　1放开
#define GouZMode              X22||(user_datas[24])          	//0　普通勾针  1 隐形勾针
#define GuoLianMode          (user_datas[11] & 0x0008) 
#define FenZSelect           (user_datas[11] & 0x0010)
#define PARAM_DAOKOU_LENGTH  user_datas[13]
#define PARAM_DAILUN_LENGTH  user_datas[14]
#define MXC_SET_ZIPPER_LENGTH         (user_datas[15] |  (user_datas[16] << 16)) 
#define SET_REVISE_ZIPPER_LENGTH  (user_datas[17] |  (user_datas[18] << 16)) 
#define DC_MODE        user_datas[19] //0勾针 1步进/伺服 2色标
#define XIA_ZHI_ENABLE user_datas[20] //0不使用下止 1使用下止
#define GOU_ZHEN_DEC_MODE user_datas[21]
#define SET_TOTAL      (user_datas[22] | (user_datas[23] << 16))
#define GOU_ZHEN_MODE  user_datas[24] // 0为普通勾针 1为活动勾针
#define GuoLianCheckMode user_datas[25]
#define PARAM_XIAZHI_DELAY_TIME user_datas[26]
#define XiaCongMotorMode user_datas[27]
#define MOTOR_MODE     user_datas[30]//0步进1伺服
#define PARAM_DELAY_CHUIQI_TIME user_datas[31]
#define PARAM_FIRST_SPEED       user_datas[32]
#define PARAM_SEBIAO_TQ_LENGTH  user_datas[46]
#define PARAM_SEBIAO_DW_LENGTH  user_datas[47]

#define DISPLAY_DATA0           user_datas[121]
#define DISPLAY_DATA1           user_datas[122]
#define DISPLAY_DATA2           user_datas[123]
#define DISPLAY_DATA3           user_datas[124]
#define DISPLAY_DATA4           user_datas[125]
#define DISPLAY_DATA5           user_datas[126]
#define DISPLAY_DATA6           user_datas[127]
#define DISPLAY_DATA7           user_datas[128]



#define MXC_bStart          M0000
#define MXC_bClear          M0001
#define MXC_bXiaZhi         M0002
#define MXC_bXiaChong       M0003
#define MXC_bStop           M0004
#define MXC_bLeftFenZhen    M0005
#define MXC_bRightFenZhen   M0006
#define MXC_bDotXiaChong    M0007
#define MXC_bDotXiaChongDisplay M0008
#define MXC_bGouZhen        M0009
#define MXC_bAddLength      M0010
#define MXC_bDecLength      M0011
#define MXC_bSetDCMode      M0012
#define MXC_bChuiQi         M0013
#define MXC_bChangeLength   M0014
#define MXC_bClearAlarm     M0015
#define MXC_bChangeGouZhenMode M0016
#define MXC_bChangeXiaZhiMode  M0017  
#define MXC_bChuDai         M0018
#define MXC_bDingWei        M0019
#define MXC_bNext           M0020
#define MXC_bJiaoDao        M0021
#define MXC_bSaveWorkData   M0022

#define cAutoStep          cStepMByte  
#define cMotorStep         cStepMByte1
#define cXiaChongStep      cStepMByte2
#define cLeftFenZhenStep   cStepMByte3   
#define cRightFenZhenStep  cStepMByte4   
#define cJiaoDaoStep       cStepMByte5

#define cAutoDelay         cDelayTime1
#define cChuiQiDelay       cDelayTime2
#define cXiaZhiDelay       cDelayTime3
#define cKaDaiDelay        cDelayTime8

#define START_IN     X00
#define START_IN_UP (X00 && !OLDX00)
#define STOP_IN      X01
#define STOP_IN_UP  (X01 && !OLDX01)
#define MXC_ManXiaChong_UP (X02 && !OLDX02)
#define MXC_GouZhen_IN      X03
#define MXC_GouZhen_IN_UP  (X03 && !OLDX03)
#define MXC_Dec_IN     X04
#define MXC_KaDai_IN   X05
#define MXC_KaDai_IN_UP   (X05 && !OLDX05)
#define MXC_LeftFenZhen_Origin_IN X06
#define MXC_LeftFenZhen_IN X07
#define MXC_XiaChong_IN    X10
#define MXC_XiaChong_IN_UP (X10 && !OLDX10)
#define MXC_RightFenZhen_Origin_IN X11
#define MXC_RighttFenZhen_IN X12
#define MXC_DingChuPian_IN   X13
#define MXC_DingChuPian_IN_DW  (!X13 && !OLDX13)

#define MXC_Zipper_IN        X14
#define MXC_SeBiao_IN        X15
#define MXC_XiaZhi_IN        X16
#define MXC_XiaZhi_IN_UP     (X16 && !OLDX16)
#define MXC_XiaZhi_IN_DW     (!X16 && OLDX16)
#define MXC_GuoLian_IN       X17
#define MXC_GuoLian_IN_UP    (X17 && !OLDX17)
#define MXC_FenDai_IN         X20
#define MXC_FenDai_IN_UP     (X20 && !OLDX20)

#define MXC_LIHE_VAVLE       Y00
#define MXC_XC_SongZhou      Y01
#define MXC_ChuiQi_VAVLE     Y02
#define MXC_XiaZhi_VAVLE     Y03
#define MXC_LeftFenZhen_VAVLE Y04
#define MXC_GouZhen_VAVLE    Y05
#define MXC_RightFenZhen_VAVLE Y06
#define MXC_XiaChong_MOTOR   Y07
#define MXC_ChaoSheng        Y10
#define MXC_JiaoDao_OUT      Y11
#define MXC_XiaZhi_MOTOR     Y12
#define MXC_FenDai_VAVLE     Y13
#define MXC_ChuDai_VAVLE     Y14
#define MXC_GuDingGouZhen    Y15
#define MXC_XiChiChuiQi      Y16
#define MXC_TuoDaiSongZhou   Y17

#endif

#endif