#include "global.h"


#if JIN_LONG_MACHINE ==1


void ECQ_QueDuan_AlarmProtect(void);
void ECQ_QueDuan_ManualAction(void);
void ECQ_QueDuan_AutoAction(void);
void ECQ_QueDuan_StepCheckStart(void);
void ECQ_QueDuan_XiaQue(void);
void ECQ_QueDuan_Motor(void);
void ECQ_QueDuan_YuanDianAction(void);
void ECQ_QueDuan_TuiLianAction(void);
void ECQ_QueDuan_ExtiActionX31(void);
void ECQ_QueDuan_BingLian(void);
void ECQ_StopCode(void);
void ECQD_TuiDaiAction(void);

short *ECQ_length_buffer;


void ECQD_SetAlarmCode(unsigned alarm_code)
{
    SetAlarmCode(ECQD_ALARM_ADDR,alarm_code);
    bAlarmStop = 1;
}
void ECQ_QueDuan_ExtiActionX31(void)
{
    ECQ_cCheckLianFlg = 1;
     ECQ_cRealPos = GetPos(X_AXIS);
}
void ECQ_StopCode(void)
{
   switch(ECQD_StopStep)
        {
          case 1:            
             ECQD_StopStep=2;
             if(X_DRV)
             {
                AxisChangeSpeedDirect(X_AXIS,GetCurSpeed(X_AXIS) * 2/3);      
                AxisDecStop(X_AXIS);
             }
            break;
          case 2:    
            if(!X_DRV || (cRealPos < 10))
            {
                ECQD_StopCodeDelay=dwTickCount+350;
                ECQD_StopStep = 3;
            }  
            break;
          case 3:
            if(dwTickCount >= ECQD_StopCodeDelay)
            {
              if(!cSTOPONE)
              {                
                    ECQD_StopStep=0;
                    
              }
              else
              {        
                    ECQD_SetAlarmCode(ECQD_PARAM_ANQUANMEN_ALARM);
                    ECQD_StopStep=0;
                    cSTOPONE=0;
              }
              ECQD_SZ_OUT   = 1;  //
            }
            break;
        }
   
   switch(ECQD_CHUIQIStep) 
   {
          case 1:
            ECQD_CQ_VAVLE=1;
            ECQD_CHUIQIStep=2;
            ECQD_ChuiQiDelay=dwTickCount+ECQD_PARAM_ChuiQi_TIME;
          break;
        case 2:
          if(dwTickCount >= ECQD_ChuiQiDelay)
          {
           ECQD_CQ_VAVLE=0;
            ECQD_CHUIQIStep=0;
          }
          break;
   
   }
}



void ECQ_QueDuan_InitAction(void)
{
  
    float length_buff,pulse_buff;
  //  axis_x->speed_unit = 1;   //ٶƵʱʵλ
    length_buff = ECQD_PARAM_CYCLE_LENGTH;
    pulse_buff  = ECQD_PARAM_CYCLE_PULSE;
    XGearRatio  = pulse_buff/length_buff;  
   
  //  ECQD_SZ_OUT   = 1;
  // Motor_SZ(ECQD_MOTOR_DIS); //
   ECQD_SetAlarmCode(0);
     SetDirReverse(X_AXIS, 1);
}

void ECQ_QueDuan_Action(void)
{
    
    ECQ_QueDuan_AlarmProtect();
    ECQ_QueDuan_Motor();
    ECQ_QueDuan_XiaQue();
    ECQ_QueDuan_ManualAction();
    ECQ_QueDuan_TuiLianAction();
    ECQ_QueDuan_BingLian();
    ECQ_StopCode();
    ECQ_QueDuan_AutoAction();
    ECQ_QueDuan_StepCheckStart();   // ý̤ؼ 
    
    
}

//ֶ
void ECQ_QueDuan_ManualAction(void)
{  
 //ﵽ̨ת֮ͣ
  if(ECQ_cTABLETIME)
      {
        if(ECQ_cTABLETOTAL)
        {
          ECQ_cTABLETOTAL=0;
          ECQD_TABLE_VAVLE = 1;
          ECQD_TableDelay=dwTickCount + 2000;
        
        }
        if(dwTickCount >= ECQD_TableDelay)
        {
          ECQD_TABLE_VAVLE = 0;
           ECQ_cTABLETIME=0;
        
        }
      }
  if(ECQD_HOUXIANWEI_UP && bRunning)
  {
  AxisEgmStop(X_AXIS);
   ECQD_SetAlarmCode(ECQD_PARAM_RUN_LENGTH_ALARM);
  }
    if(bRunning == 0)  
    {   

     
      
        ECQ_cGoLimitEn = 0;
        if(ECQD_bClearTotal) //жϼ
        {
            ECQD_bClearTotal       = 0;
            ClrcToTal(ECQD_TOTAL_ADDR);
        }
        
        if(ECQD_bClearNowTotal)
        {
            ECQD_bClearNowTotal = 0;
            ECQD_PARAM_NOW_CNT = 0;
        }
        
        if(ECQD_bXiaQie)
        {
            ECQD_bXiaQie = 0;
            if(ECQD_XiaQieStep == 0)
            {
                ECQD_XiaQieStep = 1;
            }  
        }
        
        if(ECQD_bQianDianDW)
        {
            ECQD_bQianDianDW = 0;
            if(ECQD_MotorStep == 0)
            {
                ECQD_MotorStep = 61;
                ECQ_cZipCnt      = 0;
            }
        }
        
        if(ECQD_bTL)
        {  
            ECQD_bTL = 0;
            if(ECQD_TL_VAVLE)
            {
                ECQD_TL_VAVLE = 0;
            } 
            else if(!ECQD_GZ_VAVLE && !ECQD_SM_VAVLE)
            {
                ECQD_TL_VAVLE = ~ECQD_TL_VAVLE;
            }
        }
        
//        if(!Y_DRV)ECQD_bTL = 0;
        
        if(ECQD_bYD)
        {
            ECQD_bYD = 0;
            ECQD_DTFK_VAVLE=~ECQD_DTFK_VAVLE;
            ECQD_YD_VAVLE = ~ECQD_YD_VAVLE;
        }
        
        if(ECQD_bGZ)
        {
            ECQD_bGZ = 0;
            ECQD_GZ_VAVLE = ~ECQD_GZ_VAVLE;
        }
            if(ECQD_bDGLG)
        {
          ECQD_bDGLG = 0;
           ECQD_DGLG_VAVLE = ~ECQD_DGLG_VAVLE;
        }
       
        if(ECQD_bJD)
        {
           ECQD_bJD = 0;
           ECQD_JD_VAVLE = ~ECQD_JD_VAVLE;
        }
        
        if(ECQD_bXM)
        {
           ECQD_bXM = 0;
           ECQD_XM_VAVLE = ~ECQD_XM_VAVLE;
           if(!ECQD_XM_VAVLE)ECQD_GZ_VAVLE = 0;
        }
        if(ECQD_GOUZHEN_IN_UP)
        {
        ECQD_YD_VAVLE=1;
        }
        
        if(ECQD_bSM)
        {
           ECQD_bSM = 0;
           if(ECQD_SM_VAVLE)
                ECQD_SM_VAVLE = 0;
           else if(!ECQD_SM_VAVLE)
                ECQD_SM_VAVLE = 1;
        }
        //Ʒ
        if(ECQD_bTFK)
        {
            ECQD_bTFK = 0;
            ECQD_TFK_VAVLE = ~ECQD_TFK_VAVLE;
        }
        //̨
        if(ECQD_bTB)
        {
            ECQD_bTB = 0;           
            ECQD_TABLE_VAVLE = ~ECQD_TABLE_VAVLE;
        }
        
//        if(ECQD_bYBD)
//  /      {
//            ECQD_bYBD = 0;
//            ECQD_YBD_VAVLE = ~ECQD_YBD_VAVLE;
//        }
        
        if(ECQD_bTestCS)
        {
           ECQD_bTestCS = 0;
           ECQD_CS_OUT  = 1;
           ECQD_CSDelay = dwTickCount + ECQD_PARAM_CS_TIME;
        }
        
        if(ECQD_bBL)//
        {
            ECQD_bBL = 0;
            ECQD_BL_VAVLE = ~ECQD_BL_VAVLE;
        }
        
        if(ECQD_bHL)  //,˫
        {
            ECQD_bHL = 0;
            ECQD_HL_VAVLE = ~ECQD_HL_VAVLE;
        }
        
        if(ECQD_bYX)
        {
            ECQD_bYX = 0;
            ECQD_YX_VAVLE = ~ECQD_YX_VAVLE;
        }
        if(ECQD_XiaQieStep == 0)
        {
            if(dwTickCount >= ECQD_CSDelay)ECQD_CS_OUT  = 0;
        }        
//        
        if(ECQD_QIAN_LIMIT_IN && ECQD_bGoMotor)
        {
        AxisEgmStop(X_AXIS);
        }
        if(ECQD_bGoMotor && !ECQD_QIAN_LIMIT_IN)
        {           
            ECQD_SZ_OUT   = 0;
        //   ECQD_JZ_DIR   = ECQD_YDIR_N;
          
            if(!X_DRV)
             AxisContinueMoveAcc(X_AXIS,ECQD_PARAM_GO_LOW_SPEED,ECQD_DIR_N,ECQD_PARAM_GO_LOW_SPEED,ECQD_PARAM_GO_LOW_SPEED,10,12);
     
        }
         if(ECQD_HOUXIANWEI && ECQD_bBackMotor)
        {
        AxisEgmStop(X_AXIS);
        }
        
        if(ECQD_bBackMotor && !ECQD_HOUXIANWEI)  //λѾȡ
        {
            ECQD_SZ_OUT   = 0;
     //       ECQD_JZ_DIR   = ECQD_YDIR_P;
            if(!X_DRV)
          
               AxisContinueMoveAcc(X_AXIS,ECQD_PARAM_GO_LOW_SPEED,ECQD_DIR_P,ECQD_PARAM_GO_LOW_SPEED,ECQD_PARAM_GO_LOW_SPEED,10,12);
      
        }
        
        if(!ECQD_bGoMotor && !ECQD_bBackMotor && (ECQD_MotorStep == 0))
        {
            if(X_DRV)AxisDecStop(X_AXIS);
        }
        
        if(ECQD_QIAN_LIMIT_IN && (ECQD_MotorStep == 0) && !ECQD_bBackMotor &&(ECQD_AutoStep == 0))
        {
            if(X_DRV)AxisEgmStop(X_AXIS);
        }       
    }
}




void ECQ_QueDuan_AlarmProtect(void)
{ 
    ECQ_cRealPos = GetPos(X_AXIS);

    if(!bRunning)
    {
      ;
      //
#if 0     
        if(ECQD_BACK_LIMIT_IN_UP)
        {
            if((ECQD_MotorStep == 0) && X_DRV && ECQD_bBackMotor)        //޲ٺ˵Եǰ
            {
                ECQD_bBackMotor = 0;
                
                AxisDecStop(X_AXIS);   
                ECQD_JD_VAVLE   = 0;
                ECQD_SetAlarmCode(ECQD_BACK_ALARM);
                
            }
        }
#endif      
    }
    else
    {
        if((ECQ_cRealPos > ECQD_PARAM_RUN_LENGTH) && (ECQD_PARAM_RUN_LENGTH > 3000)
            && (ECQ_cGoLimitEn != 0))
        {
            AxisEgmStop(X_AXIS);   
            ECQD_JD_VAVLE = 0;
            ECQD_SetAlarmCode(ECQD_BACK_ALARM);
        }
    }
}


void ECQ_QueDuan_AutoAction(void)
{  
  //̨ʱص
  
  
  if(ECQD_QIAN_STOP_Auto)
  {
   
    ECQ_cDLJ_ATUO=1;
    AxisEgmStop(X_AXIS);
    
      
      
  }
  if(ECQD_QIAN_START_Auto)
  {
    if(ECQ_cDLJ_ATUO)
    {
       ECQ_cDLJ_ATUO=0;
        ECQD_AutoDelay = dwTickCount + 1000;
        ECQD_MotorDelay = dwTickCount + 2000;
     if((ECQD_MotorStep==63 || ECQD_MotorStep==64 || ECQD_MotorStep==65) && !ECQD_QIAN_LIMIT_IN)
          AxisContinueMoveAcc(X_AXIS,ECQD_PARAM_GO_LOW_SPEED,ECQD_DIR_N,ECQD_PARAM_GO_LOW_SPEED/3,ECQD_PARAM_GO_LOW_SPEED/3,15,15);
      else if((ECQ_cRealPos < ECQD_PARAM_ZIPPER_LENGTH) && (ECQD_MotorStep > 311))
        AxisMoveTwoPos(X_AXIS,1000,(ECQD_PARAM_ZIPPER_LENGTH - ECQ_cRealPos) + (*ECQ_length_buffer),
                       ECQD_PARAM_BACK_LOW_SPEED,ECQD_PARAM_BACK_LOW_SPEED_LENGTH,ECQD_DIR_P,5000,3000,20,30);
      
  

    }             
        
        
  }
   if(!ECQ_cDLJ_ATUO)
   {
    if(bRunning)
    {  
      if(!ECQ_cTABLETIME)
      {
        if(dwTickCount >= ECQD_TBDelay)
         ECQD_TABLE_VAVLE = 0;
      }
        switch(ECQD_AutoStep)
        {
            case 1:
                  if(dwTickCount >= ECQD_AutoDelay)
                  {	
                      ECQD_AutoStep = 2;	    
                      if(ECQD_MotorStep == 0)
                      {
                          ECQD_MotorStep = 61;   //ǰ㶨λ
                      }
                      ECQ_cGoLimitEn = 0;
                  }	
                  break;	
            case 2:	 
                  if(ECQD_MotorStep == 0)
                  {   
                      ECQD_MotorStep = 30;  
                      ECQD_AutoStep = 3;	
                      ECQ_cGoLimitEn = 1;
                  }
                  break;	
            case 3:	
            
                  if(ECQD_MotorStep == 0)
                  {   
                      if(ECQD_SAFE_IN)
                      {
                          bStop = 1;
                      }
                      else 
                      {
                           
                          if(ECQD_XiaQieStep == 0)
                             ECQD_XiaQieStep = 1;                 
                         ECQD_AutoStep = 4;
                      }
                  }              
                  break;
            case 4:
                
                      //                                  տ
                      if((ECQD_XiaQieStep == 0) || ((ECQD_XiaQieStep == 6) && ECQD_KB_MODE)|| ((ECQD_XiaQieStep == 14) && (ECQD_KB_MODE == 0)))// && !ECQD_SHANG_MU_LIMIT_IN)
                      {
                          if(ECQD_MotorStep == 0) 
                          {
                            ECQ_cGoLimitEn=0;
                              ECQD_MotorStep = 40;     //
                              
                          }
                          ECQD_AutoStep = 5;	    
                      }

                 break;
            case 5:	 
                
                  if(ECQD_MotorStep == 0)
                  {
                      ECQ_cZipCnt++;
                      ECQD_PARAM_NOW_CNT++;
                      ECQ_cTableCnt++;
                      AddToTal(ECQD_TOTAL_ADDR);
                      AddToTal(CT_WORKTOTAL_ADDR);
                      CalProSP(ECQD_PROSPEED_ADDR);
                      
                      if(ECQ_cTableCnt >= ECQD_PARAM_TABLE_NUM)
                      {
                          ECQ_cTableCnt = 0;
                          ECQD_TABLE_VAVLE = 1;
                          ECQD_TBDelay = dwTickCount + ECQD_PARAM_TB_TIME;
                      }
                      
                      if( SingOneFlg || ECQ_cZhouWanone)
                      {
   
                          {
                            ECQ_cZhouWanone=0;
                           ECQ_cStopMode=0;
                              bRunning = 0;
                              ECQD_AutoStep = 0; 
                              SingOneFlg = 0;
                               ECQD_TABLE_VAVLE = 0;
                               
                          }
                          
 //                         if(GetTotal(ECQD_TOTAL_ADDR) >= ECQD_PARAM_SET_TOTAL) ECQD_SetAlarmCode(ECQD_TOTAL_ALARM);
                      }
                      else
                      {
                          ECQD_AutoStep = 1; 
                          
                          if((ECQD_PARAM_NOW_CNT >= ECQD_PARAM_ZHA_SHU) && (ECQD_PARAM_ZHA_SHU > 0))   
                          {
                              ECQD_AutoDelay = dwTickCount + ECQD_PARAM_ZS_STOP_TIME;
                              ECQD_PARAM_NOW_CNT = 0;
                                  ECQ_cTABLETIME = 1;
                                 ECQ_cTABLETOTAL= 1;
                              if(ECQD_PARAM_ZS_STOP_TIME == 0)
                              {
                                  bRunning = 0;
                                  ECQD_AutoStep = 0; 
                                  SingOneFlg = 0;
                                  ECQ_cTABLETIME = 1;
                                 ECQ_cTABLETOTAL= 1;
                                  ECQD_SetAlarmCode(ECQD_TOTAL_ALARM);
                              }
                          }
                          else
                              ECQD_AutoDelay = dwTickCount + ECQD_PARAM_CYCLE_DELAY;
                      }
                  }
                  break;
        }	
    }
   }
}

void ECQ_QueDuan_StepCheckStart(void)
{
  
  if(ECQD_DANXUNHUAN_LIMIT_IN_UP)
  {
  ECQD_bSingle=1;
  }
//		      			
    if((ECQD_START_IN_UP) || bStart || ECQD_bSingle)
    {
        bStart = 0;
        
        if(!bRunning && (ECQD_AutoStep == 0))
        {
            if(ECQD_XIA_MU_LIMIT_IN && !ECQD_PARAM_XM_ENABLE)ECQD_SetAlarmCode(ECQD_XM_DAOWEI);
//            else if(GetAlarmCode(ECQD_ALARM_ADDR) != 0);
            //else if(GetTotal(ECQD_TOTAL_ADDR) >= ECQD_PARAM_SET_TOTAL) ECQD_SetAlarmCode(ECQD_TOTAL_ALARM);
 //           else if(ECQD_BL_VAVLE)ECQD_SetAlarmCode(ECQD_BL_ALARM);
            else if(ECQD_SM_VAVLE)ECQD_SetAlarmCode(ECQD_SM_ALARM);
             else
            {
                bRunning    = 1;
                ECQD_AutoStep = 1;
                if(ECQD_PARAM_BL_ENABLE)
                    ECQD_PARAM_BL_ENABLE=1 ; //
                if(ECQD_bSingle) 
                    SingOneFlg= 1;
                ECQ_cZipCnt      = 0;
                      ECQ_cTABLETIME = 0;
               ECQ_cTABLETOTAL= 0;
               ECQD_DTFK_VAVLE=0;
                  ECQD_TFK_VAVLE   = 1;    //Ʒ   
                ECQ_cSTOPONE=0;
                ECQ_cTuiFangKuaiCnt = 0;
                ECQD_BL_VAVLE = 0;    //
                  ECQ_cDLJ_ATUO=0;
                ECQD_DGLG_VAVLE = 0;  //˹
                SetAlarmCode(ECQD_ALARM_ADDR,0); 
            }
        }
        ECQD_bSingle = 0;
    }
    if(ECQD_STOP_ANNIU_IN_UP) 
    {
        bRunning   = 0;
        ECQD_XiaQieStep = 0;
        ECQD_AutoStep   = 0;
        ECQD_MotorStep  = 0;
        ECQD_TuiLianStep = 0;
         ECQD_AutoDelay   = dwTickCount;
            ECQD_MotorDelay = dwTickCount;
            ECQD_XiaQieDelay  = dwTickCount;
            ECQD_KaDaiDelay   = dwTickCount;
            ECQD_CSDelay = dwTickCount;
            ECQD_TBDelay  = dwTickCount;
            ECQD_TFKDelay = dwTickCount;
            ECQD_TLDelay  = dwTickCount;
            dwTickCount = ECQD_TBDelay;
             ECQD_CHUIQIStep=0;
            SingOneFlg  = 0; 
            ECQD_JD_VAVLE = 0;
            ECQD_SM_VAVLE = 0;
            ECQD_XM_VAVLE = 0;
            ECQD_YD_VAVLE = 0;
            ECQD_TFK_VAVLE= 0;
            ECQD_YX_VAVLE = 0;
            ECQD_HL_VAVLE  = 0;
            ECQD_TL_VAVLE      = 0;
            ECQD_DGLG_VAVLE = 0;  //˹
            ECQD_CS_OUT   = 0;
            ECQD_XiaQieStep = 0;
            ECQD_MotorStep  = 0;
            ECQD_TuiLianStep = 0;
            ECQD_SZ_OUT   = 1;
            ECQD_GZ_VAVLE    = 0;
            ECQD_TABLE_VAVLE   = 0;
             ECQD_StopStep=1;
            ECQ_cTABLETIME = 0;
            ECQ_cTABLETOTAL= 0;
            ECQD_BinLianStep  = 0;
            ECQD_BL_VAVLE    = 0;
            SetAlarmCode(ECQD_ALARM_ADDR,0);
    
    }
    //ֹͣ
   if(ECQD_STOP_IN_UP || bStop)
   {
        bStop = 0;
      if(ECQ_cStopMode < 2)
        ECQ_cStopMode++;
      if(ECQ_cStopMode==1 && bRunning)
        ECQ_cZhouWanone=1;
        if(bRunning && ECQ_cStopMode==2)
        {
            

            ECQD_AutoDelay   = dwTickCount;
            ECQD_MotorDelay = dwTickCount;
            ECQD_XiaQieDelay  = dwTickCount;
            ECQD_KaDaiDelay   = dwTickCount;
            ECQD_CSDelay = dwTickCount;
            ECQD_TBDelay  = dwTickCount;
            ECQD_TFKDelay  = dwTickCount;
            ECQD_TLDelay     = dwTickCount;
            dwTickCount = ECQD_TBDelay;
            SingOneFlg  = 0; 
                    bRunning   = 0;
        ECQD_XiaQieStep = 0;
        ECQD_AutoStep   = 0;
        ECQD_MotorStep  = 0;
        ECQD_TuiLianStep = 0;
         ECQ_cJiaDaione=0;
            ECQD_JD_VAVLE = 0;
            ECQD_SM_VAVLE = 0;
            ECQD_XM_VAVLE = 0;
            ECQD_YD_VAVLE = 0;
            ECQD_TFK_VAVLE= 0;
            ECQD_TL_VAVLE      = 0;
            ECQD_HL_VAVLE  = 0;
            ECQD_CS_OUT   = 0;
            ECQD_XiaQieStep = 0;
            ECQD_MotorStep  = 0;
            ECQD_TuiLianStep = 0;
            //ECQD_SZ_OUT   = 1;
            ECQD_GZ_VAVLE    = 0;
            ECQD_TABLE_VAVLE   = 0;
            ECQD_DGLG_VAVLE = 0;  //˹
          if((ECQD_StopStep == 0) && X_DRV)
                ECQD_StopStep = 1;
            ECQD_BinLianStep  = 0;
            ECQD_BL_VAVLE    = 0;
               ECQ_cTABLETIME = 0;
               ECQ_cTABLETOTAL= 0;
            user_datas[121] = 0;
            user_datas[122] = 0;

            SetAlarmCode(ECQD_ALARM_ADDR,0);        
        }
        else if(!bRunning)
        {
            ECQD_AutoDelay   = dwTickCount;
            ECQD_MotorDelay = dwTickCount;
            ECQD_XiaQieDelay  = dwTickCount;
            ECQD_KaDaiDelay   = dwTickCount;
            ECQD_CSDelay = dwTickCount;
            ECQD_TBDelay  = dwTickCount;
            ECQD_TFKDelay = dwTickCount;
            ECQD_TLDelay  = dwTickCount;
            dwTickCount = ECQD_TBDelay;
            ECQD_CHUIQIStep=0;
             ECQ_cJiaDaione=0;
            SingOneFlg  = 0; 
            ECQD_JD_VAVLE = 0;
            ECQD_SM_VAVLE = 0;
            ECQD_XM_VAVLE = 0;
            ECQD_YD_VAVLE = 0;
            ECQD_TFK_VAVLE= 0;
            ECQD_YX_VAVLE = 0;
            ECQD_HL_VAVLE  = 0;
            ECQ_cStopMode=0;
                ECQ_cZhouWanone=0;
            ECQD_TL_VAVLE      = 0;
            ECQD_DGLG_VAVLE = 0;  //˹
            ECQD_CS_OUT   = 0;
            ECQD_XiaQieStep = 0;
            ECQD_MotorStep  = 0;
            ECQD_TuiLianStep = 0;
          
            ECQD_GZ_VAVLE    = 0;
            ECQD_TABLE_VAVLE   = 0;
                 if((ECQD_StopStep == 0))
            {
                 ECQ_cSTOPONE = 0;
                 AxisEgmStop(X_AXIS);   
               ECQD_SZ_OUT   = 1;
            }   
            ECQ_cTABLETIME = 0;
            ECQ_cTABLETOTAL= 0;
            ECQD_BinLianStep  = 0;
            ECQD_BL_VAVLE    = 0;
            SetAlarmCode(ECQD_ALARM_ADDR,0);
                    bRunning   = 0;
        ECQD_XiaQieStep = 0;
        ECQD_AutoStep   = 0;
        ECQD_MotorStep  = 0;
        ECQD_TuiLianStep = 0;
        }

    }
    
    if(bAlarmStop)
    {
        bAlarmStop = 0;
        ECQD_XiaQieStep = 0;
        ECQD_AutoStep   = 0;
        ECQD_MotorStep  = 0;
        ECQD_TuiLianStep = 0;
        
        ECQD_XiaQieStep = 0;
        ECQD_MotorStep  = 0;
        ECQD_TuiLianStep = 0;
        ECQD_AutoDelay   = dwTickCount;
        ECQD_MotorDelay = dwTickCount;
        ECQD_XiaQieDelay  = dwTickCount;
        ECQD_KaDaiDelay   = dwTickCount;
        ECQD_CSDelay = dwTickCount;
        ECQD_TBDelay  = dwTickCount;
        ECQD_TFKDelay  = dwTickCount;
        ECQD_TLDelay     = dwTickCount;
        SingOneFlg  = 0; 
        bRunning   = 0;
         ECQD_StopStep=1;
                  ECQ_cStopMode=0;
                ECQ_cZhouWanone=0;
        dwTickCount = ECQD_TBDelay;
        ECQD_TABLE_VAVLE = 0;
        ECQD_TFK_VAVLE =0;
       if(ECQ_cJiaDaione)
       {
        ECQD_JD_VAVLE=0;
        ECQ_cJiaDaione=0;
       
       }
        ECQD_GZ_VAVLE=0;
    }
    
}   
//䳤ģʽ
void ECQ_QueDuan_CheckLength(long zip_length)
{
    static long start_dist;
    switch(ECQD_CheckLengthStep)
    {
        case 0:break;
        case 1:
               start_dist = ECQ_cRealPos;
               ECQ_dwSaveLength = 0;
               ECQD_CheckLengthStep = 2;
               break;
        case 2:
          if(ECQD_GUO_LIAN_IN_DW)
          {  
            ECQ_dwSaveLength = ECQ_cRealPos - start_dist;   
 //           user_datas[127] = ECQ_cRealPos;

          }
               break;         
    }          
}

#if !ECQD_KB_MODE  //
//ר
//30ʼʼֽ4ֹģʽ
//40ʼжϺ
//60ʼΪǰ򣬿տһ

void ECQ_QueDuan_Motor(void)
{
        static long save_buff,length_buff,gou_zhen_buff,checkdelay_buff,dandao_buff,back_buff,gouzhen_buff,go_buff,go_length_buff,jz_buff;
       unsigned  short ch;
        ECQ_cRealPos = GetPos(X_AXIS);
        user_datas[121]= ECQD_MotorStep;
        user_datas[122]= length_buff; 
        user_datas[123] = ECQ_cRealPos;
        user_datas[124] = ECQD_BinLianStep;
        user_datas[125] = ECQD_AutoStep;
        user_datas[126] = ECQD_XiaQieStep;
    //    user_datas[127] = ECQD_XiaQieStep;
        ECQ_QueDuan_CheckLength(length_buff);
      if(!ECQ_cDLJ_ATUO)
        { 
	switch(ECQD_MotorStep)
	{
                case 30:
                 
                    switch(ECQD_PARAM_BACK_MODE)  //ڷģʽ 
                    {
                        case 0: //ģʽ
                              ECQD_MotorStep   = 310;  //ÿģʽ20
                           
                              break;
                        case 1://Ӧģʽ
                            ECQD_MotorStep   = 330;  //ÿģʽ20
                            
                            break;
                        case 2: //ȸӦģʽ+
                            ECQD_MotorStep   = 350;  //ÿģʽ20
                            break;
                        default:  //ģʽ+ⳤ
                            ECQD_MotorStep   = 370;  //ÿģʽ20
                            break;
                    }  
                    ECQD_MotorDelay  =    dwTickCount + ECQD_PARAM_DELAY_BACK;    
                    break;
         //310315Ϊģʽ                    
                case 310:
                    SetDir(X_AXIS, ECQD_DIR_P);
                    if(ECQD_PARAM_BL_ENABLE)
                        ECQD_BinLianStep = 1;  //
                     ECQD_MotorStep   = 311;
                    break;
                case 311:   
                   if(dwTickCount >= ECQD_MotorDelay)
                    {   
                      ECQ_length_buffer = &ECQD_PARAM_OFFSET_LENGTH;
                         SetPos(X_AXIS, 0);
                      //ٶƶ  +ٳֹͣ
                     //                    һٶ  һγ  ڶٶ ڶγ  
                       ECQ_DCC_TIME_BL=ECQD_PARAM_BACK_SPEED/500;                                         
                AxisMovePosAccDecNotStop(X_AXIS,ECQD_PARAM_BACK_SPEED,ECQD_PARAM_ZIPPER_LENGTH + (*ECQ_length_buffer), ECQD_PARAM_START_SPEED,ECQD_PARAM_BACK_LOW_SPEED,ECQD_PARAM_ACC,ECQ_DCC_TIME_BL,ECQD_PARAM_BACK_LOW_SPEED_LENGTH);          
                          back_buff = ECQ_cRealPos;
                     gou_zhen_buff = ECQ_cRealPos;
                     save_buff = ECQ_cRealPos;     
                    ECQD_MotorDelay  =    dwTickCount + MOTOR_ALARM_TIME;
                    ECQD_MotorStep   = 312;
                   }
                    break;   
		case 312:
                  if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                     ECQD_DTFK_VAVLE=1;
                        //ǰ ȡʱƷ
                     if(ECQ_cRealPos>300)
                        ECQD_DGLG_VAVLE = 1;  //˹
                       if (!ECQD_GZ_VAVLE && (ECQ_cRealPos >= (ECQD_PARAM_ZIPPER_LENGTH- 230)))
                                  ECQD_GZ_VAVLE = 1;
                        
                       if((ECQ_cRealPos) > (ECQD_PARAM_ZIPPER_LENGTH + (*ECQ_length_buffer)-ECQD_PARAM_BACK_LOW_SPEED_LENGTH)) //- (*ECQ_length_buffer) - (ECQD_PARAM_BACK_LOW_SPEED_LENGTH + PulseToPos(X_AXIS,MV_Cal_Dec_pulse(ECQD_PARAM_BACK_SPEED,ECQD_PARAM_BACK_LOW_SPEED,ECQD_PARAM_DCC)))))
                       {                            
                           ECQD_MotorStep   = 313;
                           
                       }
                       else if(ECQ_cRealPos >= (ECQD_PARAM_ZIPPER_LENGTH + (*ECQ_length_buffer) + ECQD_PARAM_ERROR_LENGTH))
                       {
                           ECQD_SetAlarmCode(ECQD_GZ_ALARM);
                       }

			break;
                case 313:
                     if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                                 ECQD_DTFK_VAVLE=1;
                       if (!ECQD_GZ_VAVLE && (ECQ_cRealPos >= (ECQD_PARAM_ZIPPER_LENGTH- 230)))
                                    ECQD_GZ_VAVLE = 1;
                       if(!X_DRV || ECQ_cRealPos>=(ECQD_PARAM_ZIPPER_LENGTH + (*ECQ_length_buffer)))
                       {                         
                           AxisEgmStop(X_AXIS);
                            ECQD_DTFK_VAVLE=0;
                           ECQD_MotorDelay = dwTickCount + ECQD_PARAM_TFK_DELAY;
                           ECQD_MotorStep   = 314;
                           ECQD_BL_VAVLE = 0;  //ֹͣʱһҪ
                           
                           if((ECQD_PARAM_BACK_MODE == 2) && !ECQD_DGLG_VAVLE) //ģʽ2,ȼⳤȺ
                           {//Աȳ ,Ҫйź,ģʽ2,3.  ģʽ0,1ﾭ           
                               if(ECQ_cZipCnt > 1)  //ȼ
                                {
                                   if(ECQD_PARAM_ERROR_LENGTH != 0)  //ֵΪ0
                                    {     
                                        if(((ECQ_dwSaveLength + ECQD_PARAM_MOTOR_DELAY_LENGTH) > (length_buff + ECQD_PARAM_ERROR_LENGTH)) || (ECQ_dwSaveLength == 0))
                                        {
                                           ECQD_SetAlarmCode(ECQD_LENGTH_LONG_ALARM);//䳤,ԱȾ                                   
                                        }
                                        else if((ECQ_dwSaveLength + ECQD_PARAM_MOTOR_DELAY_LENGTH+ ECQD_PARAM_ERROR_LENGTH) < length_buff) 
                                        {
                                           ECQD_SetAlarmCode(ECQD_LENGTH_SHORT_ALARM);  ////     
                                       }
                                      
                                        ECQD_CheckLengthStep = 0;
                                    }    
                                }
                            }
                       }             
                        break;
                case 314:
                       if(!X_DRV && (dwTickCount >= ECQD_MotorDelay))  //صֹͣ
                       {      
                            ECQD_MotorStep   = 0;
                            ECQD_TFK_VAVLE   = 1;    //Ʒ                       
                       }
                       break;
              //330349Ӧģʽ   
                case 330:  
                  
                    back_buff = ECQ_cRealPos;
                     gou_zhen_buff = ECQ_cRealPos;
                        ECQD_DGLG_VAVLE = 0;  //˹
                      SetDir(X_AXIS, ECQD_DIR_P);
                    ECQD_MotorStep   = 331;          
                    user_datas[127] = 0;
                    break;
                case 331:  
                 
                    if(dwTickCount >= ECQD_MotorDelay)
                    {   
                         
                        if(ECQ_cZipCnt < 2)
                        {
                            if(ECQD_PARAM_BL_ENABLE)
                                ECQD_BinLianStep = 10;  //
                           //һǹӦٶȼ//ԭECQD_PARAM_CHECK_BACK_HSPEED/2
                            //                  X       ٶ                    ٶ        ٶ  ٶ
                          AxisContinueMoveAcc(X_AXIS,9000,ECQD_DIR_P,ECQD_PARAM_START_SPEED,2000,8,13);
                          
                             //                    һٶ  һγ  ڶٶ ڶγ  
                          // AxisMoveTwoPos(X_AXIS,ECQD_PARAM_BACK_SPEED,ECQD_PARAM_ZIPPER_LENGTH + (*ECQ_length_buffer)-ECQD_PARAM_BACK_LOW_SPEED_LENGTH,ECQD_PARAM_BACK_LOW_SPEED,ECQD_PARAM_BACK_LOW_SPEED_LENGTH,ECQD_DIR_P); 
                          
                        }   
                        else
                        {  
                            if(ECQD_PARAM_BL_ENABLE)
                                ECQD_BinLianStep = 1;  //
                          //ΪÿǹӦֱмģʽٶ
                            //                  X       ٶ                    ٶ        ٶ  ٶ
                          AxisContinueMoveAcc(X_AXIS,ECQD_PARAM_CHECK_BACK_HSPEED,ECQD_DIR_P,ECQD_PARAM_START_SPEED,2000,ECQD_PARAM_ACC,ECQD_PARAM_DCC);
                              
                         }
                        ECQD_MotorStep   = 332;
                    }
                    break;
                case 332:
                 if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                                   ECQD_DTFK_VAVLE=1;
                  if(ECQ_cRealPos>300)
                  {
                    if(ECQ_cZipCnt > 1)  //ڶʼؽ
                    {
                        if((ECQ_cRealPos +  ECQD_PARAM_BACK_LOW_SPEED_LENGTH + 600)>= length_buff)
                        { 
                        //    CancelPmoveState(X_AXIS);  //ģʽȥ
                            AxisChangeSpeed(X_AXIS,ECQD_PARAM_BACK_LOW_SPEED);   
                            user_datas[127] = ECQ_cRealPos;
                            ECQD_MotorStep   = 334;  //ⶨλ
                        }   
                        if(ECQD_GUO_LIAN_IN_DW)  //µ
                        {
                           //  CancelPmoveState(X_AXIS);
                             AxisChangeSpeed(X_AXIS,ECQD_PARAM_BACK_LOW_SPEED);
                             gou_zhen_buff = ECQ_cRealPos;
                             ECQD_MotorStep   = 335;  //ⶨλ
                        }
                 //
                 //       if((ECQ_cRealPos >=  (ECQD_PARAM_BACK_LOW_SPEED_LENGTH + 60)) &&  ECQD_GUO_LIAN_IN)
                 //       {
                            
                 //       }
                    }  
                    else   //һ
                    {  
                        if(ECQD_GUO_LIAN_IN_UP)
                        {                                 
                            checkdelay_buff = ECQ_cRealPos;
                           AxisChangeSpeed(X_AXIS,ECQD_PARAM_BACK_LOW_SPEED);
                             ECQD_MotorDelay  = dwTickCount + 0;//ECQD_PARAM_DELAY_XM;
                              ECQD_MotorStep   = 333;
                         }  
                         else if((ECQ_cRealPos >= ECQD_PARAM_RUN_LENGTH) && (ECQD_PARAM_RUN_LENGTH >= 5000))  //ģ
                        {
 //                           ECQD_SetAlarmCode(ECQD_PARAM_RUN_LENGTH_ALARM);  //г
                        }
                    }
                  }
                    break;
                 case 333:
                     if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                                   ECQD_DTFK_VAVLE=1;
    
                       if(dwTickCount >= ECQD_MotorDelay)
                       {
                           ECQD_MotorStep   = 334;
                       }                        
                        break;   
                case 334:
                    if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                     ECQD_DTFK_VAVLE=1;

                   if(ECQD_GUO_LIAN_IN_DW)  //½,λ
                   {      


                            if(ECQD_GUO_LIAN_IN_DW)
                            {                  
                                 gou_zhen_buff = ECQ_cRealPos;
                                 ECQD_MotorStep   = 335;
                            }
                     
                   }
                   break;
                case 335:
                    if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                     ECQD_DTFK_VAVLE=1;

                    if(ECQD_GUO_LIAN_IN_DW)
                    {
                        gou_zhen_buff = ECQ_cRealPos; 
                         
                    }
                    //ڿǶʱ    
                    if(ECQD_GUO_LIAN_IN)
                    {
                        gou_zhen_buff = ECQ_cRealPos; 
                    }                        
                        //λֹͣ
                    if(((ECQ_cRealPos - gou_zhen_buff) >= ECQD_PARAM_MOTOR_DELAY_LENGTH) && !ECQD_GUO_LIAN_IN)
                    {                         
                        AxisEgmStop(X_AXIS);   
                        ECQD_MotorDelay =    dwTickCount +  VAVLE_ALARM_TIME;
                        ECQD_MotorStep   = 336;
                        ECQD_GZ_VAVLE = 1;
                    }   
                    break;
                case 336:   
 
                  
                    if(!X_DRV)
                    {      
                       ECQD_GZ_VAVLE = 1;
                       ECQD_DTFK_VAVLE=0;
                      
                        ECQD_MotorDelay =    dwTickCount +  VAVLE_ALARM_TIME;
                           // ECQD_XM_VAVLE    = 1;
                        ECQD_MotorStep   = 337;
                    }
                    break;
                case 337:
                    if(1)
                    {
                      
                        ECQD_MotorStep   = 338;
                        ECQD_MotorDelay = dwTickCount + ECQD_PARAM_TFK_DELAY;
                    } 
           //             else if(dwTickCount >= ECQD_MotorDelay) ECQD_SetAlarmCode(ECQD_XM_DAOWEI);
                        break;
                case 338:  
                    if((dwTickCount >= ECQD_MotorDelay))
                    { 
                      ECQD_TFK_VAVLE   = 1;    //Ʒ                       
                      ECQD_MotorStep   = 339;
                      ECQD_MotorDelay =    dwTickCount +  VAVLE_ALARM_TIME;
                    }
                    break;                    
                case 339:
                    if(ECQ_cZipCnt == 1)
                    {
                         length_buff = ECQ_cRealPos - save_buff;
                         SetData32bits(ECQD_PARAM_ZIPPER_LENGTH_ADDR,length_buff-ECQD_PARAM_DK_LENGTH);
                    }     
                    else if(ECQ_cZipCnt > 1)  //ȼ
                    {
                        if(ECQD_PARAM_ERROR_LENGTH != 0)  //ֵΪ0
                        {       
                            if(ECQ_cRealPos >= length_buff)  //䳤,ԱȾ
                            {
                                if((ECQ_cRealPos - save_buff) > (length_buff+ECQD_PARAM_ERROR_LENGTH)) 
                                {
                                    ECQD_SetAlarmCode(ECQD_LENGTH_LONG_ALARM);
                                     ECQ_cJiaDaione=1;
                                }
                                
                            }
                            else   //
                            {
                                if((ECQ_cRealPos - save_buff + ECQD_PARAM_ERROR_LENGTH) < (length_buff))
                                {
                                     ECQD_SetAlarmCode(ECQD_LENGTH_SHORT_ALARM);
                                      ECQ_cJiaDaione=1;
                                }
                             } 
                         }
                    }
                    ECQD_MotorStep   = 0;
                    break;
              //350369Ӧģʽ   
                case  350:  
                    back_buff = ECQ_cRealPos;
                     gou_zhen_buff = ECQ_cRealPos;
                      SetDir(X_AXIS, ECQD_DIR_P);
                     
                    ECQD_MotorStep   = 351;   
       
                    
                    
                    break;
                case 351:  
                    if(dwTickCount >= ECQD_MotorDelay)
                    {   
                      
                        //һ,ǹӦ
                        if(ECQ_cZipCnt < 2)
                        {
                            if(ECQD_PARAM_BL_ENABLE)  //Ϊδ֪,ֻͨ˺
                                ECQD_BinLianStep = 10;  //
                           ECQD_DGLG_VAVLE = 0;  //˹
                            //                  X       ٶ                    ٶ        ٶ  ٶ
                            AxisContinueMoveAcc(X_AXIS,9000,ECQD_DIR_P,ECQD_PARAM_START_SPEED,2000,8,12);
                           ECQD_MotorStep   = 352; 
                        }   
                        else
                        {  
                            if(ECQD_PARAM_BL_ENABLE)
                                ECQD_BinLianStep = 1;  //
                            ECQD_DGLG_VAVLE = 1;  //˹
                            ECQD_CheckLengthStep = 1;    //ȼ,3жԱ
                            //طʽ,ڶѾȣֱӰطʽ
                            ECQD_MotorStep   = 311; 
                        }  
                        
                         
                    }
                    break;
                case 352:
                      if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                                         ECQD_DTFK_VAVLE=1;
                   if(ECQ_cRealPos>300)
                  {
                  //ǰٶȹ
                    if(ECQD_GUO_LIAN_IN_UP)
                    {                                 
                         checkdelay_buff = ECQ_cRealPos;
                         AxisChangeSpeed(X_AXIS,ECQD_PARAM_BACK_LOW_SPEED);
                         ECQD_MotorDelay  = dwTickCount + 2;//٣8MS˲
                         ECQD_MotorStep   = 353;
                     }  
                     else if((ECQ_cRealPos >= ECQD_PARAM_RUN_LENGTH) && (ECQD_PARAM_RUN_LENGTH >= 5000))  //ģ
                     {
 //                       ECQD_SetAlarmCode(ECQD_PARAM_RUN_LENGTH_ALARM);  //г
                     }
                  }

                    break;
                 case 353:
                     if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                     ECQD_DTFK_VAVLE=1;

                     if(dwTickCount >= ECQD_MotorDelay)
                     {
                         ECQD_MotorStep   = 354;
                     }                        
                     break;   
                case 354:
                    if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                     ECQD_DTFK_VAVLE=1;

                   if(ECQD_GUO_LIAN_IN_DW)  //½,λ
                   {      

                            if(ECQD_GUO_LIAN_IN_DW)
                            {                  
                                 gou_zhen_buff = ECQ_cRealPos;
                                 ECQD_MotorStep   = 355;
                            }
                     
                   }
                   break;
                case 355:
                    if(ECQ_cRealPos>ECQD_PARAM_DTFK_LENGTH)
                     ECQD_DTFK_VAVLE=1;

                    if(ECQD_GUO_LIAN_IN_DW)
                    {
                        gou_zhen_buff = ECQ_cRealPos; 
                         
                    }
                    //ڿǶʱ    
                    if(ECQD_GUO_LIAN_IN)
                    {
                        gou_zhen_buff = ECQ_cRealPos; 
                    }                        
                        //λֹͣ
                    if(((ECQ_cRealPos - gou_zhen_buff) >= ECQD_PARAM_MOTOR_DELAY_LENGTH) && !ECQD_GUO_LIAN_IN)
                    {                         
                        AxisEgmStop(X_AXIS);   
                        ECQD_MotorStep   = 356;
                        ECQD_GZ_VAVLE = 1;
                    }   
                    break;
                case 356:  
   
                    if(!X_DRV)
                    {      
                       ECQD_GZ_VAVLE = 1;
                       ECQD_DTFK_VAVLE=0;
                        ECQD_MotorDelay =    dwTickCount +  VAVLE_ALARM_TIME;
                           // ECQD_XM_VAVLE    = 1;
                        ECQD_MotorStep   = 357;
                    }
                    break;
                case 357:
                    if(1)
                    {
                     
                        ECQD_MotorStep   = 358;
                        ECQD_MotorDelay = dwTickCount + ECQD_PARAM_TFK_DELAY;
                    } 
                    break;
                case 358:  
                    if((dwTickCount >= ECQD_MotorDelay))
                    { 
                      ECQD_TFK_VAVLE   = 1;    //Ʒ                       
                      ECQD_MotorStep   = 359;
                      ECQD_MotorDelay =    dwTickCount +  VAVLE_ALARM_TIME;
                    }
                    break;                    
                case 359:
                    if(ECQ_cZipCnt == 1)
                    {
                         length_buff = ECQ_cRealPos - save_buff;
                         //
                         SetData32bits(ECQD_PARAM_ZIPPER_LENGTH_ADDR,length_buff-ECQD_PARAM_DK_LENGTH);
                    }     
                    ECQD_MotorStep   = 0;
                    break;                    
              case 40:
                         //ʱɼ
	               if(ECQD_PARAM_SJZ_LENGTH == 0)
                        {
                            ECQD_MotorDelay  = dwTickCount + ECQD_PARAM_TDYS_DELAY;
                           SetDir(X_AXIS, ECQD_DIR_P);
                            ECQD_MotorStep   = 43;
                            ECQD_JD_VAVLE = 0; 
                        }
                        else
                        {
                       jz_buff = ECQ_cRealPos;
                        SetDir(X_AXIS, ECQD_DIR_P);
                        ECQD_MotorStep   = 41;
                        }
                        break; 
              case 41:
                
                  AxisMovePosAccDecNotStop(X_AXIS,ECQD_PARAM_CUT_BACK_SPEED,ECQD_PARAM_SJZ_LENGTH+ECQD_PARAM_BACK_LENGTH,500,1500,100,100,00);          
           //        AxisMovePosAccDec(X_AXIS,ECQD_PARAM_CUT_BACK_SPEED,ECQD_PARAM_SJZ_LENGTH+ECQD_PARAM_BACK_LENGTH,1000,1000,80,100,0);
                    ECQD_MotorStep   = 42;
                   //   ECQD_MotorDelay  = dwTickCount+ 10;
                 break;  
                 
	     case 42:	 

                    if((ECQD_PARAM_SJZ_LENGTH <= (ECQ_cRealPos - jz_buff)))
                    {
                
                        ECQD_JD_VAVLE = 0;
                        ECQD_GZ_VAVLE=0; 
                      
                        ECQD_MotorStep   = 44;
                    }
                    break;
                case 44:	                           // жɺ
                        if((ECQ_cRealPos - jz_buff) >= (ECQD_PARAM_SJZ_LENGTH+ECQD_PARAM_BACK_LENGTH))
                        {
                            AxisEgmStop(X_AXIS);
                            ECQD_MotorStep   = 0;
                             ECQD_GZ_VAVLE=0;
                            ECQD_MotorDelay  =    dwTickCount;
                        }
                        break; 
                case 61: // ǰ㶨λģʽ
                        if(ECQD_SZ_OUT)
                        {
                            ECQD_SZ_OUT   = 0;                       
                            ECQD_MotorDelay = dwTickCount + 150;
                         
                        }
                        else
                            ECQD_MotorDelay = dwTickCount;
                        
                        ECQD_BL_VAVLE = 0;//ҲҪ
                   //     ECQD_JZ_DIR   = ECQD_YDIR_N; 
                        if(ECQD_TuiLianStep==0)
                        {
                          if(!ECQD_TL_VAVLE && ECQ_cZipCnt)  //û
                          {
                              if(!ECQD_SHANG_MU_LIMIT_IN && (ECQD_TuiLianStep == 0))
                              {
                                   ECQD_TuiLianStep = 1;
                                   ECQD_MotorStep = 62;
                              }                          
                          }
                          else
                             ECQD_MotorStep = 62;
                            
                        }
                        else
                            ECQD_MotorStep = 62;
                        break;
                case 62:
                
                        if(dwTickCount >= ECQD_MotorDelay)
                        {                            
                            if(ECQD_QIAN_LIMIT_IN)
                            {
                                SetPos(X_AXIS, 0);//ǰ㣬ֱ
                       //        ECQD_JZ_DIR   = ECQD_YDIR_P;
                                //ǰ˳
                       
                                AxisMovePos(X_AXIS,ECQD_PARAM_GO_LOW_SPEED,1000);                           
                                ECQD_MotorDelay = dwTickCount + 300;
                            }
                            ECQD_MotorStep = 63;            
                            ECQD_JD_VAVLE = 0;  
                        }
			break;
		case 63:
                        if(ECQD_ANQUANMEN_LIMIT_IN_UP)
                        {
                         
                         ECQD_StopStep=1;
                           ECQ_cSTOPONE=1;
                        }
                        if(!X_DRV && !ECQD_QIAN_LIMIT_IN && (dwTickCount >= ECQD_MotorDelay))// && !ECQD_SHANG_MU_LIMIT_IN)
                        {
                       
               
                            go_buff  = ECQ_cRealPos;
                            ECQD_YD_VAVLE = 1;
                            ECQD_HL_VAVLE = 1;      
                            ECQD_YX_VAVLE = 1;
                            //,λ֮,صٵ
                            if(ECQ_cZipCnt > 0)
                            {
                             
                                if(ECQ_cRealPos>(ECQD_PARAM_GO_LOW_SPEED_LENGTH))   
                                {   
                                   ECQ_DCC_TIME_BL=ECQD_PARAM_GO_HIGH_SPEED/500;
                                 AxisMovePosAccDecNotStop(X_AXIS,ECQD_PARAM_GO_HIGH_SPEED,-ECQ_cRealPos,
                                              ECQD_PARAM_START_SPEED,ECQD_PARAM_GO_LOW_SPEED,ECQD_PARAM_ACC,ECQ_DCC_TIME_BL,
                                              ECQD_PARAM_GO_LOW_SPEED_LENGTH);                            
                                } 
                               
                                else
                                 {
                                    //                  X       ٶ                    ٶ        ٶ  ٶ
                                    AxisContinueMoveAcc(X_AXIS,ECQD_PARAM_GO_LOW_SPEED,ECQD_DIR_N,ECQD_PARAM_GO_LOW_SPEED/3,2000,15,20);
       
                                }
                              
                            }
                            else
                            {
                               //                  X       ٶ                    ٶ        ٶ  ٶ
                                    AxisContinueMoveAcc(X_AXIS,ECQD_PARAM_GO_LOW_SPEED,ECQD_DIR_N,ECQD_PARAM_GO_LOW_SPEED/3,2000,15,20);
                           }
                            
                            ECQD_MotorDelay =    dwTickCount + MOTOR_ALARM_TIME;
                            ECQD_MotorStep   =64;
                        }  
                       
			break;
                case 64:
                 if(ECQ_cZipCnt > 0)
                  {
                  if(ECQ_cRealPos<600 && !ECQD_XIA_MU_ORIGIN_IN && !ECQD_SHANG_MU_ORIGIN_IN)
                  {
                   AxisContinueMoveAcc(X_AXIS,1000,ECQD_DIR_N,ECQD_PARAM_GO_LOW_SPEED/3,1000,15,20);
                  }
                  }
                            if(ECQD_ANQUANMEN_LIMIT_IN_UP)
                            {
                             
                             ECQD_StopStep=1;
                               ECQ_cSTOPONE=1;
                            }
                        if(ECQ_cZipCnt > 1)
                        {                         
                              //
                              if(((ECQ_cRealPos) < (ECQD_PARAM_GO_LOW_SPEED_LENGTH+1200)))// || (ECQD_QIAN_DEC_IN))
                              {
                                   user_datas[126]= GetCurSpeed(X_AXIS);
                               //     MoveChangSpeedDec(X_AXIS,ECQD_PARAM_GO_HIGH_SPEED*2/3,6,8);
                             //    AxisChangeSpeed(X_AXIS,40);
                                   ECQD_MotorStep   =65;
                              }
                                if(ECQD_QIAN_LIMIT_IN)  //ǰλ
                                {
                                 
                                    AxisMovePosAccDec(X_AXIS,3000,ECQD_PARAM_QDW_LENGTH,2000,2000,ECQD_PARAM_ACC,ECQD_PARAM_DCC,0);                                   
                 
                                    ECQD_MotorStep   = 66;                            
                                }
                        }
                        else
                        {                            
                            if(ECQD_QIAN_LIMIT_IN)  //ǰλ
                            {
                                 AxisMovePosAccDec(X_AXIS,3000,ECQD_PARAM_QDW_LENGTH,2000,2000,ECQD_PARAM_ACC,ECQD_PARAM_DCC,0);                                   
                 
                                ECQD_MotorStep   = 66;                            
                            }
                        }

                        break;
		case 65:
                    if(ECQ_cZipCnt > 0)
                  {
                  if(ECQ_cRealPos<600 && !ECQD_XIA_MU_ORIGIN_IN && !ECQD_SHANG_MU_ORIGIN_IN)
                  {
                   AxisContinueMoveAcc(X_AXIS,1000,ECQD_DIR_N,ECQD_PARAM_GO_LOW_SPEED/3,1000,15,20);
                  }
                  }
                            if(ECQD_ANQUANMEN_LIMIT_IN_UP)
                            {
                             
                             ECQD_StopStep=1;
                               ECQ_cSTOPONE=1;
                            }
                        if(ECQD_QIAN_LIMIT_IN)
                        {       
                         
                            AxisMovePosAccDec(X_AXIS,3000,ECQD_PARAM_QDW_LENGTH,2000,2000,ECQD_PARAM_ACC,ECQD_PARAM_DCC,0);                                   
                 
                            ECQD_MotorStep   = 66;                                  
                        }
                        else if(dwTickCount >= ECQD_MotorDelay)
                            ECQD_SetAlarmCode(ECQD_NO_ZIPPER_ALARM);
                        
                        break;
		case 66:
                   if(ECQ_cZipCnt > 0)
                  {
                  if(ECQ_cRealPos<600 && !ECQD_XIA_MU_ORIGIN_IN && !ECQD_SHANG_MU_ORIGIN_IN)
                  {
                   AxisContinueMoveAcc(X_AXIS,1000,ECQD_DIR_N,ECQD_PARAM_GO_LOW_SPEED/3,1000,15,20);
                  }
                  }
                            if(ECQD_ANQUANMEN_LIMIT_IN_UP)
                            {
                             
                             ECQD_StopStep=1;
                               ECQ_cSTOPONE=1;
                            }
                        if(!X_DRV)
                        {   
                        
                             AxisEgmStop(X_AXIS);
                            SetPos(X_AXIS, 0);
                            ECQD_MotorDelay =    dwTickCount;
                            ECQD_MotorStep   = 67;
                        }
			break;   
		case 67:  //ɺ,
                        if((dwTickCount >= ECQD_MotorDelay) && (ECQD_TuiLianStep == 0) && ((ECQD_PARAM_TIAOSHI_MODE && ECQD_bTS) || (ECQD_PARAM_TIAOSHI_MODE == 0)) )
                        {
                            if(bRunning)
                            {
                                ECQD_JD_VAVLE = 1;
                                ECQD_MotorDelay =    dwTickCount + ECQD_PARAM_DELAY_BACK;
                            }
                            ECQD_MotorStep   = 68;
                        }
			break;
                case 68:
                        if(dwTickCount >= ECQD_MotorDelay)
                        {
                            ECQD_YD_VAVLE = 0;
                            ECQD_HL_VAVLE = 0;      
                            ECQD_YX_VAVLE = 0;
                            ECQD_TFK_VAVLE=0;
                            ECQD_TL_VAVLE    = 0;
                            ECQD_MotorStep   = 0;
                            ECQD_MotorDelay  = dwTickCount;
                        }
                        break;
               
	}
        }
}
#endif

void ECQ_QueDuan_BingLian(void)
{
    static long bl_pos_buff,HL_delay;
    
    switch(ECQD_BinLianStep)
    {
        case 1:
              bl_pos_buff = ECQ_cRealPos;
            
              ECQD_BinLianStep = 2;
        break;       
        case 2:
              if((ECQ_cRealPos - bl_pos_buff) >= ECQD_PARAM_DELAY_HL_LENGTH)
              {
                   ECQD_BL_VAVLE = 1;   
                   ECQD_BinLianStep = 3;
              }            
        break;
        case 3://й
              if((ECQ_cRealPos - bl_pos_buff) >= (ECQD_PARAM_ZIPPER_LENGTH - ECQD_PARAM_HL_DELAY_BACK))  
              {
                    ECQD_BL_VAVLE = 0;
                   ECQD_BinLianStep = 0;   
              }
              if(ECQD_GUO_LIAN_IN_DW && ECQD_PARAM_BACK_MODE ==1) //|| (ECQD_PARAM_BACK_MODE==2 && ECQ_cZipCnt < 2)))
              {
                 ECQD_BL_VAVLE = 0;
                  ECQD_BinLianStep = 0;  
              }
        break;
        case 10:
           bl_pos_buff = ECQ_cRealPos;
              ECQD_BinLianStep = 11;
        break;       
        case 11:
              if((ECQ_cRealPos - bl_pos_buff) >= ECQD_PARAM_DELAY_HL_LENGTH)
              {
                   ECQD_BL_VAVLE = 1;   
                   ECQD_BinLianStep = 12;
              }            
        break;
        case 12://й
              if(ECQD_GUO_LIAN_IN_DW)  
              {
                    ECQD_BL_VAVLE = 0;
                   ECQD_BinLianStep = 0;   
              }
        break;
        default:;    
    }
    
}

//ʽ,ר
void ECQ_QueDuan_XiaQue_KK(void)	
{
   switch(ECQD_XiaQieStep) 
    {
        case 0:
                break;
        case 1:
         
                 ECQD_XiaQieStep = 2;                     
                break;
        case 2:             
                ECQD_XiaQieDelay = dwTickCount + VAVLE_ALARM_TIME;
                ECQD_XiaQieStep = 3;   
               break;
        case 3:
                if(1)
                {
                    ECQD_XiaQieDelay = dwTickCount + 0;//ECQD_PARAM_GZ_DELAY;
                    ECQD_XiaQieStep = 4; 
                     ECQD_DTFK_VAVLE=0;
                }
                else if(dwTickCount >= ECQD_XiaQieDelay)
                {
                    ECQD_SetAlarmCode(ECQD_XM_DAOWEI);
                }
                break;
        case 4:   
                if(ECQD_GZ_VAVLE )  //ѾͲҪʱ
                {
                    ECQD_XiaQieDelay = dwTickCount + 20;
                }
                else
                   ECQD_XiaQieDelay = dwTickCount + ECQD_PARAM_TFK_DELAY;
                ECQD_GZ_VAVLE  = 1;
                ECQ_cTuiFangKuaiCnt=0;
                ECQD_XiaQieStep = 5;  
                
                break;
        case 5:  
                if(dwTickCount >= ECQD_XiaQieDelay)
                {
                    ECQD_TFK_VAVLE = 1;
                    ECQD_XiaQieDelay = dwTickCount + VAVLE_ALARM_TIME;
                    ECQD_XiaQieStep = 6;  
                }
                break;
        case 6: 
                if(1)
                {                         
                    ECQD_XiaQieStep = 7;  
                    ECQD_XiaQieDelay = dwTickCount + 1000;
                }
                else if(dwTickCount >= ECQD_XiaQieDelay)
                {
                    ECQD_SetAlarmCode(ECQD_XM_DAOWEI);
                }
                break;
        case 7:
           
               if(ECQD_GOUZHEN_IN)
               {      
                 
                   ECQ_cTuiFangKuaiCnt = 0;
                   ECQD_YD_VAVLE    = 1;
                   if(!bRunning)
                     ECQD_XiaQieDelay = dwTickCount + 200;
                   else
                     ECQD_XiaQieDelay = dwTickCount + ECQD_PARAM_CUT_DELAY;
                   
                   if(!ECQD_QIAN_LIMIT_IN)
                       ECQD_XiaQieStep = 8;   
                   else
                       ECQD_SetAlarmCode(ECQD_QIAN_LIMIT_ALARM);
               }
               else if((dwTickCount >= ECQD_XiaQieDelay))
               {  
                   if(ECQ_cTuiFangKuaiCnt < ECQD_PARAM_TFK_NUMBER)
                   {
                       ECQD_TFK_VAVLE = 0;
                       ECQ_cTuiFangKuaiCnt++;
                       ECQD_XiaQieDelay = dwTickCount + 500;
                       ECQD_XiaQieStep = 100;   
                   }
                   else   
                      
                       ECQD_SetAlarmCode(ECQD_GZ_ALARM);
               }
               break;
        case 100:
               if((dwTickCount >= ECQD_XiaQieDelay))
               {
                   ECQD_XiaQieStep = 5;   
               }
               break;
        case 8://ģͬʱ
             if(ECQD_GOUZHEN_IN)
                  {
   
               if(dwTickCount >= ECQD_XiaQieDelay)
               {
                  ECQD_SM_VAVLE = 1;
                  if(ECQD_PARAM_XM_ENABLE == 0)   //ģ
                        ECQD_XM_VAVLE   = 1;
                  ECQD_XiaQieDelay = dwTickCount + VAVLE_ALARM_TIME;
                  ECQD_XiaQieStep = 9;   
               }
                   
                  }
         
               break;
    case 9://ģλģµĻȰһ     ģ
                if(ECQD_SHANG_MU_LIMIT_IN && (ECQD_XIA_MU_LIMIT_IN || ECQD_PARAM_XM_ENABLE) && ((ECQD_PARAM_TIAOSHI_MODE && ECQD_bTS) || (ECQD_PARAM_TIAOSHI_MODE == 0)) )
                {
                    if(!ECQD_PARAM_CS_MODE)   //޳
                    {
                        ECQD_XiaQieDelay = dwTickCount + ECQD_PARAM_DELAYBACK_SM;       // 
                        ECQD_XiaQieStep = 12;        
                    }
                    else
                    {
                        ECQD_XiaQieDelay = dwTickCount + ECQD_PARAM_DELAY_CS;       // 
                        ECQD_XiaQieStep = 10;                      
                    }
                }
                else if(dwTickCount >= ECQD_XiaQieDelay)
                {
                    if(!ECQD_SHANG_MU_LIMIT_IN)ECQD_SetAlarmCode(ECQD_SM_DAOWEI);
                    else ECQD_SetAlarmCode(ECQD_XM_DAOWEI);
                }
                break;
        case 10:
                if(dwTickCount >= ECQD_XiaQieDelay)	
                {
 
                        ECQD_CS_OUT = 1;
                 //
                    ECQD_XiaQieDelay = dwTickCount + ECQD_PARAM_CS_TIME;       // 
                    ECQD_XiaQieStep = 11;      
                }
                break;
        case 11:
                if(dwTickCount >= ECQD_XiaQieDelay)	
                {
                    ECQD_CS_OUT = 0;
                    ECQD_XiaQieDelay = dwTickCount + ECQD_PARAM_CS_COLD_TIME;       // 
                    ECQD_XiaQieStep = 12;	
                }
                break;
        case 12:  
               if(dwTickCount >= ECQD_XiaQieDelay)
               {
                    ECQD_SM_VAVLE   = 0;
                    if(ECQD_PARAM_XM_ENABLE == 0)   //ģ
                        ECQD_XM_VAVLE   = 0;
                 
                 //  ECQD_DGLG_VAVLE = 0;  //˹
                    ECQD_TFK_VAVLE  = 0;
          //          ECQD_GZ_VAVLE = 0  
                    ECQD_XiaQieStep = 13;	
               }// 
                break;
          case 13:
            ECQD_GZ_VAVLE = 0;
            ECQD_XiaQieDelay = dwTickCount + ECQD_PARAM_TTFK_TIME;
            ECQD_XiaQieStep = 14;   
            break;
        case 14:
                if(dwTickCount >= ECQD_XiaQieDelay)
                {
                  
                    ECQD_TFK_VAVLE  = 1;
                  
                     
                }
                if(!ECQD_SHANG_MU_LIMIT_IN && (!ECQD_XIA_MU_LIMIT_IN || ECQD_PARAM_XM_ENABLE))
                {
                    //()
                    if((ECQD_TuiLianStep == 0) && !ECQD_TL_VAVLE)
                       ECQD_TuiLianStep = 1;
                }
                if(ECQD_TFK_VAVLE && !ECQD_SHANG_MU_LIMIT_IN && (!ECQD_XIA_MU_LIMIT_IN || ECQD_PARAM_XM_ENABLE))	
                {   
                    ECQD_XiaQieStep = 0;                      
                }

                break;
    }	
}


void ECQ_QueDuan_TuiLianAction(void)
{
    if(ECQD_PARAM_XM_ENABLE == 0)
    {
        ECQD_TuiLianStep = 0;
    }
    else
    {  
        switch(ECQD_TuiLianStep) 
        {
            case 1:
                ECQD_TuiLianStep = 2;
            break;
            case 2:
                  ECQD_TLDelay     = dwTickCount + ECQD_PARAM_YD_DELAY;
                  ECQD_TuiLianStep = 3;
            break;
            case 3:
                if(!ECQD_SM_VAVLE && !ECQD_SHANG_MU_LIMIT_IN)//dwTickCount >= ECQD_TLDelay)
                {   
                    ECQD_TL_VAVLE    = 0;
                   // ECQD_TFK_VAVLE  = 0;
                  //  if(!bRunning)ECQD_TFK_VAVLE = 1;
                 
                     ECQD_TLDelay     = dwTickCount + ECQD_PARAM_TL_DELAY;
                    ECQD_TuiLianStep = 4;
                }
            break;
            case 4:
                if(dwTickCount >= ECQD_TLDelay)
                {
                    ECQD_TuiLianStep = 0;
                   
                }
            break;
            case 10:
             
                ECQD_TuiLianStep = 11;
            break;
            case 11:
                if(!Y_DRV)
                {
                   {
                      ECQD_TuiLianStep = 0;
                   }
                }
            break;
        }
    }
}


//ж϶
void ECQ_QueDuan_XiaQue(void)	 
{
  
  if(ECQD_KB_MODE) //տ
    {
        ECQ_QueDuan_XiaQue_NO_GL();  //
    }
    else  //
    {
        ECQ_QueDuan_XiaQue_KK(); 
    }  
#if 0  
    switch(ECQD_MACHINE_TYPE)
    {	
        case ECQD_NO_CS_TUIFANGKUAI:ECQ_QueDuan_XiaQue_CS();break;	
        case ECQD_NO_GL_TUIFANGKUAI:ECQ_QueDuan_XiaQue_NO_GL();break;
        case ECQD_CS_TUIFANGKUAI:ECQ_QueDuan_XiaQue_NO_GL();break;
        default:;
    }
#endif  
}






#endif