#include "global.h"

#if XIN_YE_MACHINE  ==  1

void XY_CTHL_SetAlarmCode(unsigned short alarm_code,unsigned short cStopFlag);
void XY_CTHL_ManualAction(void);
void XY_CTHL_AutoStepAction(void);
void XY_CTHL_TableAction(void);
void XY_CTHL_TD_Motor(void);
void XY_CTHL_CL_Motor(void);
void XY_CTHL_CheckStart(void);
void XY_CTHL_TLiao_Step(void);  //(ͷ)
void XY_CTHL_AlarmProtect(void);
void XY_CTHL_ZLT_Step(void);
void XY_CTHL_ZhenDongAction(void);
void XY_CTHL_bFKCXTDDWStep(void);
void XY_CTHL_bCXCRStep(void);
void XY_CTHL_bCLFirstStep(void);


void ExtiAcitionX02(void)
{
  if(bCheckEN_FLG)
  {  
    bCheckEN_FLG = 0;
    XY_CTHL_CheckInX02PosBuff = GetPos(X_AXIS);
  }    
}

//ϱ
void XY_CTHL_SetAlarmCode(unsigned short alarm_code,unsigned short cStopFlag)
{
  SetAlarmCode(XY_CTHL_ALARM_ADDR,alarm_code);
  //  bAlarmStop = 0;
  // if(cStopFlag)
  if(!cWULATOUCnt && !cXiaoChaCNT && !cCHULIANBAOJIN)
  {
    bAlarmStop = 1;
  }
  else
  {
    cWULATOUCnt=0;
  }
  
  
  
}

//ʼ
void XY_CTHL_InitAction(void)
{
  float buff_pulse,buff_dist;
  
  buff_pulse  = XY_CTHL_PARAM_CYCLE_PULSE;
  buff_dist   = XY_CTHL_PARAM_CYCLE_LENGTH; 
  
  XGearRatio  =  buff_pulse/buff_dist; 
  
  buff_pulse  = 2000;//XY_CTHL_PARAM_CYCLE_PULSE;
  buff_dist   = 750;//XY_CTHL_PARAM_CYCLE_LENGTH;
  YGearRatio  =  buff_pulse/buff_dist;
  
  
  
  bYFirstDingWeiFlg = 1;
  user_datas[121] = 0;
  user_datas[122] = 0;
  user_datas[123] = 0;
  
  SetEnReverse(X_AXIS, 1);
  SetEnReverse(Y_AXIS, 1);
  SetEnReverse(Z_AXIS, 1);
  
  SetDirReverse(X_AXIS, 0);
  SetDirReverse(Y_AXIS, 0);
  SetDirReverse(Z_AXIS, 0);
  
  SetEn(X_AXIS, MOTOR_DISEN);
  SetEn(Y_AXIS, MOTOR_DISEN);
  SetEn(Z_AXIS, MOTOR_DISEN);
  
  SetAlarmCode(XY_CTHL_ALARM_ADDR,0); 
  //    QDCT_SZ_OUT   = QDCT_MOTOR_DISEN;
}

void XY_CTHL_Action(void)
{ 
  user_datas[121] = XY_CTHL_LianLengSave;
  //   user_datas[122] =axis_x->cur_speed;
  //  user_datas[123] = XY_CTHL_bCXCR_Step;
  dwXRealPos = GetPos(X_AXIS);
  dwYRealPos = GetPos(Y_AXIS);
  dwZRealPos = GetPos(Z_AXIS);  
  user_datas[124] = dwXRealPos;
  user_datas[125] = dwYRealPos;
  
  user_datas[126] = XY_CTHL_CL_MotorStep;
  user_datas[127] = XY_CTHL_TD_MotorStep;
  user_datas[128] = XY_CTHL_AutoStep;  
  
  XY_CTHL_ZhenDongAction();
  XY_CTHL_AlarmProtect();
  XY_CTHL_CheckStart();    
  XY_CTHL_ZLT_Step();
  XY_CTHL_TLiao_Step();
  
  XY_CTHL_TD_Motor();
  XY_CTHL_CL_Motor();
  XY_CTHL_bFKCXTDDWStep();
  XY_CTHL_bCXCRStep();
  XY_CTHL_bCLFirstStep();
  XY_CTHL_ManualAction();
  
  XY_CTHL_AutoStepAction();  
}

void XY_CTHL_AlarmProtect(void)
{ 
  
  
  
}


//Զ
void XY_CTHL_AutoStepAction(void)
{  
  
  
  
  if(bRunning)
  {
    switch(XY_CTHL_AutoStep)
    {
    case 1:
      if(XY_CTHL_SF_Origin_IN || cBanAuTo)
      {
        /*       XY_CTHL_AutoStep = 10;       //ϴλ
        XY_CTHL_AutoDelay = dwTickCount + 1000;
        break; */
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_FKJD_VAVLE = 1;   //д
          XY_CTHL_XKTD_VAVLE = 1;   //бƴ    
          XY_CTHL_FKGD_VAVLE = 0;     //̶
          //    XY_CTHL_XKDW_VAVLE = 1;
          XY_CTHL_AutoStep = 2;
          //     XY_CTHL_AutoDelay = dwTickCount + 10;
          if(XY_CTHL_ZhuangLiaoStep == 0)
          { 
            XY_CTHL_ZhuangLiaoStep = 1;
            XY_CTHL_TryCnt = 0;
          }   
        }
      }
      break;
    case 2: 
      if(!XY_CTHL_XKTD_Origin_IN)// && (dwTickCount >= XY_CTHL_AutoDelay))  //бƴԭλ뿪
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 3;
          XY_CTHL_XKDW_VAVLE = 1;
          XY_CTHL_AutoDelay = dwTickCount + 20;
        }
      }  
      break;
    case 3://бڶλ
      if(dwTickCount >= XY_CTHL_AutoDelay)
      {                   
        XY_CTHL_AutoStep = 4;
        //         XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_XKDW_TD_DELAY;
      }  
      break;
    case 4:
      if(!cBanAuTo)
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          AxisMovePosAccDecNotStop(X_AXIS,1600,1500,600,1000,15,30,00); 
          XY_CTHL_AutoStep = 5;
          XY_CTHL_XSavePosBuff = dwXRealPos;
          //       SetPos(X_AXIS, 0);  //λΪ0
          if(cZipCnt < 1)
            XY_CTHL_AutoDelay = dwTickCount +350;
          else
            XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_FKJD_DELAY;
        }
      }
      else
      {
        XY_CTHL_AutoStep = 5;
        XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_FKJD_DELAY;
        XY_CTHL_XSavePosBuff = dwXRealPos;
      }
      
      break;
    case 5:
      if(dwTickCount >= XY_CTHL_AutoDelay)
      {
        XY_CTHL_FKJD_VAVLE = 1;   //д
        
      }
      if(bCL_EN_FLG && (dwXRealPos >= 230) && XY_CTHL_XKSC_Limit_IN)
      {                    
        XY_CTHL_HLJJ_VAVLE = 1; //Y20 оߵŷ,
      }
      
      if(XY_CTHL_XKSC_Limit_IN)   //ֹλ
      {
        AxisEgmStop(X_AXIS);
        // AxisMovePosAccDec(X_AXIS,1200,10,1200,1200,6,6,0); 
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_QDXK_VAVLE = 1;
          XY_CTHL_FKJD_VAVLE=0;
          
          XY_CTHL_AutoStep = 6;
          //                   
          
          XY_CTHL_bLTCHECK_Delay = dwTickCount + 20;
          //
          bCL_OK_FLG = 1;   //ôĻΪѾ
          if(bCL_EN_FLG)
          {
            bCL_OK_FLG = 0;
            XY_CTHL_HLJJ_VAVLE = 1; //Y20 оߵŷ,
            XY_CTHL_CL_MotorStep = 1;
            XY_CTHL_CL_MotorDelay = dwTickCount + XY_CTHL_PARAM_HLJJ_CL_DELAY;
            
            XY_CTHL_AutoDelay = dwTickCount + 50 + XY_CTHL_PARAM_HLJJ_CL_DELAY;  
          }
          else
          {
            XY_CTHL_XKTD_VAVLE = 0;   //бƴ׹ر      
            XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;       
          }   
        }
      }
      else if(dwXRealPos >= (XY_CTHL_XSavePosBuff + 3000))
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_FKCXDW_ALARM,bRunning);  //λ쳣
        
      }  
      break;
    case 6:
      if((dwYRealPos > 1000) || XY_CTHL_CL_MotorStep==0)
      {
        XY_CTHL_XKTD_VAVLE = 0;   //бƴ׹ر      
        XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;    
      }  
      
      if(XY_CTHL_XKTD_Origin_IN)      //бƴصԭλ
      {
        if(bZhuangLiaoOkFlg && (XY_CTHL_ZhuangLiaoStep == 0))
        {
          if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
          {
            if(dwTickCount >= XY_CTHL_bLTCHECK_Delay)
            {
              if(bSingOneFlg)
              {
                XY_CTHL_AutoStep = 0;
                bRunning = 0;
              }     
              else
              {   
                if(!XY_CTHL_LTou_Check)
                {
                  if(XY_CTHL_PARAM_TDFZ_LENTH && !X_DRV)  //ϴת
                  {
                    AxisMovePosAccDec(X_AXIS,8000,-XY_CTHL_PARAM_DXKFZ_LENTH,800,600,6,6,0); 
                    if(!XY_CTHL_PARAM_NLSL_MODE)
                      XY_CTHL_FKJD_VAVLE= 0;   //д׹
                    
                  }
                  if(XY_CTHL_PARAM_CXXY_MODE)
                    XY_CTHL_CXXY_VAVLE = 1;
                  XY_CTHL_CTXM_VAVLE = 1; //ͷģ
                  XY_CTHL_AutoStep = 7;
                  XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
                }
                else
                {
                  cWULATOUCnt=1;
                  XY_CTHL_SetAlarmCode(XY_CTHL_ZLT_ALARM,bRunning);  // ûͷ                               
                }
              }
            }
          } 
        }
      }
      else if((dwTickCount >= XY_CTHL_AutoDelay) && !XY_CTHL_XKTD_VAVLE  && !cBanAuTo) 
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_XKTD_Origin_ALARM,bRunning); //бƴص쳣
      }
      break;
    case 7: 
      if(!XY_CTHL_CTM_Origin_IN)
      {
        XY_CTHL_JLTou_VAVLE = 0;    //ͷ
      }
      if(XY_CTHL_CTM_Limit_IN) 
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          if(XY_CTHL_PARAM_NLSL_MODE)
          {
            
            XY_CTHL_XKTD_VAVLE=1;
          }
          XY_CTHL_JLTou_VAVLE = 0;
          XY_CTHL_AutoStep = 8;    
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_DXKYS_DELAY;
        }
        
      }  
      else if(dwTickCount >= XY_CTHL_AutoDelay)
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_CTM_Limit_ALARM,bRunning);  //ͷģ쳣
      }
      break;
      
    case 8:
      if(!X_DRV)  //ʱб
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          if((dwTickCount >= XY_CTHL_AutoDelay) || (XY_CTHL_PARAM_NLSL_MODE))
          {  
            if(!XY_CTHL_PARAM_NLSL_MODE)
              XY_CTHL_DXK_VAVLE=1;
            XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_DXK_XKDW_Off_DELAY;
            XY_CTHL_AutoStep = 9;
          }
        }
        
      }
      break;
    case 9: 
      if((dwTickCount >= XY_CTHL_AutoDelay) && (bCL_OK_FLG))  //бʱбֹλ
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          //                   AxisMovePosAccDec(X_AXIS,2000,-150,1200,1200,3,6,0);  //ת1.5CM
          XY_CTHL_XKDW_VAVLE = 0;    //бֹλ
          XY_CTHL_FKJD_VAVLE = 0;   //д׹
          XY_CTHL_AutoStep = 10;    
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_XK_CR_DELAY;
        }
      }              
      break;
    case 10:  
      if(!cBanAuTo)
      {
        if((dwTickCount >= XY_CTHL_AutoDelay) && !X_DRV)
        {
          if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
          {
            XY_CTHL_TD_MotorStep = 10;   //ϴ            
            XY_CTHL_AutoStep = 11;  
          }
          
        }
      }
      else
      {
        XY_CTHL_AutoStep = 801; 
        XY_CTHL_AutoDelay = dwTickCount + 1000;
        cCHULIANBAOJIN=1;
      }
      break;
    case 801:
      if(dwTickCount >= XY_CTHL_AutoDelay)
      {
        
        bRunning=0;
        cBanAuTo=0;
        XY_CTHL_QDXK_VAVLE=0;
        XY_CTHL_XKTD_VAVLE = 0;
        XY_CTHL_DXK_VAVLE=0;
        XY_CTHL_AutoStep = 0; 
        
      }
      break;
    case 11:
      
      if(XY_CTHL_TD_MotorStep == 0)  //붨λ
      {      
        /*   //ϴλ  
        XY_CTHL_AutoStep = 1;       
        XY_CTHL_AutoDelay = dwTickCount + 1000;
        if(cZipCnt<3)
        cZipCnt++;
        break;  */
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          
          XY_CTHL_XKDW_VAVLE = 0;    //бֹλ
          XY_CTHL_XKTD_VAVLE = 1;     //бƴ 
          XY_CTHL_CXSCDW_VAVLE = 1;   //Y21 ֹλŷ
          cXcxcrCnt = 0;
          if(XY_CTHL_CL_MotorStep == 0)
          {                          
            XY_CTHL_CXQJD_VAVLE = 1;
          }                 
          XY_CTHL_AutoStep = 12; 
          XY_CTHL_AutoDelay = dwTickCount;
        }
        
      }  
      break;        
    case 12: 
      if(XY_CTHL_CL_MotorStep == 0)  //ǰдصԭλ
      {
        if(XY_CTHL_SF_Origin_IN)
        {
          if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
          {
            XY_CTHL_AutoStep = 14; 
            XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_XCQJD_XCDW_DELAY;
            if(cXcxcrCnt != 1)
            {                        
              XY_CTHL_CXQJD_VAVLE = 1;                    
            }
          }
        }
        else if(!XY_CTHL_SF_Origin_IN)
        {
          XY_CTHL_CL_MotorStep = 50;  //ŷԭ  
          
        }
        
      }
      break;
    case 14:
      if(dwTickCount >= XY_CTHL_AutoDelay)
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_XKDW_VAVLE = 1; //бڶλ 
          XY_CTHL_AutoStep = 15; 
          XY_CTHL_FKGD_VAVLE = 1;     //̶
          //Y
          if(cXcxcrCnt != 1)
          {   
            XY_CTHL_CL_MotorStep = 20;  //λ     
          }
        }
      }
      break;
    case 15:   
      if(XY_CTHL_CL_MotorStep == 0)   //λ
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 16; 
          XY_CTHL_CXDWZ_VAVLE = 1;    //λ(λ)ŷ
          XY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
          XY_CTHL_AutoDelay = dwTickCount + 10;  //ʱ
        }
      }  
      break;
    case 16: 
      if(dwTickCount >= XY_CTHL_AutoDelay)
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 17; 
          if(XY_CTHL_PARAM_CXXY_MODE)
            XY_CTHL_CXXY_VAVLE = 0;
          else
            XY_CTHL_CXXY_VAVLE = 1;     //Y06 Ƶŷ
          XY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;  //쳣ʱ
        }
      }
      break;
    case 17:   
      if(XY_CTHL_PARAM_CXXY_MODE)
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          if(XY_CTHL_CXXY_Limit_IN)
          {
            XY_CTHL_AutoStep = 18; 
            if( cXcxcrCnt==0 && !X_DRV && !cCXCONE)  //ϴת
            {
              AxisMovePosAccDec(X_AXIS,8000,-XY_CTHL_PARAM_TDFZ_LENTH,800,600,6,6,0);               
            }
            XY_CTHL_CXQJD_VAVLE = 0;    //ǰдŷ     
            XY_CTHL_CXSCDW_VAVLE = 0;   //Y21 ֹλ                    
            XY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
            XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_SCDWOff_CXDW_DELAY;
          }
          
        }  
        else if(dwTickCount >= XY_CTHL_AutoDelay)  
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_CXXY_Limit_ALARM,bRunning); //쳣
          
        }
      }
      else
      {        
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 18; 
          if( cXcxcrCnt==0 && !X_DRV && !cCXCONE)  //ϴת
          {
            AxisMovePosAccDec(X_AXIS,8000,-XY_CTHL_PARAM_TDFZ_LENTH,800,600,6,6,0);               
          }
          XY_CTHL_CXQJD_VAVLE = 0;    //ǰдŷ
          XY_CTHL_CXSCDW_VAVLE = 0;   //Y21 ֹλ   
          
          XY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_SCDWOff_CXDW_DELAY;    
        }
      }
      break;
    case 18:   
      //              if(START_IN_UP)
      {
        if(dwTickCount >= XY_CTHL_AutoDelay) 
        {
          if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
          {
            XY_CTHL_AutoStep = 19; 
            cBAOHUCNT=0;
            XY_CTHL_CXHDW_VAVLE = 1;     //λ()
            XY_CTHL_AutoDelay = dwTickCount + 500;  //뵽λ쳣ʱ
            XY_CTHL_CL_MotorStep = 50;  //ԭ
          }
        }
      }
      break;
    case 19:   
      
      if(XY_CTHL_CX_Limit_IN && (cXcxcrCnt<4))
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          cXcxcrCnt=0;
          cXiaoChaCNT=0;
          user_datas[100]=0;
          bZhuangLiaoOkFlg = 0;
          XY_CTHL_CXXY_VAVLE=0;
          XY_CTHL_AutoStep = 901;
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_FKGD_DELAY; //˷̶ʱ
          XY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
        }
        
      }  
      else if ((dwTickCount >= XY_CTHL_AutoDelay) && (cXcxcrCnt<3) )
      {
        cXcxcrCnt++;
        XY_CTHL_CXHJD_VAVLE=0;
        XY_CTHL_CXHDW_VAVLE=0;
        if(!XY_CTHL_PARAM_CXXY_MODE)
          XY_CTHL_CXXY_VAVLE=0;
        else
          XY_CTHL_CXXY_VAVLE=1;
        if(cXcxcrCnt<3)
        {
          XY_CTHL_CXSCDW_VAVLE=1;
          XY_CTHL_AutoStep = 12;
          XY_CTHL_AutoDelay = dwTickCount + 120;
        }
      }
      else if((dwTickCount >= (XY_CTHL_AutoDelay +3000))  && !XY_CTHL_CX_Limit_IN )
      {
        cXiaoChaCNT=1;
        if(!XY_CTHL_PARAM_CXXY_MODE)
          XY_CTHL_CXXY_VAVLE=0;
        else
          XY_CTHL_CXXY_VAVLE=1; 
        XY_CTHL_CXHJD_VAVLE =0;
        
        cBAOHUCNT=1;
        XY_CTHL_SetAlarmCode(XY_CTHL_CX_Limit_ALARM ,bRunning);//뵽λ쳣  
      }
      
      if( cXcxcrCnt > 2) 
      {
        cXiaoChaCNT=1;
        
        XY_CTHL_CXXY_VAVLE=0;
        XY_CTHL_CXHJD_VAVLE =0;
        cBAOHUCNT=1;
        XY_CTHL_SetAlarmCode(XY_CTHL_CX_Limit_ALARM ,bRunning);//뵽λ쳣  
      }
      
      break;
      
    case 901:
      if(dwTickCount >= XY_CTHL_AutoDelay)
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_FKGD_VAVLE = 0;     //̶
          XY_CTHL_AutoStep = 20;
          if(!cBAOHUCNT)
            XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_First_CL_DELAY;//ʱһδ
          else
          {
            XY_CTHL_AutoDelay = dwTickCount + 1000;//ֶʱ
            cBAOHUCNT=0;
          }
        }
        
      }
      break;
    case 20:  
      if(dwTickCount >= XY_CTHL_AutoDelay) 
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 21;
          XY_CTHL_First_CT_VAVLE = 1;   //һδŷ
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
        }
      }
      break;
    case 21:   
      if(!XY_CTHL_First_CT_Origin_IN)  //ԭ뿪ſʼʱ
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 22;
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_First_CL_Timer;  //һδʱ
        }
      }
      else if(dwTickCount >= XY_CTHL_AutoDelay) 
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_YCCRYWYC_ALARM,bRunning); //һδԭλ쳣
      }
      break;
    case 22:
      if(dwTickCount >= XY_CTHL_AutoDelay) 
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 23;
          XY_CTHL_MGuo_VAVLE = 0;     //빴
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_PARAM_MGOff_XiaMo_DELAY;
          XY_CTHL_FKGD_VAVLE = 0;     //̶
          XY_CTHL_FKJD_VAVLE=0;
          XY_CTHL_CXHJD_VAVLE = 0;    //Y14 д 
          XY_CTHL_CXXY_VAVLE = 0;     //Y06 Ƶŷ
        }
      } 
      break;
    case 23:  
      if(dwTickCount >= XY_CTHL_AutoDelay) 
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 24;
          XY_CTHL_CTXM_VAVLE = 0; //ͷģ½
          XY_CTHL_AutoDelay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
        }
      } 
      break;
    case 24: 
      if(!XY_CTHL_CTM_Limit_IN)
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 25;
          XY_CTHL_AutoDelay = dwTickCount + 20;  //һδʱ
        }
      }
      else if(dwTickCount >= XY_CTHL_AutoDelay) 
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_CTM_Origin_ALARM,bRunning);//ͷģ½쳣
      }
      break;
    case 25:
      if(dwTickCount >= XY_CTHL_AutoDelay) 
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          XY_CTHL_AutoStep = 26;
          XY_CTHL_First_CT_VAVLE = 0;   //һδŷ
          XY_CTHL_AutoDelay = dwTickCount + 5;
          XY_CTHL_CXHDW_VAVLE = 0;     //λ()ر
          //³
          XY_CTHL_AutoDelay1 = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
          XY_CTHL_AutoStep1 = 1;
        }
      }
      break;
      
      
    case 26: 
      if(dwTickCount >= XY_CTHL_AutoDelay) 
      {
        if(!XY_CTHL_bDanBu || XY_CTHL_START_IN_UP)
        {
          if(!cCXCONE)
          {
            XY_CTHL_FKJD_VAVLE = 1;   //д   
            XY_CTHL_FKGD_VAVLE = 0;     //̶            
            XY_CTHL_AutoStep = 2;
            bCL_EN_FLG = 1;
            cXcxcrCnt=0;
            AddToTal(XY_CTHL_TOTAL_ADDR);
            
            CalProSP(XY_CTHL_SPEED_ADDR);
            if(cZipCnt<3)
              cZipCnt++;
          }
          else
          {
            bRunning=0;
            cCXCONE=0;
            XY_CTHL_AutoStep = 0;
            
          }
        }
        
      }
      break;
      
    }   
  }       
  //ģͷ
  switch(XY_CTHL_AutoStep1)
  {   
  case 1:
    if(cStopMode==1)
    {
      bCL_EN_FLG=1;
      cStopMode=2;
      bStop=1;
    }
    if(XY_CTHL_CTM_Origin_IN && XY_CTHL_First_CT_Origin_IN)
    {
      XY_CTHL_ZhuangLiaoStep = 1;
      XY_CTHL_TryCnt = 0;
      XY_CTHL_AutoStep1 = 0;
      XY_CTHL_MGuo_VAVLE = 0;
      XY_CTHL_JLTou_VAVLE = 0;
    }
    else if(dwTickCount >= XY_CTHL_AutoDelay1) 
    {
      //ͷģһδλ쳣
      if(!XY_CTHL_CTM_Origin_IN)
        XY_CTHL_SetAlarmCode(XY_CTHL_CTM_Origin_ALARM,bRunning);
      else if(!XY_CTHL_First_CT_Origin_IN)
        XY_CTHL_SetAlarmCode(XY_CTHL_First_CT_Origin_ALARM,bRunning);                    
    } 
    break;
    
  }  
  
}





void XY_CTHL_CheckStart(void)
{
  //
  if(cBanAuTo)
  {
    XY_CTHL_PARAM_XCRU=1;
  }
  else
  {
    XY_CTHL_PARAM_XCRU=0;
  }
  //
  if(cCXCONE)
  {
    XY_CTHL_PARAM_CXCR=1;
  }
  else
  {
    XY_CTHL_PARAM_CXCR=0;
  }
  
  if(cXCXQXQD)
  {
    if(XY_CTHL_START_IN_UP || bStart)
    {
      bStart=0;
      if(!bRunning)
      {
        if(XY_CTHL_SafeDoor_IN )
        {
          bRunning=1;             
          cXCXQXQD =0;  
          XY_CTHL_TD_MotorStep = 0;   
          XY_CTHL_AutoStep=11;
        }
        else
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
        }
      }
    }
    
    
  }
  if(cWULATOUCnt) // ͷ
  {
    if(XY_CTHL_START_IN_UP || bStart)
    {
      bStart=0;
      if(!bRunning)
      {
        if(XY_CTHL_SafeDoor_IN)
        {  
          bRunning=1;
          XY_CTHL_TryCnt=0;
          cWULATOUCnt=0;
          XY_CTHL_ZhuangLiaoStep = 1; 
          XY_CTHL_AutoStep=6;
          bTuiLaTouOkFlg = 1;
          bZhuangLiaoOkFlg= 0;
          XY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
          XY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
        }
        else
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
        }
      }
    }
  }
  if(!XY_CTHL_SafeDoor_IN && bRunning && !cBanAuTo && !cCXCONE)
  {
    bStop=1;
    XY_CTHL_SetAlarmCode(XY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
  }
  
  //    Զ һԶ	 			
  if((XY_CTHL_START_IN_UP || bStart ) && !cWULATOUCnt  && !cXCXQXQD)
  {
    if(cCHULIANBAOJIN) //ͣ
    {
      cCHULIANBAOJIN=0;
      SetEn(X_AXIS, MOTOR_EN);
      //      dwXRealPos=0;
      XY_CTHL_TD_MotorStep=9;
      
      
      if(GetAlarm(Y_AXIS)==0 || GetAlarm(X_AXIS)==0)
      {
        SetClr(Y_AXIS, MOTOR_NOALARM);
        SetClr(X_AXIS, MOTOR_NOALARM); 
        SetEn(X_AXIS, MOTOR_DISEN);
        SetEn(Y_AXIS, MOTOR_DISEN);
        XY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
      }
      cZipCnt=0;
      XY_CTHL_TD_MotorDelay = dwTickCount + 500;
      XY_CTHL_AutoDelay = dwTickCount + 150;
      if(GetAlarmCode(XY_CTHL_ALARM_ADDR) != 0)
        SetAlarmCode(XY_CTHL_ALARM_ADDR,0);   
      
    }
    
    if(!bRunning)
    {
      if(XY_CTHL_SafeDoor_IN)
      {  
        cStopMode=0;
        bRunning = 1;
        cWULATOUCnt=0;
        cHeLian=0;
        SetEn(X_AXIS, MOTOR_EN);
        SetEn(Y_AXIS, MOTOR_EN);        
        XY_CTHL_CL_MotorStep = 40;
        XY_CTHL_AutoStep = 1;
        bTuiLaTouOkFlg = 1;
        XY_CTHL_PARAM_ZDP_AUTO= 0;
        bZhuangLiaoOkFlg= 0;
        XY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
        XY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
        //   bCL_EN_FLG = 0;
        cZipCnt = 0;
        cQDXK_DXK=0;
        XY_CTHL_LianLengthCheck = 0;
        cStopInCnt = 0;
      }
      else
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_SafeDoor_ALARM,0);  // ȫŹϲ
      }            
    }  
    bStart = 0;
  }   
  
  //ֹͣ
  if(XY_CTHL_STOP_IN_UP || bStop)
  {	
    
    if(cStopMode < 2)
      cStopMode++;
    if(bRunning && cStopMode==2)
    {   
      cBanAuTo=0;
      cCXCONE=0;
      bRunning=0;
      cStopMode=0;
      cXcxcrCnt=0;
      cXCXQXQD=0;
      cCHULIANBAOJIN=0;
      cWULATOUCnt=0;
      AxisEgmStop(X_AXIS);
      AxisEgmStop(Y_AXIS);
      XY_CTHL_AutoStep = 0; 
      XY_CTHL_CL_MotorStep =0;      
      XY_CTHL_bCLFirst_Step=0;  
      XY_CTHL_ZhuangLiaoStep=0;
      //  XY_CTHL_XKTD_VAVLE = 0; 
      cQDXK_DXK=0;
      //   XY_CTHL_XKDW_VAVLE =0;
      if(XY_CTHL_SF_ALR_IN )
      {
        XY_CTHL_SF_ALR_CLR=1;
        XY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
      }
      if(GetAlarm(Y_AXIS)==0 || GetAlarm(X_AXIS)==0)
      {
        SetClr(Y_AXIS, MOTOR_NOALARM);
        SetClr(X_AXIS, MOTOR_NOALARM);
        XY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
      }
      if(GetAlarmCode(XY_CTHL_ALARM_ADDR) != 0)
        SetAlarmCode(XY_CTHL_ALARM_ADDR,0);    
      
    }
    else if(!bRunning)
    {
      cBanAuTo=0;
      cCXCONE=0;
      bRunning=0;
      cXcxcrCnt=0;
      cStopMode=0;
      cCHULIANBAOJIN=0;
      cXCXQXQD=0;
      cWULATOUCnt=0;
      bCL_EN_FLG=0;
      AxisEgmStop(X_AXIS);
      AxisEgmStop(Y_AXIS);
      SetEn(X_AXIS, MOTOR_DISEN);
      SetEn(Y_AXIS, MOTOR_DISEN);
      cStopMode=0;
      cQDXK_DXK=0;
      if(XY_CTHL_SF_ALR_IN )
      {
        XY_CTHL_SF_ALR_CLR=1;
        XY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
      }
      if(GetAlarm(Y_AXIS)==0 || GetAlarm(X_AXIS)==0)
      {
        SetClr(Y_AXIS, MOTOR_NOALARM);
        SetClr(X_AXIS, MOTOR_NOALARM);
        XY_CTHL_bSFBBAOJIN_Delay= dwTickCount + 2000;
      }
      XY_CTHL_TLiao_VAVLE=0;             
      XY_CTHL_HSLiao_VAVLE  =0;    
      XY_CTHL_JLTou_VAVLE  =0;     
      XY_CTHL_XKTD_VAVLE  =0;        
      XY_CTHL_XKDW_VAVLE  =0;       
      XY_CTHL_DXK_VAVLE  =0;         
      XY_CTHL_CXXY_VAVLE  =0;         
      XY_CTHL_CTXM_VAVLE =0;         
      XY_CTHL_First_CT_VAVLE =0;     
      XY_CTHL_FKGD_VAVLE =0;         
      XY_CTHL_CXQJD_VAVLE =0;        
      XY_CTHL_CXDWZ_VAVLE  =0;       
      XY_CTHL_CXHJD_VAVLE =0;        
      XY_CTHL_CXHDW_VAVLE =0;        
      XY_CTHL_FKJD_VAVLE  =0;        
      XY_CTHL_HLJJ_VAVLE  =0;                       
      XY_CTHL_CXSCDW_VAVLE =0;
      XY_CTHL_MGuo_VAVLE =0;
      XY_CTHL_QDXK_VAVLE=0;
      
      XY_CTHL_AutoStep = 0;
      XY_CTHL_ZhuangLiaoStep=0;
      XY_CTHL_TLiaoStep=0;
      XY_CTHL_TD_MotorStep=0;
      XY_CTHL_JiaLianStep  =0;        
      XY_CTHL_SongLiaoStep   =0;     
      XY_CTHL_CL_MotorStep =0;      
      XY_CTHL_AutoStep1  =0;
      XY_CTHL_bFKCXTDDW_Step=0;
      XY_CTHL_bCXCR_Step=0;
      XY_CTHL_bCLFirst_Step=0;
      if(GetAlarmCode(XY_CTHL_ALARM_ADDR) != 0)
        SetAlarmCode(XY_CTHL_ALARM_ADDR,0);  
      SetPos(X_AXIS, 0); 
      
      XY_CTHL_TLiaoStep = 0; 
      XY_CTHL_AutoStep = 0;
      
      //㷽ʱֹͣ
      if(GetDir(Y_AXIS) == DIR_N)
        AxisEgmStop(Y_AXIS);
      
    }
    bStop=0;
  }
  
  if(bAlarmStop)
  {   
    bRunning   = 0;
    bAlarmStop=0;
    cStopMode=0;
    cXcxcrCnt=0;
    AxisEgmStop(X_AXIS);
    AxisEgmStop(Y_AXIS);
    XY_CTHL_AutoStep = 0; 
    cQDXK_DXK=0;
    XY_CTHL_CL_MotorStep =0;      
    XY_CTHL_bCLFirst_Step=0;  
    XY_CTHL_SongLiaoStep =0;
    XY_CTHL_ZhuangLiaoStep=0;
    // XY_CTHL_XKTD_VAVLE = 0; 
    // XY_CTHL_XKDW_VAVLE =0;
    
  }
}   

//ϴƶ  X
void XY_CTHL_TD_Motor(void)	 //
{   
#if 1
  switch(XY_CTHL_TD_MotorStep)
  {
    //1ʼλ, ûд
  case 1:
    if(dwTickCount >= XY_CTHL_TD_MotorDelay)  //ʱ
    {
      bCheckEN_FLG = 1;
      XY_CTHL_CheckInX02PosBuff= 0;
      XY_CTHL_TD_MotorStep = 2;   
      SetPos(X_AXIS, 0);  //λΪ0
      AxisContinueMoveAcc(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed*2/3,DIR_P,800,600,15,15);
      XY_CTHL_X_CXPosBuff=0;
    }  
    break;
  case 2://⵽
    if(dwXRealPos > 400)    //2CM
    {
      if(XY_CTHL_PARAM_NLSL_MODE)
      {
        XY_CTHL_XKTD_VAVLE=0;
      }
      XY_CTHL_DXK_VAVLE = 0;   //б׹  
      XY_CTHL_QDXK_VAVLE = 0;
    }    
    if(dwXRealPos >= XY_CTHL_PARAM_WLCDSHEZHI_LENTH)
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_WLZDTJ_ALARM,bRunning);   //Զͣ              
    }
    if(XY_CTHL_FK_Check)
    {
      XY_CTHL_DXK_VAVLE = 0;   //б׹
      XY_CTHL_QDXK_VAVLE = 0;
      XY_CTHL_XSavePosBuff = dwXRealPos;
      XY_CTHL_TD_MotorStep = 3;  
      user_datas[123] = dwXRealPos - XY_CTHL_CheckInX02PosBuff;
      if((dwXRealPos >= XY_CTHL_CheckInX02PosBuff) && XY_CTHL_CheckInX02PosBuff)
        AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed*2/3,XY_CTHL_PARAM_first_length,
                          XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,300,50); 
      else
        AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed*2/3,XY_CTHL_PARAM_first_length,
                          XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,300,50); 
    }
    break;
  case 3:    
    if(XY_CTHL_CXSC_Limit_IN_UP)
    {
      XY_CTHL_X_CXPosBuff = dwXRealPos;
      
    }  
    
    if(!X_DRV || (dwXRealPos >= (XY_CTHL_XSavePosBuff + XY_CTHL_PARAM_FKDW_Length)))
    {
      AxisEgmStop(X_AXIS);
      XY_CTHL_TD_MotorStep =4 ; 
      XY_CTHL_LianLengthAutoCheck = dwXRealPos;
    }
    break;
  case 4:
    if(XY_CTHL_PARAM_XCX_LENTH)   //0Ļжλ
    {
      
      if ((dwXRealPos - XY_CTHL_X_CXPosBuff) > (XY_CTHL_PARAM_XCX_LENTH + XY_CTHL_PARAM_XCXWC_LENTH)) 
      {
        //                    user_datas[121] = 1;
        XY_CTHL_TD_MotorStep = 0;
        XY_CTHL_SetAlarmCode(XY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
        
      }         
      
      else if(XY_CTHL_X_CXPosBuff == 0)
      {
        //                    user_datas[121] = 3;
        XY_CTHL_TD_MotorStep = 0;
        XY_CTHL_SetAlarmCode(XY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
      }   
      else
      {
        XY_CTHL_TD_MotorStep = 0;
        XY_CTHL_X_CXPosBuff=dwXRealPos;
        
      }
      
    }
    else
    {
      XY_CTHL_TD_MotorStep = 0;
      //     XY_CTHL_X_CXPosBuff=dwXRealPos;
    }
    break;
  case 9:
    if(dwTickCount >= XY_CTHL_TD_MotorDelay)
    {
      XY_CTHL_TD_MotorStep = 10;
      XY_CTHL_TD_MotorDelay=dwTickCount+500;
      SetEn(X_AXIS, MOTOR_EN);
      
    }
    break;
    //ͷλ
  case 10:   
    if(dwTickCount >= XY_CTHL_TD_MotorDelay)
    {
      
      XY_CTHL_TD_MotorStep = 11;
      SetPos(X_AXIS, 0);  //λΪ0
      dwXRealPos = 0;
      AxisContinueMoveAcc(X_AXIS,XY_CTHL_PARAM_TDCR_LowSpeed,DIR_P,1200,1200,15,15);   
      XY_CTHL_CheckInX02PosBuff= 0;
      XY_CTHL_X_CXPosBuff=0;
      bCheckEN_FLG = 1;
    }
    break;
  case 11:  
    if(dwXRealPos > 350)    //2CM
    {
      if(XY_CTHL_PARAM_NLSL_MODE)
      {
        XY_CTHL_XKTD_VAVLE=0;
      }
      XY_CTHL_DXK_VAVLE = 0;   //б׹
      XY_CTHL_QDXK_VAVLE =0;
    }
    if(dwXRealPos > XY_CTHL_PARAM_TDCR_LowSpeedLength)    //2CM
    {
      
      XY_CTHL_CheckInX02PosBuff= 0;
      XY_CTHL_DXK_VAVLE = 0;   //б׹
      XY_CTHL_QDXK_VAVLE = 0;
      if(XY_CTHL_PARAM_NLSL_MODE)
      {
        XY_CTHL_XKTD_VAVLE=0;
      }
      XY_CTHL_TD_MotorStep = 12;
      if((cZipCnt < 2) || (XY_CTHL_LianLengthCheck < XY_CTHL_PARAM_TDCR_LowSpeedLength))
        AxisContinueMoveAcc(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed*2/3,DIR_P,3000,600,10,10); 
      else ////ٶƶ                
      {  
        
        AxisMovePosAccDecNotStop(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed ,XY_CTHL_LianLengthCheck-(XY_CTHL_PARAM_TDCR_LowSpeedLength),1500,7000,30,300,250); 
        
      }
    }
    
    if(XY_CTHL_FK_Check)    //⵽˵ٶȻû
    {
      //   XY_CTHL_SongDai_VAVLE=1;
      XY_CTHL_DXK_VAVLE = 0;   //б׹
      XY_CTHL_QDXK_VAVLE = 0;
      if(XY_CTHL_PARAM_NLSL_MODE)
      {
        XY_CTHL_XKTD_VAVLE=0;
      }
      XY_CTHL_TD_MotorDelay= dwTickCount + XY_CTHL_PARAM_FKJDSECONG_DEALY;
      XY_CTHL_LianLengthReal = dwXRealPos;
      
      XY_CTHL_XSavePosBuff = dwXRealPos;
      XY_CTHL_TD_MotorStep = 13;  
      //     user_datas[122] = XY_CTHL_PARAM_FKDW_Length - (dwXRealPos- XY_CTHL_CheckInX02PosBuff);
      
      if((dwXRealPos >= XY_CTHL_CheckInX02PosBuff) && XY_CTHL_CheckInX02PosBuff)
        AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed,XY_CTHL_PARAM_FKDW_Length - (dwXRealPos- XY_CTHL_CheckInX02PosBuff),
                          XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,250,40); 
      else
        AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed,XY_CTHL_PARAM_FKDW_Length,
                          XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,250,40); 
      //XY_CTHL_TD_MotorStep = 0;  
    }
    else if(XY_CTHL_CXSC_Limit_IN_UP)
    {
      AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed * 2/3,XY_CTHL_PARAM_FKDW_Length,
                        XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,250,50); 
      
    }
    else if(XY_CTHL_CXSC_Limit_IN_DW)
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_DK_ERROR_ALARM,bRunning);
    }
    break;
  case 12://⵽  
    
    if(cZipCnt<2)
    { 
      if(dwXRealPos >= XY_CTHL_PARAM_WLCDSHEZHI_LENTH)
      {
        if(bRunning)
        {
          cCHULIANBAOJIN=1;
          SetEn(X_AXIS, MOTOR_DISEN);
          AxisEgmStop(X_AXIS);
          SetPos(X_AXIS, 0);  //λΪ0
          //     dwXRealPos=0;
        }
        XY_CTHL_SetAlarmCode(XY_CTHL_WLZDTJ_ALARM,bRunning);   //Զͣ             
      }
    }
    else
    {
      if(dwXRealPos >= XY_CTHL_LianLengthAutoCheckERROR + XY_CTHL_PARAM_WUCD_LENTH)
      {
        if(bRunning)
        {
          cCHULIANBAOJIN=1;
          SetEn(X_AXIS, MOTOR_DISEN);
          AxisEgmStop(X_AXIS);
          SetPos(X_AXIS, 0);  //λΪ0
          //     dwXRealPos=0;
        }
        XY_CTHL_SetAlarmCode(XY_CTHL_WLZDTJ_ALARM,bRunning);   //Զͣ             
      }
      
    }
    if(XY_CTHL_FK_Check)
    {
      
      XY_CTHL_TD_MotorDelay= dwTickCount + XY_CTHL_PARAM_FKJDSECONG_DEALY;
      XY_CTHL_LianLengthReal = dwXRealPos;
      //if(cZipCnt == 1)
      //   user_datas[122] = dwXRealPos;
      //               user_datas[121] = dwXRealPos;
      if((cZipCnt == 1)  || dwXRealPos < (XY_CTHL_LianLengthCheck*0.85) || dwXRealPos>(XY_CTHL_LianLengthCheck*1.3))
        XY_CTHL_LianLengthCheck = dwXRealPos;
      
      XY_CTHL_LianLengthCheckOLD=XY_CTHL_LianLengthNEWCheck;
      XY_CTHL_LianLengthNEWCheck  = dwXRealPos; 
      //break;
      XY_CTHL_XSavePosBuff = dwXRealPos;
      XY_CTHL_TD_MotorStep = 13;  
      //     user_datas[122] = XY_CTHL_PARAM_FKDW_Length - (dwXRealPos- XY_CTHL_CheckInX02PosBuff);
      if(cZipCnt > 1 )
      {
        if((dwXRealPos >= XY_CTHL_CheckInX02PosBuff) && XY_CTHL_CheckInX02PosBuff)
          AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed*2/3,XY_CTHL_PARAM_FKDW_Length - (dwXRealPos- XY_CTHL_CheckInX02PosBuff),
                            XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,300,50); 
        else
          AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed*2/3,XY_CTHL_PARAM_FKDW_Length,
                            XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,300,50); 
      }
      else
      {
        
        AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed*2/3,XY_CTHL_PARAM_first_length,
                          XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,30,300,50); 
      }
      //XY_CTHL_TD_MotorStep = 0;  
    }
    else if(XY_CTHL_CXSC_Limit_IN_UP)
    {
      AxisMovePosAccDec(X_AXIS,XY_CTHL_PARAM_TD_RunSpeed * 2/3,XY_CTHL_PARAM_FKDW_Length,
                        XY_CTHL_PARAM_FKDW_Speed,XY_CTHL_PARAM_FKDW_Speed,10,150,50); 
      
    }
    else if(XY_CTHL_CXSC_Limit_IN_DW)
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_DK_ERROR_ALARM,bRunning);
    }
    
    break;   
  case 13:
    
    if(dwTickCount >= XY_CTHL_TD_MotorDelay)
    {
      XY_CTHL_FKJD_VAVLE = 1;   //д
      
    }
    if(XY_CTHL_CXSC_Limit_IN_DW)
    {
      XY_CTHL_X_CXPosBuff = dwXRealPos;
      
    }  
    if((!X_DRV ))// || (dwXRealPos >= (XY_CTHL_XSavePosBuff + XY_CTHL_PARAM_FKDW_Length)))
    {
      // user_datas[123] = dwXRealPos-XY_CTHL_CheckInX02PosBuff;
      
      AxisEgmStop(X_AXIS);
      XY_CTHL_TD_MotorStep = 14; 
      /*       if(cZipCnt>2)
      {
      if(((XY_CTHL_LianLengthNEWCheck+XY_CTHL_LianLengthCheckOLD)*0.5) < (XY_CTHL_LianLengthCheck*0.95))
      {
      cZipCnt=0;  
      cHeLian=1;
    }
    }*/
      if(cZipCnt==1)
        XY_CTHL_LianLengthAutoCheckERROR = dwXRealPos;
      
      if(cZipCnt==1)
        XY_CTHL_LianLengSave=dwXRealPos;
      
      XY_CTHL_LianLengthAutoCheck = dwXRealPos;
      //  user_datas[122] = dwXRealPos-XY_CTHL_X_CXPosBuff;
    }
    break;
  case 14:
    
    if(XY_CTHL_PARAM_XCX_LENTH)   //0Ļжλ
    {
      
      if ((dwXRealPos - XY_CTHL_X_CXPosBuff) > (XY_CTHL_PARAM_XCX_LENTH + XY_CTHL_PARAM_XCXWC_LENTH)) 
      {
        //  user_datas[121] = 1;
        XY_CTHL_TD_MotorStep = 0;
        cXCXQXQD=1;
        XY_CTHL_SetAlarmCode(XY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
        
      }         
      else if((dwXRealPos - XY_CTHL_X_CXPosBuff) < (XY_CTHL_PARAM_XCX_LENTH - XY_CTHL_PARAM_XCXWC_LENTH))
      {
        //   user_datas[121] = 2;
        XY_CTHL_TD_MotorStep = 0;
        cXCXQXQD=1;
        XY_CTHL_SetAlarmCode(XY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
      }    
      else if(XY_CTHL_X_CXPosBuff == 0)
      {
        //    user_datas[121] = 3;
        XY_CTHL_TD_MotorStep = 0;
        cXCXQXQD=1;
        XY_CTHL_SetAlarmCode(XY_CTHL_XCXXCYC_ALARM,bRunning);        // Сг쳣
      }   
      else
      {
        
        XY_CTHL_TD_MotorStep = 15;
      }
      
    }
    else
    {
      
      XY_CTHL_TD_MotorStep = 15;
    }
    break;
  case 15:
    //          if(XY_CTHL_START_IN_UP)
    XY_CTHL_TD_MotorStep = 0;
    
    
    break;     
  }   
#endif    
}
//Y
void XY_CTHL_CL_Motor(void)	 //
{   
#if 0
  //1ʼ,  ȿʼ
  //20ʼ  λʼ
  //40,ԭΪ
  switch(XY_CTHL_CL_MotorStep)
  {
    //볤λ
  case 1:
    
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      // SetDir(Y_AXIS, DIR_P);
      if(XY_CTHL_PARAM_CL_Length >= XY_CTHL_PARAM_CL_MAX_Length)
        XY_CTHL_PARAM_CL_Length = XY_CTHL_PARAM_CL_MAX_Length;
      //볤Ҫݼⳤȼһδ1CM,ת2CM
      if((XY_CTHL_LianLengthAutoCheck < (XY_CTHL_PARAM_CL_Length + 500 )) && bRunning) 
        AxisMovePosAccDec(Y_AXIS,XY_CTHL_PARAM_CL_Speed,(XY_CTHL_LianLengthAutoCheck-500),800,600,6,6,50);       
      else
        AxisMovePosAccDec(Y_AXIS,XY_CTHL_PARAM_CL_Speed,(XY_CTHL_PARAM_CL_Length-100),800,600,6,6,50); 
      XY_CTHL_CL_MotorStep = 2; 
    }
    break;
  case 2:
    if((dwYRealPos + 120) > XY_CTHL_PARAM_CL_Length)
      XY_CTHL_HLJJ_VAVLE = 0;
    if(!Y_DRV || dwYRealPos >= XY_CTHL_PARAM_CL_Length)  
    {
      XY_CTHL_HLJJ_VAVLE = 0;
      XY_CTHL_CL_MotorStep = 3;  
      bCL_OK_FLG = 1;
      XY_CTHL_CL_MotorDelay = dwTickCount + 40;  //ʱػ
    }
    break; 
  case 3: 
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      XY_CTHL_CL_MotorStep = 50;  
    }
    break;
    //дλ  
  case 20: //˴öλ
    if(cXcxcrCnt > 0)
    {
      XY_CTHL_LENTH = XY_CTHL_PARAM_CXDW_Length + 30; 
      XY_CTHL_CL_MotorStep = 21;
    }
    else
    {
      XY_CTHL_LENTH = XY_CTHL_PARAM_CXDW_Length ;
      XY_CTHL_CL_MotorStep = 21;
    }         
    break;
  case 21:
    SetDir(Y_AXIS, DIR_P);
    AxisMovePosAccDec(Y_AXIS,8000,XY_CTHL_LENTH,800,500,6,6,50);            
    XY_CTHL_CL_MotorStep = 22; 
    break;
  case 22: 
    if(!Y_DRV || (dwYRealPos >= XY_CTHL_LENTH)) //λѾ
    {
      AxisEgmStop(Y_AXIS);
      XY_CTHL_YsaveCXDWPosBuff = 0;
      XY_CTHL_CL_MotorStep = 0;                       
    } 
    break;
    //ԭ㿪ʼ
  case 40: 
    //Ҫ뿪    
    if(XY_CTHL_SF_Origin_IN && (GetEn(Y_AXIS) == MOTOR_DISEN))  
    {
      XY_CTHL_CL_MotorStep = 41; 
      SetDir(Y_AXIS, DIR_P);
    }    
    else  
    {
      SetDir(Y_AXIS, DIR_N);
      XY_CTHL_CL_MotorStep = 46;
      
    }    
    if(GetEn(Y_AXIS) == MOTOR_DISEN) 
    {
      SetEn(Y_AXIS, MOTOR_EN);
      XY_CTHL_CL_MotorDelay = dwTickCount + 260;   //ʱ
      
    }
    else  //Ѿ
      XY_CTHL_CL_MotorDelay = dwTickCount + 5;            
    break;
  case 41:
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      XY_CTHL_CL_MotorStep = 42; 
      AxisContinueMoveAcc(Y_AXIS,5000,DIR_P,1000,800,15,15);
    }
    break;
  case 42:
    if(!XY_CTHL_SF_Origin_IN)
    {
      XY_CTHL_CL_MotorStep = 43; 
      XY_CTHL_YSavePosBuff = dwYRealPos;
    }
    break;
  case 43:    
    //뿪ԭ5CMֹͣ
    if((dwYRealPos - XY_CTHL_YSavePosBuff) >= 800)
    {
      AxisEgmStop(Y_AXIS);
      XY_CTHL_CL_MotorStep = 46; //ռ
      XY_CTHL_CL_MotorDelay = dwTickCount + 50;  
    }
    break;
  case 46:  
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      XY_CTHL_CL_MotorStep = 47; //صԭλ
      if(!XY_CTHL_SF_Origin_IN)
        AxisContinueMoveAcc(Y_AXIS,1500,DIR_N,1000,800,15,10);
    }
    break;
  case 47: 
    if(XY_CTHL_SF_Origin_IN)
    {
      XY_CTHL_CL_MotorStep = 0;       
      AxisEgmStop(Y_AXIS); 
      SetPos(Y_AXIS, 0);
    }    
    break;
    //ػԭλ (ΪԶSONһֱûɿ)  
  case 50: 
    if(dwYRealPos > 150)
    {  //ٶ
      SetDir(Y_AXIS, DIR_N);
      AxisMovePosAccDecNotStop(Y_AXIS,XY_CTHL_PARAM_CL_Back_O_Speed,-dwYRealPos + 150,5000,2000,10,50,50);
      
      
    } 
    else
      AxisContinueMoveAcc(Y_AXIS,1000,DIR_N,1000,1000,15,15);
    XY_CTHL_CL_MotorStep = 51; 
    break;
  case 51: 
    if(XY_CTHL_SF_Origin_IN)
    {
      XY_CTHL_CL_MotorStep = 0;       
      AxisEgmStop(Y_AXIS); 
      SetPos(Y_AXIS, 0);
    } 
    break;
    
  }
#endif
  
#if 1
  //1ʼ,  ȿʼ
  //20ʼ  λʼ
  //40,ԭΪ
  switch(XY_CTHL_CL_MotorStep)
  {
    //볤λ
  case 1:     
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      if(XY_CTHL_SF_Origin_IN)
      {
        if(!XY_CTHL_PARAM_AUTO_MODE) 
        {
          //볤Ҫݼⳤȼһδ1CM,ת2CM
          if(XY_CTHL_LianLengthAutoCheck <= 700)
          {
            XY_CTHL_Y_CL_Length=XY_CTHL_LianLengthAutoCheck-200;
            if(XY_CTHL_Y_CL_Length<10)
              XY_CTHL_Y_CL_Length=200;
            if(XY_CTHL_Y_CL_Length >= XY_CTHL_PARAM_CL_MAX_Length)
              XY_CTHL_Y_CL_Length = XY_CTHL_PARAM_CL_MAX_Length-40;  
            AxisMovePosAccDec(Y_AXIS,XY_CTHL_PARAM_CL_Speed,XY_CTHL_Y_CL_Length,800,600,6,6,50);     
          }
          else if(XY_CTHL_LianLengthAutoCheck>700)
          {
            
            user_datas[123] =XY_CTHL_LianLengthAutoCheck;
            if(cZipCnt>1)
              XY_CTHL_Y_CL_Length=XY_CTHL_LianLengSave-XY_CTHL_PARAM_HLTSY_LENTH-300;
            else
            {
              if(cZipCnt<1)
                XY_CTHL_Y_CL_Length=XY_CTHL_LianLengthAutoCheck-XY_CTHL_PARAM_HLTSY_LENTH-100;
              else
                XY_CTHL_Y_CL_Length=XY_CTHL_LianLengthAutoCheck-XY_CTHL_PARAM_HLTSY_LENTH-300; 
            }
            
            if(XY_CTHL_Y_CL_Length<200)
              XY_CTHL_Y_CL_Length=200;   
            if(XY_CTHL_Y_CL_Length >= XY_CTHL_PARAM_CL_MAX_Length)
              XY_CTHL_Y_CL_Length = XY_CTHL_PARAM_CL_MAX_Length-40;  
            AxisMovePosAccDec(Y_AXIS,XY_CTHL_PARAM_CL_Speed,XY_CTHL_Y_CL_Length,800,600,6,6,50); 
            
          }
          
        }
        
        else
        {
          if(XY_CTHL_PARAM_CL_Length >= XY_CTHL_PARAM_CL_MAX_Length)
            XY_CTHL_PARAM_CL_Length = XY_CTHL_PARAM_CL_MAX_Length;
          //볤Ҫݼⳤȼһδ1CM,ת2CM
          if((XY_CTHL_LianLengthAutoCheck < (XY_CTHL_PARAM_CL_Length + 500 )) && bRunning) 
            AxisMovePosAccDec(Y_AXIS,XY_CTHL_PARAM_CL_Speed,(XY_CTHL_LianLengthAutoCheck-500),800,600,6,6,50);       
          else
            AxisMovePosAccDec(Y_AXIS,XY_CTHL_PARAM_CL_Speed,(XY_CTHL_PARAM_CL_Length-100),800,600,6,6,50); 
          
        }
        XY_CTHL_CL_MotorStep = 2; 
      }
    }
    break;
  case 2:
    if(XY_CTHL_PARAM_AUTO_MODE)
    {
      if((dwYRealPos + 120) > XY_CTHL_PARAM_CL_Length)
        XY_CTHL_HLJJ_VAVLE = 0;
      if(!Y_DRV || dwYRealPos >= XY_CTHL_PARAM_CL_Length)  
      {
        XY_CTHL_HLJJ_VAVLE = 0;
        XY_CTHL_CL_MotorStep = 3;  
        bCL_OK_FLG = 1;
        XY_CTHL_CL_MotorDelay = dwTickCount + 30;  //ʱػ
      }
    }
    else
    {
      if((dwYRealPos + 120) > XY_CTHL_Y_CL_Length)
        XY_CTHL_HLJJ_VAVLE = 0;
      if(!Y_DRV || dwYRealPos >= XY_CTHL_Y_CL_Length)  
      {
        XY_CTHL_HLJJ_VAVLE = 0;
        XY_CTHL_CL_MotorStep = 3;  
        bCL_OK_FLG = 1;
        XY_CTHL_CL_MotorDelay = dwTickCount + 30;  //ʱػ
      }
      
    }
    break; 
  case 3: 
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      XY_CTHL_CL_MotorStep = 50;  
    }
    break;
    //дλ  
  case 20: //˴öλ
    if(cXcxcrCnt > 0)
    {
      if(cXcxcrCnt==1)
        XY_CTHL_LENTH = XY_CTHL_PARAM_CXDW_Length+XY_CTHL_PARAM_TDFZ_LENTH + 50; 
      if(cXcxcrCnt>1)
        XY_CTHL_LENTH = XY_CTHL_PARAM_CXDW_Length +XY_CTHL_PARAM_TDFZ_LENTH + 120;
      XY_CTHL_CL_MotorStep = 21;
    }
    else
    {
      XY_CTHL_LENTH = XY_CTHL_PARAM_CXDW_Length ;
      XY_CTHL_CL_MotorStep = 21;
    }    
    break;
  case 21:
    if(XY_CTHL_SF_Origin_IN)
    {
      SetDir(Y_AXIS, DIR_P);
      XY_CTHL_Y_CL_PosBuff = dwYRealPos;
      AxisMovePosAccDec(Y_AXIS,20000,XY_CTHL_LENTH,800,500,6,6,50);            
      XY_CTHL_CL_MotorStep = 22; 
    }
    break;
  case 22: 
    if(dwYRealPos >= XY_CTHL_Y_CL_PosBuff+XY_CTHL_LENTH-XY_CTHL_PARAM_CXDW_Length) //λѾ
    {
      XY_CTHL_CXSCDW_VAVLE = 1;                     
    }
    
    if(!Y_DRV || (dwYRealPos >= XY_CTHL_Y_CL_PosBuff+XY_CTHL_LENTH)) //λѾ
    {
      AxisEgmStop(Y_AXIS);
      XY_CTHL_YsaveCXDWPosBuff = 0;
      XY_CTHL_CL_MotorStep = 0;                       
    } 
    
    break;
  case 30:
    XY_CTHL_YsaveCXDWPosBuff = 0;
    XY_CTHL_CL_MotorStep = 0;  
    break;
    //ԭ㿪ʼ
  case 40: 
    //Ҫ뿪    
    if(XY_CTHL_SF_Origin_IN && (GetEn(Y_AXIS) == MOTOR_DISEN))  
    {
      XY_CTHL_CL_MotorStep = 41; 
      SetDir(Y_AXIS, DIR_P);
    }    
    else  
    {
      SetDir(Y_AXIS, DIR_N);
      XY_CTHL_CL_MotorStep = 46;
      
    }    
    if(GetEn(Y_AXIS) == MOTOR_DISEN) 
    {
      SetEn(Y_AXIS, MOTOR_EN);
      XY_CTHL_CL_MotorDelay = dwTickCount + 260;   //ʱ
      
    }
    else  //Ѿ
      XY_CTHL_CL_MotorDelay = dwTickCount + 5;            
    break;
  case 41:
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      XY_CTHL_CL_MotorStep = 42; 
      AxisContinueMoveAcc(Y_AXIS,5000,DIR_P,1000,800,15,15);
    }
    break;
  case 42:
    if(!XY_CTHL_SF_Origin_IN)
    {
      XY_CTHL_CL_MotorStep = 43; 
      XY_CTHL_YSavePosBuff = dwYRealPos;
    }
    break;
  case 43:    
    //뿪ԭ5CMֹͣ
    if((dwYRealPos - XY_CTHL_YSavePosBuff) >= 800)
    {
      AxisEgmStop(Y_AXIS);
      XY_CTHL_CL_MotorStep = 46; //ռ
      XY_CTHL_CL_MotorDelay = dwTickCount + 50;  
    }
    break;
  case 46:  
    if(dwTickCount >= XY_CTHL_CL_MotorDelay)
    {
      XY_CTHL_CL_MotorStep = 47; //صԭλ
      if(!XY_CTHL_SF_Origin_IN)
        AxisContinueMoveAcc(Y_AXIS,1500,DIR_N,1000,800,15,10);
    }
    break;
  case 47: 
    if(XY_CTHL_SF_Origin_IN)
    {
      XY_CTHL_CL_MotorStep = 0;       
      AxisEgmStop(Y_AXIS); 
      SetPos(Y_AXIS, 0);
    }    
    break;
    //ػԭλ (ΪԶSONһֱûɿ)  
  case 50: 
    if(dwYRealPos > 151)
    {  //ٶ          
      SetDir(Y_AXIS, DIR_N);
      AxisMovePosAccDecNotStop(Y_AXIS,XY_CTHL_PARAM_CL_Back_O_Speed,-dwYRealPos + 150,5000,2500,30,200,00);
    } 
    else
      AxisContinueMoveAcc(Y_AXIS,1000,DIR_N,1000,1000,15,15);
    XY_CTHL_CL_MotorStep = 51; 
    break;
  case 51: 
    if(XY_CTHL_SF_Origin_IN)
    {
      XY_CTHL_CL_MotorStep = 0;       
      AxisEgmStop(Y_AXIS); 
      SetPos(Y_AXIS, 0);
    } 
    break;
    
  }
#endif      
}



//װͷ
void XY_CTHL_ZLT_Step(void)
{
  
  switch(XY_CTHL_ZhuangLiaoStep)
  {
  case 1:
    
    if(bZhuangLiaoOkFlg)
    {
      XY_CTHL_ZhuangLiaoStep = 0;
    }
    else if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)
    {
      
      if(((XY_CTHL_MGuo_VAVLE && XY_CTHL_LTou_Check) || (!XY_CTHL_MGuo_VAVLE)) && !XY_CTHL_JLiao_Limit_IN  )//˵ûͷ
      {       
        //ͷģһδԭλ,ϲ
        if(XY_CTHL_CTM_Origin_IN && !XY_CTHL_CTXM_VAVLE)
        {  
          XY_CTHL_First_CT_VAVLE = 0;
          XY_CTHL_JLTou_VAVLE = 0;
          XY_CTHL_MGuo_VAVLE = 0;                     
          if(XY_CTHL_TLiaoStep == 0)
          {
            XY_CTHL_TLiaoStep = 1;        
            XY_CTHL_ZhuangLiaoStep = 2; 
          }
        }
        
        else if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay + 500)  //뱣֤ͷģһδԭλ,ϲ
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_CTM_Origin_ALARM,bRunning);
          
        }  
      }
      else  //Ѿͷֱ
      {
        XY_CTHL_ZhuangLiaoDelay = dwTickCount + 40;
        XY_CTHL_ZhuangLiaoStep = 9;
      }  
    }
    break;            
  case 2:        
    if(XY_CTHL_TLiaoStep == 0)  //Ѿ
    {
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
      XY_CTHL_JLTou_VAVLE = 0;
      XY_CTHL_MGuo_VAVLE = 0;   
      if(!XY_CTHL_JLiao_Limit_IN && XY_CTHL_First_CT_Origin_IN)
      {
        XY_CTHL_ZhuangLiaoStep = 3;
        XY_CTHL_HSLiao_VAVLE = 1;   
      }
    }
    break;
  case 3:
    //͵λ
    if(XY_CTHL_HSLiao_Limit_IN && !XY_CTHL_HSLiao_Origin_IN)
    {
      XY_CTHL_ZhuangLiaoStep = 4;
      //                XY_CTHL_JLTou_VAVLE = 1;    //ͷ,Ҫʱ
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + 5;
    }
    else if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_HSLiao_Limit_ALARM,bRunning);
    }
    break;
  case 4:
    if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)
    {
      XY_CTHL_ZhuangLiaoStep = 5;
      XY_CTHL_JLTou_VAVLE = 1;    //ͷ,Ҫʱ
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
    }  
    break;
  case 5:    
    if(XY_CTHL_JLiao_Limit_IN)
    {
      XY_CTHL_ZhuangLiaoStep = 6;
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + XY_CTHL_PARAM_MaGou_DELAY;
    }
    else if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)  //ͷ()ź쳣
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_JLiao_Limit_ALARM,bRunning);
    }
    break;
  case 6:       
    if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)  //ʱ빴
    {
      XY_CTHL_MGuo_VAVLE = 1; //빴
      XY_CTHL_ZhuangLiaoStep = 7;
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + XY_CTHL_PARAM_HSLiaoOff_DELAY;
      bTuiLaTouOkFlg = 0;   //Ϊͷû
    }
    break;
  case 7:  
    if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)
    {
      XY_CTHL_HSLiao_VAVLE = 0; 
      XY_CTHL_ZhuangLiaoStep = 8;
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
    }
    break;
  case 8:  
    if(!XY_CTHL_HSLiao_Limit_IN)  //
    {
      XY_CTHL_ZhuangLiaoStep = 9;
      XY_CTHL_TLiaoStep = 1; //ͷ
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + XY_CTHL_PARAM_CheckLT_DELAY;   //ҲǸģʱ
    }          
    else if (XY_CTHL_LTou_Check)  //ʱź˵ûͷ
    {
      //3
      XY_CTHL_TryCnt++;
      XY_CTHL_JLTou_VAVLE = 0;    //ͷ
      XY_CTHL_MGuo_VAVLE = 0;     //빴
      if(XY_CTHL_TryCnt >= 3)
      {
        XY_CTHL_TryCnt = 0;
        bZhuangLiaoOkFlg = 0;
        XY_CTHL_ZhuangLiaoStep = 0;
        XY_CTHL_SetAlarmCode(XY_CTHL_ZLT_ALARM,bRunning);
        cWULATOUCnt=1;
      }
      else
      {
        XY_CTHL_ZhuangLiaoStep = 20;    //3   
        XY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
      }  
    }
    else if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_HSLiao_Limit_ALARM,bRunning);
      if(bRunning)
      {
        XY_CTHL_ZhuangLiaoStep = 0 ;
      }  
    }  
    break;
  case 9:   
    if(XY_CTHL_LTou_Check)  //ʱź˵ûͷ
    {
      XY_CTHL_TryCnt++;
      XY_CTHL_JLTou_VAVLE = 0;    //ͷ
      XY_CTHL_MGuo_VAVLE = 0;     //빴
      if(XY_CTHL_TryCnt >= 3)
      {
        XY_CTHL_TryCnt=0;
        bZhuangLiaoOkFlg = 0;
        XY_CTHL_ZhuangLiaoStep = 0;
        XY_CTHL_SetAlarmCode(XY_CTHL_ZLT_ALARM,bRunning);
        cWULATOUCnt=1;
      }
      else
      {
        XY_CTHL_ZhuangLiaoStep = 20;    //3   
        XY_CTHL_ZhuangLiaoDelay = dwTickCount + QDCT_VAVLE_ERROR_TIME;
      }  
    }
    else if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)
    {
      bZhuangLiaoOkFlg = 1;
      XY_CTHL_ZhuangLiaoStep = 0;
    }
    break;
    //װͷɹͷ
  case 20: 
    if(XY_CTHL_HSLiao_Origin_IN)
    {
      XY_CTHL_JLTou_VAVLE = 0;    //ͷ
      XY_CTHL_MGuo_VAVLE = 0;     //빴
      XY_CTHL_ZhuangLiaoStep = 1;
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + 10;
    }
    else if(dwTickCount >= XY_CTHL_ZhuangLiaoDelay)
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_HSLiao_Origin_ALARM,bRunning);
    }  
    break;
  }  
}

void XY_CTHL_TLiao_Step(void)
{
  switch(XY_CTHL_TLiaoStep)
  {
  case 1:
    if(bTuiLaTouOkFlg)
    {
      XY_CTHL_TLiaoStep = 0; 
    }
    else
    {
      XY_CTHL_TLiao_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
      XY_CTHL_TLiaoStep = 2;
    }
    break;
  case 2:    //ԭλ
    if(XY_CTHL_HSLiao_Origin_IN && !XY_CTHL_HSLiao_Limit_IN && !XY_CTHL_HSLiao_VAVLE)
    {
      XY_CTHL_TLiao_VAVLE = 1;    //(ͷ)
      XY_CTHL_TLiao_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
      XY_CTHL_TLiaoStep = 3;
    }
    else if(dwTickCount >= XY_CTHL_TLiao_Delay) 
      XY_CTHL_SetAlarmCode(XY_CTHL_HSLiao_Origin_ALARM,1);          
    break;
  case 3:  //ͷλ
    if(XY_CTHL_TLiao_Limit_IN)
    { 
      XY_CTHL_TLiao_Delay = dwTickCount + XY_CTHL_PARAM_TLiao_BACKDELAY;
      XY_CTHL_TLiaoStep = 4;
    }
    else if(dwTickCount >= XY_CTHL_TLiao_Delay) 
      XY_CTHL_SetAlarmCode(XY_CTHL_TLiao_Limit_ALARM,1);        
    break;
  case 4:
    if(dwTickCount >= XY_CTHL_TLiao_Delay)
    {
      XY_CTHL_TLiao_VAVLE       = 0;
      XY_CTHL_TLiao_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME; 
      XY_CTHL_TLiaoStep = 5;
    }
    break;
  case  5:
    if(!XY_CTHL_TLiao_Limit_IN)
    {
      XY_CTHL_TLiaoStep = 0;
      XY_CTHL_TLiao_Delay = dwTickCount;
      bTuiLaTouOkFlg    = 1;
    }
    else if(dwTickCount >= XY_CTHL_TLiao_Delay) 
      XY_CTHL_SetAlarmCode(XY_CTHL_TLiao_Limit_ALARM,0);    
    break;
  } 
  
}
//̿
void XY_CTHL_ZhenDongAction(void)
{
  
#if 0  
  if((XY_CTHL_bDLP || bRunning) && XY_CTHL_ZhenDongPian_OUT && XY_CTHL_PARAM_DALIAOPIAN)
  {        
    if(CT_DLP_Time >= dwTickCount)
    {
      CT_ZDP_Delay = dwTickCount + CT_PARAM_DLP_TIME + 40;  
      CT_DaLaPian_VAVLE = ~CT_DaLaPian_VAVLE;
    }
  }
  else
    CT_DaLaPian_VAVLE = 0;   
#endif
  
#if 1  
  
  //    if(bRunning)
  //    {
  switch(XY_CTHL_PARAM_ZDP_AUTO)
  {
  case 0:
    if(XY_CTHL_ZhenDongPian_OUT == 0)
    {
      if(!XY_CTHL_ZDP_IN)
      {
        if(dwTickCount >= XY_CTHL_ZDP_Delay)
        {
          XY_CTHL_ZhenDongPian_OUT = 1;
          XY_CTHL_ZDP_Delay = dwTickCount + XY_CTHL_PARAM_ZDP_Stop_TIME;//XY_CTHL_PARAM_ZDP_Stop_TIME + 50;
        }
      }
      else
      {
        XY_CTHL_ZDP_Delay = dwTickCount + XY_CTHL_PARAM_ZDP_Start_TIME;//XY_CTHL_PARAM_ZDP_Start_TIME;
      }   
    }
    else
    {  
      if(XY_CTHL_ZDP_IN)
      {  
        if(dwTickCount >= XY_CTHL_ZDP_Delay)
        {
          XY_CTHL_ZhenDongPian_OUT = 0;  
          XY_CTHL_ZDP_Delay = dwTickCount + XY_CTHL_PARAM_ZDP_Start_TIME;//XY_CTHL_PARAM_ZDP_Start_TIME
        }
      }
      else
        XY_CTHL_ZDP_Delay = dwTickCount + XY_CTHL_PARAM_ZDP_Stop_TIME;//XY_CTHL_PARAM_ZDP_Stop_TIME+ 50;
    }
    break;
  case 1:
    XY_CTHL_ZhenDongPian_OUT=0;
    XY_CTHL_ZDP_Delay = dwTickCount;
    break;
  case 2:     
    XY_CTHL_ZhenDongPian_OUT=1;
    XY_CTHL_ZDP_Delay = dwTickCount;
    break;
  }    
  if(XY_CTHL_ZhenDongPian_OUT)
  {
    if(XY_CTHL_PARAM_LaPian_EN)
    {
      if(dwTickCount >= XY_CTHL_DLP_Delay)
      {
        
        XY_CTHL_DaLaPian_OUT = !XY_CTHL_DaLaPian_OUT;
        
        if(XY_CTHL_DaLaPian_OUT)
          XY_CTHL_DLP_Delay = dwTickCount + XY_CTHL_PARAM_DaLaPian;
        else
          XY_CTHL_DLP_Delay = dwTickCount + XY_CTHL_PARAM_DaLaPian+50;
      }  
    }
    else
      XY_CTHL_DaLaPian_OUT = 0;      
  }
  else
    XY_CTHL_DaLaPian_OUT = 0;
#endif    
}
void XY_CTHL_bFKCXTDDWStep(void)
{
  switch(XY_CTHL_bFKCXTDDW_Step)
  {
  case 1:
    XY_CTHL_FKJD_VAVLE = 1;   //д
    XY_CTHL_XKTD_VAVLE = 1;   //бƴ    
    XY_CTHL_FKGD_VAVLE = 0;     //̶
    XY_CTHL_bFKCXTDDW_Step = 2;
    
    break;
  case 2: 
    if(!XY_CTHL_XKTD_Origin_IN)  //бƴԭλ뿪
    {
      XY_CTHL_bFKCXTDDW_Step = 3;
      XY_CTHL_bFKCXTDDW_Delay = dwTickCount + 20;
    }  
    break;
  case 3://бڶλ
    if(dwTickCount >= XY_CTHL_bFKCXTDDW_Delay)
    {
      XY_CTHL_XKDW_VAVLE = 1;
      XY_CTHL_bFKCXTDDW_Step = 4;
      //         XY_CTHL_bFKCXTDDW_Delay = dwTickCount + XY_CTHL_PARAM_XKDW_TD_DELAY;
    }  
    break;
  case 4:
    if(dwTickCount >= XY_CTHL_bFKCXTDDW_Delay)
    {
      AxisContinueMoveAcc(X_AXIS,1200,DIR_P,800,600,10,10);//ϴ                       
      XY_CTHL_bFKCXTDDW_Step = 5;
      XY_CTHL_XSavePosBuff = dwXRealPos;
      SetPos(X_AXIS, 0);  //λΪ0
      dwXRealPos = 0;
    }
    break;
  case 5:
    if(XY_CTHL_XKSC_Limit_IN)   //鵽λ
    {
      AxisEgmStop(X_AXIS);
      XY_CTHL_QDXK_VAVLE=1;
      XY_CTHL_bFKCXTDDW_Step = 6;
      XY_CTHL_XKTD_VAVLE = 0;   //бƴ׹ر 
      XY_CTHL_bFKCXTDDW_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
      
    }
    else if(dwXRealPos >= (XY_CTHL_XSavePosBuff + 800))
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_FKCXDW_ALARM,bRunning);//λ쳣
      
    }  
    break;
  case 6:  
    if(XY_CTHL_PARAM_TDFZ_LENTH && !X_DRV)  //ϴת
      AxisMovePosAccDec(X_AXIS,8000,-XY_CTHL_PARAM_DXKFZ_LENTH,800,600,6,6,0); 
    if(XY_CTHL_PARAM_CXXY_MODE)
      XY_CTHL_CXXY_VAVLE = 1;
    XY_CTHL_bFKCXTDDW_Step = 0;
    break;
    
  }  
}

//붯
void XY_CTHL_bCXCRStep(void)
{
  switch(XY_CTHL_bCXCR_Step)
  {
  case 11:
    XY_CTHL_XKTD_VAVLE = 1;   //бƴ    
    XY_CTHL_FKGD_VAVLE = 0;     //̶
    XY_CTHL_CXSCDW_VAVLE=1;
    XY_CTHL_bCXCR_Step = 12;      
    
    break;
  case 12: 
    if(!XY_CTHL_XKTD_Origin_IN)  //бƴԭλ뿪
    {
      XY_CTHL_bCXCR_Step = 13;
      //     XY_CTHL_CXQJD_VAVLE = 1;    //ǰд  
      XY_CTHL_bCXCR_Delay = dwTickCount + 20;
    }  
    break;
  case 13: 
    if((XY_CTHL_CL_MotorStep == 0) && (XY_CTHL_SF_Origin_IN) && (dwTickCount >= XY_CTHL_bCXCR_Delay))  //ǰдصԭλ
    {
      XY_CTHL_bCXCR_Step = 14; 
      //  XY_CTHL_FKGD_VAVLE = 1;     //̶
      XY_CTHL_CXQJD_VAVLE = 1;    //ǰд                    
      XY_CTHL_bCXCR_Delay = dwTickCount + XY_CTHL_PARAM_XCQJD_XCDW_DELAY+100;
    }
    break;
  case 14:
    if(dwTickCount >= XY_CTHL_bCXCR_Delay)
    {
      XY_CTHL_bCXCR_Step = 15; 
      XY_CTHL_FKGD_VAVLE = 1;     //̶
      //Y
      XY_CTHL_CL_MotorStep = 20;  //λ                   
    }
    break;
  case 15:   
    if(XY_CTHL_CL_MotorStep == 0)   //λ
    {
      XY_CTHL_bCXCR_Step = 16; 
      XY_CTHL_CXDWZ_VAVLE = 1;    //λ(λ)ŷ
      XY_CTHL_bCXCR_Delay = dwTickCount + 10;  //ʱ
    }  
    break;
  case 16: 
    if(dwTickCount >= XY_CTHL_bCXCR_Delay)
    {
      XY_CTHL_bCXCR_Step = 17;
      if(XY_CTHL_PARAM_CXXY_MODE)
        XY_CTHL_CXXY_VAVLE = 0;
      else
        XY_CTHL_CXXY_VAVLE = 1;     //Y06 Ƶŷ
      if(XY_CTHL_PARAM_NLSL_MODE == 0)
        XY_CTHL_bCXCR_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;  //쳣ʱ
      else
        XY_CTHL_bCXCR_Delay = dwTickCount + 80;  //쳣ʱ
    }
    break;
  case 17:   
    if((XY_CTHL_CXXY_Limit_IN) || XY_CTHL_PARAM_NLSL_MODE)
    {
      
      if(XY_CTHL_CXXY_Limit_IN || (dwTickCount >= XY_CTHL_bCXCR_Delay))
      {
        XY_CTHL_bCXCR_Step = 18; 
        if( cXcxcrCnt==0 && !X_DRV)  //ϴת
        {
          AxisMovePosAccDec(X_AXIS,10000,-XY_CTHL_PARAM_TDFZ_LENTH,800,600,6,6,0);
        }
        XY_CTHL_CXQJD_VAVLE = 0;    //ǰдŷ
        XY_CTHL_CXSCDW_VAVLE = 0;   //Y21 ֹλ                    
        XY_CTHL_CXHJD_VAVLE = 1;         //Y14 д
        XY_CTHL_bCXCR_Delay = dwTickCount + XY_CTHL_PARAM_SCDWOff_CXDW_DELAY;
        
      }
    }  
    else if(dwTickCount >= XY_CTHL_bCXCR_Delay)  
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_CXXY_Limit_ALARM,bRunning);//쳣
      
    }
    break;
  case 18:   
    //              if(START_IN_UP)
    {
      if(dwTickCount >= XY_CTHL_bCXCR_Delay) 
      {
        XY_CTHL_bCXCR_Step = 19; 
        
        XY_CTHL_CXHDW_VAVLE = 1;     //λ()
        XY_CTHL_bCXCR_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME +1000;  //뵽λ쳣ʱ
        XY_CTHL_CL_MotorStep = 50;  //ԭ
      }
    }
    break;
  case 19:  
    if( cXcxcrCnt > 1)  
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_CX_Limit_ALARM,bRunning); //뵽λ쳣  
    }
    
    if( XY_CTHL_CX_Limit_IN  &&  cXcxcrCnt<2 )
    {
      cXcxcrCnt=0;
      bZhuangLiaoOkFlg = 0;
      XY_CTHL_bCXCR_Step = 0;
      XY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
      
    } 
    else if (dwTickCount >= XY_CTHL_bCXCR_Delay)
    {
      cXcxcrCnt++;
      
      XY_CTHL_CXHJD_VAVLE=0;
      XY_CTHL_CXHDW_VAVLE=0;
      XY_CTHL_CXDWZ_VAVLE = 0;
      if(XY_CTHL_PARAM_CXXY_MODE)
        XY_CTHL_CXXY_VAVLE = 0;
      else
        XY_CTHL_CXXY_VAVLE = 1;     //Y06 Ƶŷ
      XY_CTHL_bCXCR_Step = 11;
    }
    
    break;
  }
}

void XY_CTHL_bCLFirstStep(void)
{
  switch(XY_CTHL_bCLFirst_Step)
  {
  case 19:   
    XY_CTHL_JLTou_VAVLE = 0;        //ͷ
    bZhuangLiaoOkFlg = 0;
    XY_CTHL_bCLFirst_Step = 20;
    XY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
    XY_CTHL_CXXY_VAVLE = 0;     //Y06 Ƶŷ
    XY_CTHL_bCLFirst_Delay = dwTickCount + XY_CTHL_PARAM_First_CL_DELAY;//ʱһδ
    break;
  case 20:  
    if(dwTickCount >= XY_CTHL_bCLFirst_Delay) 
    {
      XY_CTHL_bCLFirst_Step = 21;
      XY_CTHL_First_CT_VAVLE = 1;   //һδŷ
      XY_CTHL_bCLFirst_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
    }
    break;
  case 21:   
    if(!XY_CTHL_First_CT_Origin_IN)  //ԭ뿪ſʼʱ
    {
      XY_CTHL_bCLFirst_Step = 22;
      XY_CTHL_bCLFirst_Delay = dwTickCount + XY_CTHL_PARAM_First_CL_Timer;  //һδʱ
    }
    else if(dwTickCount >= XY_CTHL_bCLFirst_Delay) 
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_YCCRYWYC_ALARM,bRunning); //һδԭλ쳣
    }
    break;
  case 22:
    if(dwTickCount >= XY_CTHL_bCLFirst_Delay) 
    {
      XY_CTHL_bCLFirst_Step = 23;                                     
      XY_CTHL_MGuo_VAVLE = 0;     //빴
      XY_CTHL_bCLFirst_Delay = dwTickCount + XY_CTHL_PARAM_MGOff_XiaMo_DELAY;
      XY_CTHL_FKGD_VAVLE = 0;     //̶
      XY_CTHL_CXHJD_VAVLE = 0;    //Y14 д 
      XY_CTHL_CXXY_VAVLE = 0;     //Y06 Ƶŷ
    } 
    break;
  case 23:  
    if(dwTickCount >= XY_CTHL_bCLFirst_Delay) 
    {
      XY_CTHL_bCLFirst_Step = 24;
      XY_CTHL_CTXM_VAVLE = 0; //ͷģ½
      XY_CTHL_CXHDW_VAVLE = 0;     //λ()ر
      XY_CTHL_bCLFirst_Delay = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
    } 
    break;
  case 24: 
    if(!XY_CTHL_CTM_Limit_IN)
    {
      XY_CTHL_bCLFirst_Step= 25;
      XY_CTHL_bCLFirst_Delay = dwTickCount + 25;  //һδʱ
    }
    else if(dwTickCount >= XY_CTHL_bCLFirst_Delay) 
    {
      XY_CTHL_SetAlarmCode(XY_CTHL_CTM_Origin_ALARM,bRunning); //ͷģ½쳣
    }
    break;
  case 25:
    if(dwTickCount >= XY_CTHL_bCLFirst_Delay) 
    {
      
      XY_CTHL_bCLFirst_Step= 0;
      XY_CTHL_First_CT_VAVLE = 0;   //һδŷ
      XY_CTHL_CXHDW_VAVLE = 0;     //λ()ر
      
      
      //³
      XY_CTHL_AutoDelay1 = dwTickCount + XY_CTHL_VAVLE_ERROR_TIME;
      XY_CTHL_AutoStep1 = 1;
      bTuiLaTouOkFlg = 1;
    }
    break;
  }
}
//ֶ
void XY_CTHL_ManualAction(void)
{ 
  if(bRunning) // е
  {
    XY_CTHL_Run_State=1;
    XY_CTHL_Stop_State=0;
  }
  else 
  {
    XY_CTHL_Stop_State=1;
    XY_CTHL_Run_State=0;
  }
  
  if((XY_CTHL_SF_ALR_IN && (XY_CTHL_PARAM_DB_MODE == 1))|| (((GetAlarm(Y_AXIS)==0) || (GetAlarm(X_AXIS)==0)) && (XY_CTHL_PARAM_DB_MODE == 0))) // ŷ
  {
    cCHULIANBAOJIN=1;
    XY_CTHL_SetAlarmCode(XY_CTHL_SF_ALR_ALARM,0);
  }
  if(dwTickCount >= XY_CTHL_bSFBBAOJIN_Delay)  
  {
    XY_CTHL_SF_ALR_CLR=0;
    SetClr(Y_AXIS,MOTOR_ALARM);
    SetClr(X_AXIS,MOTOR_ALARM);
  }
  
  if(bRunning == 0)  
  {   
    if(bClearTotal) //жϼ
    {
      bClearTotal       = 0;
      ClrcToTal(QDCT_TOTAL_ADDR);
    }
    if(XY_CTHL_bTLiao )                 //ֶ(ͷ)
    {
      XY_CTHL_bTLiao = 0;           
      if(XY_CTHL_TLiao_VAVLE)
        XY_CTHL_TLiao_VAVLE = 0;//XY_CTHL_TLiao_VAVLE; 
      else if(!XY_CTHL_HSLiao_VAVLE && XY_CTHL_HSLiao_Origin_IN)
      {
        XY_CTHL_TLiao_VAVLE = 1;
      } 
      else//
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_HENSONGLIAO_ALARM,0); // ϲ
      }
      
    } 
    
    if(XY_CTHL_bHSL)     //ֶ   
    {
      XY_CTHL_bHSL= 0;
      if(!XY_CTHL_First_CT_VAVLE)
      {
        if(XY_CTHL_HSLiao_VAVLE)
        {
          XY_CTHL_HSLiao_VAVLE = 0;//~XY_CTHL_HSLiao_VAVLE;
        }
        else if(!XY_CTHL_TLiao_VAVLE && !XY_CTHL_TLiao_Limit_IN && XY_CTHL_CTM_Origin_IN && !XY_CTHL_JLiao_Limit_IN &&
                !XY_CTHL_JLTou_VAVLE && !XY_CTHL_CTXM_VAVLE && !XY_CTHL_CXDWZ_VAVLE && (!XY_CTHL_bMG || (XY_CTHL_bMG && XY_CTHL_LTou_Check)))
        {
          XY_CTHL_HSLiao_VAVLE = 1;
        }  
        else   //  һΪѾͷ
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_YCCT_ALARM,0); 
        }  
      }
    }           
    if(XY_CTHL_bJLT)                  //ͷ
    {
      XY_CTHL_bJLT = 0;
      if(XY_CTHL_JLTou_VAVLE)
        XY_CTHL_JLTou_VAVLE = 0;
      else if(!XY_CTHL_First_CT_VAVLE && !XY_CTHL_CTXM_VAVLE && XY_CTHL_CTM_Origin_IN && XY_CTHL_First_CT_Origin_IN)
      {
        XY_CTHL_MGuo_VAVLE = 0;
        XY_CTHL_JLTou_VAVLE = 1;
      } 
      else//
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_YCXM_Origin_ALARM,0); 
      }
    } 
    if(XY_CTHL_bMG)                   //빴
    {
      XY_CTHL_bMG = 0;
      XY_CTHL_MGuo_VAVLE = !XY_CTHL_MGuo_VAVLE;
    } 
    if(XY_CTHL_bFKJD)                 //д
    {
      XY_CTHL_bFKJD = 0;
      XY_CTHL_FKJD_VAVLE = !XY_CTHL_FKJD_VAVLE;
    } 
    if(XY_CTHL_bXKTD)                  //бƴ
    {
      XY_CTHL_bXKTD = 0;
      if(XY_CTHL_XKTD_VAVLE)
        XY_CTHL_XKTD_VAVLE = 0;
      else if(!XY_CTHL_DXK_VAVLE && (!XY_CTHL_XKSC_Limit_IN  || !XY_CTHL_CTXM_VAVLE|| XY_CTHL_PARAM_NLSL_MODE))
        XY_CTHL_XKTD_VAVLE = 1;
      else//
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_DXKCTXM_Origin_ALARM,0);          
      }
    } 
    if(XY_CTHL_bXKDW)                  //бڶλ
    {
      XY_CTHL_bXKDW = 0;
      XY_CTHL_XKDW_VAVLE = ~XY_CTHL_XKDW_VAVLE;
    } 
    if(XY_CTHL_bCTXM)                  //ͷģ
    {
      XY_CTHL_bCTXM = 0;
      if(XY_CTHL_CTXM_VAVLE )
      {
        if(!XY_CTHL_CXXY_VAVLE)
        {
          XY_CTHL_CTXM_VAVLE = 0;
          XY_CTHL_JLTou_VAVLE = 0;
        }
        else 
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_TXC_Limit_ALARM,0);   
        }
      }    
      else if(!XY_CTHL_HSLiao_VAVLE && XY_CTHL_HSLiao_Origin_IN && (!XY_CTHL_XKSC_Limit_IN || !XY_CTHL_XKTD_VAVLE))                
      {  
        if(XY_CTHL_PARAM_CXXY_MODE)
          XY_CTHL_CXXY_VAVLE = 1;
        XY_CTHL_MGuo_VAVLE = 1;
        XY_CTHL_CTXM_VAVLE = 1;
      }  
    } 
    if(XY_CTHL_bQianDXK)                  //ǰб
    {
      XY_CTHL_bQianDXK = 0;
      if(XY_CTHL_QDXK_VAVLE)
        XY_CTHL_QDXK_VAVLE = 0;
      else if(!XY_CTHL_XKTD_VAVLE)
        XY_CTHL_QDXK_VAVLE = 1;
      else  //
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_XKTD_ALARM,0);   
      } 
    } 
    
    if(XY_CTHL_bDXK)                  //б
    {
      XY_CTHL_bDXK = 0;
      if(!XY_CTHL_PARAM_NLSL_MODE)
      {
        if(XY_CTHL_DXK_VAVLE)
          XY_CTHL_DXK_VAVLE = 0;
        else if(!XY_CTHL_XKTD_VAVLE)
        {
          if(!XY_CTHL_PARAM_NLSL_MODE)
            XY_CTHL_DXK_VAVLE = 1;
        }
        else  //
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_XKTD_ALARM,0);   
        } 
      }
      else
      {
        if(XY_CTHL_XKTD_VAVLE)
          XY_CTHL_XKTD_VAVLE = 0;
        else if(!XY_CTHL_DXK_VAVLE )
        {
          if(!XY_CTHL_XKSC_Limit_IN  || !XY_CTHL_CTXM_VAVLE || XY_CTHL_PARAM_NLSL_MODE)
            XY_CTHL_XKTD_VAVLE = 1;
          else
          {
            XY_CTHL_SetAlarmCode(XY_CTHL_YCXM_Origin_ALARM,0);   
          }
        }
        else//
        {
          XY_CTHL_SetAlarmCode(XY_CTHL_DXKCTXM_Origin_ALARM,0);          
        }
        
      }
    } 
    
    if(XY_CTHL_bQianDXK_DXK)
    {
      XY_CTHL_bQianDXK_DXK = 0;
      if(!XY_CTHL_XKTD_VAVLE && XY_CTHL_AutoStep==0)
      {
        cQDXK_DXK=1;
        XY_CTHL_AutoStep = 8;
        SetEn(X_AXIS, MOTOR_EN);
        XY_CTHL_AutoDelay = dwTickCount + 50;
        bRunning=1;
      }
      
    }
    //б
    if(XY_CTHL_bBanZiDong)
    {
      XY_CTHL_bBanZiDong=0;
      cBanAuTo=1;
      //          XY_CTHL_PARAM_BanAuto_MODE=1;
      XY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
      XY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
      XY_CTHL_ZhuangLiaoStep = 1; 
      bTuiLaTouOkFlg = 1;
      bZhuangLiaoOkFlg= 0;
      bCL_EN_FLG=0;
      XY_CTHL_AutoStep = 1;  
      bRunning=1;
    }
    //С
    if(XY_CTHL_CXC)//С
    {
      XY_CTHL_CXC=0;
      cCXCONE=1;
      cBanAuTo=0;
      //    XY_CTHL_PARAM_BanAuto_MODE=0;
      XY_CTHL_AutoStep = 11;  
      bRunning=1;
      if(GetEn(Y_AXIS) == MOTOR_DISEN) 
      {
        SetEn(Y_AXIS, MOTOR_EN);
        XY_CTHL_CL_MotorDelay = dwTickCount + 260;   //ʱ
        
      } 
    }
    
    if(XY_CTHL_bFKGD)                 //̶
    {
      XY_CTHL_bFKGD = 0;
      XY_CTHL_FKGD_VAVLE = ~XY_CTHL_FKGD_VAVLE;
    } 
    if(XY_CTHL_bCXQJD)                 //ǰд
    {
      XY_CTHL_bCXQJD = 0;
      XY_CTHL_CXQJD_VAVLE = ~XY_CTHL_CXQJD_VAVLE;
    } 
    if(XY_CTHL_bCXSY)                 //Ƶŷ
    {
      XY_CTHL_bCXSY = 0;
      XY_CTHL_CXXY_VAVLE = !XY_CTHL_CXXY_VAVLE;
    } 
    if(XY_CTHL_bCXDWZ)                 //Y14 λŷ
    {
      XY_CTHL_bCXDWZ = 0;
      if(XY_CTHL_CXDWZ_VAVLE)
        XY_CTHL_CXDWZ_VAVLE = 0;
      else if(XY_CTHL_HSLiao_Origin_IN)
      {
        XY_CTHL_CXDWZ_VAVLE = 1;
      }
      else //
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_HENSONGLIAO_ALARM,0);   
      }
      
    } 
    if(XY_CTHL_bCXHJD)                 //Y15 дŷ
    {
      XY_CTHL_bCXHJD = 0;
      XY_CTHL_CXHJD_VAVLE =~XY_CTHL_CXHJD_VAVLE;
    } 
    if(XY_CTHL_bCXHDW)                 //Y16 λŷ
    {
      XY_CTHL_bCXHDW = 0;
      if(XY_CTHL_CXHDW_VAVLE)
        XY_CTHL_CXHDW_VAVLE = 0;
      else if(!XY_CTHL_CXQJD_VAVLE)
        XY_CTHL_CXHDW_VAVLE = 1;
      else//
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_CXQJD_ALARM,0);  
      }
    } 
    if(XY_CTHL_bFirst_CT)              //Y20 һδͷŷ
    {
      XY_CTHL_bFirst_CT = 0;
      if( !XY_CTHL_First_CT_VAVLE )
      {
        if(!XY_CTHL_CXXY_VAVLE)
          XY_CTHL_First_CT_VAVLE=1;
        else 
          XY_CTHL_SetAlarmCode(XY_CTHL_TXC_Limit_ALARM,0);   
        
      }
      else if(XY_CTHL_First_CT_VAVLE)
      {
        XY_CTHL_First_CT_VAVLE=0;
      }
      
      
    } 
    if(XY_CTHL_bHLJJ)                  //Y21 оߵŷ
    {
      XY_CTHL_bHLJJ = 0;
      XY_CTHL_HLJJ_VAVLE = ~XY_CTHL_HLJJ_VAVLE;
    } 
    if(XY_CTHL_bCXSCDW)               //Y23 ֹλŷ 
    {
      XY_CTHL_bCXSCDW = 0;
      XY_CTHL_CXSCDW_VAVLE = ~XY_CTHL_CXSCDW_VAVLE;
    } 
    //Զװ
    if(XY_CTHL_bAutoZhuangLiao)
    {
      XY_CTHL_bAutoZhuangLiao = 0;
      if(XY_CTHL_ZhuangLiaoStep == 0)
      {
        bTuiLaTouOkFlg = 1;
        bZhuangLiaoOkFlg = 0;
        XY_CTHL_ZhuangLiaoStep = 1;
        XY_CTHL_MGuo_VAVLE = 1;   //жǷѾ
        XY_CTHL_ZhuangLiaoDelay = dwTickCount + 150;
      }  
    }
    //Ե
    if(XY_CTHL_bCLMotor_N)
    {           
      SetEn(Y_AXIS, MOTOR_EN);
      if(!XY_CTHL_SF_Origin_IN)
      {  
        if(!Y_DRV)
          //                Y       ٶ                    ٶ        ٶ  ٶ
          AxisContinueMoveAcc(Y_AXIS,2000,DIR_N,1000,1000,15,15);
      } 
      else
      {
        XY_CTHL_bCLMotor_N = 0;
      }
      
    }
    
    if(XY_CTHL_bCLMotor_P)  //λѾȡ
    {
      SetEn(Y_AXIS, MOTOR_EN);
      if(!Y_DRV)
        //                Y       ٶ                    ٶ        ٶ  ٶ
        AxisContinueMoveAcc(Y_AXIS,2000,DIR_P,1000,1000,15,15);
    }
    
    if(!XY_CTHL_bCLMotor_P && !XY_CTHL_bCLMotor_N && (XY_CTHL_CL_MotorStep == 0))
    {
      AxisEgmStop(Y_AXIS);//AxisDecStop(Y_AXIS); 
    }
    //ԭ
    if(XY_CTHL_bCLMotor_O)
    {
      XY_CTHL_bCLMotor_O = 0;
      if(XY_CTHL_CL_MotorStep == 0)
        XY_CTHL_CL_MotorStep = 40;
    } 
    //ϴ鶨λ ,ⲽΪǰϴλ, ܶŷҪص       
    if(XY_CTHL_bFKTDDW)
    {
      XY_CTHL_bFKTDDW = 0;
      if(XY_CTHL_TD_MotorStep == 0)
      {
        XY_CTHL_XKDW_VAVLE = 0;     //бڶλ
        XY_CTHL_CXQJD_VAVLE = 0;    //ǰд 
        if(!XY_CTHL_PARAM_CXXY_MODE)     
          XY_CTHL_CXXY_VAVLE = 0;     //
        
        XY_CTHL_CXHJD_VAVLE = 0;    //д 
        XY_CTHL_CXHDW_VAVLE = 0;    //λ
        XY_CTHL_CXDWZ_VAVLE = 0;    //λ
        XY_CTHL_bHLJJ = 0;          //о
        XY_CTHL_FKJD_VAVLE = 0;     //д
        if((GetEn(X_AXIS) == MOTOR_DISEN))
        {
          SetEn(X_AXIS, MOTOR_EN);
          XY_CTHL_TD_MotorDelay = dwTickCount + 200;                    
        } 
        else
          XY_CTHL_TD_MotorDelay = dwTickCount + 50;
        XY_CTHL_TD_MotorStep = 1;
      } 
    } 
    //ϴλ(бƴбڶλб)
    if(XY_CTHL_bFKCXTDDW)
    {
      XY_CTHL_bFKCXTDDW = 0;
      if((XY_CTHL_bFKCXTDDW_Step == 0) && (XY_CTHL_CL_MotorStep == 0) && 
         !XY_CTHL_CTXM_VAVLE)
      {
        XY_CTHL_bFKCXTDDW_Step = 1;
        SetEn(X_AXIS, MOTOR_EN);
        XY_CTHL_CXQJD_VAVLE = 0;    //ǰд 
        XY_CTHL_CXXY_VAVLE = 0;     //
        XY_CTHL_CXHJD_VAVLE = 0;    //д 
        XY_CTHL_CXHDW_VAVLE = 0;    //λ
        XY_CTHL_CXDWZ_VAVLE = 0;    //λ
        XY_CTHL_HLJJ_VAVLE = 0;          //о
      }  
    } 
    //(ǰλ,,,λ)
    if(XY_CTHL_bCXCR) 
    {
      XY_CTHL_bCXCR = 0;
      //ͷģ浽ǲ빴,жͷ
      if(XY_CTHL_CTXM_VAVLE && XY_CTHL_MGuo_VAVLE && !XY_CTHL_CXQJD_VAVLE &&
         XY_CTHL_CTM_Limit_IN && !XY_CTHL_LTou_Check)
      {                
        if(XY_CTHL_CL_MotorStep == 0)
        {
          XY_CTHL_bCXCR_Step = 11; 
          SetEn(Y_AXIS, MOTOR_EN);
          if(!XY_CTHL_SF_Origin_IN)
            XY_CTHL_CL_MotorStep = 40;
        }
      }
      else   //治Զ
      {
        XY_CTHL_SetAlarmCode(XY_CTHL_WFZIDONGCX_ALARM,0);  
      }
    }
    //
    if(XY_CTHL_bMotorHL)
    {
      XY_CTHL_bMotorHL = 0;
      if(XY_CTHL_SF_Origin_IN)
      {
        if((XY_CTHL_CL_MotorStep == 0) && !XY_CTHL_CTXM_VAVLE && (!XY_CTHL_CTM_Limit_IN))
        {
          bCL_OK_FLG = 0;   
          XY_CTHL_HLJJ_VAVLE = 1; //Y20 оߵŷ,
          XY_CTHL_CL_MotorStep = 1;
          XY_CTHL_CL_MotorDelay = dwTickCount + XY_CTHL_PARAM_HLJJ_CL_DELAY + 130;
          if((GetEn(Y_AXIS) == MOTOR_DISEN))
          {
            SetEn(Y_AXIS, MOTOR_EN);
            XY_CTHL_CL_MotorDelay = dwTickCount + 250;                    
          } 
        }
      }
      else
      {
        XY_CTHL_bCLMotor_O =1;
        
      }
    } 
    //һδ
    if(XY_CTHL_bCL_First)
    {
      XY_CTHL_bCL_First = 0;
      //ͷģ浽ǲ빴,жͷ
      if(XY_CTHL_CTXM_VAVLE && XY_CTHL_MGuo_VAVLE && !XY_CTHL_CXQJD_VAVLE &&
         XY_CTHL_CTM_Limit_IN && !XY_CTHL_LTou_Check && (XY_CTHL_CL_MotorStep == 0))
      {  
        XY_CTHL_bCLFirst_Step = 19;
        XY_CTHL_CXHJD_VAVLE = 1;    //д 
        XY_CTHL_CXDWZ_VAVLE = 0;    //λ(λ)ŷ  
        XY_CTHL_CXQJD_VAVLE = 0;    //ǰд 
      }
    }        
  }        
}

#endif
