#ifndef __XYDAKONG_H__
#define __XYDAKONG_H__

#if XIN_YE_MACHINE
//输入说明
//X000      起动  
//X001      停止
//X002      缺料微动开关
//X003      储料上感应
//X004      储料下感应
//X005      过链接近开关
//X006      勾针磁感感应(到位感应)
//X007      勾针气缸上感应(输出到位)
//X010      勾针气缸下感应(关闭到位)
//X011      下模到位光电感应
//X012      上模到位感应
//X013      
		
//输出说明
//NEW 2006/03/22
//输出说明
//Y000	    勾针电磁阀
//Y001      压带针形气缸电磁阀   
//Y002      下模气缸电磁阀 
//Y003      下模吹气电磁阀    
//Y004      上模气缸电磁阀
//Y005      废料吹气电磁阀
//Y006      音波箱	     
//Y007      储带电机(220V最好接另外继电器控制电机)
//
/*
P00		起动速度
P01     加速度
P02		最高速度
P03		空位速度
P04		到位延时停机
P05		下模上到位延时发超声	
P06		发超声波时间
P07		固化时间
P08		下模吹气时间
P09		压带输出时间
P10		废料吹气时间
P11		延时上勾针
P12		0  下模动,  1下模不动
P13     0  过链在空位上亮,  1  空位时灭(链上亮)
P14     可二次超声
P15     延时启动电机
P16     0  合模时先合上模, 1   先合下模
*/

// [ huanghui 2012-3-29
/*********************************************************************************************************
  宏定义
*********************************************************************************************************/
#define __gotoWarningPage()             (user_datas[75] = 11)            /* 跳到警告页面                 */
#define __sendWarning(x)                 user_datas[100] = x              /* 发送警告编号                 */
#define DK_ALARM_ADDR 100
/*
 *      警告类型                     警告编号
 */
#define __W_NO_WARNING                  0                               /* 没警告*/
#define __W_LIAN_JIA_LIMIT              1                               /* 启动条件不足*/
#define __W_LIAN_JIA_ORIGIN             2                               /* 链架上感应异常*/
#define __W_CUTTER_LIMIT                3                               /* 切刀不到位*/
#define __W_NO_ZIP                      4                               /* 没拉链，自动停机*/
#define __W_GZ_LIMIT                    5                               /* 上模不到位*/
#define __W_GZ_OUT                      6                               /* 生产数量到*/
#define __W_GZ_UP_LIMIT                 7                               /* 下模不到位*/
#define __W_MANUAL_CROCHET              8                               /* 手动钩针条件不满足*/
#define __W_SHOU_DONG_YA_DAI            9                               /* 拖带中不能压带*/
#define __W_UP_MODE_INADEQUATE          10                              /* 上模动作条件不满足*/
#define __W_DOWN_MODE_INADEQUATE        11                              /* 下模动作条件不满足*/
#define __W_PRODUCT                     12                              /* 发超声条件不满足*/
#define __W_SAVE_DOOR                   13  
#define __W_KA_DAI                      14 
                       /* 自动切断条件满足*/

#define DK_VAVLE_ERROR_TIME 3000

#define DK_bAlarmStop M20
#endif

#endif

