#ifndef __XYQUE_DUAN_JI_H__
#define __XYQUE_DUAN_JI_H__

#if XIN_YE_MACHINE


extern void QueDuan_Action(void);
extern void QueDuan_InitAction(void);
extern void QueDuanEx_ExtiActionX31(void);
extern void FastTimerAction(void);



#define QD_DIR_P           1
#define QD_DIR_N           0

#define QD_YDIR_P          0
#define QD_YDIR_N          1

#define QD_TOTAL_ADDR      76
#define QD_QIE_DUAN_TOTAL_ADDR 79
#define QD_ALARM_ADDR      100
#define QD_PROSPEED_ADDR   78

/*
 *                           
 */
#define QD_NO_ALARM             	0                               /* û*/
#define QD_NO_ZIPPER_ALARM		1                              	/* ûԶͣ*/
#define QD_KA_DAI_ALARM	         	2                               /* 쳣*/
#define QD_SM_YUANWEI                 	3                               /* ģλ*/ 
#define QD_SM_DAOWEI                 	4                               /* ģλ*/
#define QD_XM_YUANWEI                 	5                               /* ģλ*/ 
#define QD_XM_DAOWEI                 	6                               /* ģλ*/
#define QD_BACK_ALARM                   7                        
#define QD_TOTAL_ALARM                  8
#define QD_TL_ALARM                     9
#define QD_GZ_ALARM                     10
#define QD_JD_ORIGIN_ALARM              11
#define QD_DEC_ALARM                    12
#define QD_BL_ALARM                     17
#define QD_SM_ALARM                     18
#define QD_LENGTH_LONG_ALARM            19
#define QD_LENGTH_SHORT_ALARM           20
#define QD_JD_IN_ALARM                  21
   
#define VAVLE_ALARM_TIME                3000
#define MOTOR_ALARM_TIME                5000


#define QD_PARAM_ZIPPER_LENGTH (user_datas[1] | (user_datas[2] >> 16))
#define QD_PARAM_SET_TOTAL     (user_datas[74] | (user_datas[75] >> 16))
#define QD_PARAM_MAX_BACK_LENGTH (user_datas[42] | (user_datas[43] >> 16))
#define QD_PARAM_ON_BACK_LENGTH user_datas[5] 
#define QD_PARAM_BACK_LENGTH   user_datas[19] 
#define QD_PARAM_FZ_LENGTH     user_datas[22] 
#define QD_PARAM_Go_LOW_SPEED_LENGTH user_datas[16] 
#define QD_PARAM_Back_LOW_SPEED_LENGTH user_datas[6] 
#define QD_PARAM_SJZ_LENGTH    user_datas[27] 
#define QD_PARAM_GO_HIGH_SPEED user_datas[15] 
#define QD_PARAM_GO_LOW_SPEED  user_datas[17] 
#define QD_PARAM_BACK_SPEED    user_datas[18] 
#define QD_PARAM_CUT_BACK_SPEED    user_datas[26] 
#define QD_PARAM_HL_LENGTH      user_datas[29] 
#define QD_PARAM_TABLE_NUM      user_datas[40] 
#define QD_PARAM_CYCLE_LENGTH   user_datas[38] 
#define QD_PARAM_CYCLE_PULSE    user_datas[39] 
#define QD_PARAM_FIRST_SPEED    user_datas[9]
#define QD_PARAM_ZHA_SHU        user_datas[85]
#define QD_PARAM_NOW_CNT        user_datas[84]

#define QD_PARAM_DELAY_CS      (user_datas[20] * 10)
#define QD_PARAM_CS_TIME       (user_datas[21] * 10)
#define QD_PARAM_CS_COLD_TIME  (user_datas[10] * 10)
#define QD_PARAM_ZS_STOP_TIME  (user_datas[11] * 10)   
#define QD_PARAM_DELAY_BACK    (user_datas[12]*10)   
#define QD_PARAM_DELAY_FZ      (user_datas[13]*10)   
#define QD_PARAM_CYCLE_DELAY   (user_datas[14]*10)  
#define QD_PARAM_TL_DELAY      (user_datas[3]*10)  
#define QD_PARAM_YD_DELAY      (user_datas[4]*10) 
#define QD_PARAM_GZ_DELAY      (user_datas[0]*10)  
#define QD_PARAM_CUT_DELAY     (user_datas[7]*10)    
#define QD_PARAM_CUT_BACK_DELAY (user_datas[8]*10)
#define QD_PARAM_TB_TIME       (user_datas[23]*10)
#define QD_PARAM_MOTOR_DELAY_LENGTH user_datas[41]
#define QD_PARAM_TFK_DELAY     (user_datas[44]*10)
   
#define QD_PARAM_TL_MODE          0//user_datas[45] //ʽ0Ϊ1Ϊ
#define QD_PARAM_TL_CYCLE_LENGTH  user_datas[46]
#define QD_PARAM_TL_CYCLE_PULSE   user_datas[47]
#define QD_PARAM_TL_SPEED         user_datas[48]
#define QD_PARAM_TL_LENGTH        user_datas[49]
#define QD_PARAM_DELAY_CHECK      user_datas[50]  
#define QD_PARAM_DAO_MODE         user_datas[51]  //0Ϊ˫1Ϊ
#define QD_PARAM_DANDAO_MODE_LENGTH user_datas[52]
#define QD_PARAM_OFFSET_LENGTH    user_datas[53]
#define QD_PARAM_GOUZHEN_LENGTH   user_datas[54]
#define QD_PARAM_TIAOSHI_MODE    user_datas[55]
#define QD_PARAM_DELAY_HL_LENGTH user_datas[56]
#define QD_PARAM_HL_ENABLE     user_datas[33] 
#define QD_PARAM_CS_ENABLE     user_datas[90]
#define QD_PARAM_XM_ENABLE     user_datas[35] //0Ϊģ 1Ϊģģ
#define QD_PARAM_CS_MODE       user_datas[36] //0Ϊ1Ϊ
#define QD_PARAM_DELAY_XM      (user_datas[58]*10)
#define QD_PARAM_DELAY_XM_LENGTH user_datas[59]   
#define QD_PARAM_BACK_LOW_SPEED user_datas[60]
#define QD_PARAM_NO_LT_DELAY_CHECK      user_datas[63]
#define QD_PARAM_ERROR_LENGTH  user_datas[64]
#define QD_PARAM_DELAYBACK_SM  (user_datas[65]*10)
#define QD_PARAM_SL_LENGTH     user_datas[66]
#define QD_PARAM_TC_LENGTH     user_datas[67]
#define QD_PARAM_DELAY_SJ_TIME user_datas[68]
#define QD_PARAM_XHG_LENGTH    user_datas[69]
#define QD_PARAM_DELAY_BL_BACK user_datas[70]
#define QD_PARAM_MAX_ERROR_LENGTH user_datas[71]
#define QD_PARAM_MIN_SPEED     user_datas[72]
#define QD_PARAM_RUN_STATE     user_datas[250]

#define QD_PARAM_YD_ENABLE     1 
#define QD_PARAM_DC_MODE       user_datas[31]   //˶ģʽ1Ϊ룬0Ϊù
#define QD_PARAM_DEC_MODE      user_datas[30]  //˷ʽ  1Ϊ볤أ0Ϊǰⳤ
#define QD_PARAM_GO_MODE       1//1ǰʹؽ
#define QD_PARAM_BACK_MODE     user_datas[61]//1ʹؽ
#define QD_PARAM_BACK_ALARM_MODE 1 //λģʽ 0Ϊأ1ΪӦλ  
#define QD_PARAM_TFK_ENABLE    1
#define QD_PARAM_LT_ENABLE     user_datas[62]
#define QD_SAVE_POS            (user_datas[200] | (user_datas[201] >> 16))
#define QD_PARAM_BL_ENABLE     user_datas[57]

   
#define QD_AutoDelay     cDelayTime1
#define QD_MotorDelay    cDelayTime2
#define QD_XiaQieDelay   cDelayTime3   
#define QD_KaDaiDelay    cDelayTime4 
#define QD_CSDelay       cDelayTime5
#define QD_TBDelay       cDelayTime6
#define QD_TFKDelay      cDelayTime7
#define QD_TLDelay      cDelayTime8
#define QD_CheckDelay    cDelayTime9
#define QD_AlarmDelay    cDelayTime10
#define QD_SJDelay       cDelayTime11
#define QD_XMDelay       cDelayTime12
#define QD_GZDelay       cDelayTime13
#define QD_BLDelay       cDelayTime14

#define QD_AutoStep    cStepMByte
#define QD_MotorStep   cStepMByte1
#define QD_XiaQieStep  cStepMByte2
#define QD_YuanDianStep  cStepMByte3
#define QD_TuiLianStep  cStepMByte4
#define QD_TuiFangKuaiStep  cStepMByte5
#define QD_BinLianStep  cStepMByte6

//
#define QD_START_IN     X00
#define QD_START_IN_UP (X00 && !OLDX00)
#define QD_STOP_IN      X01
#define QD_STOP_IN_UP  (X01 && !OLDX01)
#define QD_GUO_LIAN_IN       X17
#define QD_GUO_LIAN_IN_UP   (X17 && !OLDX17)
#define QD_GUO_LIAN_IN_DW   (!X17 && OLDX17)
#define QD_GOUZHEN_IN        X04
#define QD_QIAN_LIMIT_IN     X10
#define QD_QIAN_LIMIT_IN_UP  (X10 && !OLDX10) 
#define QD_QIAN_DEC_IN       X03 
#define QD_QIAN_DEC_IN_UP    (X03 && !OLDX03)      
#define QD_BACK_LIMIT_IN     X11
#define QD_BACK_LIMIT_IN_UP  (X11 && !OLDX11)    
#define QD_JD_ORIGIN_IN       X10 
#define QD_JD_IN              X02

#define QD_SHANG_MU_ORIGIN_IN X11
#define QD_SHANG_MU_LIMIT_IN  X06
#define QD_SHANG_MU_LIMIT_IN_DW   (!X06 && OLDX06)
#define QD_XIA_MU_LIMIT_IN    X12
#define QD_XIA_MU_LIMIT_IN_UP (X12 && !OLDX12) 



#define QD_GZ_VAVLE           Y01
#define QD_YD_VAVLE           Y07
#define QD_JD_VAVEL           Y03
#define QD_SM_VAVLE           Y05
#define QD_XM_VAVLE           Y04
#define QD_SUO_MU_VAVLE       Y06
#define QD_SZ_OUT             Y10
#define QD_CS_OUT             Y15
#define QD_TABLE_VAVLE        Y11
#define QD_TFK_VAVEL          Y12

#define QD_TL_VAVLE           Y13
#define QD_YBD_VAVLE          Y14
#define QD_JZ_DIR             Y11
#define QD_BL_VAVLE           Y02
#define QD_XHG_VAVLE          Y00

//M0~M4ȫ̶ֹʹ
/*
#define bRunning            M0000
#define bStart              M0001
#define bStop               M0002
#define bAlarmStop          M0003
#define bClearTotal         M0004
*/
#define QD_bSM                M0006
#define QD_bXM                M0007
#define QD_bClearTotal        M0008
#define QD_bXiaQie            M0009
#define QD_bQianDianDW        M0010
#define QD_bChaoSheng         M0011
#define QD_bJiaDai            M0012
#define QD_bGoMotor           M0013
#define QD_bBackMotor         M0014
#define QD_bTL                M0015
#define QD_bYD                M0016
#define QD_bGZ                M0017
#define QD_bJD                M0018   
#define QD_bHL                M0019
#define QD_bYuanDianDW        M0020
#define QD_bTestCS            M0021
#define QD_bSingle            M0022
#define QD_bTFK               M0023   
#define QD_bTB                M0024   
#define QD_bYBD               M0025   
#define QD_bClearNowTotal     M0026
#define QD_bTS                M0027
#define QD_bBL                M0028
#define QD_bSetGZMode         M0029
   
#endif

#endif