#ifndef __XDCHUAN_TOU_JI_H__
#define __XDCHUAN_TOU_JI_H__

#if FJ_YING_XING_MACHINE==1

extern void ChuanTou_Action(void);
extern void ChuanTou_InitAction(void);


#define CT_DIR_P           1
#define CT_DIR_N           0

#define CT_Y_DIR_P 1
#define CT_Y_DIR_N 0

#define CT_MOTOR_DISEN 1
#define CT_MOTOR_EN    0

#define HouMa_MODE_DANKUAI   0
#define HouMa_MODE_SHUANGBI   1
#define HouMa_MODE_YOUHOUMA   2

/*
 *                           
 */
#define CT_NO_ALARM             	0                               /* û*/
#define CT_NO_ZIPPER_ALARM		1                              	/* ûԶͣ*/
#define CT_KA_DAI_ALARM	         	2                               /* 쳣*/
#define CT_SL_ORIGIN_ALARM               3                 
#define CT_HSL_ORIGIN_ALARM              4                                
#define CT_HSL_LIMIT_ALARM            	5                             
#define CT_XM_ORIGIN_ALARM              6                               /* ģλ*/                      
#define CT_ZIPPER_MAXLENGHT_ALARM	       7                               /* ϴȱǷλ*/
#define CT_TOTAL_ALARM                  8
#define CT_DZ_ALARM                     10
#define CT_BL_ALARM                     17
#define CT_CR_ORIGIN_ALARM              21  
#define CT_FD_IN_ALARM                  22  
#define CT_HangSongLiao_Out_ALARM       25
#define CT_SongLiao_VAVLE_Not_ALARM     26      //ϵŷ
#define CT_JieLiao_VAVLE_Not_ALARM      27      //ϵŷ
#define  CT_XiaMo_VAVLE_Not_ALARM       28      //ģŷ
#define  CT_LaTuo_Not_ALARM             29      //Ѿͷ  
#define  CT_TuiJieLiao_ALARM            30      //˽Ϊ빴ºҪ˻ԭ
#define  CT_JieLiao_out_ALARM           31      //빴ûԭ   
#define  CT_XiaMo_out_ALARM             32      //ԭ   
#define  CT_Guo_Lian_IN_ALARM           33      //ڿλױ    
#define  CT_ZhuangLiao_ALARM            34      //װϲɹ   
#define  CT_HuChi_out_ALARM             35      //ϴ
#define  CT_FenDai_out_ALARM            36      //ִϴ
#define  CT_HeLian_out_ALARM            37      //ϴ
            
   
#define VAVLE_ALARM_TIME                3000
#define MOTOR_ALARM_TIME                5000

#define CT_WORKTOTAL_ADDR      102   
#define CT_TOTAL_ADDR      76
#define CT_ALARM_ADDR      100
#define CT_PROSPEED_ADDR   78


//#define CT_PARAM_SET_TOTAL             (user_datas[74] | (user_datas[75] >> 16))
#define CT_PARAM_CR_LENGTH              (user_datas[1] | (user_datas[2] >> 16))      // 볤ȣ2λС CM
#define CT_PARAM_SL_DELAY_BACK          (user_datas[3] * 10)    //ʱ   2λС    //ʱ
#define CT_PARAM_JIELIAO_DELAY          (user_datas[4] * 10)    //ʱ   2λС    //ʱ 
#define CT_PARAM_GJ_TIME                (user_datas[5] * 10)    //ʱ   2λС    //ʱ빴
#define CT_PARAM_HSL_BACK_DELAY         (user_datas[6]*10)      //ʱ   2λС    //ʱ   
#define CT_PARAM_HSPEED                 (user_datas[7])                              //ϴ
#define CT_PARAM_LSPEED                 (user_datas[8])                              //λٶ   
#define CT_PARAM_STOP_LENGTH            (user_datas[9])          // CM2λС //λ
#define CT_PARAM_CYCLE_LENGTH           2950     //user_datas[10]
#define CT_PARAM_CYCLE_PULSE            2000     //user_datas[11]
#define CT_PARAM_FD_DELAY               (user_datas[10]* 10)    //ʱ   2λС        //ʱִ
#define CT_PARAM_XM_BACK_DELAY_START    (user_datas[11] * 10)   //ʱ  2λС        //ģʱϴ
#define CT_PARAM_MAX_LENGTH             (user_datas[12] * 10)   // CM 1λС       //
#define CT_PARAM_ZDP_START_TIME         (user_datas[13] * 10)   //ʱ   2λС        //ʱ
#define CT_PARAM_CR_SPEED               user_datas[14]                                  //ٶ
#define CT_PARAM_GZ_LENGTH              user_datas[15]          // ȣCM 2λС    //ӳϹ
#define CT_PARAM_TUIHELIAN_DELAY        user_datas[16]          // ȣCM 2λС    //ʱ˺ 
#define CT_PARAM_TUIFENGDAI_DELAY       user_datas[17]          // ȣCM 2λС    //ʱ˷ִ
#define CT_PARAM_ZDP_STOP_TIME         (user_datas[18] * 10)   //ʱ  2λС         //ʱ()
#define CT_PARAM_DLP_TIME              (user_datas[19] * 10)   //ʱ  2λС         //Ƭʱ
   
#define CT_PARAM_HL_ENABLE          user_datas[30]   //
#define CT_PARAM_DALIAOPIAN         user_datas[31]   //ԶƬ
#define CT_PARAM_SL_MODE            user_datas[32]   //ģʽ(0 , 1Ͽ)
#define CT_PARAM_GZ_MODE            user_datas[33]   //ѡ
#define CT_PARAM_ZDP_MODE           user_datas[34]   //
#define CT_PARAM_HouMa_MODE         user_datas[35]   // 0޺뵥ģʽ 1޺˫ģʽ,2кģʽ,
   
#define CT_AutoDelay     cDelayTime1
#define CT_MotorDelay    cDelayTime2
#define CT_HeMoDelay     cDelayTime3
#define CT_SL_Delay      cDelayTime4
#define CT_HSL_Delay     cDelayTime5
#define CT_ZL_Delay      cDelayTime6
#define CT_XM_BACK_Delay cDelayTime7  
#define CT_CLT_Delay     cDelayTime8     
#define CT_ZDP_Delay     cDelayTime9
#define CT_AlarmDelay    cDelayTime10
#define CT_DLP_Time      cDelayTime11
 
#define CT_AutoStep    cStepMByte               //Զ
#define CT_MotorStep   cStepMByte1              //ϴ
#define CT_HeMoStep    cStepMByte2              //ģ
#define CT_SL_Step     cStepMByte3              //϶
#define CT_HSL_Step    cStepMByte4              //ģ϶
#define CT_ZL_Step     cStepMByte5              //װ϶
#define CT_CLT_Step    cStepMByte6              //ͷ
#define CT_ZD_Step     cStepMByte7              //̶
   
#define CT_START_IN             X00                     // 
#define CT_START_IN_UP          (X00 && !OLDX00)         //
#define CT_STOP_IN              X01                     //ֹͣ
#define CT_STOP_IN_UP           (X01 && !OLDX01)
   
#define CT_MG_IN                X02                      //빴
#define CT_MG_IN_UP           (X02 && !OLDX02)
#define CT_FD_IN                X05                      //ִλ
#define CT_DZ_IN                X06                     //ͷ()
#define CT_XM_ORIGIN_IN         X07                     //ģԭλ
#define CT_HSL_ORIGIN_IN        X10                     //ԭλ
#define CT_HSL_LIMIT_IN         X11                     //͵λ

#define CT_ZDP_IN              X14                      //ϼ
#define CT_ZDP_IN_UP          (X14 && !OLDX14)          
#define CT_ZDP_IN_DW          (!X14 && OLDX14)

#define CT_GUO_LIAN_IN         X15                      //Ӧ
#define CT_GUO_LIAN_IN_UP     (X15 && !OLDX15)
#define CT_GUO_LIAN_IN_DW    (!X15 && OLDX15)

#define CT_SL_ORIGIN_IN       X16                       //ԭλ
#define CT_Manual_DW          X20                       //ֶλ
#define CT_Manual_DW_DW       (!X20 && OLDX20)
#define CT_Manual_DW_UP       (!X20 && OLDX20)
#define CT_Manual_ZHUANGLI     X21                       //ֶװ
#define CT_Manual_ZHUANGLI_DW  (!X20 && OLDX20)
#define CT_Manual_ZHUANGLI_UP  (!X20 && OLDX20)


#define CT_XiaMo_VAVLE             Y01               //ģ
#define CT_SongLiao_VAVLE          Y02               //

#define CT_GouZhen_VAVLE           Y03               //
#define CT_MaGou_VAVLE             Y04               //빴
#define CT_DaLaPian_VAVLE          Y05               //Ƭ(Ƭ)
#define CT_FenDai_VAVLE            Y06               //ִ
#define CT_HeLian_VAVLE            Y07               //(ģ)
#define CT_ZhenDongPian_OUT        Y11               //
#define CT_HangSongLiao_VAVLE      Y12               //

#define CT_JieLiao_VAVLE           Y13               //ģ       
#define CT_HuChi_VAVLE             Y14                //
   
   
   
//M0~M4ȫ̶ֹʹ
/*
#define bRunning            M0000
#define bStart              M0001
#define bStop               M0002
#define bAlarmStop          M0003
#define bClearTotal         M0004
*/
#define CT_bSL                M0006     //ֶ
#define CT_bHSL                M0007     //ֶͷ
#define CT_bJL                M0008     //ֶ
#define CT_bGM                M0009     //ֶ
#define CT_bFD                M0010     //ִֶ
#define CT_bXM                M0011    //ֶģ
#define CT_bMotorH            M0012    //ֶϴ
#define CT_bHL                M0013     //ֶ
#define CT_bDLP               M0014     //ֶƬ
#define CT_bHC                M0015     //ֶ  
#define CT_bMotorDW           M0016     //һλ
   
#define CT_bZL                M0017     //װ
#define CT_bHM                M0018     //ģ
#define CT_bSingle            M0019     //һԶ
#define CT_bZDP               M0020     //

#endif

#endif