#ifndef __XDMXC_NILONG_STEP_JI_H__
#define __XDMXC_NILONG_STEP_JI_H__

#if FJ_YING_XING_MACHINE

extern void MXC_InitAction(void);
extern void MXC_NiLongXiuCiJiAction(void);
extern void MXC_ExtiActionX20(void);



#define MXC_ALARM_ADDR   100
#define MXC_ZIPPER_LENGTH_ADDR 17
#define MXC_TOTAL_ADDR 76
#define MXC_PROSPEED_ADDR 78

#define MXC_SERVER_EN    0
#define MXC_SERVER_DISEN 1

#define MXC_SC_EN    1
#define MXC_SC_DISEN 0

#define MXC_XC_SERVER_EN    0
#define MXC_XC_SERVER_DISEN 1

#define MXC_DIR_P 1
#define MXC_DIR_N 0

#define MXC_DC_GZ_MODE 0
#define MXC_DC_SF_MODE 1
#define MXC_DC_SB_MODE 2
#define MXC_DC_BMQ_MODE 3

#define MXC_NO_ALARM        0
#define MXC_TOTAL_ALARM     1
#define MXC_XIA_CHONG_ALARM 2
#define MXC_KA_DAI_ALARM    3
#define MXC_XC_ALARM        4
#define MXC_NO_ZIPPER_ALARM 5

#define MXC_NO_GOUZHEN_ALARM 7
#define MXC_LFZ_ORIGIN_ALARM  8
#define MXC_LFZ_LIMIT_ALARM   9
#define MXC_RFZ_ORIGIN_ALARM  10
#define MXC_RFZ_LIMIT_ALARM   11
#define MXC_LONG_TIME_NO_ZIPPER_ALARM  12
#define MXC_NO_SEBIAO_ALARM    13
#define MXC_SEBIAO_ZIPPER_LENGTH_ALARM    14

#define MXC_MOTOR_ALALRM_TIME 20000
#define MXC_FenZhengErrorTime    500
#define MXC_ERRORTIME  2000    //出错时间

#define MXC_PARAM_XIAZHI_TIME    (user_datas[0]*10)
#define MXC_PARAM_CHUIQI_TIME    (user_datas[1]*10)
#define MXC_PARAM_CHAOSHENG_TIME (user_datas[2]*10)
#define MXC_PARAM_INCH_MODE       user_datas[3]
#define MXC_PARAM_SC_DELAY        user_datas[4]
#define MXC_PARAM_XC_DELAY       (user_datas[5]*10)
#define MXC_PARAM_SET_SPEED      user_datas[8]
#define MXC_PARAM_LOW_SPEED      user_datas[9]
#define MXC_PARAM_LOWSPEED_LENGTH user_datas[10]
#define MXC_GuoLianMode           user_datas[12]
#define MXC_PARAM_DAOKOU_LENGTH  user_datas[13]
#define MXC_PARAM_DAILUN_LENGTH  user_datas[11]
#define MXC_SET_ZIPPER_LENGTH   (user_datas[15] |  (user_datas[16] << 16)) 
#define MXC_SET_REVISE_ZIPPER_LENGTH  user_datas[17]
#define MXC_SET_ZIPPER_LENGTH_INCH   (user_datas[18] |  (user_datas[19] << 16)) 
#define MXC_SET_REVISE_ZIPPER_LENGTH_INCH  user_datas[20]
#define MXC_DC_MODE        user_datas[62]           //0勾针 1步进/伺服 2色标 3编码器
#define MXC_XZ_ENABLE      user_datas[44]           //0不使用下止 1使用下止
#define MXC_DEC_MODE user_datas[21]        //0为感应减速模式，1为数控减速模式
#define MXC_SET_TOTAL      (user_datas[84] | (user_datas[85] << 16))
#define MXC_GOU_ZHEN_MODE  user_datas[24]           // 0为普通勾针 1为活动勾针
#define MXC_GuoLianCheckMode user_datas[25]         // 超声下止模式下，过链感应有效电平配置1为翻转电平
#define MXC_PARAM_XIAZHI_DELAY_TIME user_datas[26]
#define MXC_XiaChongMotorMode user_datas[27]        //0为交流1为步进/伺服
#define MXC_XiaChongSpeed     user_datas[29]
#define MXC_XiaChongLowSpeed 10
#define MXC_MOTOR_MODE     user_datas[30]           //0步进松轴电平1伺服松轴电平
#define MXC_PARAM_DELAY_CHUIQI_TIME (user_datas[31]*10)
#define MXC_PARAM_FIRST_SPEED       user_datas[32]
#define MXC_PARAM_GZ_RESET_MODE     user_datas[33]  //勾针复位方式 0为自动1为数控
#define MXC_PARAM_CYCLE_PULSE       user_datas[34]
#define MXC_PARAM_KONG_WEI_LENGTH   user_datas[35]
#define MXC_PARAM_SEBIAO_TQ_LENGTH  user_datas[46]
#define MXC_PARAM_SEBIAO_DW_LENGTH  user_datas[47]
#define MXC_PARAM_GZ_LENGTH         user_datas[48]
#define MXC_PARAM_GZ_DELAY          (user_datas[49]*10)
#define MXC_PARAM_MOTOR_ALARM_TIME  (user_datas[50]*10)
#define MXC_PARAM_R_FZ_DELAY        (user_datas[51]*10)
#define MXC_PARAM_L_FZ_DELAY        (user_datas[52]*10)
#define MXC_PARAM_MOTOR_DELAY       (user_datas[53]*10)
#define MXC_PARAM_SC_MODE           0
#define MXC_PARAM_AUTO_CHECK_MODE    1//1为自动测长0为手动输入长度
#define MXC_PARAM_DELAY_XC          (user_datas[56]*10)
#define MXC_PARAM_SB_HIGH_SPEED      user_datas[57]
#define MXC_PARAM_SB_LOW_SPEED       user_datas[58]
#define MXC_PARAM_SB_OFFSET_SPEED    user_datas[59]
#define MXC_ERROR_LENGTH             user_datas[60]
#define MXC_BM_LENGTH                user_datas[12]

#define DISPLAY_DATA0           user_datas[121]
#define DISPLAY_DATA1           user_datas[122]
#define DISPLAY_DATA2           user_datas[123]
#define DISPLAY_DATA3           user_datas[124]
#define DISPLAY_DATA4           user_datas[125]
#define DISPLAY_DATA5           user_datas[126]
#define DISPLAY_DATA6           user_datas[127]
#define DISPLAY_DATA7           user_datas[128]

#define MXC_bStart          M0000
#define MXC_bClear          M0001
#define MXC_bXiaZhi         M0002
#define MXC_bXiaChong       M0003
#define MXC_bStop           M0004
#define MXC_bLeftFenZhen    M0005
#define MXC_bRightFenZhen   M0006
#define MXC_bDotXiaChong    M0007
#define MXC_bDotXiaChongDisplay M0008
#define MXC_bGouZhen        M0009
#define MXC_bAddLength      M0010
#define MXC_bDecLength      M0011
#define MXC_bSetDCMode      M0012
#define MXC_bChuiQi         M0013
#define MXC_bChangeLength   M0014
#define MXC_bClearAlarm     M0015
#define MXC_bChangeGouZhenMode M0016
#define MXC_bChangeXiaZhiMode  M0017  
#define MXC_bChuDai         M0018
#define MXC_bDingWei        M0019
#define MXC_bNext           M0020
#define MXC_bJiaoDao        M0021
#define MXC_bSaveWorkData   M0022
#define MXC_bAlarmStop      M0023
#define MXC_bRunning        M0024
#define MXC_bTestMotor      M0025
#define MXC_bSetLength      M0026

#define MXC_cAutoStep          cStepMByte  
#define MXC_cMotorStep         cStepMByte1
#define MXC_cXiaChongStep      cStepMByte2
#define MXC_cLeftFenZhenStep   cStepMByte3   
#define MXC_cRightFenZhenStep  cStepMByte4   
#define MXC_cJiaoDaoStep       cStepMByte5
#define MXC_cChuiQiStep        cStepMByte6
#define MXC_cDCPStep           cStepMByte7

#define MXC_cAutoDelay         cDelayTime1
#define MXC_cChuiQiDelay       cDelayTime2
#define MXC_cXiaZhiDelay       cDelayTime3
#define MXC_cGouZhenTime       cDelayTime4
#define MXC_cBudaiCheckDelay   cDelayTime5
#define MXC_cFenZhenLeftDelay  cDelayTime6
#define MXC_cFenZhenRightDelay cDelayTime7
#define MXC_cKaDaiDelay        cDelayTime8
#define MXC_cXiaChongDelay     cDelayTime9
#define MXC_cDaoJuCheckDelay   cDelayTime10
#define MXC_cMotorDelay        cDelayTime11

#define START_IN     X00
#define START_IN_UP (X00 && !OLDX00)
#define STOP_IN      X01
#define STOP_IN_UP  (X01 && !OLDX01)
#define MXC_KaDai_IN        X03
#define MXC_KaDai_IN_UP    (X03 && !OLDX03)
#define MXC_XiaChong_IN     X04
#define MXC_XiaChong_IN_UP (X04 && !OLDX04)
#define MXC_XiaChong_IN_DW (!X04 && OLDX04)
#define MXC_LeftFenZhen_Origin_IN  X05
#define MXC_RightFenZhen_Origin_IN X06
#define MXC_LeftFenZhen_IN   X07
#define MXC_RighttFenZhen_IN X10
#define MXC_Zipper_IN        X14
#define MXC_GouZhen_IN       X15
#define MXC_XC_ShaChe        Y00
#define MXC_XiaChong_MOTOR   Y01
#define MXC_LeftFenZhen_VAVLE  Y02
#define MXC_RightFenZhen_VAVLE Y03
#define MXC_GouZhen_VAVLE    Y04
#define MXC_ChuiQi_VAVLE     Y05
#define MXC_ALARM_OUT        Y06
#define MXC_XCSZ_OUT         Y07
#define MXC_XiaZhi_MOTOR     Y11
#define MXC_XiaZhi_VAVLE     Y12

#endif

#endif