
#if ZHEN_YU_MACHINE  ==  1

extern void YWXChuanTou_HeLian_InitAction(void);
extern void YWXChuanTou_HeLian_Action(void);
extern void YWXChuanTou_HeLian_SetAlarmCode(unsigned alarm_code);
extern void ExtiAcitionX02(void);

#define DIR_P 1
#define DIR_N 0

#define MOTOR_EN 0
#define MOTOR_DISEN 1


#define MOTOR_ALARM 0
#define MOTOR_NOALARM 1

#define CTHL_VAVLE_ERROR_TIME   3000 
#define CTHL_MOTOR_ALARM_TIME   5000


//故障代码列表
#define CTHL_NO_ALARM                0
#define CTHL_WLZDTJ_ALARM            1   //无拉链自动停机
#define CTHL_TLiao_Limit_ALARM       3   //给拉头到位异常*
#define CTHL_HSLiao_Limit_ALARM      5   //横送料到位异常
#define CTHL_HSLiao_Origin_ALARM     6   //横送料原位异常*

#define CTHL_JLT_MZ_ALARM            7   //夹拉头到位信号、拉头检测异常*

#define CTHL_CTXM_Limit_ALARM         8    //下模到位异常*
#define CTHL_CTXM_Origin_ALARM        9   //下模原位异常*
#define CTHL_JLT_Limit_ALARM         20   //夹拉头到位异常*
#define CTHL_XCJC_Origin_ALARM       21   //插销钩针原位异常 * 
#define CTHL_FZYL_Limit_ALARM       22   //右压轮到位异常  
#define CTHL_JCXBD_Limit_ALARM       23   //插销布带夹到位异常  
#define CTHL_CXHT_Limit_ALARM       25   //插销回退到位异常  
#define CTHL_CXBB_Limit_ALARM       26   //插销摆臂到位异常
#define CTHL_FK_Check_ALARM       27   //方块光纤检测异常
#define CTHL_CXGY_Check_ALARM       28   //插销到位感应检测异常
#define CTHL_SM_Limit_ALARM       29   //上摸到位异常
#define CTHL_SERVO_CONFIG_ALARM       30  //是否配置转矩限制失败
#define CTHL_MSLENGTH_OUT_ALARM       31  //穿链慢速超出拉链长度
#define CTHL_FZMOTOR_ALARM       32  //反转电机卡滞
#define CTHL_SYHL_ERRO_ALARM       33  //剩余合练长度设置错误

#define CTHL_TXM_Limit_ALARM        13   //侧推布带到位异常

#define CTHL_JXM_Limit_ALARM         10  //夹斜码要输出才能推斜码
#define CTHL_XCDW_Limit_ALARM        11   //拉头缺料感应异常
#define CTHL_QMDW_Limit_ALARM        12   //前码定位感应异常

#define CTHL_XCBI_Limit_ALARM        14   //小插摆臂到位异常
#define CTHL_SafeDoor_ALARM             15   //
#define CTHL_SF_ALR_ALARM            16   //伺服报警异常
#define CTHL_FXDW_ALARM             17   //方块定位(X04)异常
#define CTHL_ZLT_ALARM               18   //装拉头异常*
#define CTHL_CRFK_ALARM             19   //穿入长度异常超出预设长度

#define CTHL_AutoStep            cStepMByte
#define CTHL_ZhuangLiaoStep      cStepMByte1
#define CTHL_TLiaoStep           cStepMByte2
#define CTHL_TD_MotorStep        cStepMByte3     //拖带电机
#define CTHL_JiaLianStep         cStepMByte4
#define CTHL_ZhenDongStep        cStepMByte6
#define CTHL_SongLiaoStep        cStepMByte7
#define CTHL_FZ_MotorStep        cStepMByte8     //穿链
#define CTHL_AutoStep1           cStepMByte9


#define CTHL_ZhuangLiaoDelay      cDelayTime2
#define CTHL_TLiao_Delay          cDelayTime3
#define CTHL_TD_MotorDelay        cDelayTime4
#define CTHL_AutoDelay            cDelayTime5
#define CTHL_TestDelay            cDelayTime6
#define CTHL_FZ_MotorDelay        cDelayTime7
#define CTHL_TouchDelay           cDelayTime8
#define CTHL_AutoDelay1           cDelayTime9
#define CTHL_ZDP_Delay            cDelayTime10
#define CTHL_MOTORZ_Delay            cDelayTime11
#define CTHL_bSFBBAOJIN_Delay   cDelayTime12


//32位无符号变量
#define CTHL_LianLengthCheckFirst       cUDword32Buff1
#define CTHL_LianLengthCheck            cUDword32Buff2
#define CTHL_LianLengthXFZCheckFirst    cUDword32Buff3
#define CTHL_LianLengthXFZCheck         cUDword32Buff4
#define CTHL_LianLengthYFZCheckFirst    cUDword32Buff5
#define CTHL_LianLengthYFZCheck         cUDword32Buff6
#define CTHL_LianLengthGLCheckFirst     cUDword32Buff13
#define CTHL_LianLengthGLCheck          cUDword32Buff14

#define CTHL_GLGY_FKDW_Length           cUDword32Buff7//过链感应与方块钩针的距离
#define CTHL_FKGY_FKDW_Length           cUDword32Buff8//过链感应与方块钩针的距离
#define CTHL_FKGY_Length                cUDword32Buff9//方块感应长度，X轴
#define CTHL_FKGY_STOP_Length           cUDword32Buff10//方块感应减停长度
#define CTHL_DataBuff                   cUDword32Buff11
#define CTHL_CXCD                       cUDword32Buff12 //穿插销长度  

//32位有符号变量
#define CTHL_XSavePosBuff       cDword32Buff1
#define CTHL_X_CXPosBuff         cDword32Buff2
#define CTHL_YSavePosBuff        cDword32Buff3
#define CTHL_YsaveFZPosBuff    cDword32Buff5
#define CTHL_LENTH               cDword32Buff6
#define CTHL_XSavePosBuff1       cDword32Buff7
#define CTHL_XSavePosBuff2       cDword32Buff8
#define CTHL_XSavePosBuff3       cDword32Buff9//感应到第一个方块插销位置
#define CTHL_HL_LENTH            cDword32Buff10
//
#define XY_CTHL_CheckInX02PosBuff   cDword32Buff4//?
//16位变量
#define CTHL_RunStepSave                cUShort16Buff1
#define CTHL_Test               cUShort16Buff2
//8位变量
#define CTHL_TryCnt              cCharBuff1
#define CTHL_cZipCnt             cCharBuff2
#define CTHL_stop               cCharBuff3
#define CTHL_AUTO_start          cCharBuff4
#define CTHL_wltzi               cCharBuff6
#define cStopMode                cCharBuff7
#define cTDAUTO                  cCharBuff8
#define cDELAYONE                cCharBuff9
#define cHELIANMG                cCharBuff11
#define cBAOjin                  cCharBuff12


//位标志位
#define bTuiLaTouOkFlg              bBitFlag0
#define bZhuangLiaoOkFlg            bBitFlag1
#define bXiaoMOUpFlg                bBitFlag2
#define bCL_EN_FLG                  bBitFlag4
#define bCL_OK_FLG                  bBitFlag5
#define bCheckEN_FLG                bBitFlag6
#define bSingOneFlg                 bBitFlag7  
#define bCxcAuto                    bBitFlag8
#define bDanBuAuto                  bBitFlag9
#define bFZ_LengthOK                bBitFlag10  
#define bFKCheck_Flag               bBitFlag11
#define CTHL_ZhouWanone             bBitFlag12
#define CTHL_ZhouWantwo             bBitFlag13
#define CTHL_GF_Change              bBitFlag14
#define CTHL_SD                    bBitFlag15         //松一次带


#define CTHL_TOTAL_ADDR  76

#define CTHL_SPEED_ADDR     78
#define CTHL_ALARM_ADDR     100
#define CTHL_TRUST_ALARM_ADDR     102
//104、105地址 作产量锁

#define CTHL_PARAM_TDCYCLE_PULSE       user_datas[0]//0 转一圈脉冲数  
#define CTHL_PARAM_TDCYCLE_LENGTH      user_datas[1]//整数 转一圈拖带多长 
#define CTHL_PARAM_FZCYCLE_LENGTH      user_datas[2]//0 转一圈脉冲数  
#define CTHL_PARAM_FZLDCYCLE_LENGTH    user_datas[3]//整数 转一圈拖带多长  



//#define CTHL_PARAM_TD_RunSpeed         user_datas[4]//整数 拖带电机拖带速度
#define CTHL_PARAM_FKDW_Speed          user_datas[5]//整数 方块定位速度(低速度)
#define CTHL_PARAM_FZDS_Speed            user_datas[6]//整数 反转低速
#define CTHL_PARAM_FZJSDS_LENGTH          user_datas[34] //穿入方块低速长度

//#define CTHL_PARAM_FKDW_Length         user_datas[8]//0.01 方块定位长度


//给拉头
#define CTHL_PARAM_TLiao_FORWARDDELAY    (10*user_datas[12])//延时推给拉头阀*
#define CTHL_PARAM_TLiao_BACKDELAY     (10*user_datas[13])//延时回退给拉头阀*
//装拉头
#define CTHL_PARAM_HSLiao_FORWARDDELAY   (10*user_datas[14])//0.01延时横送
#define CTHL_PARAM_HSLiao_BACKDELAY      (10*user_datas[15])//延时横送回退
#define CTHL_PARAM_JLiaoCH_DELAY         (10*user_datas[18]) //夹拉头检测延时
#define CTHL_PARAM_MaGou_DELAY           (10*user_datas[19])  //夹到位后延时码钩
// 保护长度 
#define CTHL_PARAM_first_CL_MAX_Length (10*user_datas[7])//第一条拉链最长度
#define  CTHL_PARAM_WLCDSHEZHI_LENTH    user_datas[16]  //拉带报警长度
#define CTHL_PARAM_CXDW_Length         user_datas[17]  //小插定位长度
//固定尺寸长度

//
#define CTHL_PARAM_FMOTOR_BILI       0.95// (user_datas[20]/100)  //0.01 副电机指数
//



#define CTHL_PARAM_HLDW_LENGTH        user_datas[23] //合练定位长度

#define CTHL_PARAM_SMG_LENGTH        user_datas[24] //松码钩后输出合链长度

#define CTHL_PARAM_ZDP_Start_TIME      (10*user_datas[25])      //0.01振动盘启动延时  
#define CTHL_PARAM_ZDP_Stop_TIME       (10*user_datas[26])       //0.01振动盘延时停止 
#define CTHL_PARAM_HELIAN_LENGTH      user_datas[27] //剩余合链长度
//#define CTHL_PARAM_FDGN_LENGTH        user_datas[28] //第一个方块屏蔽长度
//#define CTHL_PARAM_FKJC_DELAY      (user_datas[29]*10) //延时输出方块检测

#define CTHL_PARAM_XCCR_SPEED        user_datas[31] //小插插入速度
#define  CTHL_PARAM_ZDP_AUTO         user_datas[32]  //振动盘控制




//#define CTHL_PARAM_GFJSZ_LENGTH              user_datas[37] //倒带长度
#define CTHL_PARAM_XMDD_LENGTH              user_datas[38] //斜码松带反转
#define CTHL_PARAM_DBSF_MODE                 user_datas[39] // DB伺服报警切换   1外部接口




//穿链参数
#define CTHL_PARAM_JXM_SPEED                  user_datas[41] //穿拉头速度
#define CTHL_PARAM_FZ_Speed                     (user_datas[51]) //走链速度
#define CTHL_PARAM_XMCR_SLOW_LENGTH             user_datas[56]//穿链长度
#define CTHL_PARAM_SMXJ_LENGTH                user_datas[43]//上摸下降长度   
#define CTHL_PARAM_TJXM_LENGTH                  user_datas[44]//退夹斜码长度
#define CTHL_PARAM_FZFirst_SPEED                  user_datas[152]//前两条反转速度

#define CTHL_PARAM_TXM_DELAY                  (user_datas[42]*10) //侧推布带到位延时
#define CTHL_PARAM_FKDW_OUT_DELAY               (user_datas[52]*10) //方块定位阀延时动作
//插销参数
#define CTHL_PARAM_HLT_SPEED_Speed              user_datas[11]//穿插销的速度
#define CTHL_PARAM_CRFZ_LENGTH          (user_datas[58]) //穿插销后退长度       
#define CTHL_PARAM_XCCR_LENGTH          user_datas[33] //小插插入长度
#define CTHL_PARAM_XCIN_DELAY           (user_datas[35]*10) //小插定位下降后，延时松上模
#define CTHL_PARAM_CXBB_DELAY             (user_datas[36]*10) //插销摆臂
#define CTHL_PARAM_YSCX_DELAY             user_datas[22]*10 //延时插销时间
#define CTHL_PARAM_JBD_DELAY      (user_datas[30]*10) //夹布带延时
#define CTHL_PARAM_XCLD_DELAY        (10*user_datas[21]) //延时合链

#define CTHL_PARAM_FZXZ_LENGTH                 user_datas[46]//反转修正长度
#define CTHL_PARAM_FZJS_LENGTH              user_datas[38] //反转入方块减速长度
#define CTHL_PARAM_FZSTOP_LENGTH      user_datas[9]  //反转入方块停机长度
#define CTHL_PARAM_FZSJ_LENGTH                 user_datas[45]//反转松紧调整
//合链参数
#define CTHL_PARAM_TD_RunSpeed        (user_datas[50])//整数 拖带电机拖带速度
#define CTHL_PARAM_TuiXiaMo_DELAY                    (10*user_datas[53]) //延时退上模
//拖带设置
#define CTHL_PARAM_CLsudu_SPEED            (user_datas[62]) //长链拖带快速速度
#define CTHL_PARAM_First_SPEED                  user_datas[150] //前两拖带条速度
#define CTHL_PARAM_XMUP_LENGTH                 user_datas[40] // 下模上升位置
//方块定位
#define CTHL_PARAM_FKDWMAN_Speed        user_datas[10]  //感应到方块后慢速
#define CTHL_PARAM_TDDW_LENGTH          user_datas[8] //感应到方块后定位距离
#define CTHL_PARAM_GJSY_LENGTH          user_datas[28] //方块过链感减速位置
#define CTHL_PARAM_FKDW_DW_LENGTH       user_datas[54] //方块定位下降位置
//伺服参数 180~190
#define SERVO_PARAM_TRARR_LIMITMAX       user_datas[180]//伺服扭矩最大限制
#define SERVO_PARAM_TRARR_LIMITMIN       user_datas[181]//伺服扭矩最小限制
#define SERVO_PARAM_SPEED_DIFFER         user_datas[182]//速度差值
#define SERVO_PARAM_ENCODE             user_datas[190]//转换后的值
#define SERVO_PARAM_ALARM              user_datas[192]//转换后的值




#define CTHL_PARAM_FZCXC_LENGTH                 user_datas[47]//穿小插反转距离
#define CTHL_PARAM_XMZM_MODE                   user_datas[48]//斜码直码切换
#define CTHL_PARAM_YSXC_DELAY                   (user_datas[49]*10)//延时顶链

#define CTHL_PARAM_TDDW_FIRST_LENGTH          user_datas[63] //感应到方块后定位距离
#define CTHL_PARAM_FKDW_DW_FIRST_LENGTH       user_datas[55] //方块定位下降位置


#define CTHL_PARAM_CYCLE_TIME              (user_datas[57]) //循环时间
#define CTHL_PARAM_ZLT_TIME                (user_datas[61]) //装拉头时间
#define CTHL_PARAM_CL_TIME                 (user_datas[66]) //穿链时间
#define CTHL_PARAM_TD_TIME                 (user_datas[65]) //拉带时间     

#define CTHL_PARAM_HeLianSY_LENGTH          (user_datas[60]) //最后一条合链剩余长度





//速度页面调试参数


#define CTHL_PARAM_Stop_length                  user_datas[151] //前两条定位长度

#define CTHL_PARAM_GFJ_LENGTH                  user_datas[153] //前两条反转定位长度

/*
#define CTHL_FK_Check              M0384    //X00过链感应
#define CTHL_FK_Check_UP           (M0384 && !OLDM384)
#define CTHL_FK_Check_DW           (!M0384 && OLDM384)
#define CTHL_TFK_Limit_IN          M0385  //X01推前码到位
#define CTHL_FKGY_IN               M0386   //X02方块感应
#define CTHL_FKGY_IN_UP            (M0386 && !OLDM386)   
#define CTHL_FKGY_IN_DW            (!M0386 && OLDM386)  
#define CTHL_TXC_Limit_IN          M0387   //X03推小插到位
#define CTHL_FKDW_IN               M0388   //X04方块定位感应
#define CTHL_FKDW_IN_UP            (M0388 && !OLDM388)   
#define CTHL_LTou_Check            M0389     //X05开锁完成
#define CTHL_CTM_Origin_IN         M0390       //X06下模原位
#define CTHL_CTM_Limit_IN          M0391       //X07下模到位
#define CTHL_JLiao_Limit_IN        M0392      //X10接拉头到位
#define CTHL_HSLiao_Origin_IN      M0393       //X11横送料原位
#define CTHL_HSLiao_Limit_IN       M0394       //X12横送料到位
#define CTHL_TLiao_Origin_IN       M0395        //X13推料原位
#define CTHL_TXM_Limit_IN          M0396       //X14推斜码到位
#define CTHL_XCDW_Limit_IN         M0397      //X15小插到位
#define CTHL_QMDW_IN               M0398          //X16前码定位
#define CTHL_QMDW_IN_UP            (M0398 && !OLDM398)
#define CTHL_ZDP_IN                M0399          //X17振动盘
#define CTHL_SF_ALR_IN             M0400            //X20 伺服报警
#define CTHL_SafeDoor_IN           M0401          //X21 安全门
#define CTHL_START_IN              M0402           //X22  //启动
#define CTHL_START_IN_UP           (M0402 && !OLDM402)
#define CTHL_STOP_IN               M0403          // X23  //停止
#define CTHL_STOP_IN_UP            (M0403 && !OLDM403)
#define CTHL_STOP_IN_DW            (!M0403 && OLDM403)
#define CTHL_NoLaLian_IN           M0404          //X24 最后拉链信号
#define CTHL_NoLaLian_IN_UP        (M0404 && !OLDM404)
*/
//振宇输入
#define CTHL_START_IN              M0384           //X00 //启动
#define CTHL_START_IN_UP           (M0384 && !OLDM384)
#define CTHL_STOP_IN               M0385          // X01  //停止
#define CTHL_STOP_IN_UP            (M0385 && !OLDM385)
#define CTHL_STOP_IN_DW            (!M0385 && OLDM385)
#define CTHL_TLiao_Limit_IN       M0386       //X02推料到位，给拉头到位
#define CTHL_HSLiao_Origin_IN      M0387       //X03横送料原位
#define CTHL_HSLiao_Limit_IN       M0388       //X04横送料到位
#define CTHL_FK_Check              M0389    //X05方块过链感应
#define CTHL_FK_Check_UP           (M0389 && !OLDM389)
#define CTHL_FK_Check_DW           (!M0389 && OLDM389)

#define CTHL_FKDW_IN               M0390   //X06方块定位感应
#define CTHL_FKDW_IN_UP            (M0390 && !OLDM390)
#define CTHL_FKDW_IN_DW            (!M0390 && OLDM390)

#define CTHL_FKGY_IN               M0391   //X07方块感应，反转时感应
#define CTHL_FKGY_IN_UP            (M0391 && !OLDM391)   
#define CTHL_FKGY_IN_DW            (!M0391 && OLDM391)  

#define CTHL_SML_Limit_IN          M0392        //X10上模到位
#define CTHL_TXM_Limit_IN          M0393       //X11推斜码到位，侧推布带到位

#define CTHL_CXGY_IN              M0394       //X12插销到位感应开关
#define CTHL_CXGY_IN_UP            (M0394 && !OLDM394)   
#define CTHL_CXGY_IN_DW            (!M0394 && OLDM394)  

#define CTHL_JLiao_Limit_IN        M0395      //X13接拉头到位，夹拉头到位

#define CTHL_XCJC_Origin_IN        M0396      //X14插销钩针原位，插销检测气缸原位

#define CTHL_CTXM_Origin_IN         M0397       //X15下模原位
#define CTHL_CTXM_Limit_IN          M0398       //X16下模到位

#define CTHL_XCBB_Limit_IN          M0399     //X17插销摆动到位
#define CTHL_JCXBD_Limit_IN         M0400      //X20夹插销布
#define CTHL_CXHT_Limit_IN        M0401      //X21插销h后退到位
#define CTHL_FZYL_Limit_IN        M0402      //X22右拖带压轮到位

#define CTHL_LTou_Check          M0403     //X23缺拉头检测，有信号代表缺拉头。

#define CTHL_KDSW_IN               M0404          //X23卡带开关
#define CTHL_ZDP_IN                M0405          //X17振动盘
#define CTHL_SF_ALR_IN             M0406            //X20 伺服报警
#define CTHL_SafeDoor_IN           M0407         //X21 安全门
#define CTHL_NoLaLian_IN           M0408          //X24 最后拉链信号
#define CTHL_NoLaLian_IN_UP        (M0408 && !OLDM408)
//输出
/*
#define CTHL_TLiao_VAVLE          M0304      //Y00推料
#define CTHL_HSLiao_VAVLE         M0305      //Y01横送料 
#define CTHL_JLTou_VAVLE          M0306      //Y02接拉头

//#define CTHL_CTXM_VAVLE           M0307      //Y03下模

#define CTHL_MGuo_VAVLE           M0308      //Y04码勾电磁阀
#define CTHL_JXM_VAVLE            M0309      //Y05夹斜码电磁阀 
#define CTHL_TXM_VAVLE            M0310      //Y06推斜码电磁阀 
#define CTHL_QMDW_VAVLE           M0311      //Y07前码定位电磁阀 
#define CTHL_TFK_VAVLE            M0312      //Y10推方块

//#define CTHL_FKDW_VAVLE           M0313       //Y11方
#define CTHL_CTXM_VAVLE           M0313      //Y11下模

#define CTHL_HL_VAVLE             M0314       //Y12合链电磁阀
#define CTHL_YFK_VAVLE            M0315       //Y13压方块电磁阀
#define CTHL_YXC_VAVLE            M0316       //Y14压小插电磁阀
#define CTHL_XCDW_VAVLE           M0317       //Y15小插到位检测电磁阀
#define CTHL_JCBI_VAVLE           M0318       //Y16小插摆臂电磁阀
#define CTHL_ZhenDongPian_OUT     M0319      //Y17振动盘吹气
#define CTHL_SF_ALR_CLR           M0320      //Y20伺服报警清除
#define CTHL_DingLian_VAVLE       M0321      //Y21顶链电磁阀

#define CTHL_TestLED              M0328   //Y30 测试状态灯
*/
#define CTHL_TLiao_VAVLE          M0304      //Y00给拉头
#define CTHL_HSLiao_VAVLE         M0305      //Y01横送拉头
#define CTHL_TXM_VAVLE            M0306      //Y02侧推布带电磁阀 ，推方块侧的斜码、直码
#define CTHL_SMZ_VAVLE            M0307      //Y03上模组电磁阀，反转后检测方块装置、检测信号X7
#define CTHL_FKDW_VAVLE           M0308      //Y04方块钩针定位升降电磁阀，拖带时检测方块装置，信号X6
#define CTHL_HL_VAVLE           M0309      //Y05合练
#define CTHL_XCJC_VAVLE           M0310       //Y06小插到位检测电磁阀，插销钩针气缸，检测信号X12；
#define CTHL_JLTou_VAVLE          M0311      //Y07夹拉头电磁阀
#define CTHL_MGuo_VAVLE           M0312      //Y10码勾电磁阀，拉头开锁电磁阀
#define CTHL_CTXM_VAVLE           M0313      //Y11下模
#define CTHL_XCBB_VAVLE           M0314      //Y12插销摆臂电磁阀，侧推小插侧的布带
#define CTHL_JCXBD_VAVLE           M0315     //Y13夹插侧的布带，为装入小插准备
#define CTHL_CXHT_VAVLE             M0316       //Y14小插销后退，夹着小插销布带后退
#define CTHL_FZYL_VAVLE          M0317       //Y15右拖带压轮，反转压轮

#define CTHL_ZhenDongPian_OUT     M0319      //Y17控制振动盘

#define CTHL_SF_ALR_CLR           M0320      //Y20伺服报警清除
#define CTHL_DingLian_VAVLE       M0321      //Y21顶链电磁阀
#define CTHL_TestLED              M0328      //Y30 测试状态

//M0~M4全局固定使用
/*
#define bRunning                    M0000
#define bStart                      M0001
#define bStop                       M0002
#define bAlarmStop                  M0003
#define bClearTotal                 M0004
*/

#define CTHL_bHSL            M0005      //手动横送料 
#define CTHL_bTLiao          M0006      //手动推料
#define CTHL_bJLT            M0007      //夹拉头
#define CTHL_bMG             M0008      //码勾 
#define CTHL_bCTXM           M0009      //下模
#define CTHL_bCXHT           M0010      //插销回退
#define CTHL_bTXM            M0011      //侧推布带
#define CTHL_bSM             M0013      //上摸 
#define CTHL_bFKDW            M0014      //方块定位
#define CTHL_bJCXBD           M0015     //插销布带夹
#define CTHL_bGLBG            M0016      //过链摆杆
#define CTHL_bFZYL             M0017      //右拖压带
#define CTHL_bCXDW            M0018      //插销钩针
#define CTHL_bCXBB            M0019      //插销摆动

#define CTHL_bSingOne       M0020     //单循环
#define CTHL_bDANBU_MODE              M0021      //单步调试
#define CTHL_bHandWork_MODE              M0022      //手动穿链模式

#define CTHL_bAutoZhuangLiao        M0024       //自动装料
#define CTHL_bYJDW                 M0029     //一键定位

#define CTHL_bCLMotor_P         M0025       //X轴电机测试
#define CTHL_bCLMotor_N         M0026       //X轴电机测试
#define CTHL_bCLMotor_Z        M0027       //Z轴电机测试
#define CTHL_bBaoJin          M0028       //报警清除加松轴

#define CTHL_bTiaoShiMode           M0040     //调试模式
#define CTHL_bTiaoShiStep           M0041     //调试单步


extern void CTHL_InitAction(void);
extern void CTHL_Action(void);

#endif


