#ifndef __IO_APP_H__
#define __IO_APP_H__
#include "st_sys.h"


#define LOCAL_INPUT_BITS_NUMBER       20
#define LOCAL_OUTPUT_BITS_NUMBER      19

extern byte_bits_t io_inputs[];
extern byte_bits_t io_inputs_old[];

extern byte_bits_t io_outputs[];

#define X00 io_inputs[0].bits.b0
#define X01 io_inputs[0].bits.b1
#define X02 io_inputs[0].bits.b2
#define X03 io_inputs[0].bits.b3
#define X04 io_inputs[0].bits.b4
#define X05 io_inputs[0].bits.b5
#define X06 io_inputs[0].bits.b6
#define X07 io_inputs[0].bits.b7

#define X10 io_inputs[1].bits.b0
#define X11 io_inputs[1].bits.b1
#define X12 io_inputs[1].bits.b2
#define X13 io_inputs[1].bits.b3
#define X14 io_inputs[1].bits.b4
#define X15 io_inputs[1].bits.b5
#define X16 io_inputs[1].bits.b6
#define X17 io_inputs[1].bits.b7

#define X20 io_inputs[2].bits.b0
#define X21 io_inputs[2].bits.b1
#define X22 io_inputs[2].bits.b2
#define X23 io_inputs[2].bits.b3
#define X24 io_inputs[2].bits.b4
#define X25 io_inputs[2].bits.b5
#define X26 io_inputs[2].bits.b6
#define X27 io_inputs[2].bits.b7


#define X30 io_inputs[3].bits.b0
#define X31 io_inputs[3].bits.b1
#define X32 io_inputs[3].bits.b2
#define X33 io_inputs[3].bits.b3
#define X34 io_inputs[3].bits.b4
#define X35 io_inputs[3].bits.b5
#define X36 io_inputs[3].bits.b6
#define X37 io_inputs[3].bits.b7

#define X40 io_inputs[4].bits.b0
#define X41 io_inputs[4].bits.b1
#define X42 io_inputs[4].bits.b2
#define X43 io_inputs[4].bits.b3
#define X44 io_inputs[4].bits.b4
#define X45 io_inputs[4].bits.b5
#define X46 io_inputs[4].bits.b6
#define X47 io_inputs[4].bits.b7

#define OLDX00 io_inputs_old[0].bits.b0
#define OLDX01 io_inputs_old[0].bits.b1
#define OLDX02 io_inputs_old[0].bits.b2
#define OLDX03 io_inputs_old[0].bits.b3
#define OLDX04 io_inputs_old[0].bits.b4
#define OLDX05 io_inputs_old[0].bits.b5
#define OLDX06 io_inputs_old[0].bits.b6
#define OLDX07 io_inputs_old[0].bits.b7

#define OLDX10 io_inputs_old[1].bits.b0
#define OLDX11 io_inputs_old[1].bits.b1
#define OLDX12 io_inputs_old[1].bits.b2
#define OLDX13 io_inputs_old[1].bits.b3
#define OLDX14 io_inputs_old[1].bits.b4
#define OLDX15 io_inputs_old[1].bits.b5
#define OLDX16 io_inputs_old[1].bits.b6
#define OLDX17 io_inputs_old[1].bits.b7

#define OLDX20 io_inputs_old[2].bits.b0
#define OLDX21 io_inputs_old[2].bits.b1
#define OLDX22 io_inputs_old[2].bits.b2
#define OLDX23 io_inputs_old[2].bits.b3
#define OLDX24 io_inputs_old[2].bits.b4
#define OLDX25 io_inputs_old[2].bits.b5
#define OLDX26 io_inputs_old[2].bits.b6
#define OLDX27 io_inputs_old[2].bits.b7

#define OLDX30 io_inputs_old[3].bits.b0
#define OLDX31 io_inputs_old[3].bits.b1
#define OLDX32 io_inputs_old[3].bits.b2
#define OLDX33 io_inputs_old[3].bits.b3
#define OLDX34 io_inputs_old[3].bits.b4
#define OLDX35 io_inputs_old[3].bits.b5
#define OLDX36 io_inputs_old[3].bits.b6
#define OLDX37 io_inputs_old[3].bits.b7

#define OLDX40 io_inputs_old[4].bits.b0
#define OLDX41 io_inputs_old[4].bits.b1
#define OLDX42 io_inputs_old[4].bits.b2
#define OLDX43 io_inputs_old[4].bits.b3
#define OLDX44 io_inputs_old[4].bits.b4
#define OLDX45 io_inputs_old[4].bits.b5
#define OLDX46 io_inputs_old[4].bits.b6
#define OLDX47 io_inputs_old[4].bits.b7

#define Y00 io_outputs[0].bits.b0
#define Y01 io_outputs[0].bits.b1
#define Y02 io_outputs[0].bits.b2
#define Y03 io_outputs[0].bits.b3
#define Y04 io_outputs[0].bits.b4
#define Y05 io_outputs[0].bits.b5
#define Y06 io_outputs[0].bits.b6
#define Y07 io_outputs[0].bits.b7

#define Y10 io_outputs[1].bits.b0
#define Y11 io_outputs[1].bits.b1
#define Y12 io_outputs[1].bits.b2
#define Y13 io_outputs[1].bits.b3
#define Y14 io_outputs[1].bits.b4
#define Y15 io_outputs[1].bits.b5
#define Y16 io_outputs[1].bits.b6
#define Y17 io_outputs[1].bits.b7

#define Y20 io_outputs[2].bits.b0
#define Y21 io_outputs[2].bits.b1
#define Y22 io_outputs[2].bits.b2
#define Y23 io_outputs[2].bits.b3
#define Y24 io_outputs[2].bits.b4
#define Y25 io_outputs[2].bits.b5
#define Y26 io_outputs[2].bits.b6
#define Y27 io_outputs[2].bits.b7

#define Y30 io_outputs[3].bits.b0
#define Y31 io_outputs[3].bits.b1
#define Y32 io_outputs[3].bits.b2
#define Y33 io_outputs[3].bits.b3
#define Y34 io_outputs[3].bits.b4
#define Y35 io_outputs[3].bits.b5
#define Y36 io_outputs[3].bits.b6
#define Y37 io_outputs[3].bits.b7

extern int io_inputs_buffer[20];

void io_app_read_input(void);
void io_app_write_ouput(void);
void io_app_init(void);
void io_app_run(void);
extern void TestAction(void);
extern void InitTestAction(void);

#endif
