#ifndef __VARIABLE_H__
#define __VARIABLE_H__

#include "st_sys.h"

#define MIDDLE_COILS_NUMBER     1024    //线圈变量的个数
#define USER_DATA_NUMBER        2048     //用户数据的个数
#define IO_X_NUMBER             32
#define IO_Y_NUMBER             32

#define MIDDLE_COILS2_NUMBER     512    //线圈变量的个数
#define USER_DATA2_NUMBER        256     //用户数据的个数


extern byte_bits_t middle_coils[];
extern unsigned short user_datas[];

extern byte_bits_t io_x_reg[];
extern byte_bits_t io_y_reg[];

extern unsigned short user_datas2[];
extern byte_bits_t middle_coils2[];

#define M0000            middle_coils[0].bits.b0
#define M0001            middle_coils[0].bits.b1
#define M0002            middle_coils[0].bits.b2
#define M0003            middle_coils[0].bits.b3
#define M0004            middle_coils[0].bits.b4
#define M0005            middle_coils[0].bits.b5
#define M0006            middle_coils[0].bits.b6
#define M0007            middle_coils[0].bits.b7
#define M0008            middle_coils[1].bits.b0
#define M0009            middle_coils[1].bits.b1
#define M0010            middle_coils[1].bits.b2
#define M0011            middle_coils[1].bits.b3
#define M0012            middle_coils[1].bits.b4
#define M0013            middle_coils[1].bits.b5
#define M0014            middle_coils[1].bits.b6
#define M0015            middle_coils[1].bits.b7
#define M0016            middle_coils[2].bits.b0
#define M0017            middle_coils[2].bits.b1
#define M0018            middle_coils[2].bits.b2
#define M0019            middle_coils[2].bits.b3
#define M0020            middle_coils[2].bits.b4
#define M0021            middle_coils[2].bits.b5
#define M0022            middle_coils[2].bits.b6
#define M0023            middle_coils[2].bits.b7
#define M0024            middle_coils[3].bits.b0
#define M0025            middle_coils[3].bits.b1
#define M0026            middle_coils[3].bits.b2
#define M0027            middle_coils[3].bits.b3
#define M0028            middle_coils[3].bits.b4
#define M0029            middle_coils[3].bits.b5
#define M0030            middle_coils[3].bits.b6
#define M0031            middle_coils[3].bits.b7
#define M0032            middle_coils[4].bits.b0
#define M0033            middle_coils[4].bits.b1
#define M0034            middle_coils[4].bits.b2
#define M0035            middle_coils[4].bits.b3
#define M0036            middle_coils[4].bits.b4
#define M0037            middle_coils[4].bits.b5
#define M0038            middle_coils[4].bits.b6
#define M0039            middle_coils[4].bits.b7
#define M0040            middle_coils[5].bits.b0
#define M0041            middle_coils[5].bits.b1
#define M0042            middle_coils[5].bits.b2
#define M0043            middle_coils[5].bits.b3
#define M0044            middle_coils[5].bits.b4
#define M0045            middle_coils[5].bits.b5
#define M0046            middle_coils[5].bits.b6
#define M0047            middle_coils[5].bits.b7
#define M0048            middle_coils[6].bits.b0
#define M0049            middle_coils[6].bits.b1
#define M0050            middle_coils[6].bits.b2
#define M0051            middle_coils[6].bits.b3
#define M0052            middle_coils[6].bits.b4
#define M0053            middle_coils[6].bits.b5
#define M0054            middle_coils[6].bits.b6
#define M0055            middle_coils[6].bits.b7
#define M0056            middle_coils[7].bits.b0
#define M0057            middle_coils[7].bits.b1
#define M0058            middle_coils[7].bits.b2
#define M0059            middle_coils[7].bits.b3
#define M0060            middle_coils[7].bits.b4
#define M0061            middle_coils[7].bits.b5
#define M0062            middle_coils[7].bits.b6
#define M0063            middle_coils[7].bits.b7
#define M0064            middle_coils[8].bits.b0
#define M0065            middle_coils[8].bits.b1
#define M0066            middle_coils[8].bits.b2
#define M0067            middle_coils[8].bits.b3
#define M0068            middle_coils[8].bits.b4
#define M0069            middle_coils[8].bits.b5
#define M0070            middle_coils[8].bits.b6
#define M0071            middle_coils[8].bits.b7
#define M0072            middle_coils[9].bits.b0
#define M0073            middle_coils[9].bits.b1
#define M0074            middle_coils[9].bits.b2
#define M0075            middle_coils[9].bits.b3
#define M0076            middle_coils[9].bits.b4
#define M0077            middle_coils[9].bits.b5
#define M0078            middle_coils[9].bits.b6
#define M0079            middle_coils[9].bits.b7
#define M0080            middle_coils[10].bits.b0
#define M0081            middle_coils[10].bits.b1
#define M0082            middle_coils[10].bits.b2
#define M0083            middle_coils[10].bits.b3
#define M0084            middle_coils[10].bits.b4
#define M0085            middle_coils[10].bits.b5
#define M0086            middle_coils[10].bits.b6
#define M0087            middle_coils[10].bits.b7
#define M0088            middle_coils[11].bits.b0
#define M0089            middle_coils[11].bits.b1
#define M0090            middle_coils[11].bits.b2
#define M0091            middle_coils[11].bits.b3
#define M0092            middle_coils[11].bits.b4
#define M0093            middle_coils[11].bits.b5
#define M0094            middle_coils[11].bits.b6
#define M0095            middle_coils[11].bits.b7
#define M0096            middle_coils[12].bits.b0
#define M0097            middle_coils[12].bits.b1
#define M0098            middle_coils[12].bits.b2
#define M0099            middle_coils[12].bits.b3
#define M0100            middle_coils[12].bits.b4
#define M0101            middle_coils[12].bits.b5
#define M0102            middle_coils[12].bits.b6
#define M0103            middle_coils[12].bits.b7
#define M0104            middle_coils[13].bits.b0
#define M0105            middle_coils[13].bits.b1
#define M0106            middle_coils[13].bits.b2
#define M0107            middle_coils[13].bits.b3
#define M0108            middle_coils[13].bits.b4
#define M0109            middle_coils[13].bits.b5
#define M0110            middle_coils[13].bits.b6
#define M0111            middle_coils[13].bits.b7
#define M0112            middle_coils[14].bits.b0
#define M0113            middle_coils[14].bits.b1
#define M0114            middle_coils[14].bits.b2
#define M0115            middle_coils[14].bits.b3
#define M0116            middle_coils[14].bits.b4
#define M0117            middle_coils[14].bits.b5
#define M0118            middle_coils[14].bits.b6
#define M0119            middle_coils[14].bits.b7
#define M0120            middle_coils[15].bits.b0
#define M0121            middle_coils[15].bits.b1
#define M0122            middle_coils[15].bits.b2
#define M0123            middle_coils[15].bits.b3
#define M0124            middle_coils[15].bits.b4
#define M0125            middle_coils[15].bits.b5
#define M0126            middle_coils[15].bits.b6
#define M0127            middle_coils[15].bits.b7
#define M0128            middle_coils[16].bits.b0
#define M0129            middle_coils[16].bits.b1
#define M0130            middle_coils[16].bits.b2
#define M0131            middle_coils[16].bits.b3
#define M0132            middle_coils[16].bits.b4
#define M0133            middle_coils[16].bits.b5
#define M0134            middle_coils[16].bits.b6
#define M0135            middle_coils[16].bits.b7
#define M0136            middle_coils[17].bits.b0
#define M0137            middle_coils[17].bits.b1
#define M0138            middle_coils[17].bits.b2
#define M0139            middle_coils[17].bits.b3
#define M0140            middle_coils[17].bits.b4
#define M0141            middle_coils[17].bits.b5
#define M0142            middle_coils[17].bits.b6
#define M0143            middle_coils[17].bits.b7
#define M0144            middle_coils[18].bits.b0
#define M0145            middle_coils[18].bits.b1
#define M0146            middle_coils[18].bits.b2
#define M0147            middle_coils[18].bits.b3
#define M0148            middle_coils[18].bits.b4
#define M0149            middle_coils[18].bits.b5
#define M0150            middle_coils[18].bits.b6
#define M0151            middle_coils[18].bits.b7
#define M0152            middle_coils[19].bits.b0
#define M0153            middle_coils[19].bits.b1
#define M0154            middle_coils[19].bits.b2
#define M0155            middle_coils[19].bits.b3
#define M0156            middle_coils[19].bits.b4
#define M0157            middle_coils[19].bits.b5
#define M0158            middle_coils[19].bits.b6
#define M0159            middle_coils[19].bits.b7
#define M0160            middle_coils[20].bits.b0
#define M0161            middle_coils[20].bits.b1
#define M0162            middle_coils[20].bits.b2
#define M0163            middle_coils[20].bits.b3
#define M0164            middle_coils[20].bits.b4
#define M0165            middle_coils[20].bits.b5
#define M0166            middle_coils[20].bits.b6
#define M0167            middle_coils[20].bits.b7
#define M0168            middle_coils[21].bits.b0
#define M0169            middle_coils[21].bits.b1
#define M0170            middle_coils[21].bits.b2
#define M0171            middle_coils[21].bits.b3
#define M0172            middle_coils[21].bits.b4
#define M0173            middle_coils[21].bits.b5
#define M0174            middle_coils[21].bits.b6
#define M0175            middle_coils[21].bits.b7
#define M0176            middle_coils[22].bits.b0
#define M0177            middle_coils[22].bits.b1
#define M0178            middle_coils[22].bits.b2
#define M0179            middle_coils[22].bits.b3
#define M0180            middle_coils[22].bits.b4
#define M0181            middle_coils[22].bits.b5
#define M0182            middle_coils[22].bits.b6
#define M0183            middle_coils[22].bits.b7
#define M0184            middle_coils[23].bits.b0
#define M0185            middle_coils[23].bits.b1
#define M0186            middle_coils[23].bits.b2
#define M0187            middle_coils[23].bits.b3
#define M0188            middle_coils[23].bits.b4
#define M0189            middle_coils[23].bits.b5
#define M0190            middle_coils[23].bits.b6
#define M0191            middle_coils[23].bits.b7
#define M0192            middle_coils[24].bits.b0
#define M0193            middle_coils[24].bits.b1
#define M0194            middle_coils[24].bits.b2
#define M0195            middle_coils[24].bits.b3
#define M0196            middle_coils[24].bits.b4
#define M0197            middle_coils[24].bits.b5
#define M0198            middle_coils[24].bits.b6
#define M0199            middle_coils[24].bits.b7
#define M0200            middle_coils[25].bits.b0
#define M0201            middle_coils[25].bits.b1
#define M0202            middle_coils[25].bits.b2
#define M0203            middle_coils[25].bits.b3
#define M0204            middle_coils[25].bits.b4
#define M0205            middle_coils[25].bits.b5
#define M0206            middle_coils[25].bits.b6
#define M0207            middle_coils[25].bits.b7
#define M0208            middle_coils[26].bits.b0
#define M0209            middle_coils[26].bits.b1
#define M0210            middle_coils[26].bits.b2
#define M0211            middle_coils[26].bits.b3
#define M0212            middle_coils[26].bits.b4
#define M0213            middle_coils[26].bits.b5
#define M0214            middle_coils[26].bits.b6
#define M0215            middle_coils[26].bits.b7
#define M0216            middle_coils[27].bits.b0
#define M0217            middle_coils[27].bits.b1
#define M0218            middle_coils[27].bits.b2
#define M0219            middle_coils[27].bits.b3
#define M0220            middle_coils[27].bits.b4
#define M0221            middle_coils[27].bits.b5
#define M0222            middle_coils[27].bits.b6
#define M0223            middle_coils[27].bits.b7
#define M0224            middle_coils[28].bits.b0
#define M0225            middle_coils[28].bits.b1
#define M0226            middle_coils[28].bits.b2
#define M0227            middle_coils[28].bits.b3
#define M0228            middle_coils[28].bits.b4
#define M0229            middle_coils[28].bits.b5
#define M0230            middle_coils[28].bits.b6
#define M0231            middle_coils[28].bits.b7
#define M0232            middle_coils[29].bits.b0
#define M0233            middle_coils[29].bits.b1
#define M0234            middle_coils[29].bits.b2
#define M0235            middle_coils[29].bits.b3
#define M0236            middle_coils[29].bits.b4
#define M0237            middle_coils[29].bits.b5
#define M0238            middle_coils[29].bits.b6
#define M0239            middle_coils[29].bits.b7
#define M0240            middle_coils[30].bits.b0
#define M0241            middle_coils[30].bits.b1
#define M0242            middle_coils[30].bits.b2
#define M0243            middle_coils[30].bits.b3
#define M0244            middle_coils[30].bits.b4
#define M0245            middle_coils[30].bits.b5
#define M0246            middle_coils[30].bits.b6
#define M0247            middle_coils[30].bits.b7
#define M0248            middle_coils[31].bits.b0
#define M0249            middle_coils[31].bits.b1
#define M0250            middle_coils[31].bits.b2
#define M0251            middle_coils[31].bits.b3
#define M0252            middle_coils[31].bits.b4
#define M0253            middle_coils[31].bits.b5
#define M0254            middle_coils[31].bits.b6
#define M0255            middle_coils[31].bits.b7
#define M0256            middle_coils[32].bits.b0
#define M0257            middle_coils[32].bits.b1
#define M0258            middle_coils[32].bits.b2
#define M0259            middle_coils[32].bits.b3
#define M0260            middle_coils[32].bits.b4
#define M0261            middle_coils[32].bits.b5
#define M0262            middle_coils[32].bits.b6
#define M0263            middle_coils[32].bits.b7
#define M0264            middle_coils[33].bits.b0
#define M0265            middle_coils[33].bits.b1
#define M0266            middle_coils[33].bits.b2
#define M0267            middle_coils[33].bits.b3
#define M0268            middle_coils[33].bits.b4
#define M0269            middle_coils[33].bits.b5
#define M0270            middle_coils[33].bits.b6
#define M0271            middle_coils[33].bits.b7
#define M0272            middle_coils[34].bits.b0
#define M0273            middle_coils[34].bits.b1
#define M0274            middle_coils[34].bits.b2
#define M0275            middle_coils[34].bits.b3
#define M0276            middle_coils[34].bits.b4
#define M0277            middle_coils[34].bits.b5
#define M0278            middle_coils[34].bits.b6
#define M0279            middle_coils[34].bits.b7
#define M0280            middle_coils[35].bits.b0
#define M0281            middle_coils[35].bits.b1
#define M0282            middle_coils[35].bits.b2
#define M0283            middle_coils[35].bits.b3
#define M0284            middle_coils[35].bits.b4
#define M0285            middle_coils[35].bits.b5
#define M0286            middle_coils[35].bits.b6
#define M0287            middle_coils[35].bits.b7
#define M0288            middle_coils[36].bits.b0
#define M0289            middle_coils[36].bits.b1
#define M0290            middle_coils[36].bits.b2
#define M0291            middle_coils[36].bits.b3
#define M0292            middle_coils[36].bits.b4
#define M0293            middle_coils[36].bits.b5
#define M0294            middle_coils[36].bits.b6
#define M0295            middle_coils[36].bits.b7
#define M0296            middle_coils[37].bits.b0
#define M0297            middle_coils[37].bits.b1
#define M0298            middle_coils[37].bits.b2
#define M0299            middle_coils[37].bits.b3
#define M0300            middle_coils[37].bits.b4
#define M0301            middle_coils[37].bits.b5
#define M0302            middle_coils[37].bits.b6
#define M0303            middle_coils[37].bits.b7
#define M0304            middle_coils[38].bits.b0
#define M0305            middle_coils[38].bits.b1
#define M0306            middle_coils[38].bits.b2
#define M0307            middle_coils[38].bits.b3
#define M0308            middle_coils[38].bits.b4
#define M0309            middle_coils[38].bits.b5
#define M0310            middle_coils[38].bits.b6
#define M0311            middle_coils[38].bits.b7
#define M0312            middle_coils[39].bits.b0
#define M0313            middle_coils[39].bits.b1
#define M0314            middle_coils[39].bits.b2
#define M0315            middle_coils[39].bits.b3
#define M0316            middle_coils[39].bits.b4
#define M0317            middle_coils[39].bits.b5
#define M0318            middle_coils[39].bits.b6
#define M0319            middle_coils[39].bits.b7
#define M0320            middle_coils[40].bits.b0
#define M0321            middle_coils[40].bits.b1
#define M0322            middle_coils[40].bits.b2
#define M0323            middle_coils[40].bits.b3
#define M0324            middle_coils[40].bits.b4
#define M0325            middle_coils[40].bits.b5
#define M0326            middle_coils[40].bits.b6
#define M0327            middle_coils[40].bits.b7
#define M0328            middle_coils[41].bits.b0
#define M0329            middle_coils[41].bits.b1
#define M0330            middle_coils[41].bits.b2
#define M0331            middle_coils[41].bits.b3
#define M0332            middle_coils[41].bits.b4
#define M0333            middle_coils[41].bits.b5
#define M0334            middle_coils[41].bits.b6
#define M0335            middle_coils[41].bits.b7
#define M0336            middle_coils[42].bits.b0
#define M0337            middle_coils[42].bits.b1
#define M0338            middle_coils[42].bits.b2
#define M0339            middle_coils[42].bits.b3
#define M0340            middle_coils[42].bits.b4
#define M0341            middle_coils[42].bits.b5
#define M0342            middle_coils[42].bits.b6
#define M0343            middle_coils[42].bits.b7
#define M0344            middle_coils[43].bits.b0
#define M0345            middle_coils[43].bits.b1
#define M0346            middle_coils[43].bits.b2
#define M0347            middle_coils[43].bits.b3
#define M0348            middle_coils[43].bits.b4
#define M0349            middle_coils[43].bits.b5
#define M0350            middle_coils[43].bits.b6
#define M0351            middle_coils[43].bits.b7
#define M0352            middle_coils[44].bits.b0
#define M0353            middle_coils[44].bits.b1
#define M0354            middle_coils[44].bits.b2
#define M0355            middle_coils[44].bits.b3
#define M0356            middle_coils[44].bits.b4
#define M0357            middle_coils[44].bits.b5
#define M0358            middle_coils[44].bits.b6
#define M0359            middle_coils[44].bits.b7
#define M0360            middle_coils[45].bits.b0
#define M0361            middle_coils[45].bits.b1
#define M0362            middle_coils[45].bits.b2
#define M0363            middle_coils[45].bits.b3
#define M0364            middle_coils[45].bits.b4
#define M0365            middle_coils[45].bits.b5
#define M0366            middle_coils[45].bits.b6
#define M0367            middle_coils[45].bits.b7
#define M0368            middle_coils[46].bits.b0
#define M0369            middle_coils[46].bits.b1
#define M0370            middle_coils[46].bits.b2
#define M0371            middle_coils[46].bits.b3
#define M0372            middle_coils[46].bits.b4
#define M0373            middle_coils[46].bits.b5
#define M0374            middle_coils[46].bits.b6
#define M0375            middle_coils[46].bits.b7
#define M0376            middle_coils[47].bits.b0
#define M0377            middle_coils[47].bits.b1
#define M0378            middle_coils[47].bits.b2
#define M0379            middle_coils[47].bits.b3
#define M0380            middle_coils[47].bits.b4
#define M0381            middle_coils[47].bits.b5
#define M0382            middle_coils[47].bits.b6
#define M0383            middle_coils[47].bits.b7
#define M0384            middle_coils[48].bits.b0
#define M0385            middle_coils[48].bits.b1
#define M0386            middle_coils[48].bits.b2
#define M0387            middle_coils[48].bits.b3
#define M0388            middle_coils[48].bits.b4
#define M0389            middle_coils[48].bits.b5
#define M0390            middle_coils[48].bits.b6
#define M0391            middle_coils[48].bits.b7
#define M0392            middle_coils[49].bits.b0
#define M0393            middle_coils[49].bits.b1
#define M0394            middle_coils[49].bits.b2
#define M0395            middle_coils[49].bits.b3
#define M0396            middle_coils[49].bits.b4
#define M0397            middle_coils[49].bits.b5
#define M0398            middle_coils[49].bits.b6
#define M0399            middle_coils[49].bits.b7
#define M0400            middle_coils[50].bits.b0
#define M0401            middle_coils[50].bits.b1
#define M0402            middle_coils[50].bits.b2
#define M0403            middle_coils[50].bits.b3
#define M0404            middle_coils[50].bits.b4
#define M0405            middle_coils[50].bits.b5
#define M0406            middle_coils[50].bits.b6
#define M0407            middle_coils[50].bits.b7
#define M0408            middle_coils[51].bits.b0
#define M0409            middle_coils[51].bits.b1
#define M0410            middle_coils[51].bits.b2
#define M0411            middle_coils[51].bits.b3
#define M0412            middle_coils[51].bits.b4
#define M0413            middle_coils[51].bits.b5
#define M0414            middle_coils[51].bits.b6
#define M0415            middle_coils[51].bits.b7
#define M0416            middle_coils[52].bits.b0
#define M0417            middle_coils[52].bits.b1
#define M0418            middle_coils[52].bits.b2
#define M0419            middle_coils[52].bits.b3
#define M0420            middle_coils[52].bits.b4
#define M0421            middle_coils[52].bits.b5
#define M0422            middle_coils[52].bits.b6
#define M0423            middle_coils[52].bits.b7
#define M0424            middle_coils[53].bits.b0
#define M0425            middle_coils[53].bits.b1
#define M0426            middle_coils[53].bits.b2
#define M0427            middle_coils[53].bits.b3
#define M0428            middle_coils[53].bits.b4
#define M0429            middle_coils[53].bits.b5
#define M0430            middle_coils[53].bits.b6
#define M0431            middle_coils[53].bits.b7
#define M0432            middle_coils[54].bits.b0
#define M0433            middle_coils[54].bits.b1
#define M0434            middle_coils[54].bits.b2
#define M0435            middle_coils[54].bits.b3
#define M0436            middle_coils[54].bits.b4
#define M0437            middle_coils[54].bits.b5
#define M0438            middle_coils[54].bits.b6
#define M0439            middle_coils[54].bits.b7
#define M0440            middle_coils[55].bits.b0
#define M0441            middle_coils[55].bits.b1
#define M0442            middle_coils[55].bits.b2
#define M0443            middle_coils[55].bits.b3
#define M0444            middle_coils[55].bits.b4
#define M0445            middle_coils[55].bits.b5
#define M0446            middle_coils[55].bits.b6
#define M0447            middle_coils[55].bits.b7
#define M0448            middle_coils[56].bits.b0
#define M0449            middle_coils[56].bits.b1
#define M0450            middle_coils[56].bits.b2
#define M0451            middle_coils[56].bits.b3
#define M0452            middle_coils[56].bits.b4
#define M0453            middle_coils[56].bits.b5
#define M0454            middle_coils[56].bits.b6
#define M0455            middle_coils[56].bits.b7
#define M0456            middle_coils[57].bits.b0
#define M0457            middle_coils[57].bits.b1
#define M0458            middle_coils[57].bits.b2
#define M0459            middle_coils[57].bits.b3
#define M0460            middle_coils[57].bits.b4
#define M0461            middle_coils[57].bits.b5
#define M0462            middle_coils[57].bits.b6
#define M0463            middle_coils[57].bits.b7
#define M0464            middle_coils[58].bits.b0
#define M0465            middle_coils[58].bits.b1
#define M0466            middle_coils[58].bits.b2
#define M0467            middle_coils[58].bits.b3
#define M0468            middle_coils[58].bits.b4
#define M0469            middle_coils[58].bits.b5
#define M0470            middle_coils[58].bits.b6
#define M0471            middle_coils[58].bits.b7
#define M0472            middle_coils[59].bits.b0
#define M0473            middle_coils[59].bits.b1
#define M0474            middle_coils[59].bits.b2
#define M0475            middle_coils[59].bits.b3
#define M0476            middle_coils[59].bits.b4
#define M0477            middle_coils[59].bits.b5
#define M0478            middle_coils[59].bits.b6
#define M0479            middle_coils[59].bits.b7
#define M0480            middle_coils[60].bits.b0
#define M0481            middle_coils[60].bits.b1
#define M0482            middle_coils[60].bits.b2
#define M0483            middle_coils[60].bits.b3
#define M0484            middle_coils[60].bits.b4
#define M0485            middle_coils[60].bits.b5
#define M0486            middle_coils[60].bits.b6
#define M0487            middle_coils[60].bits.b7
#define M0488            middle_coils[61].bits.b0
#define M0489            middle_coils[61].bits.b1
#define M0490            middle_coils[61].bits.b2
#define M0491            middle_coils[61].bits.b3
#define M0492            middle_coils[61].bits.b4
#define M0493            middle_coils[61].bits.b5
#define M0494            middle_coils[61].bits.b6
#define M0495            middle_coils[61].bits.b7
#define M0496            middle_coils[62].bits.b0
#define M0497            middle_coils[62].bits.b1
#define M0498            middle_coils[62].bits.b2
#define M0499            middle_coils[62].bits.b3
#define M0500            middle_coils[62].bits.b4
#define M0501            middle_coils[62].bits.b5
#define M0502            middle_coils[62].bits.b6
#define M0503            middle_coils[62].bits.b7
#define M0504            middle_coils[63].bits.b0
#define M0505            middle_coils[63].bits.b1
#define M0506            middle_coils[63].bits.b2
#define M0507            middle_coils[63].bits.b3
#define M0508            middle_coils[63].bits.b4
#define M0509            middle_coils[63].bits.b5
#define M0510            middle_coils[63].bits.b6
#define M0511            middle_coils[63].bits.b7
#define M1000            middle_coils[125].bits.b0




void variable_init(void);

#endif
